#include "manalink.h"

int card_phyrexian_colossus(int player, int card, event_t event){
    minimum_blockers(player, card, event, 3);
    does_not_untap(player, card, event);
    if( event == EVENT_CAN_ACTIVATE && life[player] > 7 ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        life[player]-=8;
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *instance = get_card_instance(player, card);
        untap_card(player, instance->parent_card);
    }
    return 0;
}

int card_brass_herald(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( comes_into_play(player, card, event) ){
        int creature_type = get_random_creature_type(player);
        if( player == HUMAN && unknown728574 != 1 ){
            int card_id = choose_a_card("Choose a creature that has the subtype you want to choose", -1, -1);
            card_data_t card_d = cards_data[card_id];
            if( card_d.type & TYPE_CREATURE ){
                //create_card_name_legacy(player, card, card_d.id );
                card_ptr_t* c = cards_ptr[card_d.id];
                creature_type = c->subtype1;
                if( c->subtype2 != 211 ){
                    char buffer[3500];
                    load_text(0, "HUNTING_SUBTYPENAMES");
                    sprintf(buffer, " Choose %s\nChoose %s", text_lines[c->subtype1], text_lines[c->subtype2] );
                    int choice = do_dialog(player, player, card, -1, -1, buffer, 1);
                    if( choice == 1 ){
                        creature_type = c->subtype2;
                    }
                }
            }
        }
        
        int legacy_card = create_legacy_effect_exe(player, card, LEGACY_EFFECT_ASWAN, player, card );
        card_instance_t *legacy = get_card_instance(player, legacy_card);
        legacy->info_slot = creature_type;
    
        instance->info_slot = creature_type;
                
        int i=0;
        int *deck = deck_ptr[player];
        for(i=0;i<4;i++){
        int card_added = add_card_to_hand(player, deck[0] );
            reveal_card(player, player, card, player, card_added, "Reveals...", 0);
            if( has_subtype(player, card_added, creature_type) ){
                remove_card_from_deck( player, 0 );
                hand_count[player]++;
            }
            else{
                obliterate_card(player, card_added);
                put_top_card_of_deck_to_bottom(player);
            }
        }
    }
    else if( in_play(player, card) && ( event == EVENT_POWER || event == EVENT_TOUGHNESS )){
        if(has_subtype(affected_card_controller, affected_card, instance->info_slot ) ){
            event_result++;
        }
    }
    return 0;
}

int card_sundering_titan(int player, int card, event_t event){
    if(comes_into_play(player, card, event) == 1 || leaves_play(player, card, event) ){
        // initialize targets
        card_instance_t *instance = get_card_instance(player, card);
        int i=0;
        for(i=0;i<5;i++){
            instance->targets[i].player = -1;
        }    
        
        // target each land
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_LAND);
        td.preferred_controller = 2;
        td.allow_cancel = 0;
        
        td.required_subtype = SUBTYPE_SWAMP;
        if(target_available(player, card, &td)){
            select_target(player, card, &td, "Choose a Swamp", NULL);
            instance->targets[4].player = instance->targets[0].player;   
            instance->targets[4].card = instance->targets[0].card;   
        }
        
        td.required_subtype = SUBTYPE_ISLAND;
        if(target_available(player, card, &td)){
            select_target(player, card, &td, "Choose an Island", NULL);
            instance->targets[3].player = instance->targets[0].player;   
            instance->targets[3].card = instance->targets[0].card;   
        }
        
        td.required_subtype = SUBTYPE_FOREST;
        if(target_available(player, card, &td)){
            select_target(player, card, &td, "Choose a Forest", NULL);
            instance->targets[2].player = instance->targets[0].player;   
            instance->targets[2].card = instance->targets[0].card;   
        }
        
        
        td.required_subtype = SUBTYPE_MOUNTAIN;
        if(target_available(player, card, &td)){
            select_target(player, card, &td, "Choose a Mountain", NULL );
            instance->targets[1].player = instance->targets[0].player;   
            instance->targets[1].card = instance->targets[0].card;   
        }
        
        
        td.required_subtype = SUBTYPE_PLAINS;
        if(target_available(player, card, &td)){
            select_target(player, card, &td, "Choose a Plains", NULL);
        }
        
        // Now destroy each land
        for(i=0;i<5;i++){
            if( instance->targets[i].player != -1 && in_play( instance->targets[i].player, instance->targets[i].card ) ){
                kill_card( instance->targets[i].player, instance->targets[i].card, KILL_DESTROY );
            }
        }
        
    }
    return 0;
}

int card_arcbound_worker (int player, int card, event_t event){
    card_instance_t *instance = get_card_instance( player, card);
    if( comes_into_play(player, card, event) == 1 ){
       add_1_1_counter(player, card);
//        instance->counters = 1;
//        instance->counter_power = 1;
//        instance->counter_toughness = 1;
    }
    else if(event==EVENT_TOUGHNESS && affect_me(player, card) ){
        if( instance->counters == 0 ){
            event_result++;
        }
    }
    else if(event == EVENT_GRAVEYARD_FROM_PLAY && affect_me( player, card) ){
        if( instance->kill_code > 0 && instance->kill_code != KILL_REMOVE ){
            if( ! in_play(player, card) ){ return 0; } 
            target_definition_t td;
            default_target_definition(player, card, &td, TYPE_ARTIFACT);
            if( player == AI ){
                td.allowed_controller = player;
                td.preferred_controller = player;
            }
            instance->state |= STATE_CANNOT_TARGET;
            if( target_available(player, card, &td) ){
                if( select_target(player, card, &td, "Select target artifact creature", NULL) ){
                    card_instance_t *target= get_card_instance( instance->targets[0].player, instance->targets[0].card);
                    if( cards_data[ target->internal_card_id ].type & TYPE_CREATURE  ){
                        int i;
                        for (i=0;i<instance->counters;i++){
                            target->counters++;
                            target->counter_power++;
                            target->counter_toughness++;
                        }
                    }
                    spell_fizzled = 1;
                }
            }
        }
    }
    return 0;
}

int card_stratadon(int player, int card, event_t event){
    if(event == EVENT_MODIFY_COST ){
        COST_COLORLESS -= count_domain(player, card);
    }
    return 0;
}

int card_draco(int player, int card, event_t event){
    basic_upkeep(player, card, event, 10-2*count_domain(player, card), 0,0,0,0,0);
    if(event == EVENT_MODIFY_COST ){
        COST_COLORLESS -= 2*count_domain(player, card);
    }
    return 0;
}

int card_darksteel_colossus(int player, int card, event_t event){
    if( event == EVENT_GRAVEYARD_ABILITY ){
        remove_card_from_grave(player, card);
        int *deck = deck_ptr[player];
        deck[ count_deck(player) ] = get_internal_card_id_from_csv_id( get_id_by_name("Darksteel Colossus") ); 
        shuffle(player);
    }
    else{
        indestructible(player, card, event);
    }
    return 0;
}

int card_bottle_gnomes(int player, int card, event_t event){
  switch(event){
    case EVENT_CAN_ACTIVATE:
      return 1;
      break;
    case EVENT_ACTIVATE:
      kill_card(player, card, KILL_SACRIFICE);
      break;
    case EVENT_RESOLVE_ACTIVATION:
      gain_life(player, 3);
      break;
	default:
	  break;
  }
  return 0;
}

int card_phyrexian_dreadnought(int player, int card, event_t event){
    if( comes_into_play(player, card, event) ){
        card_instance_t *instance = get_card_instance(player, card);
        instance->state |= STATE_CANNOT_TARGET;
            
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.allowed_controller = player;
        td.preferred_controller = player;
        td.illegal_abilities = 0;
        int total_power = 0;
        
        int i=0;
        while( can_target(&td) && spell_fizzled != 1 ){
            if( i > 0 ){
                instance->targets[12] = instance->targets[0];
            }
            if( pick_target(&td, "LORD_OF_THE_PIT") ){
                card_instance_t *target = get_card_instance(instance->targets[0].player, instance->targets[0].card);
                target->state |= STATE_CANNOT_TARGET;
                if( i > 0 ){
                    instance->targets[i] = instance->targets[0];
                    instance->targets[0] = instance->targets[12];
                }
                i++;
            }
            else if (i > 0 ){
                instance->targets[0] = instance->targets[12];
            }
         }
        
        int j=0;
        for(j=0;j<i;j++){
            total_power += get_power( instance->targets[j].player, instance->targets[j].card);
            kill_card( instance->targets[j].player, instance->targets[j].card, KILL_SACRIFICE);
        }
        if( total_power < 12 ){
            kill_card(player, card, KILL_SACRIFICE);
        }
        
        instance->state &= ~STATE_CANNOT_TARGET;
    }
    return 0;
}


