#include "manalink.h"

int effect_slowtrip(int player, int card, event_t event){
    if( eot_trigger(player, card, event) ){
        kill_card(player, card, KILL_REMOVE);
        draw_a_card(player);
    }
    return 0;
}

int card_horn_of_greed(int player, int card, event_t event){
    if(trigger_condition == TRIGGER_SPELL_CAST && player == affected_card_controller
       && card == affected_card && player == reason_for_trigger_controller )
    {
        card_instance_t *instance = get_card_instance(trigger_cause_controller, trigger_cause);
        if( cards_data[ instance->internal_card_id].type & TYPE_LAND ){
            if(event == EVENT_TRIGGER){
                event_result |= RESOLVE_TRIGGER_MANDATORY;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                draw_a_card(trigger_cause_controller);
            }
        }
    } 
    return 0;
}

int card_urzas_bauble(int player, int card, event_t event){
    if( event == EVENT_CAN_ACTIVATE && ! is_tapped(player, card) && ! is_animated_and_sick(player, card) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        tap_card(player, card);
        kill_card(player, card, KILL_SACRIFICE );
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int legacy_card = create_legacy_effect(player, card, &effect_slowtrip );
        card_instance_t *legacy = get_card_instance(player, legacy_card);
        legacy->targets[0].card = current_turn;
        
        if(hand_count[opp]==0){
            return 0;
        }
        int r =  rand( hand_count[opp] );
        int cards_array[ 1 ];
        int i=0;
        int hand_index = 0;
        for(i=0;i<active_cards_count[opp]; i++){
            card_instance_t *instance = get_card_instance(opp, i);
            if( ! ( instance->state & STATE_INVISIBLE ) && ! ( instance->state & STATE_IN_PLAY )  ){
                int id = instance->internal_card_id;
                if( id > -1 ){
                    if( hand_index == r ){
                        cards_array[0] = id;
                    }
                    hand_index++;
                }
            }
        }
        show_deck( player, cards_array, 1, "Card Revealed at Random", 0, 0x7375B0 );
    }
    return 0;
}

int card_teferis_puzzle_box(int player, int card, event_t event){
    
    card_instance_t *instance = get_card_instance(player, card);
    if(trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
        if(event == EVENT_TRIGGER){
            event_result |= 2;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            target_definition_t td;
            default_target_definition(player, card, &td, TYPE_NONE);
            td.allowed_controller = current_turn;
            td.preferred_controller = current_turn;
            td.who_chooses = current_turn;
            td.zone = TARGET_ZONE_HAND;
            td.illegal_abilities = 0;
            td.allow_cancel = 0;
            int cards = hand_count[current_turn];
            int i;
            for(i=0;i<cards;i++){
                pick_target(&td, "BRONZE_TABLET");
                put_on_top_of_deck(current_turn, instance->targets[0].card);
                put_top_card_of_deck_to_bottom(current_turn);
            }
            draw_cards(current_turn, cards);
            hand_count[current_turn] = cards;
        }
    }
    return 0;  
}

int card_vedalken_shackles(int player, int card, event_t event){
    
    target_definition_t td2;
    default_target_definition(player, card, &td2, TYPE_LAND);
    td2.required_subtype = SUBTYPE_ISLAND;
    td2.allowed_controller = player;
    td2.preferred_controller = player;
    td2.illegal_abilities = 0;
    int island_count = can_target(&td2);
    
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.power_requirement = island_count | 0x2000;
    
    card_instance_t *instance = get_card_instance(player, card);
    
    // if this is untapped, release any creatures
    if( (leaves_play( player, card, event) || ! is_tapped(player, card)) && instance->targets[0].card != -1 ){
        instance->targets[0].card = -1;
        kill_card(player, instance->info_slot, KILL_DESTROY );
    }
    
    if( event == EVENT_CAN_ACTIVATE && ! is_tapped(player, card) && ! is_animated_and_sick(player, card) && has_mana_multi(player, 2, 0, 0, 0, 0, 0) ){
        return can_target(&td);
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 2, 0, 0, 0, 0, 0);
        if( spell_fizzled != 1 && pick_target(&td, "TARGET_CREATURE") ){
            tap_card(player, card);
            //instance->number_of_targets = 1;
        }
        
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( valid_target(&td) && in_play(instance->parent_controller, instance->parent_card) && is_tapped(instance->parent_controller, instance->parent_card) ){
            int legacy = gain_control(player, card, instance->targets[0].player, instance->targets[0].card);
            if( legacy > -1 ){
                card_instance_t *parent = get_card_instance(instance->parent_controller, instance->parent_card);
                parent->info_slot = legacy;
            }
        }
    }
    else{
        return card_tawnoss_weaponry(player, card, event);
    }
    return 0;
}

int card_helm_of_obedience(int player, int card, event_t event){
    if( ! is_unlocked(player, card, event, 36) ){ return 0; }
    card_instance_t *instance = get_card_instance( player, card );
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 0, 0) && ! is_tapped(player, card) && ! is_animated_and_sick(player, card) ){
        return 1;
    }
    else if(event == EVENT_ACTIVATE){
        // For the AI, use the most mana we have, from 2-max
        if( player == AI ){
            int i = 10;
            while(i > 1){
                if( has_mana( player, COLOR_ANY, i) ){
                    charge_mana( player, COLOR_COLORLESS, i);
                    instance = get_card_instance(player, card);
                    instance->info_slot = i;
                    break;
                }
                i--;
            }
        }
        else{
            charge_mana( player, COLOR_COLORLESS, -1);
            int choice = x_value;
            if( spell_fizzled != 1 ){
                instance->info_slot = choice;
            }
        }
        if( spell_fizzled != 1 ){
            tap_card(player, card);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int *grave = graveyard_ptr[1-player];
        int count = count_graveyard(1-player);
        while( count_graveyard(1-player) < count + instance->info_slot && count_deck(1-player) > 0 ){
            int result = mill(1-player, 1);
            if( result > 0 && count_graveyard(1-player) > count ){
                int internal_card_id = grave[ count_graveyard(1-player) - 1 ];
                if( cards_data[ internal_card_id  ].type & TYPE_CREATURE ){
                    kill_card(player, instance->parent_card, KILL_SACRIFICE );
                    remove_card_from_grave(1-player, count_graveyard(1-player) - 1);
                    int card_added = add_card_to_hand(player, internal_card_id );
                    put_into_play(player, card_added);
                    instance->info_slot = 0;
                } 
            }
        }
    }
    return 0;
}

int card_millstone(int player, int card, event_t event){
    target_definition_t td1;
    default_target_definition(player, card, &td1, TYPE_CREATURE );
    td1.zone = TARGET_ZONE_PLAYERS;
    td1.preferred_controller = 1-player;
    td1.allow_cancel = 0;
        
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE ){
        if( ! is_tapped(player, card) && ! is_animated_and_sick(player, card) && has_mana(player, COLOR_ANY, 2) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_COLORLESS, 2);
        if( spell_fizzled == 1 ){ return 0; }
        tap_card(player, card);
        select_target(player, card, &td1, "Select target player", NULL);
        instance->number_of_targets = 1;
    }
    else if(event == EVENT_RESOLVE_ACTIVATION ){
        mill( instance->targets[0].player, 2);
    }   
    return 0;
}

int card_serum_powder(int player, int card, event_t event){
    if( ! is_unlocked(player, card, event, 7) ){ return 0; }
    return mana_producer(player, card, event);
}

int card_goblin_charbelcher(int player, int card, event_t event){
    if( ! is_unlocked(player, card, event, 12) ){ return 0; }
    
    target_definition_t td1;
    default_target_definition(player, card, &td1, TYPE_CREATURE );
    td1.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
    td1.allow_cancel = 0;
        
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE ){
        if( ! is_tapped(player, card) && ! is_animated_and_sick(player, card) && has_mana(player, COLOR_ANY, 3) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_COLORLESS, 3);
        if( spell_fizzled == 1 ){ return 0; }
        tap_card(player, card);
            
        // choose a target to shoot
        
        select_target(player, card, &td1, "Select target creature or player", NULL);
        instance->number_of_targets = 1;
    }
    else if(event == EVENT_RESOLVE_ACTIVATION ){
        if( validate_target(player, card, &td1, 0) ){
            // find the top land of opponent's deck
            int *deck = deck_ptr[player];
            int i = 0;
            while( deck[i] != -1 && !( cards_data[ deck[i] ].type & TYPE_LAND ) ){
                i++;
            }
            int damage = i;
            
            if( deck[i] != -1 ){
                card_ptr_t* c = cards_ptr[ cards_data[ deck[i] ].id ];
                if( c->subtype1 == SUBTYPE_MOUNTAIN || c->subtype2 == SUBTYPE_MOUNTAIN ){
                    damage *= 2;
                }
                i++;
            }
            
            damage_creature_or_player(player, card, event, damage, 3);  
            
            // put the revealed cards to the bottom in any order
            if( life[opp] > damage ||  duh_mode(player) == 0 ){
                while( i > 0 ){
                    int selected = -1;
                    while( selected == -1 ){
                        selected = show_deck( player, deck_ptr[player], i, "Pick a card to put on bottom of deck", 0, 0x7375B0 );
                    }
                    i--;
                    deck[ count_deck(player) ] = deck[selected];
                    remove_card_from_deck( player, selected );               
                }
            }  
        }
    }   
    return 0;
}

int card_tangle_wire(int player, int card, event_t event){
    if( ! is_unlocked(player, card, event, 15) ){ return 0; }
    card_instance_t *instance = get_card_instance(player, card);
    if( current_turn == player || trigger_condition != TRIGGER_UPKEEP){
        fading(player, card, event, 4);
    }
    if(trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
        if(event == EVENT_TRIGGER){
            event_result |= 2;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            if( instance->info_slot < 1 ){
                instance->info_slot = 0;
            }
                
            target_definition_t td;
            default_target_definition(player, card, &td, TYPE_ARTIFACT | TYPE_CREATURE | TYPE_LAND );
            td.illegal_state = TARGET_STATE_TAPPED;
            td.allowed_controller = current_turn;
            td.preferred_controller = current_turn;
            td.who_chooses = current_turn;
            td.illegal_abilities = 0;
            td.allow_cancel = 0;
        
            int i;
            for( i=0;i<count_counters(player, card);i++){
                if( target_available(player, card, &td) ){
                    select_target(player, card, &td, "Choose a card to tap", NULL);
                    int target = instance->targets[0].card;
                    tap_card( current_turn, target );
                }
            }
        }
    }
    return 0;  
}

int card_coalition_relic(int player, int card, event_t event){
    if( player == AI ){
        return mana_producer(player, card, event);
    }
    
    card_instance_t *instance = get_card_instance(player, card);     
    if(event == EVENT_ACTIVATE ){
        int choice = do_dialog(player, player, card, -1, -1, " Get Mana\n Add Charge counter", 1);
        if( choice == 1 ){
            tap_card(player, card);
            add_counter( player, card );
            return 0;
        }
        else{
            return mana_producer(player, card, event);
        }
    }
    else if( current_turn == player && count_counters(player, card) > 0 && current_phase == PHASE_MAIN1 && instance->info_slot == 2 ){
        int counters = count_counters(player, card);
        int i;
        for( i=0;i<counters;i++){
            remove_counter(player, card);
            add_one_mana_any_color(player, card, event);
        }
        untap_card(player, card);
        instance->info_slot = 0;
    }
    else if(trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) && current_turn == player && count_counters(player, card) > 0 ){
        if(event == EVENT_TRIGGER){
            event_result |= 2;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            instance->info_slot = 2;
        }
    }
    
    return mana_producer(player, card, event);
}


int card_serrated_arrows(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE );
        
    card_instance_t *instance = get_card_instance(player, card);
    if( comes_into_play(player, card, event) == 1 ){
        add_counters(player, card, 3);
    }
    else if(trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) && current_turn == player && count_counters(player, card) == 0 ){
        if(event == EVENT_TRIGGER){
            event_result |= 2;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            kill_card(player, card, KILL_SACRIFICE);
        }
    }
    else if( event == EVENT_CAN_ACTIVATE ){
        if( count_counters(player, card) > 0 && ! is_tapped(player, card) && ! is_animated_and_sick(player, card ) && target_available(player, card, &td) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        if( ! select_target(player, card, &td, "Select target creature", NULL) ){
            spell_fizzled = 1;
        }
        else{
            remove_counter(player, card);
            tap_card(player, card);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( validate_target(player, card, &td, 0) ){
            card_instance_t *new_instance = get_card_instance( instance->targets[0].player, instance->targets[0].card );
            new_instance->counters++;
            new_instance->counter_power--;
            new_instance->counter_toughness--;     
        }
    }
    return 0;
}
    
int card_cursed_scroll(int player, int card, event_t event){
    if( ! is_unlocked(player, card, event, 6) ){ return 0; }
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE ){
        if( has_mana_multi(player, 3, 0, 0, 0, 0, 0) && ! is_tapped(player, card) && ! is_animated_and_sick(player, card ) && hand_count[player] > 0 ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 3, 0, 0, 0, 0, 0);
        if( spell_fizzled != 1 ){
            tap_card(player, card);
            
            // choose a target to shoot
            instance->number_of_targets = 1;
            target_definition_t td1;
            default_target_definition(player, card, &td1, TYPE_CREATURE );
            td1.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
            td1.allow_cancel = 0;
            select_target(player, card, &td1, "Select target creature or player", NULL);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( hand_count[player] == 0 ){ return 0; }
        
        // choose a card in hand
        int player1 = instance->targets[0].player;
        int card1 = instance->targets[0].card; 
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_ANY );
        td.zone = TARGET_ZONE_HAND;
        td.allowed_controller = player;
        td.preferred_controller = player;
        td.allow_cancel = 0;
        td.illegal_abilities = 0;
        select_target(player, card, &td, "Choose a card in your hand", NULL);
        instance->info_slot = get_id( player, instance->targets[0].card );
        instance->number_of_targets = 1;
        
        instance->targets[0].player = player1;
        instance->targets[0].card = card1; 
        if( player == AI ){
            reveal_card(player, player, card, player, instance->info_slot, "AI Names...", 0);
        }
        
         // reveal a card at random
        int rand_card = rand( hand_count[player] );
        int i;
        int index = 0;
        for(i=0;i<active_cards_count[player]; i++){
            card_instance_t *card_instance = get_card_instance(player, i);
            if( ! ( card_instance->state & STATE_INVISIBLE ) && ! ( card_instance->state & STATE_IN_PLAY )  ){
                int id = card_instance->internal_card_id;
                if( id > -1 ){
                    if( index == rand_card ){
                        reveal_card(player, player, card, player, i, "Revealed Card...", 0);
                        if( get_id(player, i) == instance->info_slot ){
                            damage_creature_or_player(player, card, event, 2, 3);    
                        }
                        break;
                    }
                    index++;
                }
            }
        }
    }
    else{
        return card_rod_of_ruin(player, card, event);
    }
    return 0;
}

int card_smokestack(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if(trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
        if(event == EVENT_TRIGGER){
            event_result |= 2;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            if( instance->info_slot < 1 ){
                instance->info_slot = 0;
            }
                
            target_definition_t td;
            default_target_definition(player, card, &td, TYPE_PERMANENT);
            td.allowed_controller = current_turn;
            td.preferred_controller = current_turn;
            td.who_chooses = current_turn;
            td.illegal_abilities = 0;
            td.allow_cancel = 0;
        
            int i;
            for( i=0;i<instance->info_slot;i++){
                if( target_available(player, card, &td) ){
                    select_target(player, card, &td, "Choose a permanent to sacrifice", NULL);
                    int target = instance->targets[0].card;
                    kill_card( current_turn, target, KILL_SACRIFICE );
                }
            }
                
            if( current_turn == player && in_play(player, card) ){
                int choice = do_dialog(player, player, card, -1, -1, " Add Soot counter\n Do Not Add Counter \n", 0);
                if( choice == 0 ){
                    instance->info_slot++; 
                    add_counter(player, card); 
                }
            }
        }
    }
    return 0;  
}

int card_jesters_cap(int player, int card, event_t event){
    
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE ){
        if( has_mana_multi(player, 2, 0, 0, 0, 0, 0) && in_play(player, card) && ! is_tapped(player, card) && ! is_animated_and_sick(player, card ) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.zone = TARGET_ZONE_PLAYERS;
        td.allow_cancel = 0;
        select_target(player, card, &td, "Choose a target player", NULL);
        charge_mana_multi(player, 2, 0, 0, 0, 0, 0);
        if( spell_fizzled != 1 ){
            tap_card(player, card);
            kill_card(player, card, KILL_SACRIFICE );
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int target = instance->targets[0].player;
        int i=0;
        while(i<3){
            int selected = show_deck( player, deck_ptr[target], 500, "Pick a card", 0, 0x7375B0 );
            if( selected != -1){
                int *deck = deck_ptr[target];
                int *rfg = rfg_ptr[target];
                rfg[ count_rfg(target) ] = deck[selected];
                remove_card_from_deck( target, selected );
                i++;
            }
            else{
                break;
            }
        }
        shuffle(target);
    }
    return 0;
}

int card_trinisphere(int player, int card, event_t event){
    if( ! is_tapped(player, card) ){
        if( event == EVENT_MODIFY_COST_GLOBAL ){
            int cmc = get_cmc( affected_card_controller, affected_card );
            if( cmc < 3 ){
                card_data_t card_d = get_card_data(affected_card_controller, affected_card);
                if(! (card_d.type & TYPE_LAND) ){
                    COST_COLORLESS += 3 - cmc;
                }
            }
        }
    }
    return 0;
}

int hands[2][250];
    
int effect_memory_jar(int player, int card, event_t event){
    if( eot_trigger(player, card, event ) ){        
        int p;
        for(p=0;p<2;p++){
            // discard hands
            int i=0;
            for(i=0;i<active_cards_count[p]; i++){
                card_instance_t *instance = get_card_instance(p, i);
                if( ! ( instance->state & STATE_INVISIBLE ) && ! ( instance->state & STATE_IN_PLAY )  ){
                    int id = instance->internal_card_id;
                    if( id > -1 ){
                        discard_card(p, i);
                    }
                }
            }
            
            // replace the missing cards
            i=0;
            while( hands[p][i] != -1 ){
                add_card_to_hand(p, hands[p][i++] );
            }
            hand_count[p] = i;
        }
        kill_card(player, card, KILL_REMOVE);
    }
    return 0;
}
        
int card_memory_jar(int player, int card, event_t event){
    if( event == EVENT_CAN_ACTIVATE ){
        return 1;
    } 
    else if( event == EVENT_ACTIVATE ){
        kill_card(player, card, KILL_SACRIFICE);
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        // RFG hands
        int p;
        for(p=0;p<2;p++){
            int i=0;
            int count = 0;
            for(i=0;i<active_cards_count[p]; i++){
                card_instance_t *instance = get_card_instance(p, i);
                if( ! ( instance->state & STATE_INVISIBLE ) && ! ( instance->state & STATE_IN_PLAY )  ){
                    int id = instance->internal_card_id;
                    if( id > -1 ){
                        hands[p][count++] = instance->internal_card_id;
                        kill_card(p, i, KILL_DESTROY);
                        obliterate_top_card_of_grave(p);
                    }
                }
            }
            hands[p][count++] = -1;
            draw_cards(p, 7);
            hand_count[player] = 7;
        }
        create_legacy_effect(player, card, &effect_memory_jar );
    }
    return 0;
}


int card_lions_eye_diamond(int player, int card, event_t event){
    if( event == EVENT_COUNT_MANA ){
        return 0;
    }
    int result = card_black_lotus(player, card, event); 
    if( event == EVENT_ACTIVATE && spell_fizzled != 1){
        int i=0;
        for(i=0;i<active_cards_count[player]; i++){
            card_instance_t *instance = get_card_instance(player, i);
            if( ! ( instance->state & STATE_INVISIBLE ) && ! ( instance->state & STATE_IN_PLAY )  ){
                int id = instance->internal_card_id;
                if( id > -1 ){
                    discard_card(player, i);
                }
            }
        }
    }
    return result;
}

int card_gauntlet_of_power(int player, int card, event_t event){
    card_instance_t *instance= get_card_instance(player, card);
    
    if(comes_into_play(player, card, event) == 1 ){
        // which color should the AI pick...
        int ai_choice = 5;
        if( player == AI ){
            int *deck = deck_ptr[player];
            int i;
            for(i=0;i<500;i++){
                int color = cards_data[ deck[i] ].color;
                if( color > 1 ){
                    if( color & COLOR_TEST_BLACK ){
                        ai_choice = 1;
                    }
                    else if( color & COLOR_TEST_BLUE ){
                        ai_choice = 2;
                    }
                    else if( color & COLOR_TEST_GREEN ){
                        ai_choice = 3;
                    }
                    else if( color & COLOR_TEST_RED ){
                        ai_choice = 4;
                    }
                    i = 500;
                }
            }
        }
        
        instance->info_slot = choose_a_color(player, ai_choice);
    }
    
    int test_color = 1 << instance->info_slot;
    int subtype = SUBTYPE_SWAMP;
    if( instance->info_slot == COLOR_BLUE ){
        subtype = SUBTYPE_ISLAND;
    }
    else if( instance->info_slot == COLOR_GREEN ){
        subtype = SUBTYPE_FOREST;
    }
    else if( instance->info_slot == COLOR_RED ){
        subtype = SUBTYPE_MOUNTAIN;
    }
    else if( instance->info_slot == COLOR_WHITE ){
        subtype = SUBTYPE_PLAINS;
    }
        
    // do the mana part
    if( has_subtype(affected_card_controller, affected_card, subtype ) && is_basic_land( affected_card_controller, affected_card ) ){
        if ( event == EVENT_TAP_CARD ){
            produce_mana(affected_card_controller, instance->info_slot, 1);
        }
        else if ( event == EVENT_COUNT_MANA ){
            if( ! is_tapped(affected_card_controller, affected_card) ){
                declare_mana_available(affected_card_controller, instance->info_slot, 1);
            }
        }
    }
    
    // do the creature part
    if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
        int affected = get_color(affected_card_controller, affected_card);
        if( affected & test_color ){
            event_result++;
        }
    }
    
    return 0;
}

int card_crucible_of_worlds(int player, int card, event_t event){
    card_instance_t *instance= get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE ){
        if( can_sorcery_be_played(player) && ( count_cards_by_id(player, get_id_by_name("Fastbond")) > 0 || ! ( land_can_be_played & 1 ) ) ){
            if(count_graveyard_by_type(player, TYPE_LAND) > 0 ){
                return 1;
            }
        }
    }
    else if( event == EVENT_ACTIVATE ){
        char buffer[3500];
        sprintf(buffer, " Cancel\n" );
        
        // show each land in the graveyard
        int *graveyard = graveyard_ptr[player];
        int i;
        for(i = 0; i < count_graveyard(player); i++){
            card_data_t card_d = cards_data[ graveyard[i] ];         
            if( card_d.type & TYPE_LAND ){
                card_ptr_t* c = cards_ptr[ card_d.id ];
                sprintf(buffer, "%s Play %s\n", buffer, c->name );
            }
        }
        
        int choice = do_dialog(player, player, card, -1, -1, buffer, 1);
        if( choice != 0 && spell_fizzled != 1 ){
            // see which card was selected
            int valid = 0;
            for(i = 0; i < count_graveyard(player); i++){
                card_data_t card_d = cards_data[ graveyard[i] ];         
                if( card_d.type & TYPE_LAND ){
                    if( ++valid == choice ){
                        // remove the card from the graveyard
                        remove_card_from_grave(player, i);
                        card_ptr_t* c = cards_ptr[ card_d.id ];
                        instance->info_slot =  c->id;
                        play_spell_for_free(player, instance->info_slot);
                        return 0;
                    }
                }
            }
        }
        spell_fizzled = 1;
    }
    return 0;
}


int monolith (int player, int card, event_t event, int untap_cost){
    does_not_untap(player, card, event);
    card_instance_t *instance = get_card_instance( player, card);
    int active = 1;
    if( is_tapped(player, card) || is_animated_and_sick(player, card ) ){
        active = 0;
    }
    if( event == EVENT_COUNT_MANA && active && affect_me(player, card)){
        declare_mana_available(player, COLOR_COLORLESS, 3);
    }
    else if(event == EVENT_CAN_ACTIVATE ){
        if( active == 1 || ( is_tapped(player, card) && has_mana(player, COLOR_ANY, untap_cost) )){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE){
        if( active ){
            tap_card(player, card);
            produce_mana(player, COLOR_COLORLESS, 3);
            spell_fizzled = 1;
        }
        else{
            charge_mana(player, COLOR_COLORLESS, untap_cost);
        }
    }
    else if(event == EVENT_RESOLVE_ACTIVATION ){
        untap_card( instance->parent_controller, instance->parent_card );
    }
    return 0;
}
    
int card_basalt_monolith (int player, int card, event_t event){
    return monolith(player, card, event, 3);
}

int card_grim_monolith (int player, int card, event_t event){
    return monolith(player, card, event, 4);
}

int card_golgari_signet  (int player, int card, event_t event){
    return signet(player, card, event, COLOR_BLACK, COLOR_GREEN);
}

int card_dimir_signet  (int player, int card, event_t event){
    return signet(player, card, event, COLOR_BLACK, COLOR_BLUE);
}

int card_orzhov_signet  (int player, int card, event_t event){
    return signet(player, card, event, COLOR_BLACK, COLOR_WHITE);
}

int card_rakdos_signet  (int player, int card, event_t event){
    return signet(player, card, event, COLOR_BLACK, COLOR_RED);
}

int card_selesnya_signet(int player, int card, event_t event){
    return signet(player, card, event, COLOR_WHITE, COLOR_GREEN);
}

int card_simic_signet  (int player, int card, event_t event){
    return signet(player, card, event, COLOR_BLUE, COLOR_GREEN);
}

int card_gruul_signet  (int player, int card, event_t event){
    return signet(player, card, event, COLOR_RED, COLOR_GREEN);
}

int card_azorius_signet  (int player, int card, event_t event){
    return signet(player, card, event, COLOR_BLUE, COLOR_WHITE);
}

int card_boros_signet  (int player, int card, event_t event){
    return signet(player, card, event, COLOR_WHITE, COLOR_RED);
}

int card_aether_vial  (int player, int card, event_t event){
    card_instance_t *instance = get_card_instance( player, card);
    if(event == EVENT_RESOLVE_TRIGGER ){
        if( ! affect_me(player, card) ){ return 0;  }
        if( current_turn != player ){ return 0; }
        if( instance->info_slot > 0){ return 0; }
        instance->info_slot = 1;
        int AI_choice = 0;
        if( count_counters(player, card) == 4){
            AI_choice = 1;
        }
        char buffer[50];
        sprintf(buffer, " Add a Counter (currently at %d)\n Do not add",  count_counters(player, card));
        int choice = do_dialog(player, player, card, -1, -1, buffer, AI_choice);
        if( choice == 0 ){
            add_counter(player, card);
        }
        return 0;
    }
    else if(event == EVENT_CAN_ACTIVATE){
        if( ! is_tapped(player, card) && ! is_animated_and_sick(player, card) ){
            if( player == AI ){
                int i=0;
                for(i=0;i<active_cards_count[player];i++){
                    if( in_hand(player, i) && get_cmc(player, i) == count_counters(player, card) ){
                       card_instance_t *instance2 = get_card_instance(player, i);
                        if( cards_data[ instance2->internal_card_id ].type & TYPE_CREATURE ){
                            return 1;
                        }
                    }
                }
                return 0;
            }
            return 1;
        }
        return 0;
    }
    else if(event == EVENT_ACTIVATE){
        tap_card( player, card);
        return 0;
    }
    else if(event == EVENT_RESOLVE_ACTIVATION ){
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.allowed_controller = player;
        td.preferred_controller = player;
        td.illegal_abilities = 0;
        td.zone = TARGET_ZONE_HAND;
        while( 1 ){
            char buffer[50];
            int counters = count_counters(player, card);
            sprintf(buffer, "Choose a creature with CMC %d",  counters);
            if( select_target(player, card, &td, buffer, NULL) ){
                int cmc = get_cmc( player, instance->targets[0].card);
                if( cmc == counters ){
                    put_into_play(player, instance->targets[0].card);
                    hand_count[player]--;
                    break;
                } 
            }
            else{
                break;
            }
        }
        return 0;
    }
    else if( current_phase == PHASE_DISCARD && current_turn == player ){
        instance->info_slot = 0;
        return 0;
    }
    else{
        return card_phyrexian_arena(player, card, event);
    }
}

int card_tower_of_fortunes( int player, int card, event_t event){
    if(event == EVENT_CAN_ACTIVATE){
        if( is_animated_and_sick(player, card) || is_tapped( player, card )  ){
            return 0;
        }
        if( has_mana_multi( player, 8, 0, 0, 0, 0, 0 )  ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE){
        tap_card( player, card);
        charge_mana_multi( player, 8, 0, 0, 0, 0, 0 );
    }
    else if(event == EVENT_RESOLVE_ACTIVATION){
        draw_cards(player, 4);
    }
    return 0;
}

int card_mind_stone(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);     
    if(event == EVENT_ACTIVATE ){
        // Add AI code to sac this once we're past 6 lands
        int choice = 1;
        if( has_mana_multi(player, 2, 0, 0, 0, 0, 0) && ! is_tapped(player, card)){
            char buffer[50];
            sprintf(buffer, " Sac, Draw a Card\n Generate 1" );
            choice = do_dialog(player, player, card, -1, -1, buffer, 1);
        }
        if( choice == 0 ){
            tap_card(player, card);
            charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
            if( spell_fizzled != 1  ){
                instance->info_slot = 1;
                kill_card(player, card, KILL_SACRIFICE);
                draw_a_card(player);
                return 0;
            }
        }
        else{
            return mana_producer(player, card, event);
        }
    }
    return mana_producer(player, card, event);
}

int effect_illusionary_mask(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    card_instance_t *target = get_card_instance(player, instance->targets[0].card);
    
    int id = get_internal_card_id_from_csv_id( get_id_by_name("Face Down Creature") ); 
    target->internal_card_id = id;
    
    return 0;
}

int card_illusionary_mask(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.zone = TARGET_ZONE_HAND;
    td.allow_cancel = 0;   
    td.illegal_abilities = 0;
    if( event == EVENT_CAN_ACTIVATE && can_target(&td) && can_sorcery_be_played(player) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        select_target(player, card, &td, "Choose a card to play face down", NULL);
        if( spell_fizzled != 1 ){
            card_instance_t *target = get_card_instance( player, instance->targets[0].card );
            card_data_t card_d = cards_data[ target->internal_card_id ];    
            card_ptr_t* c = cards_ptr[ card_d.id ];
            int colorless = c->req_colorless;
            if(colorless == 40){ colorless = 0; }
            charge_mana_multi(player, colorless, c->req_black, c->req_blue, c->req_green, c->req_red, c->req_white);
            if( spell_fizzled != 1 ){
                // charge any extra
                charge_mana(player, COLOR_COLORLESS, -1);
            }
            instance->number_of_targets = 0;
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        //card_instance_t *parent = get_card_instance( instance->parent_controller, instance->parent_card );
        card_instance_t *target = get_card_instance( player, instance->targets[0].card );
        
        int effect_card = create_legacy_effect(player, card, &effect_illusionary_mask );
        card_instance_t *effect = get_card_instance( player, effect_card );
        effect->targets[0].card = instance->targets[0].card;
        
        target->info_slot = 1;
        target->targets[3].card = get_id(player, instance->targets[0].card);
        target->targets[3].player = effect_card;
        put_into_play(player, instance->targets[0].card);
        hand_count[player]--;
    }
    return 0;
}

int card_isochron_scepter  (int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);      
    if(event == EVENT_CAN_ACTIVATE){
        if( ! is_tapped(player, card) && ! is_animated_and_sick(player, card) && has_mana(player, COLOR_ANY, 2) ){
            return can_legally_play(player, instance->info_slot );
        }
    }
    else if(event == EVENT_ACTIVATE){
        tap_card( player, card);
        charge_mana(player, COLOR_COLORLESS, 2);
    }
    else if(event == EVENT_RESOLVE_ACTIVATION ){
        play_spell_for_free( player, cards_data[ instance->info_slot ].id  );
        rfg_card_from_grave(player, count_graveyard(player) - 1, -1 );
    }
    else if( comes_into_play(player, card, event) ){
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_INSTANT | TYPE_INTERRUPT );
        td.allowed_controller = player;
        td.preferred_controller = player;
        td.illegal_abilities = 0;
        td.zone = TARGET_ZONE_HAND;
        while( 1 ){
            char buffer[50];
            sprintf(buffer, "Choose an instant with CMC <= 2");
            if( select_target(player, card, &td, buffer, NULL) ){
                int cmc = get_cmc( player, instance->targets[0].card);
                if( cmc <= 2 ){
                    card_instance_t *target = get_card_instance( player, instance->targets[0].card );
                    instance->info_slot =  target->internal_card_id; 
                    kill_card( player, instance->targets[0].card, KILL_DESTROY );
                    rfg_card_from_grave(player, count_graveyard(player) - 1, -1 );
                    hand_count[player]--;
                    create_card_name_legacy(player, card, cards_data[ instance->info_slot ].id );
                    break;
                } 
            }
            else{
                break;
            }
        }
        instance->number_of_targets = 1;
    }
    return 0;
}

int card_couriers_capsule( int player, int card, event_t event){
    if(event == EVENT_CAN_ACTIVATE){
        if(is_animated_and_sick(player, card) || is_tapped(player, card)){
            return 0;
        }
        if( has_mana_multi( player, 1, 0, 1, 0, 0, 0 ) ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE){
        tap_card(player, card);
        charge_mana_multi( player, 1, 0, 1, 0, 0, 0 );
        if( spell_fizzled != 1 ){
            kill_card(player, card, KILL_SACRIFICE);
        }
        else{
            untap_card(player, card);
        }
    }
    else if(event == EVENT_RESOLVE_ACTIVATION){
        draw_cards(player, 2);
    }
    return 0;
}

int card_grafted_skullcap(int player, int card, event_t event){
     if(event == EVENT_DRAW_PHASE && current_turn == player){
        event_result++;
     }
     else if(eot_trigger(player, card, event) && current_turn == player){
        while(hand_count[player] > 0 ){
            discard(player, 1, 1);
        }
     }
    return 0;
}

int card_senseis_divining_top  (int player, int card, event_t event){
    if(event == EVENT_CAN_ACTIVATE){
        if(has_mana(player, COLOR_ANY, 1) ){
            return 1;
        }    
        else if( ! is_tapped(player, card) && ! is_animated_and_sick(player, card) ){
            return 1;
        }
        return 0;
    }
    else if(event == EVENT_ACTIVATE){
        int choice = 0;
        int tap_available = 0;
        if( ! is_tapped(player, card) && ! is_animated_and_sick(player, card) ){
            tap_available = 1;    
        }     
        if( tap_available && ! has_mana(player, COLOR_ANY, 1) && player != AI){
            choice = 1;
        }
        else if( tap_available && has_mana(player, COLOR_ANY, 1) ){
            char buffer[50];
            sprintf(buffer, " Rearrange top 3 cards.\n Draw a card and flip Top." );
            choice = do_dialog(player, player, card, -1, -1, buffer, choice);
        }
        
        card_instance_t *instance = get_card_instance(player, card);
        if( choice == 1 ){
            tap_card( player, card);
        }
        else{
            charge_mana( player, COLOR_COLORLESS, 1);
        }
        instance->info_slot = choice;
    }
    else if(event == EVENT_RESOLVE_ACTIVATION && spell_fizzled != 1){
        card_instance_t *instance = get_card_instance(player, card);
        if ( instance->info_slot == 1){
            draw_a_card(player);
            if( in_play(instance->parent_controller, instance->parent_card) ){
                put_on_top_of_deck(instance->parent_controller, instance->parent_card);
            }
        }
        else{
            rearrange_top_3(player, player, EVENT_RESOLVE_SPELL);
        }
    }
    return 0;
}


int card_chromatic_star  (int player, int card, event_t event)
{
  if(event == EVENT_CAN_ACTIVATE)
  {
    if( is_animated_and_sick(player, card) ){
        return 0;
    }
    if(has_mana(player, COLOR_ANY, 1) && !is_tapped(player, card))
      return 1;
  }
  else if(event == EVENT_ACTIVATE)
  {
    tap_card( player, card);
    charge_mana( player, COLOR_COLORLESS, 1);
    if( spell_fizzled != 1 ){
        kill_card( player, card, KILL_SACRIFICE);
        add_one_mana_any_color(player, card, event);
    }
    else{
        untap_card(player, card);
    }
  }
  else if(event == EVENT_GRAVEYARD_FROM_PLAY)
  {
    if( in_play(player, card) && affect_me( player, card) ){
      draw_a_card(player);
    }
  }
  return 0;
}

int card_chromatic_sphere(int player, int card, event_t event)
{
  if(event == EVENT_CAN_ACTIVATE)
  {
    if( is_animated_and_sick(player, card) ){
        return 0;
    }
    if( has_mana( player, COLOR_ANY, 1 ) && ! is_tapped( player, card ) )
      return 1;
  }
  else if(event == EVENT_ACTIVATE)
  {
    tap_card( player, card);
    charge_mana( player, COLOR_COLORLESS, 1);
    if( spell_fizzled != 1 ){
        kill_card( player, card, KILL_SACRIFICE);
        add_one_mana_any_color(player, card, event);
        draw_a_card(player);
    }
    else{
        untap_card(player, card);
    }
  }
  return 0;
}

int card_sphere_of_resistance(int player, int card, event_t event)
{
    if(event == EVENT_MODIFY_COST_GLOBAL ){
        card_data_t card_d = get_card_data(affected_card_controller, affected_card);
        if(! (card_d.type & TYPE_LAND) ){
            COST_COLORLESS++;
        }
    }
    return 1;
}

int card_helm_of_awakening(int player, int card, event_t event)
{
    if(event == EVENT_MODIFY_COST_GLOBAL ){
        card_data_t card_d = get_card_data(affected_card_controller, affected_card);
        if(! (card_d.type & TYPE_LAND) ){
            COST_COLORLESS--;
        }
    }
    return 1;
}

int card_thorn_of_amethyst(int player, int card, event_t event)
{
    if(event == EVENT_MODIFY_COST_GLOBAL ){
        card_data_t card_d = get_card_data(affected_card_controller, affected_card);
        if(! (card_d.type & TYPE_LAND) && ! (card_d.type & TYPE_CREATURE)){
            COST_COLORLESS++;
        }
    }
    return 1;
}

int card_chrome_mox(int player, int card, event_t event){
    if( comes_into_play(player, card, event) == 1 ){
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_INSTANT | TYPE_CREATURE | TYPE_INTERRUPT | TYPE_SORCERY | TYPE_ENCHANTMENT);
        td.allowed_controller = player;
        td.preferred_controller = player;
        td.illegal_abilities = 0;
        td.zone = TARGET_ZONE_HAND;

        if(!select_target(player, card, &td, "Choose a card to imprint", NULL)){
            spell_fizzled = 1;
            card_instance_t *instance = get_card_instance(player, card);
            cards_data[instance->internal_card_id].color = 0;
        }
        else{
            card_instance_t *instance, *target;
            instance = get_card_instance(player, card);
            
            target = get_card_instance(player, instance->targets[0].card);
            int id = target->internal_card_id;
            int color = cards_data[id].color;
            instance->info_slot = color;
            
            kill_card( player, instance->targets[0].card, KILL_DESTROY );
            rfg_card_from_grave(player, count_graveyard(player) - 1, -1 );
        }
    }
    return mana_producer(player, card, event);
}

int card_mox_diamond(int player, int card, event_t event){
    if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_LAND);
        td.allowed_controller = player;
        td.preferred_controller = player;
        td.zone = TARGET_ZONE_HAND;

        if(!select_target(player, card, &td, "Choose a land to discard", NULL)){
            kill_card(player, card, KILL_SACRIFICE);
        }
        else{
            card_instance_t *instance = get_card_instance(player, card);
            kill_card(instance->targets[0].player, instance->targets[0].card, KILL_DESTROY);
            hand_count[player]--;
        }
    }
    return mana_producer(player, card, event);
}

int card_springleaf_drum(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.illegal_state = TARGET_STATE_TAPPED;
    if( event == EVENT_CAN_ACTIVATE ){
        if(! target_available(player, card, &td) ){
            return 0;
        }
    }
    else if(event == EVENT_ACTIVATE){
        if(!select_target(player, card, &td, "Choose an untapped creature", NULL)){
            spell_fizzled = 1;
            return 0;
        }
    }
    int result = mana_producer(player, card, event);
    if( event == EVENT_ACTIVATE && spell_fizzled != 1 ){
        card_instance_t *instance = get_card_instance(player, card);
       tap_card(instance->targets[0].player, instance->targets[0].card); 
    }
    return result;
}

int card_scepter_of_fugue( int player, int card, event_t event){
    colored_artifact(player, card, event);
    if(event == EVENT_CAN_ACTIVATE){
        if( is_animated_and_sick(player, card) || is_tapped( player, card ) || current_turn != player ){
            return 0;
        }
        if( has_mana_multi( player, 1, 1, 0, 0, 0, 0 )  ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE){
        tap_card( player, card);
        charge_mana_multi( player, 1, 1, 0, 0, 0, 0 );
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_NONE);
        td.zone = TARGET_ZONE_PLAYERS;
        td.allow_cancel = 0;
        select_target(player, card, &td, "Choose Target Player", NULL);
    }
    else if(event == EVENT_RESOLVE_ACTIVATION){
        card_instance_t *instance = get_card_instance( player, card);
        card_instance_t *parent = get_card_instance(instance->parent_controller, instance->parent_card);
        discard( parent->targets[0].player, 0, 0);
    }
    return 0;
}

int card_door_to_nothingness( int player, int card, event_t event){
    if( comes_into_play(player, card, event) == 1 ){
        tap_card( player, card);
    }
    else if(event == EVENT_CAN_ACTIVATE){
        if( is_animated_and_sick(player, card) || is_tapped( player, card )  ){
            return 0;
        }
        if( has_mana_multi( player, 0, 2, 2, 2, 2, 2 )  ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE){
        tap_card( player, card);
        charge_mana_multi( player, 0, 2, 2, 2, 2, 2 );
        if( spell_fizzled != 1 ){
            kill_card(player, card, KILL_SACRIFICE);
        }
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_NONE);
        td.zone = TARGET_ZONE_PLAYERS;
        td.allow_cancel = 0;
        select_target(player, card, &td, "Choose Target Player", NULL);
    }
    else if(event == EVENT_RESOLVE_ACTIVATION){
        card_instance_t *instance = get_card_instance( player, card);
        card_instance_t *parent = get_card_instance(instance->parent_controller, instance->parent_card);
        if( count_cards_by_id(parent->targets[0].player, get_id_by_name("Platinum Angel")) < 1 ){
           lose_the_game( parent->targets[0].player );
        }
    }
    return 0;
}

int effect_tower_of_coireall(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_BLOCK_LEGALITY ){
        if( instance->targets[0].player == attacking_card_controller && instance->targets[0].card == attacking_card ){
            if( has_creature_type(affected_card_controller, affected_card, SUBTYPE_WALL) ){
                event_result = 1;
            }
        }
    }
    else if( eot_trigger(player, card, event) ){
        kill_card(player, card, KILL_REMOVE);
    }
    return 0;
}

int card_tower_of_coireall(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.preferred_controller = player;
    if( event == EVENT_CAN_ACTIVATE ){
        if( ! is_tapped(player, card) && ! is_animated_and_sick(player, card) && target_available(player, card, &td) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        if( !select_target(player, card, &td, "Select target creature", NULL) ){
            spell_fizzled = 1;
        }
        else {
            tap_card(player, card);
            instance->number_of_targets = 1;
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( in_play(instance->targets[0].player, instance->targets[0].card) ){
            int legacy_card = create_targetted_legacy_effect(player, card, &effect_tower_of_coireall, instance->targets[0].player, instance->targets[0].card);
            card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
            legacy_instance->targets[0].player = instance->targets[0].player;
            legacy_instance->targets[0].card = instance->targets[0].card;
        }
    }
    return 0;
}

int card_standing_stones(int player, int card, event_t event){
    if( event == EVENT_CAN_ACTIVATE ){
        if( life[player] > 0 && has_mana(player, COLOR_ANY, 1) && !is_tapped(player, card) && !is_animated_and_sick(player, card) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_COLORLESS, 1);
        if( spell_fizzled == 1 ){ return 0; }
        add_one_mana_any_color(player, card, event);
        if( spell_fizzled == 1 ){ return 0; }
        tap_card(player, card);
        life[player] -= 1;
    }
    return 0;
}

int card_skull_of_orm(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    int *grave = graveyard_ptr[player];
    if( event == EVENT_CAN_ACTIVATE ){
        if( count_graveyard_by_type(player, TYPE_ENCHANTMENT) > 0 && has_mana(player, COLOR_ANY, 5) && !is_tapped(player, card) && !is_animated_and_sick(player, card) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_COLORLESS, 5);
        if( spell_fizzled == 1 ){ return 0; }
        int selected = -1;
        while( selected == -1 ){
            selected = show_deck( player, graveyard_ptr[player], 500, "Pick an enchantment card", 0, 0x7375B0 );
            if( selected != -1 ){
                if( !(cards_data[ grave[selected] ].type & TYPE_ENCHANTMENT) ){
                    selected = -1;
                }
            }
        }
        tap_card(player, card);
        instance->targets[0].player = player;
        instance->targets[0].card = grave[selected];
        instance->info_slot = selected;
        instance->number_of_targets = 1;
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( instance->targets[0].card == grave[ instance->info_slot ] ){
            add_card_to_hand(player, instance->targets[0].card);
            hand_count[player]++;
            int i;
            for( i=instance->info_slot; i<count_graveyard(player); i++ ){
                grave[i] = grave[i+1];
            }
        }
    }
    return 0;
}

int card_necropolis(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE ){
        if( count_graveyard_by_type(player, TYPE_CREATURE) > 0 ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        int card_added = -1;
        while( card_added == -1 ){
            card_added = select_card_from_graveyard(player, card, player, TYPE_CREATURE);
        }
        rfg_card_from_grave(player, instance->info_slot, card_added);
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int i;
        card_instance_t *parent = get_card_instance(instance->parent_controller, instance->parent_card);
        for( i=0; i<get_cmc(player, instance->targets[0].card); i++ ){
            parent->special_counters++;
            parent->counter_toughness++;
        }
    }
    return 0;
}

int card_living_armor(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.preferred_controller = player;    
    if( event == EVENT_CAN_ACTIVATE ){
        if( !is_tapped(player, card) && !is_animated_and_sick(player, card) && target_available(player, card, &td) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        if( !select_target(player, card, &td, "Select target creature.", NULL) ){
            spell_fizzled = 1;
        }
        else{
            tap_card(player, card);
            kill_card(player, card, KILL_SACRIFICE);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *target = get_card_instance(instance->targets[0].player, instance->targets[0].card);
        int i;
        for( i=0; i<get_cmc(instance->targets[0].player, instance->targets[0].card); i++ ){
            target->counters++;
            target->counter_toughness++;
        }
    }
    return 0;
}

int effect_scarecrow(int player, int card, event_t event){
    if( event == EVENT_PREVENT_DAMAGE ){
        card_instance_t *affected = get_card_instance(affected_card_controller, affected_card);
        if( affected->internal_card_id == damage_card ){
            if( get_abilities(affected->damage_source_player, affected->damage_source_card, 52, -1) & KEYWORD_FLYING && affected->damage_target_player == player && affected->damage_target_card == -1 && affected->info_slot > 0 ){
                affected->info_slot = 0;
            }
        }
    }
    else if( eot_trigger(player, card, event) ){
        kill_card(player, card, KILL_SACRIFICE);
    }
    return 0;
}

int card_scarecrow(int player, int card, event_t event){
    if( event == EVENT_CAN_ACTIVATE ){
        if( has_mana(player, COLOR_ANY, 6) && !is_tapped(player, card) && !is_sick(player, card) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_COLORLESS, 6);
        if( spell_fizzled == 1 ){ return 0; }
        tap_card(player, card);
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        create_legacy_effect(player, card, &effect_scarecrow);
    }
    return 0;
}

int card_reflecting_mirror(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE ){
        if( !is_tapped(player, card) && !is_animated_and_sick(player, card) ){
            int p;
            int c;
            for( p=0; p<2; p++ ){
                for( c=0; c<active_cards_count[p]; c++ ){
                    card_data_t card_d = get_card_data(p, c);
                    card_instance_t *spell_instance = get_card_instance(p, c);
                    if( (card_d.type & TYPE_INTERRUPT || card_d.type & TYPE_INSTANT || card_d.type & TYPE_SORCERY) && spell_instance->number_of_targets == 1 && spell_instance->targets[0].player == player && spell_instance->targets[0].card == -1 ){
                        int other_mirrors_targeting_p_c = 0;
                        int z;
                        for( z=0; z<active_cards_count[player]; z++ ){
                            card_instance_t *another_rm = get_card_instance(player, z);
                            if( in_play(player, z) && get_id(player, z) == 354 && another_rm->targets[1].player == p && another_rm->targets[1].card == c && another_rm->number_of_targets == 2 ){
                                other_mirrors_targeting_p_c++;
                            }
                        }
                        if( other_mirrors_targeting_p_c == 0 ){
                            if( has_mana(player, COLOR_ANY, 2*get_cmc(p, c)) ){
                                instance->targets[1].player = p;
                                instance->targets[1].card = c;
                                instance->number_of_targets = 1;
                                instance->info_slot = get_cmc(p, c);
                                return 1;
                            }
                        }
                    }
                }
            }
        }
    }
    else if( event == EVENT_ACTIVATE ){
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.zone = TARGET_ZONE_PLAYERS;
        charge_mana(player, COLOR_COLORLESS, 2*instance->info_slot);
        if( spell_fizzled == 1 ){ return 0; }
        if( !select_target(player, card, &td, "Select player to become the target of target spell.", NULL) ){
            spell_fizzled = 1;
        }
        if( spell_fizzled != 1 ){
            tap_card(player, card);
            instance->number_of_targets = 2;
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *spell_instance = get_card_instance(instance->targets[1].player, instance->targets[1].card);
        spell_instance->targets[0].player = instance->targets[0].player;
        spell_instance->targets[0].card = instance->targets[0].card;
    }
    return 0;
}

int effect_runesword(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( affect_me(instance->targets[0].player, instance->targets[0].card) ){
        if( event == EVENT_POWER ){
            event_result += 2;
        }
    }
    else if( event == EVENT_DEAL_DAMAGE ){
        card_instance_t *damage = get_card_instance(affected_card_controller, affected_card);
        if( damage->internal_card_id == damage_card ){
            if( damage->damage_target_card != -1 && damage->damage_source_player == instance->targets[0].player && damage->damage_source_card == instance->targets[0].card && damage->info_slot > 0 ){
                int effect = create_legacy_effect_exe(instance->targets[1].player, instance->targets[1].card, LEGACY_EFFECT_DISINTEGRATE, damage->damage_target_player, damage->damage_target_card);
                card_instance_t *effect_instance = get_card_instance(damage->damage_target_player, effect);
                effect_instance->token_status = 0x800000;
                card_instance_t *target_instance = get_card_instance(damage->damage_target_player, damage->damage_target_card);
                target_instance->regen_status = 0x8000000;
            }
        }
    }
    if( eot_trigger(player, card, event) ){
        kill_card(player, card, KILL_REMOVE);
    }
    return 0;
}

int card_runesword(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.preferred_controller = player;
    td.required_state = TARGET_STATE_ATTACKING;
    if( event == EVENT_CAN_ACTIVATE ){
        if( has_mana(player, COLOR_ANY, 3) && !is_tapped(player, card) && !is_animated_and_sick(player, card) && target_available(player, card, &td) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_COLORLESS, 3);
        if( spell_fizzled == 1 ){ return 0; }
        if( !select_target(player, card, &td, "Select target attacking creature", NULL) ){
            spell_fizzled = 1;
        }
        if( spell_fizzled != 1 ){
            tap_card(player, card);
            instance->number_of_targets = 1;
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int legacy_card = create_targetted_legacy_effect(player, card, &effect_runesword, instance->targets[0].player, instance->targets[0].card);
        card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
        legacy_instance->targets[0].player = instance->targets[0].player;
        legacy_instance->targets[0].card = instance->targets[0].card;
        legacy_instance->targets[1].player = player;
        legacy_instance->targets[1].card = card;
    }
    if( leaves_play(instance->targets[0].player, instance->targets[0].card, event) ){
        kill_card(player, card, KILL_SACRIFICE);
    }
    return 0;
}

int effect_dark_sphere(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_DEAL_DAMAGE ){
        card_instance_t *damage = get_card_instance(affected_card_controller, affected_card);
        if( damage->internal_card_id == damage_card ){
            if( damage->damage_target_card == -1 && damage->damage_source_player == instance->targets[0].player && damage->damage_source_card == instance->targets[0].card && damage->info_slot > 0 ){
                damage->info_slot = (damage->info_slot + 1) >> 1;
                kill_card(player, card, KILL_REMOVE);
            }
        }
    }
    if( eot_trigger(player, card, event) ){
        kill_card(player, card, KILL_REMOVE);
    }
    return 0;
}

int card_dark_sphere(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t damage_source;
    default_target_definition(player, card, &damage_source, TYPE_ANY);
    damage_source.illegal_abilities = 0;
    if( comes_into_play(player, card, event) ){
        instance->targets[0].player = -1;
        instance->targets[0].card = -1;
        instance->number_of_targets = 0;
        instance->info_slot = -1;
    }
    if( event == EVENT_CAN_ACTIVATE ){
        if( !is_tapped(player, card) && !is_animated_and_sick(player, card) ){
            int p;
            int c;
            for( p=0; p<2; p++ ){
                for( c=0; c<active_cards_count[p]; c++ ){
                    card_instance_t *spell_instance = get_card_instance(p, c);
                    if( !in_hand(p, c) && spell_instance->number_of_targets > 0 ){
                        int z;
                        for( z=0; z<spell_instance->number_of_targets; z++ ){
                            if( spell_instance->targets[z].player == player && spell_instance->targets[z].card == -1 ){
                                instance->targets[0].player = p;
                                instance->targets[0].card = c;
                                instance->number_of_targets = 1;
                                return 1;
                            }
                        }
                    }
                }
            }
            if( target_available(player, card, &damage_source) ){
                return 1;
            }
        }
    }
    else if( event == EVENT_ACTIVATE ){
        int choice;
        if( instance->targets[0].player == -1 && instance->targets[0].card == -1 ){
            choice = 1;
        }
        else {
            if( !target_available(player, card, &damage_source) ){
                choice = 0;
            }
            else {
                choice = do_dialog(player, player, card, -1, -1, "Choose damage source\n Spell on stack\n Permanent in play\n Cancel", 0);
            }
        }
        if( choice == 2 ){
            spell_fizzled = 1;
        }
        else if( choice == 1){
            if( !select_target(player, card, &damage_source, "Select target permanent.", NULL) ){
                spell_fizzled = 1;
            }
            instance->number_of_targets = 1;
        }
//        else if( choice == 0 ){
//            life[player] += 10;
//        }
        if( spell_fizzled != 1 ){
            instance->info_slot = choice;
            tap_card(player, card);
            kill_card(player, card, KILL_SACRIFICE);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *parent = get_card_instance(instance->parent_controller, instance->parent_card);
        if( parent->info_slot == 1 ){
            if( validate_target(player, card, &damage_source, 0) ){
                int legacy_card = create_targetted_legacy_effect(player, card, &effect_dark_sphere, parent->targets[0].player, parent->targets[0].card);
                card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
                legacy_instance->targets[0].player = parent->targets[0].player;
                legacy_instance->targets[0].card = parent->targets[0].card;
                legacy_instance->number_of_targets = 1;
            }
        }
        else if( parent->info_slot == 0 ){
            int legacy_card = create_legacy_effect(player, card, &effect_dark_sphere);
            card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
            legacy_instance->targets[0].player = parent->targets[0].player;
            legacy_instance->targets[0].card = parent->targets[0].card;
            legacy_instance->number_of_targets = 1;
        }
    }
    return 0;
}

int card_triassic_egg(int player, int card, event_t event){
card_instance_t *instance = get_card_instance( player, card);

    if( event == EVENT_CAN_ACTIVATE){
        if( has_mana_multi(player, 3, 0, 0, 0, 0, 0) && ! is_tapped(player, card) && ! is_animated_and_sick(player, card) ){
            return 1;
        }
        else if(count_counters(player, card) > 1){
                return 1;
        }
        else{
            return 0;
        }
    }
    
    else if( event == EVENT_ACTIVATE && affect_me(player, card)){
            if(player == AI){
               if(count_counters(player, card) < 2){
                  if( has_mana_multi(player, 3, 0, 0, 0, 0, 0) && ! is_tapped(player, card) && ! is_animated_and_sick(player, card) ){       
                    charge_mana_multi(player, 3, 0, 0, 0, 0, 0);
                    add_counter(player, card);
                    tap_card(player, card);
                  }
               }
               if( count_graveyard_by_type(player, TYPE_CREATURE) > 0 && count_counters(player, card) > 1){
                  int *graveyard = graveyard_ptr[player];
                  int max_cmc = -1;
                  int max_index = -1;
                  int i;
                  for(i = 0; i < 61; i++){
                      if( (graveyard[i] != -1) && (cards_data[  graveyard[i] ].type & TYPE_CREATURE) ){
                         int cmc = cards_data[  graveyard[i] ].cc[0] + cards_data[  graveyard[i] ].cc[1];
                         if( cmc > max_cmc ){
                            max_cmc = cmc;
                            max_index = i;
                         } 
                      } 
                  } 
                  instance->targets[7].card = max_index; 
                  instance->targets[8].card = graveyard[max_index]; 
                  instance->targets[9].player = 2; 
                  instance->targets[10].player = 1;
                  kill_card(player, card, KILL_SACRIFICE);
               }
            }

      else{
       if( has_mana_multi(player, 3, 0, 0, 0, 0, 0) && ! is_tapped(player, card) && ! is_animated_and_sick(player, card) ){
          instance->info_slot = 1;
       }
       if(count_counters(player, card) > 1){
          if(instance->info_slot == 1){
             instance->info_slot = 3;
          }
          else{
               instance->info_slot = 2;
          }
       }

       if(instance->info_slot == 3){
          int choice = do_dialog(player, player, card, -1, -1, " Add counter\n Open the egg\n Cancel", 1);
          instance->targets[10].player = choice;

          if(instance->targets[10].player == 0 ){
             instance->info_slot = 1;
          }

          if(instance->targets[10].player == 1 ){
             instance->info_slot = 2;
          }
  
          if(instance->targets[10].player == 2 ){
             instance->info_slot = 0;
          }
       }

       if(instance->info_slot == 2){
          remove_counter(player, card);
          remove_counter(player, card);
          int choice2 = do_dialog(player, player, card, -1, -1, " From hand\n From graveyard\n No creature", 1);
          instance->targets[10].player = choice2;

          if(instance->targets[10].player == 0 && hand_count[player] > 0){
             target_definition_t td;
             default_target_definition(player, card, &td, TYPE_CREATURE);
             td.zone = TARGET_ZONE_HAND;
             td.illegal_abilities = 0;
             td.allowed_controller = player;
             td.preferred_controller = player;
             td.who_chooses = player; 
             int choice = select_target(player, card, &td, "Choose a permanent to put into play", NULL);
             if( !(choice > 0) ){ 
               instance->targets[10].player = 2;
             }
             else{
                  instance->targets[9].player = 2; 
                  kill_card(player, card, KILL_SACRIFICE);
             }
          }
          else if(instance->targets[10].player == 1 && count_graveyard(player) > 0){
                  int *grave = graveyard_ptr[player]; 
                  int selected;             
                  selected = show_deck( player, graveyard_ptr[player], 500, "Pick a card", 0, 0x7375B0 );
                  if( selected != -1){
                     if( cards_data[ grave[selected] ].type & TYPE_CREATURE ){
                        instance->targets[7].card = selected; 
                        instance->targets[8].card = grave[selected]; 
                        instance->targets[9].player = 2; 
                        kill_card(player, card, KILL_SACRIFICE);
                     }
                     else {
                          instance->info_slot = 2;
                     }
                  }
                  else {
                        instance->info_slot = 2;
                  }
          }
          else {
                instance->info_slot = 0;
                kill_card(player, card, KILL_SACRIFICE);
          }
       }

       if(instance->info_slot == 1){
          charge_mana_multi(player, 3, 0, 0, 0, 0, 0);
          if( spell_fizzled == 1 ){
             instance->info_slot = 0;
          }
          else{
               tap_card(player, card);
               add_counter(player, card);
               instance->info_slot = 0;
          }
       }
   }
 }
  else if( event == EVENT_RESOLVE_ACTIVATION ){

     if(instance->targets[9].player == 2 && instance->targets[10].player == 0){
        put_into_play(player, instance->targets[0].card);
        hand_count[player]--;
        
     }

     if(instance->targets[9].player == 2 && instance->targets[10].player == 1){
        int card_added = add_card_to_hand(player, instance->targets[8].card );
        remove_card_from_grave(player, instance->targets[7].card);
        put_into_play( player, card_added );
     }
 }

    return 0;
}

int card_voodoo_doll( int player, int card, event_t event){
card_instance_t *instance = get_card_instance( player, card);

  if( player == current_turn && trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
     if(event == EVENT_TRIGGER){
        event_result |= RESOLVE_TRIGGER_MANDATORY;
     }
     else if(event == EVENT_RESOLVE_TRIGGER){
             add_counter(player, card);
     }
   }

  else if(event == EVENT_CAN_ACTIVATE){
          int k = count_counters(player, card) * 2;  
          if( has_mana_multi( player, k, 0, 0, 0, 0, 0 )  ){
             return 1;
          }
  }

  else if(event == EVENT_ACTIVATE){
          int k = count_counters(player, card) * 2;
          tap_card( player, card);
          charge_mana_multi( player, k, 0, 0, 0, 0, 0 );
          if( spell_fizzled != 1 ){
             instance->number_of_targets = 1;
             target_definition_t td1;
             default_target_definition(player, card, &td1, TYPE_CREATURE );
             td1.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
             td1.allow_cancel = 0;
             select_target(player, card, &td1, "Select target creature or player", NULL);
             instance->number_of_targets = 1;
          }
  }

  else if(event == EVENT_RESOLVE_ACTIVATION){
        damage_creature_or_player(player, card, event, count_counters(player, card), 3);
  }


  else if( player == current_turn && trigger_condition == TRIGGER_EOT && affect_me(player, card) && !(is_tapped(player, card)) && count_counters(player, card) > 0){
          if(event == EVENT_TRIGGER){
             event_result |= RESOLVE_TRIGGER_MANDATORY;
          }
          else if(event == EVENT_RESOLVE_TRIGGER){
                  damage_player(player, count_counters(player, card), player, card);
                  kill_card(player, card, KILL_DESTROY);
          }
  }


    return 0;
}

int card_ironworks( int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_ARTIFACT);
  td.allowed_controller = player;
  td.preferred_controller = player;
  td.illegal_abilities = 0;

  if(event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( target_available(player, card, &td) > 0){
        return 1;
     }
  }

  else if(event == EVENT_ACTIVATE && affect_me(player, card)){
          pick_target(&td, "TARGET_ARTIFACT");
          if( valid_target(&td) ){
             kill_card(instance->targets[0].player, instance->targets[0].card, KILL_SACRIFICE);
             instance->info_slot = 66;
          }
  }
 
  else if(event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66 ){
          produce_mana(player, 0, 2);
          instance->info_slot = 0;
  }

  return 0;
}

int card_myr_incubator( int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);

  if(event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( !(is_animated_and_sick(player, card)) && !(is_tapped( player, card )) ){  
        if( has_mana_multi(player, 6, 0, 0, 0, 0, 0) ){ 
            return 1;
        }
     }
  }

  if(event == EVENT_ACTIVATE && affect_me(player, card) ){
     tap_card( player, card);
     charge_mana_multi(player, 6, 0, 0, 0, 0, 0);
     if( spell_fizzled != 1 ){
        kill_card(player, card, KILL_SACRIFICE);
        instance->targets[10].card = 66;
     }
  }

  if(event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->targets[10].card == 66){
     int i;
     int *deck = deck_ptr[player];
     int myr = 0;

     for(i=0;i<1;i++){
         int selected = pick_card_from_deck(player);
         if( selected != -1 && cards_data[ deck[selected] ].type & TYPE_ARTIFACT ){
            remove_card_from_deck( player, selected );
            myr++;
            i--;
         }
     }
     
     if( myr > 0 ){
        i = 0;
        for(i=0; i<myr; i++){
            generate_token (player, "Metallic Sliver");
        }
     }
  }

  return 0;
}

int card_time_sieve(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_ARTIFACT);
  td.allowed_controller = player;
  td.preferred_controller = player;
  td.allow_cancel = 0;
  td.illegal_abilities = 0;

  colored_artifact(player, card, event);

  if(event == EVENT_CAN_CAST && affect_me(player, card) ){
     return 1;
  }

  if(event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_tapped(player, card)) ){
     if( !(is_animated_and_sick(player, card)) && target_available(player, card, &td) > 4){
        return 1;
     }
  }

  else if(event == EVENT_ACTIVATE && affect_me(player, card) ){
          tap_card(player, card);
          int count = 4;
          int targets = 0;
          while( count > -1){
                pick_target(&td, "TARGET_ARTIFACT");
                if( valid_target(&td) ){
                   targets++;
                   instance->targets[count].player = instance->targets[0].player;
                   instance->targets[count].card = instance->targets[0].card;
                   card_instance_t *target = get_card_instance( player, instance->targets[0].card );
                   target->state |= STATE_CANNOT_TARGET;
                }
                count--;
          }

          count = targets-1;
          if(count > -1){
             while( count > -1){
                   card_instance_t *target = get_card_instance( player, instance->targets[count].card );
                   target->state &= ~STATE_CANNOT_TARGET;
                   count--;
             }
          }

          if(targets == 5 ){         
             instance->info_slot = 66;
          }
  }

  else if(event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
          int count = 4;
          while( count > -1){
                kill_card(instance->targets[count].player, instance->targets[count].card, KILL_SACRIFICE);
                count--;
          }
          instance->info_slot = 0;
          return card_time_walk(player, card, EVENT_RESOLVE_SPELL);
  }

  return 0;
}
