#include "manalink.h"

int card_phyrexian_negator(int player, int card, event_t event){
  if( ! is_unlocked(player, card, event, 33) ){ 
        kill_card(player, card, KILL_SACRIFICE);
        return 0; 
    }
    
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_DEAL_DAMAGE && instance->info_slot != current_phase ){
        card_instance_t *damage= get_card_instance( affected_card_controller, affected_card);
        if( damage->internal_card_id == damage_card ){
            if( damage->damage_target_card == card && damage->damage_target_player == player && damage->info_slot > 0 ){
                int i;
                int p = player;
                target_definition_t td;
                default_target_definition(player, card, &td, TYPE_PERMANENT);
                td.allowed_controller = p;
                td.preferred_controller = p;
                td.who_chooses = p;
                td.illegal_abilities = 0;
                td.allow_cancel = 0;
                for( i=0;i<damage->info_slot;i++){
                    if( target_available(player, card, &td) ){
                        select_target(player, card, &td, "Choose a permanent to sacrifice", NULL);
                        int target = instance->targets[0].card;
                        kill_card( p, target, KILL_SACRIFICE );
                    }
                }
                instance->info_slot = current_phase;
            }
        }
    }
    else if( instance->info_slot != -1 && eot_trigger(player, card, event) ){
        instance->info_slot = -1;
    }
    
    return 0;
}

int card_vampire_nocturnus(int player, int card, event_t event){
    reveal_top_card(player, card, event);
    int* deck = deck_ptr[player];
    card_data_t card_d = cards_data[ deck[0] ];    
    if( in_play(player, card) && ( card_d.color & COLOR_TEST_BLACK) && ! (card_d.type & TYPE_LAND)   ){
        boost_creature_type(player, card, event, SUBTYPE_VAMPIRE, 2, 1, KEYWORD_FLYING, BCT_CONTROLLER_ONLY | BCT_INCLUDE_SELF);
    }
    return 0;
}

int card_golgari_thug(int player, int card, event_t event){
    if(event == EVENT_GRAVEYARD_FROM_PLAY){
        if( affect_me( player, card) && in_play(player, card) ){
            card_instance_t *instance = get_card_instance( player, card);
            if(instance->kill_code != KILL_REMOVE  ){
                if( count_graveyard_by_type(player, TYPE_CREATURE) > 0 ){
                    select_card_from_graveyard(player, card, 0, TYPE_CREATURE );
                    put_on_top_of_deck(instance->targets[0].player, instance->targets[0].card);
                }
            }
        }
    }
    else if( event == EVENT_GRAVEYARD_ABILITY ){
        return 4;
    }
    return 0;
}

int card_stinkweed_imp(int player, int card, event_t event){
    deathtouch(player, card, event);
    if( event == EVENT_GRAVEYARD_ABILITY ){
        return 5;
    }
    return 0;
}

int card_ichorid(int player, int card, event_t event){
    haste(player, card);
    if( event == EVENT_GRAVEYARD_ABILITY_UPKEEP ){
        int found = 0;
        int *graveyard = graveyard_ptr[player];
        int i;
        for(i=0;i<count_graveyard(player);i++){
            if(graveyard[i] != -1 && ( cards_data[  graveyard[i] ].color & COLOR_TEST_BLACK ) && ( cards_data[  graveyard[i] ].type & TYPE_CREATURE ) ){
                found++;
            }
        }
        if( found > 1 ){
            int choice = do_dialog(player, player, card, -1, -1," Return Ichorid\n Do not return Ichorid\n", 0);
            if( choice == 0 ){
                // first remove ichorid from the grave
                for(i=0;i<count_graveyard(player);i++){
                    if( cards_data[  graveyard[i] ].id == 691 ){
                        remove_card_from_grave(player, i);
                        break;
                    }
                }
                
                // choose a black dude to remove
                while(1){
                    int selected = show_deck( player, graveyard, 500, "Pick a card", 0, 0x7375B0 );
                    if( selected != -1){
                        if ( ( cards_data[  graveyard[selected] ].color & COLOR_TEST_BLACK ) && ( cards_data[ graveyard[selected] ].type & TYPE_CREATURE )   ){
                            rfg_card_from_grave(player, selected, -1);
                            
                            // put ichorid into play
                            put_into_play(player, card);     
                            
                            return -1;
                        }
                    }
                }
                
                 
            }
        }
        return -2;
    }
    else if( eot_trigger(player, card, event ) ){
        kill_card(player, card, KILL_SACRIFICE);
    }
    return 0;
}

int card_street_wraith(int player, int card, event_t event){
    if( ! is_unlocked(player, card, event, 14) ){ return 0; }
    int result = cycling(player, card, event, 0, 0, 0, 0, 0, 0);
    if( event == EVENT_ACTIVATE_FROM_HAND && spell_fizzled != 1 ){
        life[player]-=2;
    }
    return result;
}

int card_shriekmaw(int player, int card, event_t event){
    fear(player, card, event);
    
    if(comes_into_play(player, card, event) == 1 ){
        card_instance_t *instance = get_card_instance(player, card);
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE );
        td.illegal_color = COLOR_TEST_BLACK;
        td.illegal_type = TYPE_ARTIFACT;
        td.allow_cancel = 0;
        if( target_available(player, card, &td) ){
            select_target(player, card, &td, "Select target creature", NULL);
            kill_card( instance->targets[0].player, instance->targets[0].card, KILL_DESTROY );
        }
        
        if( instance->targets[9].card == 1 ){
            kill_card(player, card, KILL_SACRIFICE);
        }
    }
    evoke(player, card, event, 3);
    return 0;
}

int card_cemetery_reaper(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if(event == EVENT_CAN_ACTIVATE){
        if( count_graveyard_by_type(AI, TYPE_CREATURE) > 0
            || count_graveyard_by_type(HUMAN, TYPE_CREATURE) > 0 )
        {
            if( has_mana_multi(player, 2, 1, 0, 0, 0, 0 ) && ! is_tapped(player, card) && ! is_sick(player, card) ){
                return 1;
            }
        }
    }
    else if(event == EVENT_ACTIVATE){
        charge_mana_multi(player, 2, 1, 0, 0, 0, 0 );
        if( spell_fizzled == 1 ){
            return 0;
        }
        tap_card(player, card);
        int mine_ok = 0;
        int choice = 0;
        if( count_graveyard_by_type(player, TYPE_CREATURE) > 0 ){
            mine_ok = 1;
        }
        if( count_graveyard_by_type(1-player, TYPE_CREATURE) > 0 ){
            if( mine_ok == 0 ){
                choice = 1;
            }
            else{
                choice = do_dialog(player, player, card, -1, -1, " From My Grave\n From Opponent's Grave", 0);
            }
        }
        if( player == AI ){ choice = 1-choice; }
        if( select_card_from_graveyard(player, card, choice, TYPE_CREATURE ) == -1 ){
            untap_card(player, card);
            spell_fizzled = 1;
        }
    }
    else if(event == EVENT_RESOLVE_ACTIVATION){
        remove_card_from_grave(instance->targets[1].player, instance->info_slot);
        generate_token( player, "Zombie");
    }
    else if( affected_card_controller == player && has_creature_type(player, affected_card, SUBTYPE_ZOMBIE ) && ! affect_me(player, card) ){
        if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
            event_result++;
        }
    }
    return 0;
}

int card_swamp_mosquito(int player, int card, event_t event){
    if( event == EVENT_DECLARE_BLOCKERS ){
        if( is_unblocked(player, card) ){
            poison_counters[1-player]++;
        }
    }
    return 0;
}

int card_suqata_assassin(int player, int card, event_t event){
    fear(player, card, event);
    return card_swamp_mosquito(player, card, event);
}

int card_graveborn_muse(int player, int card, event_t event){
    if( player == current_turn && trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
        if(event == EVENT_TRIGGER){
            event_result |= RESOLVE_TRIGGER_MANDATORY;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            target_definition_t td;
            default_target_definition(player, card, &td, TYPE_CREATURE);
            td.required_subtype = SUBTYPE_ZOMBIE;
            td.allowed_controller = player;
            td.preferred_controller = player;
            int count = target_available(player, card, &td);
            life[player] -= count;
            draw_cards(player, count);
        }
    }
    return 0;
}

int card_undead_warchief(int player, int card, event_t event){
    if(!has_creature_type(affected_card_controller, affected_card, SUBTYPE_ZOMBIE )){
        return 0;
    }
    if( affected_card_controller != player){
        return 0;
    }
    if( ! in_play(player, card) ){
        return 0;
    }
    
    if(event == EVENT_MODIFY_COST_GLOBAL ){
        COST_COLORLESS--;
    }
    else if( event == EVENT_POWER ){
        event_result += 2;
    }
    else if(event == EVENT_TOUGHNESS ){
        event_result++;
    }
    return 0;
}

int card_zombie_master(int player, int card, event_t event){
    if( event == EVENT_ABILITIES && affect_me(player, card )){
        return 0;
    }
    return card_zombie_master_exe(player, card, event);
}


int card_lord_of_the_undead(int player, int card, event_t event){
     card_instance_t *instance = get_card_instance(player, card);
     if( event == EVENT_CAN_ACTIVATE ){
        if(has_mana_multi(player, 1, 1, 0, 0, 0, 0) && ! is_tapped(player, card) && ! is_sick(player, card) ){
            int *graveyard = graveyard_ptr[player];
            int i;
            for(i = 0; i < 500; i++){
                card_data_t card_d = cards_data[ graveyard[i] ];
                card_ptr_t* c = cards_ptr[card_d.id];
                if(graveyard[i] != -1 && ( c->subtype1 == SUBTYPE_ZOMBIE || c->subtype2 == SUBTYPE_ZOMBIE )){
                    return 1;
                }
            }
        }
    }      
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 1, 0, 0, 0, 0);
        tap_card(player, card);
        if( spell_fizzled != 1 ){
            while(1){
                int *grave = graveyard_ptr[player];
                int selected = show_deck( player, grave, 500, "Pick a Zombie card", 0, 0x7375B0 );
                if( selected != -1){
                    card_data_t card_d = cards_data[ grave[selected] ];
                    card_ptr_t* c = cards_ptr[card_d.id];
                    if( c->subtype1 == SUBTYPE_ZOMBIE || c->subtype2 == SUBTYPE_ZOMBIE ){
                        int card_added =  add_card_to_hand(player, grave[selected] );
                        instance->targets[0].player = player;
                        instance->targets[0].card = card_added;
                        instance->number_of_targets = 1;
                        instance->info_slot = selected;
                
                        card_instance_t *target = get_card_instance(player, card_added);
                        target->state |= STATE_INVISIBLE;
                    
                        break;
                    }
                }
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *parent = get_card_instance( instance->parent_controller, instance->parent_card  );  
        remove_card_from_grave(player, instance->info_slot);
        card_instance_t *target = get_card_instance(parent->targets[0].player, parent->targets[0].card);
        target->state &= ~STATE_INVISIBLE;
        hand_count[player]++;
    }    
    
    if(!has_creature_type(affected_card_controller, affected_card, SUBTYPE_ZOMBIE )){
        return 0;
    }
    if( affect_me(player, card) ){
        return 0;
    }
    else if( event == EVENT_POWER || event == EVENT_TOUGHNESS  ){
        event_result ++;
    }
    return 0;
}

int card_spirit_of_the_night(int player, int card, event_t event){
    check_legend_rule(player, card, event);
    pro_black(player, card, event);
    haste(player, card);
    if( event == EVENT_ABILITIES ){
        if( ! affect_me(player, card) ){ return 0; }
        card_instance_t *affected = get_card_instance(player, card);
        if( affected->state & STATE_ATTACKING  ){
            event_result |= KEYWORD_FIRST_STRIKE;
        }
    }
    return 0;
}

int card_priest_of_gix(int player, int card, event_t event){
  STANDARD_CIP_CHECK;

  if(event == EVENT_TRIGGER)
    event_result |= 2;
  else if(event == EVENT_RESOLVE_TRIGGER)
    produce_mana(player, COLOR_BLACK, 3);

  return 0;
}

int card_nightscape_familiar(int player, int card, event_t event){
    if(event == EVENT_MODIFY_COST_GLOBAL && affected_card_controller == player ){
        card_instance_t *instance = get_card_instance( affected_card_controller, affected_card);      
        if(  affected_card_controller == player && ((instance->card_color & COLOR_TEST_RED) || (instance->card_color & COLOR_TEST_BLUE)) ){
            COST_COLORLESS--;
        }  
    }
    return card_lim_duls_high_guard(player, card, event);
}

int card_desolation_angel(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_MODIFY_COST ){
        if( player == AI ){
            COST_WHITE+=2;
            instance->info_slot = 1;
        }
    }
    else if(event == EVENT_CAST_SPELL ){
        if( ! affect_me(player, card) ){
            return 0;
        }
        int choice = 1;
        if( instance->info_slot != 1 ){
            if(  has_mana_multi(player, 0, 0, 0, 0, 0, 2)  ){
                char buffer[50];
                sprintf(buffer, " Pay WW\n Do Not Pay" );
                choice = do_dialog(player, player, card, -1, -1, buffer, 1);
                if( choice == 0 ){
                    charge_mana_multi(player, 0, 0, 0, 0, 0, 2);
                }
            }
        }
        else{
            choice = 0;
        }
        instance->info_slot = choice;
    }
    if( comes_into_play(player, card, event) == 1 ){
        int count = 0;
        while(count < active_cards_count[player]){
            card_data_t card_d = get_card_data(player, count);
            if((card_d.type & TYPE_LAND) && in_play(player, count)){
                kill_card( player, count, KILL_DESTROY );
            }
            count++;
        }
        if( instance->info_slot == 0 ){
            count = 0;
            while(count < active_cards_count[1-player]){
                card_data_t card_d = get_card_data(1-player, count);
                if((card_d.type & TYPE_LAND) && in_play(1-player, count)){
                    kill_card(1- player, count, KILL_DESTROY );
                }
                count++;
            }
        }
    }
    return 0;
}

int card_dark_confidant  (int player, int card, event_t event){
    if(trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) && current_turn==player ){
        if(event == EVENT_TRIGGER){
            event_result |= 2;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            int *deck = deck_ptr[player];
            int card_added = add_card_to_hand(player, deck[0] );
            hand_count[player]++;
            remove_card_from_deck( player, 0 );
            int cmc = get_cmc(player, card_added);
            life[player] -= cmc;
            if( player == AI ){
                reveal_card(player, player, card, player, card_added, "Reveals", 0);
            }
        }
    }
    return 0;    
}

int card_putrid_imp(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && hand_count[player] > 0 ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE  ){
        discard(player, 0, 0);
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        pump_ability_until_eot(player, card, player, instance->parent_card, 0, 0, KEYWORD_FLYING);
    }
    
    if( has_threshold(player) ){
        if( ( event == EVENT_POWER || event == EVENT_TOUGHNESS ) && affect_me(player, card) ){
            event_result++;
        }
        cannot_block(player, card, event);
    }
    return 0;
}
  
int card_disciple_of_the_vault  (int player, int card, event_t event){
    card_instance_t *instance= get_card_instance(player, card);
    if(event == EVENT_GRAVEYARD_FROM_PLAY){
        if( ! in_play(affected_card_controller, affected_card) ){ return 0; } 
        card_instance_t *affected= get_card_instance(affected_card_controller, affected_card);
        if( affected->kill_code != 4) {
            if( cards_data[ affected->internal_card_id ].type & TYPE_ARTIFACT ){
                instance->targets[11].player = 1;
            }
        }
    }
    
    if( resolve_graveyard_trigger(player, card, event) == 1 ){
        life[1-player]--;
        instance->targets[11].player = 0;
    }
    
    return 0;
}

int card_rotlung_reanimator(int player, int card, event_t event){
    card_instance_t *instance= get_card_instance(player, card);
    if(event == EVENT_GRAVEYARD_FROM_PLAY){
        if( ! in_play(affected_card_controller, affected_card) ){ return 0; } 
        card_instance_t *affected= get_card_instance(affected_card_controller, affected_card);
        if(affected_card_controller == player && affected->kill_code != 4) {
            if( has_subtype(affected_card_controller, affected_card, SUBTYPE_CLERIC) ){
                if( instance->targets[11].player < 0 ){
                    instance->targets[11].player = 0;
                }
                instance->targets[11].player++;
            }
        }
    }
    
    if( resolve_graveyard_trigger(player, card, event) == 1 ){
        int i;
        for(i=0;i<instance->targets[11].player;i++){
            generate_token(player, "Zombie");
        }
        instance->targets[11].player = 0;
    }
    
    // same thing happens if I leave play
    if(event == EVENT_GRAVEYARD_FROM_PLAY){
        if( affect_me( player, card) && in_play(player, card) ){
            if(instance->kill_code != KILL_REMOVE ){
                generate_token(player, "Zombie");
            }
        }
    }
    
    return 0;
}

int card_carnophage  (int player, int card, event_t event){
    if( player == current_turn && trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
        if(event == EVENT_TRIGGER){
            event_result |= RESOLVE_TRIGGER_MANDATORY;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            int ai_choice = 0;
            if(life[player] == 1){
                ai_choice = 1;
            }
            int choice = do_dialog(player, player, card, -1, -1, " Pay 1 life\n Tap this", ai_choice);
            if( choice == 0){
                life[player]--;
            }
            else{
                tap_card(player, card);
            }
        }
    }
    return 0;
}

int card_nyxathid  (int player, int card, event_t event){
    if(event == EVENT_POWER || event == EVENT_TOUGHNESS){
        if(affect_me(player, card ) ){
            event_result -= hand_count[1-player];
        }
    }
    return 0;
}

int card_bringer_of_the_black_dawn(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if(event == EVENT_MODIFY_COST ){
        if( has_mana_multi(player, 0, 1, 1, 1, 1, 1 ) ){
            COST_COLORLESS-=7;
            COST_BLACK-=2;
            instance->targets[9].player = 1;
        }
    }
    else if(event == EVENT_CAST_SPELL ){
        if( instance->targets[9].player != 1 || ! affect_me(player, card) ){
            return 0;
        }
        int choice = 0;
        if( has_mana_multi(player, 0, 1, 1, 1, 1, 1 ) && has_mana_multi(player, 7, 2, 0, 0, 0, 0 ) ){
            char buffer[50];
            sprintf(buffer, " Pay WUBRG\n Pay 7BB" );
            choice = do_dialog(player, player, card, -1, -1, buffer, 0);
        }
        else if( has_mana_multi(player, 7, 2, 0, 0, 0, 0 ) ){
            choice = 1;
        }
        
        if( choice == 0 ){
            charge_mana_multi(player, 0, 1, 1, 1, 1, 1 );
        }
        else{
            charge_mana_multi(player, 7, 2, 0, 0, 0, 0 );
        }
    }
    else if( player == current_turn && trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
        if(event == EVENT_TRIGGER){
            event_result |= RESOLVE_TRIGGER_MANDATORY;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            char buffer[50];
            sprintf(buffer, " Tutor\n Cancel" );
            int choice = do_dialog(player, player, card, -1, -1, buffer, 0);
            if( choice == 0 ){
                type_tutor(player, -1, EVENT_RESOLVE_SPELL, 0, 0, 1, 2);
            }
        }
    }
    return 0;
}

int card_helldozer( int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_LAND);
    if(event == EVENT_CAN_ACTIVATE){
        if(is_sick(player, card) || is_tapped(player, card)){
            return 0;
        }
        if( has_mana_multi( player, 0, 3, 0, 0, 0, 0 ) &&  target_available(player, card, &td) ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE){
        tap_card(player, card);
        charge_mana_multi( player, 0, 3, 0, 0, 0, 0 );
        if( spell_fizzled != 1 ){
            if( ! select_target(player, card, &td, "Select target land", NULL) ){    
                spell_fizzled = 1;
            }      
        }
    }
    else if(event == EVENT_RESOLVE_ACTIVATION){
        card_instance_t *instance = get_card_instance(player, card);      
        card_instance_t *parent = get_card_instance( instance->parent_controller, instance->parent_card  );      
        if(validate_target(player, card, &td, 0)){
            if( ! is_basic_land( parent->targets[0].player, parent->targets[0].card ) ){
                untap_card( instance->parent_controller, instance->parent_card );
            }
            kill_card(parent->targets[0].player, parent->targets[0].card, KILL_DESTROY);
        }
    }
    return 0;
}

int card_nezumi_shortfang( int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( instance->targets[9].card == 17 ){
        if(event == EVENT_CAN_ACTIVATE){
            if( is_sick(player, card) || is_tapped( player, card ) ){
                return 0;
            }
            if( has_mana_multi( player, 1, 1, 0, 0, 0, 0 )  ){
                return 1;
            }
        }
        else if(event == EVENT_ACTIVATE){
            tap_card( player, card);
            charge_mana_multi( player, 1, 1, 0, 0, 0, 0 );
        }
        else if(event == EVENT_RESOLVE_ACTIVATION){
            discard( 1-player, 0, 0);
            if( hand_count[1-player] == 0 ){
                card_instance_t *parent = get_card_instance( instance->parent_controller, instance->parent_card  );      
                parent->targets[9].card = 14;
                reveal_card(player, player, card, player, card, "Nezumi Shortfang Flipped!", 1);           
            }
        }
    }
    else{
        if((event==EVENT_TOUGHNESS || event == EVENT_POWER) && affect_me(player, card)  ){
            event_result += 2;
        }
        if( comes_into_play(player, card, event) == 1 ){
            instance->targets[9].card = 17;
        }
        return card_the_rack(player, card, event);
    }
    return 0;
}

int card_dauthi_horror(int player, int card, event_t event){
    shadow(player, card, event);
    if(event == EVENT_BLOCK_LEGALITY ){
        if(player == attacking_card_controller && card == attacking_card ){
            card_instance_t *defender = get_card_instance(affected_card_controller, affected_card);
            if( defender->card_color & COLOR_TEST_WHITE ){
                event_result = 1;
            }   
        }      
    }
    return 0;
}

int card_dauthi_marauder(int player, int card, event_t event){
    shadow(player, card, event);
    return 0;
}

int card_dauthi_mercenary(int player, int card, event_t event){
    shadow(player, card, event);
    card_instance_t *instance = get_card_instance( player, card);
    if(event == EVENT_CAN_ACTIVATE){
        if( has_mana_multi(player, 1, 1, 0, 0, 0, 0) ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE){
        charge_mana_multi(player, 1, 1, 0, 0, 0, 0);
    }
    else if(event == EVENT_RESOLVE_ACTIVATION){
        card_instance_t *parent = get_card_instance(instance->parent_controller, instance->parent_card);
        parent->targets[9].card++;
    }
    else if( current_phase == PHASE_DISCARD || comes_into_play(player, card, event) ){
        instance->targets[9].card = 0;  
    }
    else if( affect_me(player, card) ){
        if(event == EVENT_POWER && instance->targets[9].card > 0){
            event_result +=  instance->targets[9].card;
        }
    }
    return 0;
}

int card_dauthi_slayer(int player, int card, event_t event){
    shadow(player, card, event);
    return attack_if_able(player, card, event);
}

int card_dauthi_warlord(int player, int card, event_t event){
    shadow(player, card, event);
    if(event == EVENT_POWER && affect_me(player, card) ){
        int p;
        for( p = 0; p < 2; p++){
            int count = 0;
            while(count < active_cards_count[p]){
                card_instance_t *instance = get_card_instance( p, count );
                if( in_play(p, count) && instance->extra_ability == 4 ){
                    event_result++;
                }
                count++;
           } 
        }
    }
    return 0;
}

int card_stronghold_overseer(int player, int card, event_t event){
    shadow(player, card, event);
    if(event == EVENT_CAN_ACTIVATE){
        if( has_mana_multi(player, 0, 2, 0, 0, 0, 0) ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE){
        charge_mana_multi(player, 0, 2, 0, 0, 0, 0);
    }
    else if(event == EVENT_RESOLVE_ACTIVATION){
        int p;
        for( p = 0; p < 2; p++){
            int count = 0;
            while(count < active_cards_count[p]){
                card_data_t card_d = get_card_data(p, count);
                if((card_d.type & TYPE_CREATURE) && in_play(p, count)){
                    card_instance_t *affected = get_card_instance( p, count );
                    if( affected->extra_ability == 4 ){
                        pump_until_eot(player, card, p, count, 1, 0);
                    }
                    else{
                        pump_until_eot(player, card, p, count, -1, 0);
                    }
                }
                count++;
            }
        }        
    }
    return 0;
}

int card_trespasser_il_vec(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance( player, card);
    if( instance->extra_ability == 4 ){
        shadow(player, card, event);
    }
    if(event == EVENT_CAN_ACTIVATE){
        if( hand_count[player] > 0 ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE){
        discard(player, 0, 0);
    }
    else if(event == EVENT_RESOLVE_ACTIVATION){
        card_instance_t *parent = get_card_instance(instance->parent_controller, instance->parent_card);
        parent->extra_ability = 4;
    }
    else if( current_phase == PHASE_DISCARD || comes_into_play(player, card, event) ){
        instance->extra_ability = 0;  
    }

    return 0;
}

int card_scavenger_drake(int player, int card, event_t event){
    card_instance_t *instance= get_card_instance(player, card);
    if(event == EVENT_GRAVEYARD_FROM_PLAY){
        if( ! in_play(affected_card_controller, affected_card) ){ return 0; } 
        card_instance_t *affected= get_card_instance(affected_card_controller, affected_card);
        if( affected->kill_code != 4) {
            if( cards_data[ affected->internal_card_id ].type & TYPE_CREATURE ){
                if( instance->targets[11].player < 0 ){
                    instance->targets[11].player = 0;
                }
                instance->targets[11].player++;
            }
        }
    }
    
    if( resolve_graveyard_trigger(player, card, event) == 1 ){
        instance->counters+=instance->targets[11].player;
        instance->counter_power+=instance->targets[11].player;
        instance->counter_toughness+=instance->targets[11].player;
        instance->targets[11].player = 0;
    }
    return 0;
}

int card_demonic_hordes( int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_LAND);
    if(event == EVENT_CAN_ACTIVATE){
        if(is_sick(player, card) || is_tapped(player, card)){
            return 0;
        }
        if( target_available(player, card, &td) ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE){
        tap_card(player, card);
        if( ! select_target(player, card, &td, "Select target land", NULL) ){    
            spell_fizzled = 1;
        }      
    }
    else if(event == EVENT_RESOLVE_ACTIVATION){
        card_instance_t *instance = get_card_instance(player, card);      
        card_instance_t *parent = get_card_instance( instance->parent_controller, instance->parent_card  );      
        if(validate_target(player, card, &td, 0)){
            kill_card(parent->targets[0].player, parent->targets[0].card, KILL_DESTROY);
        }
    }
    else if(event == EVENT_UPKEEP_COSTS_UNPAID ){
        card_instance_t *instance= get_card_instance(player, card);
        tap_card(player, instance->parent_card);
        td.allowed_controller = player;
        td.preferred_controller = player;
        td.illegal_abilities = 0;
        td.who_chooses = 1-player;
        if( target_available(player, card, &td) && select_target(player, card, &td, "Select target land", NULL) ){    
            kill_card(instance->targets[0].player, instance->targets[0].card, KILL_SACRIFICE);
        }
    }
    else{
        basic_upkeep(player, card, event, 0, 3, 0, 0, 0, 0);
    }
    return 0;
}

int card_tombstalker(int player, int card, event_t event){
    if( event == EVENT_MODIFY_COST ){
        COST_COLORLESS -= count_graveyard(player);
    }
    else if(event == EVENT_CAST_SPELL ){
        if( ! affect_me(player, card) ){ return 0; }
        int i;
        int count = count_graveyard(player);
        if( count > 6){ 
            count = 6; 
        }
        
        // force the AI to remove as much of grave as possible
        if( player == AI ){
            charge_mana(player, COLOR_COLORLESS, 6-count);
            for(i=0;i<count;i++){
                remove_card_from_grave(player, 0);
            }
            return 0;
        }
        
        int mana_remaining = count;
        card_instance_t *instance= get_card_instance(player, card);
        for(i=0;i<count;i++){
            
            int choice = 0;
            if( has_mana(player, COLOR_ANY, mana_remaining ) ){
                choice = do_dialog(player, player, card, -1, -1, " RFG a card from your grave\n Pay the rest in mana", 0);
            }
            if( choice == 0 ){
                int card_added = select_card_from_graveyard(player, card, choice, TYPE_ANY );
                if( card_added != -1 ){
                    rfg_card_from_grave(instance->targets[1].player, instance->info_slot, card_added);
                    mana_remaining--;
                }
                else{
                    spell_fizzled = 1;
                    break;
                }
            }
            else{
                charge_mana(player, COLOR_COLORLESS, mana_remaining);
                break;
            }
        }
    } 
    return 0;
}

int card_tar_fiend(int player, int card, event_t event){
    if( comes_into_play(player, card, event) ){
        int devoured = devour(player, card, event, 2);
        if( devoured == 0 ){ return 0; }
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE );
        td.zone = TARGET_ZONE_PLAYERS;
        td.allow_cancel = 0;
        pick_target(&td, "TARGET_PLAYER");
        card_instance_t *instance = get_card_instance( player, card);
        int i;
        for (i=0;i<devoured;i++){
            discard(instance->targets[0].player, 0, 0);
        }
    }
    return 0;
}

int card_eater_of_the_dead(int player, int card, event_t event){
    int cre_in_eotdc_grave = count_graveyard_by_type(player, TYPE_CREATURE);
    int cre_in_eotdo_grave = count_graveyard_by_type(1-player, TYPE_CREATURE);
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE ){
        if( cre_in_eotdc_grave + cre_in_eotdo_grave > 0 ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        int grave_player;
        if( cre_in_eotdc_grave == 0 ){
            grave_player = 1-player;
        }
        else if( cre_in_eotdo_grave == 0 ){
            grave_player = player;
        }
        else {
            target_definition_t td;
            default_target_definition(player, card, &td, TYPE_CREATURE);
            td.zone = TARGET_ZONE_PLAYERS;
            if( !select_target(player, card, &td, "Select player whose graveyard has target creature you wish to exile.", NULL) ){
                spell_fizzled = 1;
            }
            grave_player = instance->targets[0].player;
        }
        if( spell_fizzled != 1 ){
            int temp = -1;
            while( temp == -1 ){
                temp = select_card_from_graveyard(player, card, grave_player, TYPE_CREATURE);
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int *grave = graveyard_ptr[ instance->targets[1].player ];
        card_instance_t *invis = get_card_instance(player, instance->targets[0].card);
        if( invis->internal_card_id == grave[ instance->info_slot ] ){
            if( is_tapped(player, instance->parent_card) ){
                if( instance->targets[1].player == player ){
                    rfg_card_from_grave(instance->targets[1].player, instance->info_slot, instance->targets[0].card);
                }
                else if( instance->targets[1].player == 1-player ){
                    rfg_card_from_grave(instance->targets[1].player, instance->info_slot, -1);
                }
                untap_card(player, instance->parent_card);
            }
        }
    }
    return 0;
}

int card_grave_robbers(int player, int card, event_t event){
    int gr_c_grave = count_graveyard_by_type(player, TYPE_ARTIFACT);
    int gr_o_grave = count_graveyard_by_type(1-player, TYPE_ARTIFACT);
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE ){
        if( (gr_c_grave + gr_o_grave) > 0 && has_mana(player, COLOR_BLACK, 1) && !is_tapped(player, card) && !is_sick(player, card) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_BLACK, 1);
        if( spell_fizzled == 1 ){ return 0; }
        int grave_player;
        if( gr_c_grave == 0 ){
            grave_player = 1-player;
        }
        else if( gr_o_grave == 0 ){
            grave_player = player;
        }
        else {
            target_definition_t td;
            default_target_definition(player, card, &td, TYPE_CREATURE);
            td.zone = TARGET_ZONE_PLAYERS;
            if( !select_target(player, card, &td, "Select player whose graveyard has target artifact you wish to exile.", NULL) ){
                spell_fizzled = 1;
            }
            grave_player = instance->targets[0].player;
        }
        if( spell_fizzled != 1 ){
            int temp = -1;
            while( temp == -1 ){
                temp = select_card_from_graveyard(player, card, grave_player, TYPE_ARTIFACT);
            }
            tap_card(player, card);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int *grave = graveyard_ptr[ instance->targets[1].player ];
        card_instance_t *invis = get_card_instance(player, instance->targets[0].card);
        if( invis->internal_card_id == grave[instance->info_slot] ){
            if( instance->targets[1].player == player ){
                rfg_card_from_grave(instance->targets[1].player, instance->info_slot, instance->targets[0].card);
            }
            else if( instance->targets[1].player == 1-player ){
                rfg_card_from_grave(instance->targets[1].player, instance->info_slot, -1);
            }
            gain_life(player, 2);
        }
    }
    return 0;
}

int card_frankensteins_monster(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_CAST ){
        return 1;
    }
    else if( event == EVENT_CAST_SPELL ){
        return 1;
    }
    else if( event == EVENT_RESOLVE_SPELL && affect_me(player, card) ){
        if( count_graveyard_by_type(player, TYPE_CREATURE) >= x_value ){
            int i=0;
            int j;
            int choice;
            while( i < x_value ){
                if( select_card_from_graveyard(player, card, player, TYPE_CREATURE) != -1 ){
                    rfg_card_from_grave(player, instance->info_slot, instance->targets[0].card);
                    i++;
                }
            }
            for( j=0; j<x_value; j++ ){
                choice = do_dialog(player, player, card, -1, -1, "Select a counter\n +2/+0\n +1/+1\n +0/+2", 1 );
                if( choice == 1 ){
                    instance->counters++;
                }
                else {
                    instance->special_counters++;
                }
                instance->counter_power += (-choice + 2);
                instance->counter_toughness += choice;
            }
        }
        else {
            kill_card(player, card, KILL_SACRIFICE);
//            discard_card(player, card);
        }
    }
    return 0;
}

int card_nameless_race(int player, int card, event_t event){
    if( affect_me(player, card) ){
        card_instance_t *instance = get_card_instance(player, card);
        if( event == EVENT_RESOLVE_SPELL ){
            int i;
            int j;
            int white_count = 0;
            for( i=0; i<active_cards_count[1-player]; i++ ){
                card_instance_t *instancei = get_card_instance(1-player, i);
                if( in_play(1-player, i) && !(instancei->token_status & 0x10) && !(instancei->state & STATE_INVISIBLE) && get_color(1-player, i) & COLOR_TEST_WHITE ){
                    white_count++;
                }
            }
            int *graveyard = graveyard_ptr[1-player];
            for( j=0; j<count_graveyard(1-player); j++ ){
                card_data_t card_dj = cards_data[ graveyard[j] ];
                card_ptr_t* c = cards_ptr[card_dj.id];
                if( c->color == 8 ){
                    white_count++;
                }
            }
            int max_spend = white_count;
            if( life[player] < white_count ){
                max_spend = life[player];
            }
            int number = max_spend + 1;
            while( number > max_spend ){
                number = choose_a_number(player, "Pay how much life for Nameless Race?", max_spend);
            }
            if( number >= 0 ){
                life[player] -= number;
                instance->info_slot = number;
            }
            else {
                spell_fizzled = 1;
                return 0;
            }
        }
        else if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
            event_result = instance->info_slot;
        }
    }
    return 0;
}

int card_the_fallen(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_DEAL_DAMAGE ){
        card_instance_t *damage = get_card_instance(affected_card_controller, affected_card);
        if( damage->internal_card_id == damage_card ){
            if( damage->damage_target_player == 1-player && damage->damage_target_card == -1 && damage->damage_source_player == player &&  damage->damage_source_card == card && damage->info_slot > 0 ){
                instance->targets[player].player = 1;
            }
        }
    }
    else if( comes_into_play(player, card, event) ){
         instance->targets[0].player = -1;
         instance->targets[1].player = -1;
         instance->number_of_targets = 2;
    }
    if( current_turn == player && trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) && reason_for_trigger_controller == player && instance->targets[player].player == 1 ){
        if( event == EVENT_TRIGGER ){
            event_result |= RESOLVE_TRIGGER_MANDATORY;
        }
        else if( event == EVENT_RESOLVE_TRIGGER){
            damage_player(1-player, 1, player, card);
        }
    }
    return 0;
}

int card_hells_caretaker(int player, int card, event_t event){
target_definition_t td;
default_target_definition(player, card, &td, TYPE_CREATURE);
td.allowed_controller = player;
td.preferred_controller = player;
td.illegal_abilities = 0;
card_instance_t *instance = get_card_instance(player, card);

  if(current_turn == player && current_phase == PHASE_UPKEEP && !(is_tapped(player, card)) && event == EVENT_CAN_ACTIVATE){
     if( player == AI){
        if(count_graveyard_by_type(player, TYPE_CREATURE) > 0){
           return 1;
        }
        else{
             return 0;
        }
     }
     else{ 
          return 1;
     }

  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     tap_card(player, card);
     pick_target(&td, "LORD_OF_THE_PIT");
     kill_card(instance->targets[0].player, instance->targets[0].card, KILL_BURY);
     if( player == AI){
                       int *graveyard = graveyard_ptr[player];
                       int max_cmc = -1;
                       int max_index = -1;
                       int i;
                       if( count_graveyard_by_type(player, TYPE_CREATURE) > 0 ){
                          for(i = 0; i < count_graveyard(player); i++){
                              if( (graveyard[i] != -1) && (cards_data[  graveyard[i] ].type & TYPE_CREATURE) ){
                                 int cmc = cards_data[  graveyard[i] ].cc[0] + cards_data[  graveyard[i] ].cc[1];
                                 if( cmc > max_cmc ){
                                    max_cmc = cmc;
                                    max_index = i;
                                 } 
                              } 
                           }
                           if( max_index > 0){
                              instance->info_slot = graveyard[max_index];  
                              instance->targets[10].card = max_index;
                           }
                       } 
    }
     else{
         int *grave = graveyard_ptr[player];
         int selected;             
         selected = show_deck( player, graveyard_ptr[player], 500, "Pick a card", 0, 0x7375B0 );
         if( selected != -1){
            if ( cards_data[ grave[selected] ].type & TYPE_CREATURE ){
                instance->info_slot = grave[selected];
                instance->targets[10].card = selected;
            }
         }
     }
  }

  if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot > 0 ){
     int card_added =  add_card_to_hand(player, instance->info_slot );     
     remove_card_from_grave(player, instance->targets[10].card);
     put_into_play( player, card_added );
  }

    return 0;
}

int krovikan_horror(int player, int card, event_t event){
  int cnt = count_graveyard_by_id(player, get_id_by_name("Krovikan Horror"));

  if( trigger_condition == TRIGGER_EOT && affect_me(player, card) && cnt > 0){
     if(event == EVENT_TRIGGER){
        event_result |= RESOLVE_TRIGGER_MANDATORY;
     }
     else if(event == EVENT_RESOLVE_TRIGGER){
        int *graveyard = graveyard_ptr[player];
        int count = count_graveyard(player)-1;
        int activate = -1;
        int horrors = 0;
        int position[3];
        while( count > -1){
              if( cards_data[  graveyard[count] ].id == get_id_by_name("Krovikan Horror") ){
                 position[horrors] = count;
                 horrors++;
              }
              count--;
        }

        if( horrors == 1 && (cards_data[ graveyard[position[0]+1] ].type & TYPE_CREATURE) ){
           activate = position[0];
        }
        else if(horrors > 1){
                int k;
                for(k = 0; k < horrors; k++){
                    if( cards_data[ graveyard[position[k]+1] ].type & TYPE_CREATURE){
                       activate = position[k];
                    }
                }
        }
  
        if( activate > -1 ){          
           int choice = 0;
           if( ! duh_mode(player) ){
            do_dialog(player, player, card, -1, -1," Return Krovikan Horror\n Do not return Krovikan Horror\n", 0);
           }
           if( choice == 0 ){
              add_card_to_hand(player, graveyard[activate]);   
              remove_card_from_grave(player, activate);
           }
        }
     }
   }
  return 0;
}

int card_krovikan_horror(int player, int card, event_t event){
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.allowed_controller = player;
  td.preferred_controller = player;
  td.who_chooses = player;
  td.allow_cancel = 0;
  card_instance_t *instance = get_card_instance(player, card);


  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( has_mana_multi(player, 1, 0, 0, 0, 0, 0)  && target_available(player, card, &td) > 0){
        return 1;
     }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card)){
          charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
          if(spell_fizzled != 1){
             pick_target(&td, "LORD_OF_THE_PIT");
             if( valid_target(&td) ){ 
                kill_card(instance->targets[0].player, instance->targets[0].card, KILL_BURY);
                instance->number_of_targets = 1;
                target_definition_t td1;
                default_target_definition(player, card, &td1, TYPE_CREATURE );
                td1.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
                td1.allow_cancel = 0;
                pick_target(&td1, "TARGET_CREATURE_OR_PLAYER");
                instance->number_of_targets = 1;
                if( valid_target(&td1) ){ 
                   instance->targets[1].player = instance->targets[0].player;
                   instance->targets[1].card = instance->targets[0].card;
                   instance->info_slot = 66;
                }
             }
          }
  }

  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
          damage_creature_or_player(player, card, event, 1, 3);
          instance->info_slot = 0;
  }
 
  return 0;
}

int card_ashen_ghoul(int player, int card, event_t event){
  haste(player, card);

  if( event == EVENT_GRAVEYARD_ABILITY_UPKEEP ){
     int position = 0;
     int *graveyard = graveyard_ptr[player];
     int victims = 0;
     int count = count_graveyard(player) - 1;
     while( count > -1 ){
           if( cards_data[  graveyard[count] ].id == get_id_by_name("Ashen Ghoul") ){
              position = count;
           }
           count--;
     }

     count = count_graveyard(player) - 1;
     while( count > position ){
           if( (cards_data[ graveyard[count] ].type & TYPE_CREATURE) ){
              victims++;
           }
           count--;
     }

     if( victims >= 3){          
        int choice = do_dialog(player, player, card, -1, -1," Return Ashen Ghoul\n Do not return Ashen Ghoul\n", 0);
        if( choice == 0 ){
           charge_mana_multi(player, 0, 1, 0, 0, 0, 0);
           if( spell_fizzled != 1){
              put_into_play(player, card); 
              return -1;    
           }
        }
     }
     return -2;
  }

 return 0;
}

int card_nshadow(int player, int card, event_t event){
  haste(player, card);

  if( event == EVENT_GRAVEYARD_ABILITY_UPKEEP ){
     int position = 0;
     int *graveyard = graveyard_ptr[player];
     int victims = 0;
     int count = count_graveyard(player) - 1;
     while( count > -1 ){
           if( cards_data[  graveyard[count] ].id == get_id_by_name("Nether Shadow") ){
              position = count;
           }
           count--;
     }

     count = count_graveyard(player) - 1;
     while( count > position ){
           if( (cards_data[ graveyard[count] ].type & TYPE_CREATURE) ){
              victims++;
           }
           count--;
     }

     if( victims >= 3){          
        int choice = do_dialog(player, player, card, -1, -1," Return Nether Shadow\n Do not return Nether Shadow\n", 0);
        if( choice == 0 ){
           put_into_play(player, card); 
           return -1;   
        }
     }
     return -2;
  }

 return 0;
}

int card_rotting_rats(int player, int card, event_t event){
  
  if( comes_into_play(player, card, event) == 1){
     discard(player, 0, 0);
     discard(1-player, 0, 0);
  }
    
    return unearth(player, event, 1, 1, 0, 0, 0, 0); 
}

int card_extractor_demon(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE );
  td.zone = TARGET_ZONE_PLAYERS;

  if( trigger_condition == TRIGGER_LEAVE_PLAY && affect_me(player, card) ){
     if( trigger_cause_controller == player && trigger_cause == card ){ return 0; }
     card_instance_t *dead = get_card_instance(trigger_cause_controller, trigger_cause);
     if(  (cards_data[ dead->internal_card_id].type & TYPE_CREATURE) ){
        if(event == EVENT_TRIGGER){
           event_result |= RESOLVE_TRIGGER_MANDATORY;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
                pick_target(&td, "TARGET_PLAYER");
                if( valid_target(&td) ){
                   mill(instance->targets[0].player, 2);
                }
        }
     }
  }

    return unearth(player, event, 2, 1, 0, 0, 0, 0); 
}

int card_vein_drinker(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.allowed_controller = 2;
  td.preferred_controller = 1-player;

  if(event == EVENT_CAN_ACTIVATE && !(is_tapped(player, card)) && has_mana_multi(player, 0, 0, 0, 0, 1, 0) ){
     if( !(is_sick(player, card)) ){
        return 1;
     }
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     tap_card(player, card);
     charge_mana_multi(player, 0, 0, 0, 0, 1, 0);
     if( spell_fizzled != 1){
        pick_target(&td, "TARGET_CREATURE");
        instance->info_slot = 1;
     }
  }

  if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && valid_target(&td) ){
     int vd_damage = get_power(player, instance->parent_card);
     int t_damage = get_power(instance->targets[0].player, instance->targets[0].card);
     damage_creature(instance->targets[0].player, instance->targets[0].card, vd_damage, player, card); 
     damage_creature(player, instance->parent_card, t_damage,instance->targets[0].player, instance->targets[0].card );
     instance->info_slot = 0;
  }

  return card_sengir_vampire(player, card, event);
}

int card_viscera_dragger(int player, int card, event_t event){
  return cycling(player, card, event, 2, 0, 0, 0, 0, 0) + unearth(player, event, 1, 1, 0, 0, 0, 0); 
}

