#include "manalink.h"
    
// white
int card_combat_medic(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.extra = damage_card;
    td.required_type = 0;
    //
    if( event == EVENT_CAN_ACTIVATE && can_target(&td) && has_mana_multi(player, 1, 0, 0, 0, 0, 1)  ){
        return 0x63;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 1);
        if( spell_fizzled != 1 ){
            pick_target(&td, "TARGET_DAMAGE");
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *instance = get_card_instance(player, card);
        card_instance_t *target = get_card_instance(instance->targets[0].player, instance->targets[0].card);
        if( target->info_slot > 0 ){
            target->info_slot--;
        }
    }
    return 0;
}    

int card_farrelite_priest(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 0, 0)){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
        if( spell_fizzled != 1 ){
            produce_mana(player, COLOR_WHITE, 1);
            if( instance->info_slot < 0 ){ instance->info_slot = 0; }
            instance->info_slot++;
        }
    }
    else if( instance->info_slot > 0 && current_turn == player && eot_trigger(player, card, event) ){
        if( instance->info_slot >= 4 ){
            kill_card(player, card, KILL_SACRIFICE);
        }
        else{
            instance->info_slot = 0;
        }
    }
    return 0;
}

int card_farrels_mantle(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    
    if( event == EVENT_DECLARE_BLOCKERS ){
        int p = instance->targets[0].player;
        int c = instance->targets[0].card;
        card_instance_t *enchanted = get_card_instance(p, c);
        if( is_unblocked(p, c) ){
            int choice = do_dialog(p, player, card, -1, -1, " Use Ability\n Do not use ability", 1);
            if( choice == 0 ){
                target_definition_t td;
                default_target_definition(p, c, &td, TYPE_CREATURE);
                td.who_chooses = p;
                if( pick_target(&td, "TARGET_CREATURE") ){
                    damage_creature(enchanted->targets[0].player, enchanted->targets[0].card, get_power(p, c)+2, enchanted->targets[0].player, enchanted->targets[0].card);
                    int result = create_legacy_effect_exe(p, c, LEGACY_EFFECT_ITH, p, c);
                    card_instance_t *legacy_instance = get_card_instance(p, result);
                    legacy_instance->info_slot = 3;
                }
            }            
        }
    }
    
    load_text(0, "TARGET_CREATURE");
    return aura_pump(player, card, event, 0, 0);
}

int card_farrels_zealot(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_DECLARE_BLOCKERS ){
        if( is_unblocked(player, card) ){
            int choice = do_dialog(player, player, card, -1, -1, " Use Ability\n Do not use ability", 1);
            if( choice == 0 ){
                target_definition_t td;
                default_target_definition(player, card, &td, TYPE_CREATURE);
                if( pick_target(&td, "TARGET_CREATURE") ){
                    damage_creature(instance->targets[0].player, instance->targets[0].card, 3, instance->targets[0].player, instance->targets[0].card);
                    int result = create_legacy_effect_exe(player, card, LEGACY_EFFECT_ITH, player, card);
                    card_instance_t *legacy_instance = get_card_instance(player, result);
                    legacy_instance->info_slot = 3;
                }
            }            
        }
    }   
    return 0;
}

int card_hand_of_justice(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_color = 1 << get_sleighted_color(player, card, COLOR_WHITE);
    td.illegal_state = TARGET_STATE_TAPPED;
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.allow_cancel = 0;
    
    target_definition_t td1;
    default_target_definition(player, card, &td1, TYPE_CREATURE);
    td1.allow_cancel = 0;
        
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && ! is_tapped(player, card) && ! is_sick(player, card) && can_target(&td) > 3 ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        tap_card(player, card);
        int i;
        for(i=0;i<3;i++){
            pick_target(&td, "CREATURE_TO_TAP" );
            tap_card( player, instance->targets[0].card );
        }
        instance->number_of_targets = 3;
        
        pick_target(&td1, "TARGET_CREATURE" );
        instance->number_of_targets = 1;
    }
    else if( event == EVENT_RESOLVE_ACTIVATION && valid_target(&td1) ){
        kill_card(instance->targets[0].player, instance->targets[0].card, KILL_DESTROY);
    }
    return 0;
}

int effect_heroism(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_PREVENT_DAMAGE && ( current_phase == PHASE_NORMAL_COMBAT_DAMAGE || current_phase == PHASE_FIRST_STRIKE_DAMAGE ) ){
        card_instance_t *source = get_card_instance(affected_card_controller, affected_card);
        if( damage_card != source->internal_card_id ){
            return 0;
        }
        if( source->damage_source_player == instance->targets[0].player &&  source->damage_source_card == instance->targets[0].card ){
            source->info_slot = 0;
        }
    }
    if( eot_trigger(player, card, event) ){
        kill_card(player, card, KILL_SACRIFICE );
    }
    return 0;
}

int card_heroism(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_color = 1 << get_sleighted_color(player, card, COLOR_WHITE);
    td.allowed_controller = player;
    td.preferred_controller = player;
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && can_target(&td) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        if( pick_target(&td, "LORD_OF_THE_PIT") ){
            kill_card(player, instance->targets[0].card, KILL_SACRIFICE);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int count = 0;
        while(count < active_cards_count[1-player]){
            card_instance_t *inst = get_card_instance(1-player, count);
            int color = 1 << get_sleighted_color(player, card, COLOR_RED);
            
            if( ( inst->state & STATE_ATTACKING ) && (get_color(1-player, count) & color) ){
                int choice = 1;
                if( has_mana_multi(1-player, 2, 0, 0, 0, 1, 0) ){
                    choice = do_dialog(1-player, player, card, -1, -1, " Pay 2R\n Do not pay", 0);
                    if( choice == 0 ){
                        charge_mana_multi(1-player, 2, 0, 0, 0, 1, 0);
                        if( spell_fizzled == 1 ){
                            choice = 1;
                        } 
                    }
                }
                if( choice == 1 ){
                    int legacy_card = create_targetted_legacy_effect(player, card, &effect_heroism, 1-player, count);
                    card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
                    legacy_instance->targets[0].player = 1-player;
                    legacy_instance->targets[0].card = count;
                }
            }
            count++;
        }
    }
    
    return global_enchantment(player, card, event);
}

int card_icatian_infantry(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 0, 0) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
        if( spell_fizzled != 1 ){
            int ai_choice = rand(2);
            instance->info_slot = do_dialog(player, player, card, -1, -1, " First Strike\n Banding", ai_choice);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( instance->info_slot == 1 ){
            pump_ability_until_eot(player, card, player, instance->parent_card, 0, 0, KEYWORD_BANDING);
        }
        else{
            pump_ability_until_eot(player, card, player, instance->parent_card, 0, 0, KEYWORD_FIRST_STRIKE);
        }
    }
    return 0;
}
    
int card_icatian_javelineers(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE );
    td.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
        
    if( comes_into_play(player, card, event) ){
        add_ccounter(player, card);
    }
    else if(count_ccounters(player, card) > 0 ){
        if( event == EVENT_CAN_ACTIVATE && ! is_tapped(player, card) && ! is_sick(player, card) ){
            return 1;
        }
        else if( event == EVENT_ACTIVATE ){
            if( pick_target(&td, "TARGET_CREATURE_OR_PLAYER") ){
                tap_card(player, card);
                remove_ccounter(player, card);
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( valid_target(&td) ){
            damage_creature_or_player(player, card, event, 1, 3);
        }
    }
    return 0;
}

int card_icatian_lieutenant(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_SOLDIER;
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 0, 1) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 1);
        if( spell_fizzled != 1 ){
            instance->number_of_targets = 0;
            pick_target(&td, "TARGET_CREATURE");
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if(valid_target(&td) ){
            pump_until_eot(player, instance->parent_card, instance->targets[0].player, instance->targets[0].card, 1, 0);
        }
    }
    return 0;
}

int card_icatian_moneychanger(int player, int card, event_t event){
    if( event == EVENT_CAN_ACTIVATE && current_phase == PHASE_UPKEEP ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        kill_card(player, card, KILL_SACRIFICE);
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        gain_life(player, count_ccounters(player, card) );
    }
    else if( comes_into_play(player, card, event) ){
        set_ccounters(player, card, 3);
        damage_player(player, 3, player, card); 
    }
    else if( current_turn == player && upkeep_trigger(player, card, event) ){
        add_ccounter(player, card);
    }
    return 0;
}

int card_icatian_priest(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 0, 2) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 2);
        if( spell_fizzled != 1 ){
            instance->number_of_targets = 0;
            pick_target(&td, "TARGET_CREATURE");
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if(valid_target(&td) ){
            pump_until_eot(player, instance->parent_card, instance->targets[0].player, instance->targets[0].card, 1, 1);
        }
    }
    return 0;
}

int card_icatian_scout(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 0, 0) && ! is_sick(player, card) && ! is_tapped(player, card)){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
        if( spell_fizzled != 1 ){
            instance->number_of_targets = 0;
            if( pick_target(&td, "TARGET_CREATURE") ){
                tap_card(player, card);
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if(valid_target(&td) ){
            pump_ability_until_eot(player, instance->parent_card, instance->targets[0].player, instance->targets[0].card, 0, 0, KEYWORD_FIRST_STRIKE);
        }
    }
    return 0;
}

int card_icatian_skirmishers(int player, int card, event_t event){
   card_instance_t *instance = get_card_instance(player, card);
   if( event == EVENT_DECLARE_ATTACKERS && instance->state & STATE_ATTACKING ){
        int count =0;
        while(count < active_cards_count[player] && instance->blocking > 0 && instance->blocking != 255){
            if( count == card){ count++; }
            card_instance_t *inst = get_card_instance(player, count);
            if( instance->blocking ==  count || instance->blocking == inst->blocking || inst->blocking == card ){
                pump_ability_until_eot(player, card, player, count, 0, 0, KEYWORD_FIRST_STRIKE );
            }
            count++;
        }
   
    }
    return 0;
}

// blue cards
int card_homarid_warrior(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && has_mana(player, COLOR_BLUE, 1) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_BLUE, 1);
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        pump_ability_until_eot(player, card, player, instance->parent_card, 0, 0, KEYWORD_SHROUD );
        tap_card(player, instance->parent_card);
        create_targetted_legacy_effect(player, card, &effect_does_not_untap, player, instance->parent_card);
    }
    return 0;
}

int card_deep_spawn(int player, int card, event_t event){
    if( current_turn == player && upkeep_trigger(player, card, event) ){
        int choice = 1;
        if( count_deck(player) > 1 ){
             choice = do_dialog(player, player, card, -1, -1, " Mill 2\n Sacrifice", 0);
        }
        if( choice == 0 ){    
            mill(player, 2);
        }
        else{
            kill_card(player, card, KILL_SACRIFICE);
        }
    }
    return card_homarid_warrior(player, card, event);
}

int effect_high_tide(int player, int card, event_t event){
    if( has_subtype(affected_card_controller, affected_card, SUBTYPE_ISLAND) ){
        if ( event == EVENT_TAP_CARD ){
            produce_mana(player, COLOR_BLUE, 1);
        }
        else if ( event == EVENT_COUNT_MANA ){
            if( ! is_tapped(affected_card_controller, affected_card) ){
                declare_mana_available(player, COLOR_BLUE, 1);
            }
        }
    }
    
    else if( eot_trigger(player, card, event ) ){
          kill_card(player, card, KILL_REMOVE);
    }
    return 0;
}

int card_high_tide(int player, int card, event_t event){
    if( event == EVENT_CAN_CAST ){
        return 1;
    }
    else if(event == EVENT_RESOLVE_SPELL ){
        create_legacy_effect(player, card, &effect_high_tide );
        kill_card(player, card, KILL_DESTROY);
    }
    return 0;
}

int card_homarid(int player, int card, event_t event){
    if( comes_into_play(player, card, event) ){
        add_ccounter(player, card);
    }
    else if( current_turn == player && upkeep_trigger(player, card, event) ){
        add_ccounter(player, card);
    }
    
    int counters = count_ccounters(player, card);
    if( affect_me(player, card) && ( event == EVENT_POWER || event == EVENT_TOUGHNESS) ){
        if( counters == 1 ){
            event_result--;
        }
        else if( counters == 3 ){
            event_result++;
        }
    }
    if( counters == 4 ){
        set_ccounters(player, card, 0);
    }
    return 0;
}

int card_homarid_shaman(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_color = 1 << get_sleighted_color(player, card, COLOR_GREEN);
    if( event == EVENT_CAN_ACTIVATE && can_target(&td) && has_mana(player, COLOR_BLUE, 1) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_BLUE, 1);
        if( spell_fizzled != 1 ){
            pick_target(&td, "TARGET_CREATURE");
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( valid_target( &td ) ){
            tap_card(instance->targets[0].player, instance->targets[0].card );
        }
    }
    return 0;
}

int card_homarid_spawning_bed(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_color = 1 << get_sleighted_color(player, card, COLOR_BLUE);
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.illegal_abilities = 0;
    if( event == EVENT_CAN_ACTIVATE && can_target(&td) && has_mana_multi(player, 1, 0, 2, 0, 0, 0) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 2, 0, 0, 0);
        if( spell_fizzled != 1 ){
            if( pick_target(&td, "LORD_OF_THE_PIT") ){
                instance->targets[1].card = get_cmc(player, instance->targets[0].card);
                kill_card(player, instance->targets[0].card, KILL_SACRIFICE);
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int i;
        for(i=0;i<instance->targets[1].card;i++){
            generate_token(player, "Camarid");
        }
    }
    return global_enchantment(player, card, event);
}

int card_merseine(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( comes_into_play(player, card, event) ){
        add_counters(player, card, 3);
    }
    else if( count_counters(player, card) > 0 ){
        int p = instance->targets[0].player;
        int c = instance->targets[0].card;
        does_not_untap( p, c, event );
        if( current_turn == 1-p && eot_trigger(player, card, event) ){
            card_ptr_t* c1 = cards_ptr[ get_id(p, c) ];
            int colorless = c1->req_colorless;
            if(colorless == 40){ colorless = 0; }
            while( spell_fizzled != 1 && count_counters(player, card) > 0 && has_mana_multi(p, colorless, c1->req_black, c1->req_blue, c1->req_green, c1->req_red, c1->req_white ) ){
                char buffer[50];
                sprintf(buffer, " Remove a counter (%d left)\n Do not pay", count_counters(player, card)  );
                int choice = do_dialog(p, player, card, -1, -1, buffer, 0);
                if( choice == 0 ){
                    charge_mana_multi(p, colorless, c1->req_black, c1->req_blue, c1->req_green, c1->req_red, c1->req_white );
                    if( spell_fizzled != 1 ){
                        remove_counter(player, card);
                    }
                }
                else{
                    spell_fizzled = 1;
                }
            }
        }
    }
    
    load_text(0, "TARGET_CREATURE");
    return aura_pump(player, card, event, 0, 0);
}

int card_river_merfolk(int player, int card, event_t event){
    if( event == EVENT_CAN_ACTIVATE && has_mana(player, COLOR_BLUE, 1) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_BLUE, 1);
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *instance = get_card_instance(player, card);
        pump_ability_until_eot(player, card, player, instance->parent_card, 0, 0, KEYWORD_MOUNTAINWALK);
    }
    return 0;
}

int card_seasinger(int player, int card, event_t event){
    // if this is untapped, release any creatures
    card_instance_t *instance = get_card_instance(player, card);
    if( (leaves_play( player, card, event) || ! is_tapped(player, card)) && instance->targets[0].card != -1 ){
        instance->targets[0].card = -1;
        kill_card(player, instance->info_slot, KILL_DESTROY );
    }
    
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    
    target_definition_t td1;
    default_target_definition(player, card, &td1, TYPE_LAND);
    td1.required_subtype = SUBTYPE_ISLAND;
    td1.allowed_controller = player;
    td1.preferred_controller = player;
    td1.illegal_abilities = 0;
    if( ! can_target(&td1) ){
        kill_card(player, card, KILL_SACRIFICE);
    }   
    td1.allowed_controller = 1-player;
    td1.preferred_controller = 1-player;
    
    if( event == EVENT_CAN_ACTIVATE && ! is_sick(player, card) && ! is_tapped(player, card) && can_target(&td) && can_target(&td1)  ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        if( pick_target(&td, "TARGET_CREATURE") ){
            tap_card(player, card);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( valid_target(&td) && can_target(&td1) ){
            int legacy = gain_control(player, card, instance->targets[0].player, instance->targets[0].card);
            if( legacy > -1 ){
                card_instance_t *parent = get_card_instance(instance->parent_controller, instance->parent_card);
                parent->info_slot = legacy;
            }
        }
    }
    else{
        return card_tawnoss_weaponry(player, card, event);
    }
        
    return 0;
}

int card_svyelunite_priest (int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 0, 0, 2, 0, 0, 0) && ! is_sick(player, card) && ! is_tapped(player, card)){
        if( current_turn == player && current_phase == PHASE_UPKEEP ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 0, 0, 2, 0, 0, 0);
        if( spell_fizzled != 1 ){
            instance->number_of_targets = 0;
            if( pick_target(&td, "TARGET_CREATURE") ){
                tap_card(player, card);
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if(valid_target(&td) ){
            pump_ability_until_eot(player, instance->parent_card, instance->targets[0].player, instance->targets[0].card, 0, 0, KEYWORD_SHROUD);
        }
    }
    return 0;
}

int card_tidal_flats (int player, int card, event_t event){
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 0, 0, 2, 0, 0, 0) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 0, 0, 2, 0, 0, 0);
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int count =0;
        int  p = 1-player;
        while(count < active_cards_count[p]){
            card_instance_t *inst = get_card_instance(p, count);
            if( inst->state & STATE_ATTACKING ){
                int choice = 1;
                if( has_mana_multi(p, 1, 0, 0, 0, 0, 0) ){
                    choice = do_dialog(p, p, count, -1, -1, " Pay 1\n Do not pay", 0);
                }
                if( choice == 0 ){
                    charge_mana_multi(p, 1, 0, 0, 0, 0, 0);
                }
                if( choice == 1 || spell_fizzled == 1 ){
                    int i=0;
                    while(i < active_cards_count[player]){
                        card_instance_t *ins = get_card_instance(player, i);
                        if( ins->blocking == count ){
                            pump_ability_until_eot(player, card, player, i, 0, 0, KEYWORD_FIRST_STRIKE);
                        }
                        i++;
                    }
                }
            }
            count++;
        }
    }
    return global_enchantment(player, card, event);
}

int card_tidal_influence(int player, int card, event_t event){
    if( event == EVENT_CAN_CAST && count_cards_by_id(player, get_id(player, card) ) > 0 ){
        return 0;
    }
    
    if( comes_into_play(player, card, event) ){
        add_ccounter(player, card);
    }
    else if( current_turn == player && upkeep_trigger(player, card, event) ){
        add_ccounter(player, card);
    }
    
    int counters = count_ccounters(player, card);
    int color = 1 << get_sleighted_color(player, card, COLOR_BLUE);
    if( ( get_color(affected_card_controller, affected_card) & color )&& event == EVENT_POWER ){
        if( counters == 1 ){
            event_result-=2;
        }
        else if( counters == 3 ){
            event_result+=2;
        }
    }
    if( counters == 4 ){
        set_ccounters(player, card, 0);
    }
    return global_enchantment(player, card, event);
}

int card_vodalian_mage(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if(event == EVENT_CAN_ACTIVATE ){
        int result =  card_spiketail_hatchling(player, card, event);
        if( result == 0 || ! has_mana_multi(player, 0, 0, 1, 0, 0, 0) || is_tapped(player, card) || is_sick(player, card) ){
            return 0;
        }
        return result;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 0, 0, 1, 0, 0, 0);
        if( spell_fizzled != 1 ){
            tap_card(player, card);
            instance->targets[0].player = card_on_stack_controller;
            instance->targets[0].card = card_on_stack;
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int choice = 1;
        if( instance->targets[0].player == AI && has_mana_multi(instance->targets[0].player, 1, 0, 0, 0, 0, 0) ){
            choice = 0;
        }
        else if( player == HUMAN ){
            choice = do_dialog(player, player, card, -1, -1, " Pay 1\n Do not pay", 0); 
        }
            
        if( choice == 0 ){
            charge_mana( instance->targets[0].player, COLOR_COLORLESS, 3);
        }
        
        if( spell_fizzled == 1 || choice == 1 ){
            kill_card(instance->targets[0].player, instance->targets[0].card, KILL_DESTROY);
        }
    }
    return 0;
}

int effect_vodalian_war_machine(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    card_instance_t *inst = get_card_instance(instance->targets[1].player, instance->targets[1].card);
    if( event == EVENT_GRAVEYARD_FROM_PLAY  && affect_me(player, instance->targets[1].card) && inst->kill_code > 0 && inst->kill_code != KILL_REMOVE ){
        kill_card(instance->targets[0].player, instance->targets[0].card, KILL_DESTROY);
        gain_life(HUMAN, 1);
    }    
    if( eot_trigger(player, card, event) ){
        kill_card(player, card, KILL_SACRIFICE );
    }
    return 0;
}
int card_vodalian_war_machine(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_MERFOLK;
    td.illegal_state = TARGET_STATE_TAPPED;
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.illegal_abilities = 0;
    
    if(event == EVENT_CAN_ACTIVATE && can_target(&td) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        if( pick_target(&td, "CREATURE_TO_TAP") ){
            instance->number_of_targets = 1;
            int choice = do_dialog(player, player, card, -1, -1, " +2/+1\n Able to Attack\n Cancel", 0); 
            if( choice == 2 ){
                spell_fizzled = 1;
                return 0;
            }
            instance->info_slot = choice;
            tap_card(player, instance->targets[0].card);
            int legacy_card = create_targetted_legacy_effect(player, card, &effect_vodalian_war_machine, instance->targets[0].player, instance->targets[0].card);
            card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
            legacy_instance->targets[1].player = player;
            legacy_instance->targets[1].card = card;
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( instance->info_slot == 0 ){
            pump_until_eot(player, card, player, instance->parent_card, 2, 1);
        }
        else{
            card_instance_t *inst = get_card_instance(player, instance->parent_card);
            inst->targets[3].card = 1;
        }
    }
    else if( instance->targets[3].card == 1 ){
        if( eot_trigger(player, card, event) ){
            instance->targets[3].card = 0;
        }
    }
    else if( event == EVENT_ATTACK_LEGALITY ){
        event_result=1;
    }
    return 0;
}


// black cards
int card_armor_thrull(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE ){
        if( ! is_tapped(player, card) && ! is_sick(player, card) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        if( pick_target(&td, "TARGET_CREATURE") ){
            kill_card(player, card, KILL_SACRIFICE);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( valid_target( &td ) ){
            card_instance_t *target = get_card_instance(instance->targets[0].player, instance->targets[0].card );
            target->counter_power++;
            target->counter_toughness+=2;
            target->counters++;
        }
    }
    return 0;
}

int card_basal_thrull(int player, int card, event_t event){
    if( event == EVENT_CAN_ACTIVATE ){
        if( ! is_tapped(player, card) && ! is_sick(player, card) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        kill_card(player, card, KILL_SACRIFICE);
        produce_mana(player, COLOR_BLACK, 2);
        spell_fizzled = 1;
    }
    else if( event == EVENT_COUNT_MANA ){
        if( ! is_tapped(player, card) && ! is_sick(player, card) && affect_me(player, card) ){
            declare_mana_available(player, COLOR_BLACK, 2);     
        }
    }
    return 0;
}

int card_breeding_pit(int player, int card, event_t event){
    basic_upkeep(player, card, event, 0, 2, 0, 0, 0, 0);
    if( current_turn == player && eot_trigger(player, card, event) ){
        generate_token(player, "Thrull"); // thrull
    }
    return global_enchantment(player, card, event);
}

int card_derelor(int player, int card, event_t event){
    if(event == EVENT_MODIFY_COST_GLOBAL && affected_card_controller == player ){
        int color = 1 << get_sleighted_color(player, card, COLOR_BLACK);
        if( get_color(affected_card_controller, affected_card) & color ){
            COST_BLACK++;
        }  
    }
    return 0;
}

int card_ebon_praetor(int player, int card, event_t event){
    if(  current_turn==player && upkeep_trigger(player, card, event)){
            // add a -2/-2 creature
            card_instance_t *instance = get_card_instance( player, card);     
            instance->counter_power-=2;
            instance->counter_toughness-=2;
            instance->counters++;
            
            // sac a guy?
            target_definition_t td;
            default_target_definition(player, card, &td, TYPE_CREATURE);
            td.allowed_controller = player;
            td.preferred_controller = player;
            td.illegal_abilities = 0;
            if( player == AI ){
                td.required_subtype = SUBTYPE_THRULL;
            }
            if( can_target( &td ) ){
                if( pick_target( &td, "LORD_OF_THE_PIT" ) ){
                    int thrull = has_creature_type(player, instance->targets[0].card, SUBTYPE_THRULL);
                    kill_card(player, instance->targets[0].card, KILL_SACRIFICE );
                    if( in_play(player, card) ){
                        // remove the counter
                        instance->counter_power+=2;
                        instance->counter_toughness+=2;
                        instance->counters--;
                    
                        // add a counter?
                        if( thrull ){
                            instance->counter_power++;
                            instance->counters++;
                        }
                    }
                }
            }        
        
    }
    return 0;
}

int card_initiates_of_the_ebon_hand(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 0, 0)){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
        if( spell_fizzled != 1 ){
            produce_mana(player, COLOR_BLACK, 1);
            if( instance->info_slot < 0 ){ instance->info_slot = 0; }
            instance->info_slot++;
        }
    }
    else if( instance->info_slot > 0 && current_turn == player && eot_trigger(player, card, event) ){
        if( instance->info_slot >= 4 ){
            kill_card(player, card, KILL_SACRIFICE);
        }
        else{
            instance->info_slot = 0;
        }
    }
    return 0;
}

int card_mindstab_thrull(int player, int card, event_t event){
    if( event == EVENT_DECLARE_BLOCKERS ){
        if( is_unblocked(player, card) ){
            int choice = do_dialog(player, player, card, -1, -1, " Sacrifice\n Do not sacrifice", 0);
            if( choice == 0 ){
                kill_card(player, card, KILL_SACRIFICE );
                discard(1-player, 0, 0);
                discard(1-player, 0, 0);
                discard(1-player, 0, 0);
            }            
        }
    }
    return 0;
}

int card_necrite(int player, int card, event_t event){
    if( event == EVENT_DECLARE_BLOCKERS ){
        if( is_unblocked(player, card) ){
            int choice = do_dialog(player, player, card, -1, -1, " Sacrifice\n Do not sacrifice", 0);
            if( choice == 0 ){
                target_definition_t td;
                default_target_definition(player, card, &td, TYPE_CREATURE);
                td.allowed_controller = 1-player;
                td.preferred_controller = 1-player;
                td.allow_cancel = 0;
                if( can_target( &td ) ){
                    pick_target(&td, "TARGET_CREATURE" );
                    card_instance_t *instance = get_card_instance(player, card);
                    kill_card(1-player, instance->targets[0].card, KILL_DESTROY );    
                }
                kill_card(player, card, KILL_SACRIFICE );
            }            
        }
    }
    return 0;
}

int card_soul_exchange(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.illegal_abilities = 0;
    td.allow_cancel = 0;
    if( event == EVENT_CAN_CAST && can_target( &td ) && count_graveyard_by_type(HUMAN, TYPE_CREATURE) > 0 ){
        return 1;
    }
    else if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
        pick_target( &td, "LORD_OF_THE_PIT" );
        if( has_creature_type(player, instance->targets[0].card, SUBTYPE_THRULL ) ){
            instance->targets[3].player = 1;
        }
        kill_card(player, instance->targets[0].card, KILL_REMOVE);
        select_card_from_graveyard(player, card, HUMAN, TYPE_CREATURE );
    }
    else if( event == EVENT_RESOLVE_SPELL ){
        put_into_play(instance->targets[0].player, instance->targets[0].card);
        remove_card_from_grave(instance->targets[1].player, instance->info_slot);
        if( instance->targets[3].player == 1 ){
            card_instance_t *added = get_card_instance(player, instance->targets[0].card);
            added->counter_power+=2;
            added->counter_toughness+=2;
            added->counters++;
        } 
        kill_card(player, card, KILL_DESTROY);
    }
    return 0;
}

int card_thrull_champion(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_THRULL;
    card_instance_t *instance = get_card_instance(player, card);
    
    if(in_play(player, card) ){
        boost_creature_type(player, card, event, SUBTYPE_THRULL, 1, 1, 0, BCT_INCLUDE_SELF);
    }
    
    if( event == EVENT_CAN_ACTIVATE ){
        if( ! is_tapped(player, card) && ! is_sick(player, card) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        if(pick_target(&td, "TARGET_CREATURE") ){
            tap_card(player, card);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( valid_target(&td) && in_play(instance->parent_controller, instance->parent_card) ){
            instance = get_card_instance(player, instance->parent_card);
            int legacy = gain_control(player, card, instance->targets[0].player, instance->targets[0].card);
            if( legacy > -1 ){
                instance->info_slot++;
                instance->targets[  1 + instance->info_slot ].card = legacy;
            }
        }
    }
    else if( leaves_play(player, card, event) ){
        int i;
        for(i=2;i<2 + instance->info_slot;i++){
            kill_card(player, instance->targets[i].card, KILL_SACRIFICE );
        }
    }
    return 0;
}

int card_thrull_retainer(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    int p = instance->targets[0].player;
    int c = instance->targets[0].card;
    if(  c > -1 && in_play(p, c) ){
        if( event == EVENT_CAN_ACTIVATE ){
            card_instance_t *target = get_card_instance(p, c);
            if( target->kill_code == KILL_DESTROY ){
                return 0x63;
            }
        }
        else if( event == EVENT_ACTIVATE ){
            kill_card(player, card, KILL_SACRIFICE);
        }
        else if( event == EVENT_RESOLVE_ACTIVATION ){
            regenerate_target( p, c );
        }
    }
    load_text(0, "TARGET_CREATURE");
    return aura_pump(player, card, event, 1, 1);
}

int card_thrull_wizard(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if(event == EVENT_CAN_ACTIVATE ){
        int result =  card_spiketail_hatchling(player, card, event);
        if( result == 0 || ! has_mana_multi(player, 1, 1, 0, 0, 0, 0) ){
            return 0;
        }
        int color = 1 << get_sleighted_color(player, card, COLOR_BLACK);
        if( get_color( card_on_stack_controller, card_on_stack ) & color ){
            instance->targets[0].player = card_on_stack_controller;
            instance->targets[0].card = card_on_stack;
            return result;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 1, 0, 0, 0, 0);
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int choice = 0;
        if( instance->targets[0].player == AI && has_mana(instance->targets[0].player, COLOR_BLACK, 1) ){
            choice = 1;
        }
        else if( player == HUMAN ){
            choice = do_dialog(player, player, card, -1, -1, " Pay 3\n Pay B\n Do not pay", 0); 
        }
            
        if( choice == 0 ){
            charge_mana( instance->targets[0].player, COLOR_COLORLESS, 3);
        }
        else if( choice == 1 ){
            charge_mana( instance->targets[0].player, COLOR_BLACK, 1);
        }    
        
        if( spell_fizzled == 1 || choice == 2 ){
            kill_card(instance->targets[0].player, instance->targets[0].card, KILL_DESTROY);
        }
    }
    return 0;
}

int card_tourachs_chant(int player, int card, event_t event){
    basic_upkeep(player, card, event, 0, 1, 0, 0, 0, 0);
    if(trigger_condition == TRIGGER_COMES_INTO_PLAY && affect_me( trigger_cause_controller, trigger_cause ) && reason_for_trigger_controller == affected_card_controller && has_subtype(trigger_cause_controller, trigger_cause, SUBTYPE_FOREST) ){
        if(event == EVENT_TRIGGER){
            event_result |= RESOLVE_TRIGGER_MANDATORY;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            int p = trigger_cause_controller;
            target_definition_t td;
            default_target_definition(player, card, &td, TYPE_CREATURE);
            td.allowed_controller = p;
            td.preferred_controller = p;
            td.who_chooses = p;
            td.allow_cancel = 0;
         
            int choice = 1;
            if( can_target( &td ) ){
                choice = do_dialog(player, player, card, -1, -1, " Add a -1/-1 counter\n Take 3 damage", 0); 
            }
        
            if( choice == 0 ){
                pick_target(&td, "TARGET_CREATURE" );
                card_instance_t *instance = get_card_instance(player, card);
                card_instance_t *target = get_card_instance(instance->targets[0].player, instance->targets[0].card);
                target->counters++;
                target->counter_power--;
                target->counter_toughness--;
            }
            else{
                damage_player(p, 3, player, card);
            }
        }
    }
    return global_enchantment(player, card, event);
}

int card_tourachs_gate(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    
    int p = player;
    int c = instance->targets[5].player;
    if( c  > -1 && in_play(p, c) && p == player ){
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.required_subtype = SUBTYPE_THRULL;
        td.allowed_controller = p;
        td.preferred_controller = p;
        td.illegal_abilities = 0;
            
        if( event == EVENT_CAN_ACTIVATE ){
            if( can_target(&td) || ! is_tapped(p, c) ){
                return 1;
            }
        }
        else if( event == EVENT_ACTIVATE ){
            int choice = 0;
            int ai_choice = 1;
            if( count_counters(player, card) > 0 ){
                ai_choice = 0;
            }
            if( can_target(&td) && ! is_tapped(p, c) ){
                choice = do_dialog(player, player, card, -1, -1, " Sac a Thrull\n Tap Enchanted Land", ai_choice); 
            }
            else if( ! can_target(&td) ){
                choice = 1;
            }
            
            if( choice == 0 ){
                if( pick_target(&td, "TARGET_CREATURE" ) ){
                    kill_card(player, instance->targets[0].card, KILL_SACRIFICE ); 
                    instance->info_slot = 0;
                }  
            }
            else{
                instance->info_slot = 1;
                tap_card(p, c);  
            }
        }
        else if( event == EVENT_RESOLVE_ACTIVATION ){
            if( instance->info_slot == 0 ){
               card_instance_t *parent = get_card_instance(player, instance->parent_card);
               parent->counters+=3; 
            }
            else{
                int count =0;
                while(count < active_cards_count[player]){
                    card_instance_t *inst = get_card_instance(player, count);
                    if( inst->state & STATE_ATTACKING ){
                        pump_until_eot(player, instance->parent_card, player, count, 2, -1);
                    }
                    count++;
                }
            }
        }
    }
    
    if( current_turn == player && upkeep_trigger(player, card, event) ){
        if( count_counters(player, card) <= 1 ){
            kill_card(player, card, KILL_SACRIFICE);
        }
        instance->counters--;
    }
    
    
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_LAND);
    td.allowed_controller = player;
    td.preferred_controller = player;
    if( event == EVENT_CAN_CAST && can_target(&td) ){
        return 1;
    }
    else if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
        if( pick_target(&td, "TARGET_LAND" ) ){
            instance->targets[5].player = instance->targets[0].card;
        }
    }
    if( event == EVENT_CHANGE_TYPE || event == EVENT_CAST_SPELL ){
        return 0;
    }
    return card_evil_presence(player, card, event);
}

// red
int card_brassclaw_orcs(int player, int card, event_t event){
    if(event == EVENT_BLOCK_LEGALITY && affect_me(player, card) ){
        if( get_power(attacking_card_controller, attacking_card) >= 2 ){
            event_result = 1;
        }  
    }
    return 0;
}

int card_dwarven_armorer(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    card_instance_t *instance = get_card_instance(player, card); 
    if( event == EVENT_CAN_ACTIVATE ){
        if( ! is_tapped(player, card) && ! is_sick(player, card) && has_mana(player, COLOR_RED, 1) && hand_count[player] > 0 ){
            return 1;
        } 
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_RED, 1);
        if( pick_target(&td, "TARGET_CREATURE") ){
            tap_card(player, card);
            discard(player, 0, 0);
            instance->number_of_targets = 1;
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( valid_target(&td) ){
            int choice = do_dialog(player, player, card, -1, -1, " 1+/+0\n +0/+1", 0);
            card_instance_t *target = get_card_instance(instance->targets[0].player, instance->targets[0].card );
            target->counters++;
            if( choice == 0 ){
                target->counter_power++;
            }
            else{
                target->counter_toughness++;
            }
        }
    }
    return 0;
}

int card_dwarven_catapult(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
        instance->info_slot = x_value;
    }
    if( event == EVENT_RESOLVE_SPELL ){  
        int p = 1-player;
        int creatures = 0;
        int count = 0;
        while(count < active_cards_count[p]){
            card_data_t card_d = get_card_data(p, count);
            if((card_d.type & TYPE_CREATURE) && in_play(p, count)){
                creatures++;
            }
            count++;
        }
        
        count = 0;
        int damage = 0;
        if( creatures > 0 ){
            damage = instance->info_slot / creatures;
            while(count < active_cards_count[p]){
                card_data_t card_d = get_card_data(p, count);
                if((card_d.type & TYPE_CREATURE) && in_play(p, count)){
                    damage_creature(p, count, damage, player, card);
                }
                count++;
            }
        }
        kill_card(player, card, KILL_DESTROY);
    }
    else if ( event == EVENT_CAN_CAST ){
        return 1;
    }
    return 0;
}

int card_dwarven_lieutenant(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_DWARF;
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 1, 0) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 1, 0);
        if( spell_fizzled != 1 ){
            instance->number_of_targets = 0;
            pick_target(&td, "TARGET_CREATURE");
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if(valid_target(&td) ){
            pump_until_eot(player, instance->parent_card, instance->targets[0].player, instance->targets[0].card, 1, 0);
        }
    }
    return 0;
}

int card_dwarven_soldier(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_DECLARE_BLOCKERS ){
        if( instance->state & STATE_ATTACKING ){
            int p = 1-player;
            int count = 0;
            while(count < active_cards_count[p]){
                card_instance_t *inst = get_card_instance(p, count);
                card_data_t card_d = get_card_data(p, count);
                if((card_d.type & TYPE_CREATURE) && in_play(p, count) && inst->blocking == card && has_subtype(p, count, SUBTYPE_ORC) ){
                    pump_until_eot(player, card, player, card, 0, 2);
                    break;
                }
                count++;
            }
        }
        else if( instance->blocking != 255 && has_subtype(1-player, instance->blocking, SUBTYPE_ORC) ){
            pump_until_eot(player, card, player, card, 0, 2);
        }  
    }
    return 0;
}

int card_goblin_chirurgeon(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    if( event == EVENT_CAN_ACTIVATE ){
        if( land_can_be_played & 0x200 ){
            return is_creature_dead();
        }
    }
    else if( event == EVENT_ACTIVATE ){
        if( pick_creature_to_regen(td) ){
            target_definition_t td1;
            default_target_definition(player, card, &td1, TYPE_CREATURE);
            td1.required_subtype = SUBTYPE_GOBLIN;
            td1.allowed_controller = player;
            td1.preferred_controller = player;
            instance->targets[1] = instance->targets[0];
            if( pick_target(&td1, "LORD_OF_THE_PIT") ){
                kill_card(player, instance->targets[0].card, KILL_SACRIFICE );
                instance->targets[0] = instance->targets[1];
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( valid_target(&td) ){
            regenerate_target( instance->targets[0].player, instance->targets[0].card );
        }    
    }
    return 0;
}

int card_goblin_flotilla(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_DECLARE_ATTACKERS ){
        charge_mana(player, COLOR_RED, 1);
        if( spell_fizzled == 1 ){
            instance->info_slot = 1;
        }
        else{
            instance->info_slot = 0;
        }
    }
    
    if( event == EVENT_DECLARE_BLOCKERS && instance->info_slot == 1 ){
        if( instance->state & STATE_ATTACKING ){
            int p = 1-player;
            int count = 0;
            while(count < active_cards_count[p]){
                card_instance_t *inst = get_card_instance(p, count);
                card_data_t card_d = get_card_data(p, count);
                if((card_d.type & TYPE_CREATURE) && in_play(p, count) && inst->blocking == card ){
                    pump_ability_until_eot(player, card, p, count, 0, 0, KEYWORD_FIRST_STRIKE);
                    break;
                }
                count++;
            }
        }
        else if( instance->blocking != 255 ){
            pump_ability_until_eot(player, card, 1-player, instance->blocking, 0, 0, KEYWORD_FIRST_STRIKE);
        }  
    }
    return 0;
}

int effect_goblin_kites(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( eot_trigger(player, card, event) ){
        if( rand(2) == 1 ){
            kill_card(instance->targets[0].player, instance->targets[0].card, KILL_SACRIFICE);
        }
        kill_card(player, card, KILL_SACRIFICE );
    }
    return 0;
}

int card_goblin_kites(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.toughness_requirement = 0x2002;
    td.allowed_controller = player;
    td.preferred_controller = player;
    if( event == EVENT_CAN_ACTIVATE ){
        if( can_target(&td) && has_mana(player, COLOR_RED, 1) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_RED, 1);
        pick_target(&td, "TARGET_CREATURE");
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        pump_ability_until_eot(player, card, player, instance->targets[0].card, 0, 0, KEYWORD_FLYING);
        int legacy_card = create_targetted_legacy_effect(player, card, &effect_goblin_kites, instance->targets[0].player, instance->targets[0].card);
        card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
        legacy_instance->targets[0].player = instance->targets[0].player;
        legacy_instance->targets[0].card = instance->targets[0].card;
    }
    return global_enchantment(player, card, event);
}

int card_goblin_war_drums(int player, int card, event_t event){
    int count = 0;
    while(count < active_cards_count[player]){
        if(in_play(player, count) ){
            minimum_blockers(player, count, event, 2);
        }
        count++;
    }
    return global_enchantment(player, card, event);
}

int card_goblin_warrens(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_GOBLIN;
    td.allowed_controller = player;
    td.preferred_controller = player;
    if( event == EVENT_CAN_ACTIVATE && can_target(&td) > 1 && has_mana_multi(player, 2, 0, 0, 0, 1, 0) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 2, 0, 0, 0, 1, 0);
        if( pick_target(&td, "LORD_OF_THE_PIT") ){
            td.allow_cancel = 0;
            card_instance_t *instance = get_card_instance(player, card);
            card_instance_t *target = get_card_instance(player, instance->targets[0].card);
            target->state |= STATE_CANNOT_TARGET;
            instance->targets[1] = instance->targets[0];
            if( pick_target(&td, "LORD_OF_THE_PIT") ){
                kill_card(player, instance->targets[0].card, KILL_SACRIFICE);
                kill_card(player, instance->targets[1].card, KILL_SACRIFICE);
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        generate_token(player, "Goblin");
        generate_token(player, "Goblin");
        generate_token(player, "Goblin");
    }
    return global_enchantment(player, card, event);
}

int card_orcish_captain(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_ORC;
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 0, 0) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
        pick_target(&td, "TARGET_CREATURE");
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( valid_target(&td) ){
            card_instance_t *instance = get_card_instance(player, card);
            if( rand(2) == 1 ){
                pump_until_eot(player, card, instance->targets[0].player, instance->targets[0].card, 2, 0);
            }
            else{
                pump_until_eot(player, card, instance->targets[0].player, instance->targets[0].card, 0, -2);
            }
        }
    }
    return 0;
}

int card_orcish_spy(int player, int card, event_t event){
    if( event == EVENT_CAN_ACTIVATE && ! is_sick(player, card) && ! is_tapped(player, card) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.zone = TARGET_ZONE_PLAYERS;
        if( pick_target(&td, "TARGET_PLAYER") ){
            tap_card(player, card);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *instance = get_card_instance(player, card);
        int p = instance->targets[0].player;
        show_deck( player, deck_ptr[p], 3, "Spying...", 0, 0x7375B0 );
    }
    return 0;
}

int card_orcish_veteran(int player, int card, event_t event){
    if( event == EVENT_CAN_ACTIVATE && has_mana(player, COLOR_RED, 1) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_RED, 1);
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *instance = get_card_instance(player, card);
        pump_ability_until_eot(player, card, player, instance->parent_card, 0, 0, KEYWORD_FIRST_STRIKE);
    }
    else if( event == EVENT_BLOCK_LEGALITY ){
        if( affect_me( player, card ) ){      
            int color = 1 << get_sleighted_color(player, card, COLOR_WHITE);
            if( get_power(attacking_card_controller, attacking_card) > 1 && ( get_color(attacking_card_controller, attacking_card) & color) ){
                event_result = 1;
            }    
        }
    }
    return 0;
}

int card_orgg(int player, int card, event_t event){
    if( event == EVENT_BLOCK_LEGALITY ){
        if( affect_me( player, card ) ){      
            if( get_power(attacking_card_controller, attacking_card) > 2 ){
                event_result = 1;
            }    
        }
    }
    else if( event == EVENT_ATTACK_LEGALITY ){
        int p = 1-player;
        int count = 0;
        while(count < active_cards_count[p]){
            card_data_t card_d = get_card_data(p, count);
            if((card_d.type & TYPE_CREATURE) && in_play(p, count) && get_power(p, count) > 2 && ! is_tapped(p, count)){
                event_result = 1;
            }
            count++;
        }
    }
    return 0;
}

int card_raiding_party(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_ORC;
    td.allowed_controller = player;
    td.preferred_controller = player;
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && can_target(&td) ){
        return 1;   
    }
    else if( event == EVENT_ACTIVATE ){
        if( pick_target(&td, "LORD_OF_THE_PIT") ){
            kill_card(player, instance->targets[0].card, KILL_SACRIFICE);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        // each play may tap white creatures
        int p=0;
        for(p=0;p<2;p++){
            default_target_definition(player, card, &td, TYPE_CREATURE);
            td.required_color = 1 << get_sleighted_color(player, card, COLOR_WHITE);
            td.illegal_state = TARGET_STATE_TAPPED;
            td.who_chooses = p;
            td.allowed_controller = p;
            td.preferred_controller = p;
            int chosen = 0;
            while( can_target(&td) && spell_fizzled != 1 ){
                if( pick_target(&td, "CREATURE_TO_TAP" ) ){
                    tap_card( p, instance->targets[0].card );
                    chosen+=2;
                }
            }
            spell_fizzled = -1;
            
            // save up to 2 plains per tapped creature
            int i =0;
            default_target_definition(player, card, &td, TYPE_LAND);
            td.required_subtype = SUBTYPE_PLAINS;
            td.who_chooses = p;
            while(i<chosen && can_target(&td) && spell_fizzled != 1 ){
                if( pick_target(&td, "TARGET_LAND") ){
                    card_instance_t *inst = get_card_instance(instance->targets[0].player, instance->targets[0].card);
                    inst->state |= STATE_CANNOT_TARGET;
                    i++;
                }
            }
            spell_fizzled = -1;      
        }
        
        // destroy all plains 
        for(p=0;p<2;p++){
            int count = 0;
            while(count < active_cards_count[p]){
                card_instance_t *inst = get_card_instance(p, count);
                
                if(has_subtype(p, count, SUBTYPE_PLAINS) && in_play(p, count) ){
                    if( inst->state & STATE_CANNOT_TARGET ){
                        inst->state &= ~STATE_CANNOT_TARGET;
                    }
                    else{
                        kill_card( p, count, KILL_DESTROY );
                    }
                }
                count++;
            }
        }
    }
    return global_enchantment(player, card, event);
}

// green cards
int card_elven_fortress(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_state = TARGET_STATE_BLOCKING;
    
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 1, 0, 0) && can_target(&td) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 1, 0, 0);
        if( spell_fizzled != 1 ){
            instance->number_of_targets = 0;
            pick_target(&td, "TARGET_CREATURE");
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if(valid_target(&td) ){
            pump_until_eot(player, instance->parent_card, instance->targets[0].player, instance->targets[0].card, 0, 1);
        }
    }
    return global_enchantment(player, card, event);
}

int spore_counters(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( current_turn == player && upkeep_trigger(player, card, event) ){
        add_ccounter(player, card);
    }
    else if( event == EVENT_CAN_ACTIVATE && count_ccounters(player, card) > 2 ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE && instance->info_slot == 1 ){
        set_ccounters(player, card, count_ccounters(player, card) - 3 );
    }
    else if( event == EVENT_RESOLVE_ACTIVATION && instance->info_slot == 1 ){
        generate_token(player, "Saproling");
    }
    return 0;
}

int card_elvish_farmer(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_SAPROLING;
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.illegal_abilities = 0;
    
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && can_target(&td) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        int choice = 1;
        if( can_target(&td) && spore_counters(player, card, EVENT_CAN_ACTIVATE) ){
            choice = do_dialog(player, player, card, -1, -1, " Gain 2 Life\n Make a dude", 1);
        }
        else if( can_target(&td) ){
            choice = 0;
        }
        instance->info_slot = choice;
        if( choice == 0 ){
            instance->number_of_targets = 0;
            if( pick_target(&td, "LORD_OF_THE_PIT") ){
                kill_card(player, instance->targets[0].card, KILL_SACRIFICE);    
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION && instance->info_slot == 0  ){
        gain_life(player, 2);
    }
    return spore_counters(player, card, event);
}

int card_elvish_hunter(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 1, 0, 0) && ! is_sick(player, card) && ! is_tapped(player, card)){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 1, 0, 0);
        if( spell_fizzled != 1 ){
            instance->number_of_targets = 0;
            if( pick_target(&td, "TARGET_CREATURE") ){
                tap_card(player, card);
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if(valid_target(&td) ){
            create_targetted_legacy_effect(player, card, &effect_does_not_untap, instance->targets[0].player, instance->targets[0].card);
        }
    }
    return 0;
}

int card_elvish_scout(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_state = TARGET_STATE_ATTACKING;
    td.allowed_controller = player;
    td.preferred_controller = player;
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 0, 0, 0, 1, 0, 0) && ! is_sick(player, card) && ! is_tapped(player, card) && can_target(&td) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 0, 0, 0, 1, 0, 0);
        if( spell_fizzled != 1 ){
            instance->number_of_targets = 0;
            if( pick_target(&td, "TARGET_CREATURE") ){
                tap_card(player, card);
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if(valid_target(&td) ){
            untap_card(player,  instance->targets[0].card);
            int result = create_legacy_effect_exe(player, card, LEGACY_EFFECT_ITH, player, instance->targets[0].card);
            card_instance_t *legacy_instance = get_card_instance(player, result);
            legacy_instance->info_slot = 3;
        }
    }
    return 0;
}

int card_feral_thallid(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    int result = spore_counters(player, card, event);
    if( (land_can_be_played & 0x200) ){
        if( event == EVENT_CAN_ACTIVATE && result && instance->kill_code == KILL_DESTROY ){
            return 0x63;
        } 
        else if( event == EVENT_ACTIVATE ){
            set_ccounters(player, card, count_ccounters(player, card) - 3 );
        }
        else if( event == EVENT_RESOLVE_ACTIVATION ){
            regenerate_target(player, instance->parent_card);
        }
    }
    return 0;
}

int card_fungal_bloom(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_FUNGUS;
    
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 0, 0, 0, 2, 0, 0) && can_target(&td) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 0, 0, 0, 2, 0, 0);
        if( spell_fizzled != 1 ){
            instance->number_of_targets = 0;
            pick_target(&td, "TARGET_CREATURE");
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if(valid_target(&td) ){
            add_ccounter(instance->targets[0].player, instance->targets[0].card);
        }
    }
    return global_enchantment(player, card, event);
}

int card_night_soil(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_FUNGUS;
    
    int ok1 = 0;
    int ok2 = 0;
    if( count_graveyard_by_type(player, TYPE_CREATURE) > 1 ){
        ok1 = 1;
    }
    if( count_graveyard_by_type(1-player, TYPE_CREATURE) > 1 ){
        ok2 = 1;
    }
        
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 0, 0) && ( ok1 + ok2 > 0 ) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
        if( spell_fizzled != 1 ){
            int choice = 1;
            if( ok1 && ok2 ){
                choice = do_dialog(player, player, card, -1, -1, " From My Grave\n From Opponent's Grave", 0);
            }
            else if( ok1 == 1 ){
                choice = 0;
            }
            if( player == AI ){ choice = 1-choice; }
            
            int *grave = graveyard_ptr[choice];
            int i=0;
            while( i < 2 ){
                int selected = show_deck( player, grave, 500, "Pick a creature card", 0, 0x7375B0 );
                if( selected != -1 && cards_data[ grave[selected] ].type & TYPE_CREATURE ){
                    remove_card_from_grave(choice, selected);
                    i++;
                }
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        generate_token(player, "Saproling");
    }
    return global_enchantment(player, card, event);
}

int card_spore_cloud(int player, int card, event_t event){
    if( event == EVENT_RESOLVE_SPELL ){
        int p = current_turn;
        int count;
        for(count=active_cards_count[p]-1;count>=0;count--){
            card_data_t card_d = get_card_data(p, count);
            if((card_d.type & TYPE_CREATURE) && in_play(p, count)){
                card_instance_t *instance = get_card_instance(p, count);
                if( instance->state & STATE_ATTACKING ){
                    create_targetted_legacy_effect(player, card, &effect_does_not_untap, p, count);
                }
            }
        }
        
        p = 1-current_turn;
        for(count=active_cards_count[p]-1;count>=0;count--){
            card_data_t card_d = get_card_data(p, count);
            if((card_d.type & TYPE_CREATURE) && in_play(p, count)){
                card_instance_t *instance = get_card_instance(p, count);
                if( instance->blocking != 255 ){
                    create_targetted_legacy_effect(player, card, &effect_does_not_untap, p, count);
                    tap_card(p, count);
                }
            }
        }
    }
    else if( event == EVENT_CAN_CAST ){
        return 1;
    }
    return card_fog(player, card, event);
}

int card_spore_flower(int player, int card, event_t event){
    if( event == EVENT_ACTIVATE ){
        set_ccounters(player, card, count_ccounters(player, card) - 3 );
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        card_fog(player, card, EVENT_RESOLVE_SPELL);
    }
    return spore_counters(player, card, event);
}

int card_thallid(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    instance->info_slot = 1;
    return spore_counters(player, card, event);
}

int card_thallid_devourer(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_SAPROLING;
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.illegal_abilities = 0;
    
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && can_target(&td) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        int choice = 1;
        if( can_target(&td) && spore_counters(player, card, EVENT_CAN_ACTIVATE) ){
            choice = do_dialog(player, player, card, -1, -1, " Get +1/+2\n Make a dude", 1);
        }
        else if( can_target(&td) ){
            choice = 0;
        }
        instance->info_slot = choice;
        if( choice == 0 ){
            instance->number_of_targets = 0;
            if( pick_target(&td, "LORD_OF_THE_PIT") ){
                kill_card(player, instance->targets[0].card, KILL_SACRIFICE);    
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION && instance->info_slot == 0  ){
        pump_until_eot(player, card, player, instance->parent_card, 1, 2);
    }
    return spore_counters(player, card, event);
}

int effect_thelonite_druid(int player, int card, event_t event){
    if( eot_trigger(player, card, event) ){
        kill_card(player, card, KILL_SACRIFICE );
    }
    
    card_instance_t *instance = get_card_instance(player, card);
    int j = instance->info_slot;
    int result = 0;
    if( affected_card_controller == player ){
        card_living_lands(player, card, event);
        if( event == EVENT_POWER && has_subtype(player, affected_card, SUBTYPE_FOREST) ){
            event_result++;
        }
        if( event == EVENT_TOUGHNESS && has_subtype(player, affected_card, SUBTYPE_FOREST) ){
            event_result+=2;
        }
    }
    instance->info_slot = j;
    return result;
}

int card_thelonite_druid(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.allowed_controller = player;
    td.preferred_controller = player;
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 1, 0, 0) && ! is_sick(player, card) && ! is_tapped(player, card) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 1, 0, 0);
        if( pick_target(&td, "LORD_OF_THE_PIT") ){
            kill_card(player, instance->targets[0].card, KILL_SACRIFICE);
            tap_card(player, card);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
       create_legacy_effect(player, card, &effect_thelonite_druid);
    }
    return 0;
}

int effect_thelonite_monk(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CHANGE_TYPE && affect_me(instance->targets[0].player, instance->targets[0].card) ){
        event_result = 2;
        gain_life(HUMAN, 1);
    }
    return 0;
}
    
int card_thelonite_monk(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_color = 1 << get_sleighted_color(player, card, COLOR_GREEN);
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.allow_cancel = 0;
    
    target_definition_t td1;
    default_target_definition(player, card, &td1, TYPE_LAND);
    td1.allow_cancel = 0;
        
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && ! is_tapped(player, card) && ! is_sick(player, card) && can_target(&td) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        tap_card(player, card);
        pick_target(&td, "LORD_OF_THE_PIT" );
        kill_card( player, instance->targets[0].card, KILL_SACRIFICE );
        
        pick_target(&td1, "TARGET_LAND" );
    }
    else if( event == EVENT_RESOLVE_ACTIVATION && valid_target(&td1) ){
        create_targetted_legacy_effect(player, card, &effect_thelonite_monk, instance->targets[0].player, instance->targets[0].card);
    }
    return 0;
}

int card_thelons_chant(int player, int card, event_t event){
    basic_upkeep(player, card, event, 0, 0, 0, 1, 0, 0);
    if(trigger_condition == TRIGGER_COMES_INTO_PLAY && affect_me( trigger_cause_controller, trigger_cause ) && reason_for_trigger_controller == affected_card_controller && has_subtype(trigger_cause_controller, trigger_cause, SUBTYPE_SWAMP) ){
        if(event == EVENT_TRIGGER){
            event_result |= RESOLVE_TRIGGER_MANDATORY;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            int p = trigger_cause_controller;
            target_definition_t td;
            default_target_definition(player, card, &td, TYPE_CREATURE);
            td.allowed_controller = p;
            td.preferred_controller = p;
            td.who_chooses = p;
            td.allow_cancel = 0;
         
            int choice = 1;
            if( can_target( &td ) ){
                choice = do_dialog(player, player, card, -1, -1, " Add a -1/-1 counter\n Take 3 damage", 0); 
            }
        
            if( choice == 0 ){
                pick_target(&td, "TARGET_CREATURE" );
                card_instance_t *instance = get_card_instance(player, card);
                card_instance_t *target = get_card_instance(instance->targets[0].player, instance->targets[0].card);
                target->counters++;
                target->counter_power--;
                target->counter_toughness--;
            }
            else{
                damage_player(p, 3, player, card);
            }
        }
    }
    return global_enchantment(player, card, event);
}

int card_thelons_curse(int player, int card, event_t event){
    // blue creatures do not untap
    int color = 1 << get_sleighted_color(player, card, COLOR_BLUE);
    int p=0;
    for(p=0;p<2;p++){
        int i=0;
        for(i=0;i<active_cards_count[p];i++){
            card_data_t card_d = get_card_data(p, i);
            if((card_d.type & TYPE_CREATURE) && in_play(p, i) && (get_color(p, i) & color) ){
                does_not_untap(p, i, event);
            }
        }
    }
    
    // can untap them during upkeep
    if( upkeep_trigger(player, card, event) ){
        p = current_turn;
        int i=0;
        for(i=0;i<active_cards_count[p];i++){
            card_data_t card_d = get_card_data(p, i);
            if( is_tapped(p, i) && (card_d.type & TYPE_CREATURE) && in_play(p, i) && (get_color(p, i) & color) ){
                if( has_mana(p, COLOR_BLUE, 1) ){
                    int choice = do_dialog(p, p, i, -1, -1, " Pay U for Thelon's Curse\n Do not pay", 0);
                    if( choice == 0){
                        charge_mana(p, COLOR_BLUE, 1);
                        if( spell_fizzled != 1 ){
                            untap_card(p, i);
                        }
                    }
                }
            }
        }
    }
    return global_enchantment(player, card, event);
}

int card_thorn_thallid(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE );
    td.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
    if( event == EVENT_ACTIVATE ){
        if( pick_target(&td, "TARGET_CREATURE_OR_PLAYER") ){
            set_ccounters(player, card, count_ccounters(player, card) - 3 );
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( valid_target(&td) ){
            damage_creature_or_player(player, card, event, 1, 3);
        }
    }
    return spore_counters(player, card, event);
}

// artifacts and lands
int card_aeolipile(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE );
    td.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 0, 0) && ! is_tapped(player, card) && ! is_animated_and_sick(player, card) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
        if( spell_fizzled !=1 && pick_target(&td, "TARGET_CREATURE_OR_PLAYER") ){
            tap_card(player, card);
            kill_card(player, card, KILL_SACRIFICE);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( valid_target(&td) ){
            damage_creature_or_player(player, card, event, 2, 3);
        }
    }
    return 0;
}

int card_balm_of_restoration(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE );
    td.zone = TARGET_ZONE_PLAYERS;
    
    target_definition_t td1;
    default_target_definition(player, card, &td1, TYPE_CREATURE);
    td1.extra = damage_card;
    td1.required_type = 0;
    
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 0, 0) && ! is_tapped(player, card) && ! is_animated_and_sick(player, card) ){
        if( can_target(&td1) ){
            return 0x63;
        }
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
        if( spell_fizzled !=1 ){
            if( can_target(&td1) ){
                pick_target(&td1, "TARGET_DAMAGE");
            } 
            else{
                if( pick_target(&td, "TARGET_PLAYER") ){
                    instance->info_slot = 1;
                }
            }
            if( spell_fizzled != 1 ){
                tap_card(player, card);
                kill_card(player, card, KILL_SACRIFICE);
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( instance->info_slot == 1 ){
            gain_life( instance->targets[0].player, 2);
        }
        else{
            card_instance_t *target = get_card_instance(instance->targets[0].player, instance->targets[0].card);
            if( target->info_slot > 0 ){
                target->info_slot-=2;
            }
        }
    }
    return 0;
}

int storage_land(int player, int card, event_t event, int color){
    comes_into_play_tapped(player, card, event);
    int count = count_ccounters(player, card);
    if( current_turn == player && is_tapped(player, card) && upkeep_trigger(player, card, event) ){
        add_ccounter(player, card);
    }
    else if( event == EVENT_CAN_ACTIVATE ){
        if( ! is_tapped(player, card) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        tap_card(player, card);
        int number = count + 1;
        if( player == AI ){
            number = count;
        }
        else{    
            while( number > count ){
                number = choose_a_number(player, "Remove how many counters?", count);
            }
        }
        if( number == -1 ){
            untap_card(player, card);
            spell_fizzled = 1;
            return 0;
        }
        set_ccounters(player, card, count - number );
        produce_mana(player, color, number);
        spell_fizzled = 1;
    }
    else if( event == EVENT_COUNT_MANA ){
        if( ! is_tapped(player, card) && affect_me(player, card) ){
            declare_mana_available(player, color, count);     
        }
    }
    else if(player == AI && count < 3 ){
        does_not_untap(player, card, event);
    }
    else if(player == HUMAN ){
        return card_tawnoss_weaponry(player, card, event);
    }
    return 0;
}

int card_bottomless_vault(int player, int card, event_t event){
    return storage_land(player, card, event, COLOR_BLACK);
}

int card_dwarven_hold(int player, int card, event_t event){
    return storage_land(player, card, event, COLOR_RED);
}

int card_hollow_trees(int player, int card, event_t event){
    return storage_land(player, card, event, COLOR_GREEN);
}

int card_icatian_store(int player, int card, event_t event){
    return storage_land(player, card, event, COLOR_WHITE);
}

int card_sand_silos(int player, int card, event_t event){
    return storage_land(player, card, event, COLOR_BLUE);
}

int card_conch_horn(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE );
    td.zone = TARGET_ZONE_HAND;
    td.illegal_abilities = 0;
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.allow_cancel = 0;
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 0, 0) && ! is_tapped(player, card) && ! is_animated_and_sick(player, card) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
        if( spell_fizzled !=1 ){
            tap_card(player, card);
            kill_card(player, card, KILL_SACRIFICE);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        draw_cards(player, 2);
        pick_target(&td, "BRONZE_TABLET");
        put_on_top_of_deck(player, instance->targets[0].card);
    }
    return 0;
}


int effect_delifs_cone(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    int p = player;
    int c = instance->targets[0].card;
    
    if( event == EVENT_PREVENT_DAMAGE && ( current_phase == PHASE_NORMAL_COMBAT_DAMAGE || current_phase == PHASE_FIRST_STRIKE_DAMAGE ) ){
        card_instance_t *source = get_card_instance(affected_card_controller, affected_card);
        if( damage_card != source->internal_card_id ){
            return 0;
        }
        if( source->damage_source_player == p &&  source->damage_source_card == c ){
            if( is_unblocked(p, c)  ){
                gain_life(p,  get_power(p, c) );
                source->info_slot = 0;
            }
        }
    }
    if( eot_trigger(player, card, event) ){
        kill_card(player, card, KILL_SACRIFICE );
    }
    return 0;
}

int card_delifs_cone(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE );
    td.illegal_abilities = 0;
    td.allowed_controller = player;
    td.preferred_controller = player;
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE && ! is_tapped(player, card) && ! is_animated_and_sick(player, card) && can_target(&td) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        if( pick_target(&td, "TARGET_CREATURE") ){
            tap_card(player, card);
            kill_card(player, card, KILL_SACRIFICE);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        create_targetted_legacy_effect(player, card, &effect_delifs_cone, player, instance->targets[0].card);
    }
    return 0;
}

int effect_delifs_cube(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    int p = player;
    int c = instance->targets[0].card;
    
    if( event == EVENT_PREVENT_DAMAGE && ( current_phase == PHASE_NORMAL_COMBAT_DAMAGE || current_phase == PHASE_FIRST_STRIKE_DAMAGE ) ){
        card_instance_t *source = get_card_instance(affected_card_controller, affected_card);
        if( damage_card != source->internal_card_id ){
            return 0;
        }
        if( source->damage_source_player == p &&  source->damage_source_card == c ){
            if( is_unblocked(p, c)  ){
                gain_life(HUMAN, 1+instance->targets[1].card);
                add_ccounter( instance->targets[1].player, instance->targets[1].card ); 
                source->info_slot = 0;
            }
        }
    }
    if( eot_trigger(player, card, event) ){
        kill_card(player, card, KILL_SACRIFICE );
    }
    return 0;
}

int card_delifs_cube(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE );
    
    if( land_can_be_played & 0x200 ){
        if( event == EVENT_CAN_ACTIVATE && count_ccounters(player, card) > 0 && has_mana_multi(player, 2, 0, 0, 0, 0, 0) ){
            return is_creature_dead();
        }
        else if( event == EVENT_ACTIVATE ){
            charge_mana_multi(player, 2, 0, 0, 0, 0, 0);
            if( spell_fizzled != 1 && pick_creature_to_regen(td) ){
                remove_ccounter(player, card);
            }
        }
        else if( event == EVENT_RESOLVE_ACTIVATION ){
            if( valid_target(&td) ){
                regenerate_target( instance->targets[0].player, instance->targets[0].card );
            }
        }
        return 0;
    }
    
    td.illegal_abilities = 0;
    td.allowed_controller = player;
    td.preferred_controller = player;
    if( event == EVENT_CAN_ACTIVATE && ! is_tapped(player, card) && ! is_animated_and_sick(player, card) && can_target(&td) && has_mana_multi(player, 2, 0, 0, 0, 0, 0) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 2, 0, 0, 0, 0, 0);
        if( spell_fizzled != 1 && pick_target(&td, "TARGET_CREATURE") ){
            instance->number_of_targets = 1;
            tap_card(player, card);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( valid_target(&td) ){
            int legacy_card = create_targetted_legacy_effect(player, card, &effect_delifs_cube, player, instance->targets[0].card);
            card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
            legacy_instance->targets[1].player = player;
            legacy_instance->targets[1].card = instance->parent_card;
        }
    }
    return 0;
}
    
int card_draconian_cylix(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE );
    
    if( land_can_be_played & 0x200 ){
        if( event == EVENT_CAN_ACTIVATE && hand_count[player] > 0 && has_mana_multi(player, 2, 0, 0, 0, 0, 0) ){
            return is_creature_dead();
        }
        else if( event == EVENT_ACTIVATE ){
            charge_mana_multi(player, 2, 0, 0, 0, 0, 0);
            if( spell_fizzled != 1 && pick_creature_to_regen(td) ){
                discard(player, 1, 1);
                tap_card(player, card);
            }
        }
        else if( event == EVENT_RESOLVE_ACTIVATION ){
            if( valid_target(&td) ){
                regenerate_target( instance->targets[0].player, instance->targets[0].card );
            }
        }
    }
    return 0;
}

int card_elven_lyre(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE );
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 0, 0) && ! is_tapped(player, card) && ! is_animated_and_sick(player, card) && can_target(&td) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
        if( spell_fizzled !=1 && pick_target(&td, "TARGET_CREATURE_OR_PLAYER") ){
            tap_card(player, card);
            kill_card(player, card, KILL_SACRIFICE);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( valid_target(&td) ){
            pump_until_eot(player, card, instance->targets[0].player, instance->targets[0].card, 2, 2);
        }
    }
    return 0;
}


int card_implements_of_sacrifice(int player, int card, event_t event){
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 0, 0) && ! is_tapped(player, card) && ! is_animated_and_sick(player, card) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
        if( spell_fizzled !=1  ){
            int color = choose_a_color(player, rand(5) );
            tap_card(player, card);
            kill_card(player, card, KILL_SACRIFICE);
            produce_mana(player, color, 2);
        }
    }
    return 0;
}

int effect_rainbow_vale(int player, int card, event_t event){
    if( eot_trigger(player, card, event) ){
        card_instance_t *instance = get_card_instance(player, card);
        card_instance_t *original = get_card_instance(instance->targets[0].player, instance->targets[0].card);
        if( player != original->targets[0].player ){
            int i=0;
            int p = original->targets[0].player;
            for(i=0;i<active_cards_count[p];i++){
                card_instance_t *inst = get_card_instance(p, i);
                if( inst->targets[3].card == 121 ){
                    kill_card(p, i, KILL_SACRIFICE);
                }
            }
            int result = switch_control(instance->targets[0].player, instance->targets[0].card, instance->targets[0].player, instance->targets[0].card);
            kill_card(player, result, KILL_SACRIFICE);
        }
        else{
            int result = switch_control(instance->targets[0].player, instance->targets[0].card, instance->targets[0].player, instance->targets[0].card);
            card_instance_t *legacy_instance = get_card_instance(player, result);
            legacy_instance->targets[3].card = 121;
        }
        kill_card(player, card, KILL_SACRIFICE );
    }
    return 0;
}

int card_rainbow_vale(int player, int card, event_t event){
    int result = mana_producer(player, card, event);
    card_instance_t *instance = get_card_instance(player, card);
    if( comes_into_play(player, card, event) ){
        instance->targets[0].player = player;
    }
    if( event == EVENT_ACTIVATE && spell_fizzled != 1 ){
        create_targetted_legacy_effect(player, card, &effect_rainbow_vale, player, card);
    }
    return result;
}

int card_ring_of_renewal(int player, int card, event_t event){
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 5, 0, 0, 0, 0, 0) && ! is_tapped(player, card) && ! is_animated_and_sick(player, card) && hand_count[player] > 0 ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 5, 0, 0, 0, 0, 0);
        if( spell_fizzled !=1 ){
            tap_card(player, card);
            discard(player, 1, 1);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        draw_cards(player, 2);
    }
    return 0;
}

int sword_and_shield(int player, int card, event_t event, event_t event2){
    int cost = 0x35 - event2;
    
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    
    card_instance_t *instance = get_card_instance(player, card);
    
    // if this is untapped, release any creatures
    if( (leaves_play( player, card, event) || ! is_tapped(player, card)) && instance->targets[1].card != -1 ){
        instance->targets[1].card = -1;
    }
    
    if( event == EVENT_CAN_ACTIVATE && ! is_tapped(player, card) && ! is_animated_and_sick(player, card) && has_mana_multi(player, cost, 0, 0, 0, 0, 0) ){
        return can_target(&td);
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, cost, 0, 0, 0, 0, 0);
        if( spell_fizzled != 1 && pick_target(&td, "TARGET_CREATURE") ){
            tap_card(player, card);
            instance->number_of_targets = 1;
        }
        
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( valid_target(&td) ){
            card_instance_t *inst = get_card_instance(player, instance->parent_card);
            inst->targets[1].card = instance->targets[0].card;
        }
    }
    else if( instance->targets[1].card > -1 && event == event2 && affect_me(instance->targets[0].player, instance->targets[1].card) ){
        event_result += 2;
    }
    else{
        return card_tawnoss_weaponry(player, card, event);
    }
    return 0;
}

int card_spirit_shield(int player, int card, event_t event){
    return sword_and_shield(player, card, event, EVENT_TOUGHNESS);
}

int card_zeylon_sword(int player, int card, event_t event){
    return sword_and_shield(player, card, event, EVENT_POWER);
}


