#include "manalink.h"

// --------------------------------------------------- Jatill new functions -----------------------------------------------

int get_hacked_walk(int player, int card, int orig_walk){
    int color = get_hacked_color(player, card, orig_walk - KEYWORD_SWAMPWALK + 1 );
    return 1 << ( color - 1 ) ;
}

int get_hacked_subtype(int player, int card, int orig_type){
    int orig_color = 1;
    if( orig_type == SUBTYPE_ISLAND ){
        orig_color = 2;
    }
    else if( orig_type == SUBTYPE_FOREST ){
        orig_color = 3;
    }
    else if( orig_type == SUBTYPE_MOUNTAIN ){
        orig_color = 4;
    }
    else if( orig_type == SUBTYPE_PLAINS ){
        orig_color = 5;
    }
    int color = get_hacked_color(player, card, orig_color );
    int new_subtype = SUBTYPE_SWAMP;
    if( color == 2 ){
        new_subtype = SUBTYPE_ISLAND;
    }
    else if( color == 3 ){
        new_subtype = SUBTYPE_FOREST;
    }
    else if( color == 4 ){
        new_subtype = SUBTYPE_FOREST;
    }
    else if( color == 5 ){
        new_subtype = SUBTYPE_FOREST;
    }
    return new_subtype;
}


// --------------------------------------------------- My functions -------------------------------------------------------

int from_graveyard_to_deck(int player, int selected, int action){
// action = 1 -> Put on top
// action = 2 -> Put on bottom
// action = 3 -> Shuffle into deck

  int *grave = graveyard_ptr[player];

  if( action == 1){
     int card_added = add_card_to_hand(player, grave[selected]);
     remove_card_from_grave(player, selected);
     put_on_top_of_deck(player, card_added);
  }

  if( action == 2){
     int *deck = deck_ptr[player];
     deck[ count_deck(player) ] = grave[selected];
     remove_card_from_grave(player, selected);
  }

  if( action == 3){
     int card_added = add_card_to_hand(player, grave[selected]);
     remove_card_from_grave(player, selected);
     put_on_top_of_deck(player, card_added);
     gain_life(player, 0);
     shuffle(player);
  }
  
  return action;
}

void rampage(int p, int c, int e, int number){
  int block_count = 0;

  if( e == EVENT_DECLARE_BLOCKERS ){
     int count = 0;
     while(count < active_cards_count[1-p]){
           if(in_play(1-p, count) ){
              card_instance_t *instance = get_card_instance( 1-p, count);
              if( instance->blocking == c ){
                 block_count++;
                 if( block_count > 1){
                    pump_until_eot(p, c, p, c, number, number);
                 }

              }
           }
           count++;
     }
  }

}

void damage_all(int p, int c, int controller, int amount_damage, int all, int player_too, int keyword, int flag1, int subtype, int flag2, int color, int flag3, int id, int flag4, int cc, int flag5){


// if you want to simply deal 5 damages to all creatures opponent controls, use this :
// damage_all(player, card, 1-player, 5, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0)
//
// keyword, subtype, color and id are considered only if are > 0, instead cc is considere only if is > -1
//
// keyword is about the static abilities, so if you want to deal 3 damages to all the flying creatures opponent control
// use this : damage_all(player, card, 1-player, 3, 0, 0, KEYWORD_FLYING, 0, 0, 0, 0, 0, 0, 0, -1, 0)
//
// flag determinates inclusive or exclusive test about that particular argument
// 0 = inclusive
// 1 = exclusive
//
// example : damage_all(player, card, 1-player, 5, 0, 0, 0, 0, SUBTIPE_ZOMBIE, 0, 0, 0, 0, 0, -1, 0)
//           will deal 5 damage to all Zombie creatures opponent controls. 
//
// otherwise : damage_all(player, card, 1-player, 5, 0, 0, 0, 0, SUBTIPE_ZOMBIE, 1, 0, 0, 0, 0, -1, 0)
//             will deal 5 damage to all the non-Zombie creatures opponent controls.
//
// if player_too is set to 1, amount_damage will be dealt to "controller" (the player who controls the creatures damaged) too.

  int TEST_TYPE = 0;
  
  if( (keyword) && flag1 < 1){
     TEST_TYPE+=1;
  }

  if( (subtype) && flag2 < 1){
     TEST_TYPE+=2;
  }

  if( (color) && flag3 < 1){
     TEST_TYPE+=4;
  }

  if( (id) && flag4 < 1){
     TEST_TYPE+=8;
  }

  if( cc > -1 && flag5 < 1){
     TEST_TYPE+=16;
  }

  if( (keyword) && flag1 > 0){
     TEST_TYPE+=32;
  }

  if( (subtype) && flag2 > 0){
     TEST_TYPE+=64;
  }

  if( (color) && flag3 > 0){
     TEST_TYPE+=128;
  }

  if( (id) && flag4 > 0){
     TEST_TYPE+=256;
  }

  if( cc > -1 && flag5 > 0){
     TEST_TYPE+=512;
  }

  int count = active_cards_count[controller]-1;
  while( count > -1 ){
        int test = 0;
        card_data_t card_d = get_card_data(controller, count);
        if( (card_d.type & TYPE_CREATURE) && in_play(controller, count) ){

           if( keyword > 0 && (card_d.static_ability & keyword) ){ 
              test+=1;
           }

           if( subtype > 0 && (has_subtype(controller, count, subtype)) ){
              test+=2;
           }

           if( color > 0 && (get_color(controller, count) & color) ){
              test+=4;
           }

           if( id > 0 && card_d.id == id ){
              test+=8;
           }

           if( cc > -1 && get_cmc(controller, count) == cc ){
              test+=16;
           }

           if( keyword > 0 && flag1 > 0 && !(card_d.static_ability & keyword) ){ 
              test+=32;
           }

           if( subtype > 0 && flag2 > 0 && !(has_subtype(controller, count, subtype)) ){
              test+=64;
           }

           if( color > 0 && flag3 > 0 && !(get_color(controller, count) & color) ){
              test+=128;
           }

           if( id > 0 && flag4 > 0 && !(card_d.id == id) ){
              test+=256;
           }

           if( cc > -1 && flag5 > 0 && !(get_cmc(controller, count) == cc) ){
              test+=512;
           }

           if( all == 1 ){
              test = TEST_TYPE;
           }
            
           if( test == TEST_TYPE ){
                 damage_creature(controller, count, amount_damage, p, c);
           }

        }
        count--;
  }

  if(player_too == 1){
     damage_player(controller, amount_damage, p, c);
  }

}

int is_what(int player, int card, int test_type){
 
  int result = 0;
  card_data_t card_d = get_card_data(player, card);  

  if( card_d.type & test_type){
     result = 1;
  }

  return result;
}

int select_a_color(int player){

  int ai_choice = 5;

  if( player == AI ){
     ai_choice = get_deck_color(player, 1-player);
  }

  int color = choose_a_color(player, ai_choice);
  int keyword = COLOR_TEST_BLACK;

  if( color == 2 ){
     keyword = COLOR_TEST_BLUE;
  }
  else if( color == 3 ){
          keyword = COLOR_TEST_GREEN;
  }
  else if( color == 4 ){
          keyword = COLOR_TEST_RED;
  }
  else if( color == 5 ){
          keyword = COLOR_TEST_WHITE;
  }

  return keyword; 
}

void discard_all(int p){

  while( hand_count[p] > 0){
        discard(p, 0, 0);             
  }
}

int persist(int player, int card, event_t event){

    card_instance_t *instance = get_card_instance(player, card);
    int card_added = -1;

    // if this dies, return it to play
    if(event == EVENT_GRAVEYARD_FROM_PLAY){
        if( affect_me( player, card) && in_play(player, card) ){
            if(instance->kill_code != KILL_REMOVE && instance->counter_power >= 0  ){
                card_added = add_card_to_hand( player, get_internal_card_id_from_csv_id( get_id(player, card) ) );
                card_instance_t *new_instance = get_card_instance( player, card_added);
                new_instance->counters = 1;
                new_instance->counter_power--;
                new_instance->counter_toughness--; 
                new_instance->info_slot = new_instance->counter_power;
                put_into_play(player, card_added);
                instance->kill_code = KILL_REMOVE;
            }
        }
    }
    
    return 0;
}

int count_graveyard_by_color(int player, int selected_color){

  int *grave = graveyard_ptr[player];
  int y;
  int result = 0;
  for(y = 0; y < count_graveyard(player); y++){
      if( cards_data[grave[y]].color & selected_color ){
         result++;
      }
  }

  return result;
}

int landcycling(int player, int card, event_t event, int colorless, int land_subtype1, int land_subtype2){

    if( event == EVENT_CAN_ACTIVATE_FROM_HAND && has_mana_multi(player, colorless, 0, 0, 0, 0, 0) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE_FROM_HAND ){
        charge_mana_multi(player, colorless, 0, 0, 0, 0, 0);
        if( spell_fizzled != 1 ){
            discard_card(player, card);
            return 2;
        }
    }
    else if( event == EVENT_REVOLVE_ACTIVATION_FROM_HAND && spell_fizzled != 1 ){
            if( player == AI ){
               int *deck = deck_ptr[player];
               int count = 0;
               while(count < count_deck(player) ){
                     card_ptr_t* b = cards_ptr[ cards_data[ deck[count] ].id ];
                     if( b->subtype1 == land_subtype1 || b->subtype2 == land_subtype1 || b->subtype1 == land_subtype2 || b->subtype2 == land_subtype2){
                        add_card_to_hand(player, deck[count] );
                        remove_card_from_deck( player, count );
                        count = count_deck(player);
                     }
                     count++;
               }
            }
            else{
                 int select = pick_card_from_deck(player);
                 int *deck = deck_ptr[player];
                 card_ptr_t* b = cards_ptr[ cards_data[ deck[select] ].id ];
                 if( b->subtype1 == land_subtype1 || b->subtype2 == land_subtype1 || b->subtype1 == land_subtype2 || b->subtype2 == land_subtype2){
                    add_card_to_hand(player, deck[select] );
                    remove_card_from_deck( player, select );

                 }
            }
            gain_life(player, 0);
            shuffle(player);
    }
    return 0;
}


int transmute(int player, int card, event_t event, int colorless, int black, int blue, int green, int red, int white, int my_cmc){
    if( event == EVENT_CAN_ACTIVATE_FROM_HAND && has_mana_multi(player, colorless, black, blue, green, red, white) ){
       if( can_sorcery_be_played(player) ){
          return 1;
       }
    }
    else if( event == EVENT_ACTIVATE_FROM_HAND ){
        charge_mana_multi(player, colorless, black, blue, green, red, white);
        if( spell_fizzled != 1 ){
            discard_card(player, card);
        }
    }
    else if( event == EVENT_REVOLVE_ACTIVATION_FROM_HAND && spell_fizzled != 1 ){
            if( player == AI ){
               int *deck = deck_ptr[player];
               int count = 0;
               while(count < count_deck(player) ){
                     int cmc = get_cmc_by_id(cards_data[deck[count]].id);
                     if( my_cmc == cmc ){
                        add_card_to_hand(player, deck[count] );
                        remove_card_from_deck( player, count );
                     }
                     count++;
               }
            }
            else{
                 int select = pick_card_from_deck(player);
                 int *deck = deck_ptr[player];
                 int cmc = get_cmc_by_id(cards_data[deck[select]].id);
                 if( my_cmc == cmc ){
                    add_card_to_hand(player, deck[select] );
                    remove_card_from_deck( player, select );
                 }
            }
            gain_life(player, 0);
            shuffle(player);
    }
    return 0;
}

int count_permanents_by_color(int player, int selected_type, int selected_color){
   int result = 0;
   int count = 0;

   while( count < active_cards_count[player] ){
         card_data_t card_d = get_card_data(player, count);  
         if( (card_d.type & selected_type) && (card_d.color & selected_color) && in_play(player, count) ){
            result++;
         }
         count++;
   }
   
  return result;
}

int is_token(int player, int card){
  int result = 0;
  card_instance_t *affected = get_card_instance(player, card);
  if( affected->token_status & 0x10 ){
     result = 1;
  }

  return result;
}



// ----------------------------------------------------- New cards --------------------------------------------------------

int card_tombstone_stairwell(int player, int card, event_t event){
enchant_world(player, card, event);
card_instance_t *instance = get_card_instance(player, card);

  if(event == EVENT_CAN_CAST ){
     return 1;
  }

  if( trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
     if(event == EVENT_TRIGGER){
        event_result |= RESOLVE_TRIGGER_MANDATORY;
     }
     else if(event == EVENT_RESOLVE_TRIGGER){
             if( current_turn == player){ 
                add_ccounter(player, card);
                int result = count_ccounters(player, card);

                int ai_choice = 1;
                if( player == AI && has_mana_multi(player, result, result, 0, 0, 0, 0) ){
                   if( count_graveyard_by_type(player, TYPE_CREATURE) > count_graveyard_by_type(1-player, TYPE_CREATURE)){
                      ai_choice = 0;
                   }
                }

                int choice = do_dialog(player, player, card, -1, -1, " Pay Cumulative Upkeep\n Don't pay", ai_choice);
                if( choice == 0){
                   charge_mana_multi(player, result, result, 0, 0, 0, 0);
                   if( spell_fizzled == 1){
                      kill_card(player, card, KILL_SACRIFICE);
                      instance->info_slot = 66;
                   }
                }
                if( choice == 1){
                   kill_card(player, card, KILL_SACRIFICE);
                   instance->info_slot = 66;
                }
             }
             if( instance->info_slot != 66){
                int x = count_graveyard_by_type(player, TYPE_CREATURE);
                int y = 0;
                while( y < x){
                      generate_token(player, "Tombspawn");
                      y++;
                }
                int z = count_graveyard_by_type(1-player, TYPE_CREATURE);
                y = 0;
                while( y < z){
                      generate_token(1-player, "Tombspawn");
                      y++;
                }
             }
      }
 }

 if( leaves_play(player, card, event) == 1 || trigger_condition == TRIGGER_EOT ){     
    manipulate_all(player, 0, 0, 0, 0, 0, 0, get_id_by_name("Tombspawn"), 0, -1, 0, 3);
    manipulate_all(1-player, 0, 0, 0, 0, 0, 0, get_id_by_name("Tombspawn"), 0, -1, 0, 3);
 }

 return global_enchantment(player, card, event);
}

int card_infernal_genesis(int player, int card, event_t event){

  if(event == EVENT_CAN_CAST ){
        return 1;
  }

  if( trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
     if(event == EVENT_TRIGGER){
        event_result |= RESOLVE_TRIGGER_MANDATORY;
     }
     else if(event == EVENT_RESOLVE_TRIGGER){
             int p = player;
             if( current_turn != player ){
                p = 1-player;              
             }
             int *deck = deck_ptr[p];
             int cc = cards_data[  deck[0] ].cc[0];
             if( cards_data[  deck[0] ].cc[1] < 20 ){
                cc+=cards_data[  deck[0] ].cc[1];
             }                
             mill(p, 1);
             if( cc > 0 ){
                int count = 0;
                while(count < cc){
                      generate_token(p, "Minion");
                      count++;
                }
             }
     }
  }

  return global_enchantment(player, card, event);
}

void evincars(int p, int c, event_t e, int keyword){

  if( e == EVENT_POWER || e == EVENT_TOUGHNESS ){
     if( (get_color(affected_card_controller, affected_card) & keyword) ){
        if( !(affect_me(p, c)) ){
           event_result += 1; 
        }
     }
     if( !(get_color(affected_card_controller, affected_card) & keyword) ){
           event_result -= 1; 
     }
  }
}

int card_ascendant_evincar(int player, int card, event_t event){
check_legend_rule(player, card, event);
evincars(player, card, event, COLOR_TEST_BLACK);

return 0;
}

int card_crovax_ascendant_hero(int player, int card, event_t event){
  check_legend_rule(player, card, event);
  evincars(player, card, event, COLOR_TEST_WHITE);
  card_instance_t *instance = get_card_instance(player, card);

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( life[player] > 2){
        return 1;
     }
  }
  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
          life[player]-=2;
  }
  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) ){
          bounce_permanent(player, instance->parent_card);
  }

return 0;
}

int card_beacon_of_creation(int player, int card, event_t event){
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_LAND);
  td.required_subtype = SUBTYPE_FOREST;
  td.illegal_abilities = 0;
  td.allowed_controller = player;
  td.preferred_controller = player;


  if(event == EVENT_CAN_CAST){
     return 1;
  }
  else if( event == EVENT_RESOLVE_SPELL && affect_me(player, card) ){ 
          int y = target_available(player, card, &td);
          int count = 0;
          while(count < y){
                generate_token(player, "Insect"); 
                count++;
          }
          put_on_top_of_deck(player, card); 
          shuffle(player);
 }

 return 0;
}


int card_beacon_of_destruction(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance( player, card );
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE );
  td.zone = TARGET_ZONE_CREATURE_OR_PLAYER;

  if(event == EVENT_CAN_CAST){
     return 1;
  }

  else if( event == EVENT_CAST_SPELL && affect_me(player, card) ){ 
          pick_target(&td, "TARGET_CREATURE_OR_PLAYER");
          if( valid_target(&td) ){
             instance->info_slot = 66;
          }
  }

  else if( event == EVENT_RESOLVE_SPELL && affect_me(player, card)){ 
          if(instance->info_slot == 66 && valid_target(&td) ){
             damage_creature_or_player(player, card, event, 5, 3);
          }
          put_on_top_of_deck(player, card); 
          shuffle(player);
  }

 return 0;
}

int card_beacon_of_unrest(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance( player, card );
  int cr = count_graveyard_by_type(player, TYPE_CREATURE);
  int ar = count_graveyard_by_type(player, TYPE_ARTIFACT);
  int cr1 = count_graveyard_by_type(1-player, TYPE_CREATURE);
  int ar1 = count_graveyard_by_type(1-player, TYPE_ARTIFACT);

  if(event == EVENT_CAN_CAST){
     if( cr > 0 || ar >0 || cr1 >0 || ar1 > 0 ){
        return 1;
     }
  }

  else if( event == EVENT_CAST_SPELL && affect_me(player, card) ){ 
          int mode = -1;
          if( cr > 0 || ar > 0){
             mode = player;
          }

          if( cr1 > 0 || ar1 > 0){
             if( mode == player ){
                mode = 2;
             }
             else{
                  mode = 1-player;
             }
          }

          if(mode == 2){
             if( player == AI){
                instance->targets[0].player = 1-player;
                if( cr1 > 0 && ar1 < 1){
                   instance->info_slot = ai_best_reanimator_target(1-player, TYPE_CREATURE);
                }           
                else if( cr1 < 1 && ar1 > 0){
                        instance->info_slot = ai_best_reanimator_target(1-player, TYPE_ARTIFACT);
                }           
                else{
                     instance->info_slot = ai_best_reanimator_target(1-player, TYPE_CREATURE);
                }
             }
             else{
                  int choice = do_dialog(player, player, card, -1,-1," From your graveyard\n From opponent's graveyard", 1);
                  instance->targets[0].player = choice;
                      int selected = -1;
                      while(selected == -1){
                            selected = show_deck( player, graveyard_ptr[choice], 500, "Pick a creature or artifact card", 0, 0x7375B0 );
                            if( selected != -1){
                               int *grave = graveyard_ptr[choice];
                               if ( !(cards_data[ grave[selected] ].type & TYPE_CREATURE || cards_data[ grave[selected] ].type & TYPE_ARTIFACT) ){
                                   selected = -1;
                               }
                            }
                      }      
                      instance->info_slot = selected;
             }
         }
         else{
              instance->targets[0].player = mode;
              if( player == AI){
                 if(mode == player){               
                   if( cr > 0 && ar < 1){
                      instance->info_slot = ai_best_reanimator_target(player, TYPE_CREATURE);
                   }           
                   else if( cr < 1 && ar > 0){
                           instance->info_slot = ai_best_reanimator_target(player, TYPE_ARTIFACT);
                   }           
                   else{
                        instance->info_slot = ai_best_reanimator_target(player, TYPE_CREATURE);
                   }
                 }
                 else{
                      if( cr1 > 0 && ar1 < 1){
                         instance->info_slot = ai_best_reanimator_target(1-player, TYPE_CREATURE);
                      }           
                      else if( cr1 < 1 && ar1 > 0){
                              instance->info_slot = ai_best_reanimator_target(1-player, TYPE_ARTIFACT);
                      }           
                      else{
                           instance->info_slot = ai_best_reanimator_target(1-player, TYPE_CREATURE);
                      }
                 }
              }
              else{
                   int choice = mode;
                   int selected = -1;
                   while(selected == -1){
                         selected = show_deck( player, graveyard_ptr[choice], 500, "Pick a creature or artifact card", 0, 0x7375B0 );
                         if( selected != -1){
                            int *grave = graveyard_ptr[choice];
                            if ( !(cards_data[ grave[selected] ].type & TYPE_CREATURE || cards_data[ grave[selected] ].type & TYPE_ARTIFACT) ){
                                selected = -1;
                            }
                         }
                   }      
                   instance->info_slot = selected;
                   
              }
        }
  }

  else if( event == EVENT_RESOLVE_SPELL && affect_me(player, card)){ 
          if( instance->info_slot > 0){ 
             reanimate_permanent(player, card, instance->targets[0].player, instance->info_slot, 0, 0); 
          }
          put_on_top_of_deck(player, card); 
          shuffle(player);
  }

 return 0;
}

int card_seedborn_muse(int player, int card, event_t event){

  card_instance_t *instance = get_card_instance( player, card );

  if( current_turn == 1-player && current_phase == PHASE_UNTAP && instance->info_slot != 66 ){
     manipulate_all(player, TYPE_ENCHANTMENT, 1, 0, 0, 0, 0, 0, 0, -1, 0, 7);
     instance->info_slot = 66;
  }

  if( eot_trigger(player, card, event) ){
     instance->info_slot = 0;
  }

  return 0;
}

int card_tradewind_rider(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance( player, card );
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.illegal_abilities = 0;
  td.allowed_controller = player;
  td.preferred_controller = player;
  td.illegal_state = TARGET_STATE_TAPPED;
  td.allow_cancel = 0;

  target_definition_t td1;
  default_target_definition(player, card, &td1, TYPE_PERMANENT);
  td1.allowed_controller = 2;
  td1.preferred_controller = 1-player;
  td.allow_cancel = 0;

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( !(is_sick(player, card)) && !(is_tapped(player, card)) ){
        if( target_available(player, card, &td) > 2 && target_available(player, card, &td1) > 0 ){
           return 1;
        }
     }
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     int act = 0;
     tap_card(player, card);
     pick_target(&td, "TARGET_CREATURE");
     if( valid_target(&td) ){
        tap_card(instance->targets[0].player, instance->targets[0].card);
        act++;
     }
     pick_target(&td, "TARGET_CREATURE");
     if( valid_target(&td) ){
        tap_card(instance->targets[0].player, instance->targets[0].card);
        act++;
     }
     if( act > 1 ){
        pick_target(&td1, "TARGET_PERMANENT");
        if( valid_target(&td1) ){
           instance->info_slot = 66;
        }
     }
  }

  if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66 ){
     if(valid_target(&td1) ){
        bounce_permanent(instance->targets[0].player, instance->targets[0].card);
     }
     instance->info_slot = 0;
  }

  return 0;
}

int card_scroll_rack(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance( player, card );
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_ANY);
    td.zone = TARGET_ZONE_HAND;
    td.illegal_abilities = 0;
    td.allowed_controller = player;
    td.preferred_controller = player;

    if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && has_mana_multi(player, 1, 0, 0, 0, 0, 0) ){
         if( !(is_animated_and_sick(player, card)) && !(is_tapped(player, card)) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
        if( spell_fizzled != 1 ){
            tap_card(player, card);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int number = 0;
        while( can_target(&td) && spell_fizzled != 1){
            if( pick_target(&td, "TARGET_CARD") ){
                rfg_card_in_hand(player, instance->targets[0].card );
                number++;
            }
        }
        draw_cards(player, number);
        int i;
        int* rfg = rfg_ptr[player];
        for(i = 0; i < number; i++){
            int card_added = add_card_to_hand(player, rfg[ count_rfg(player) - 1] );
            rfg[ count_rfg(player) - 1] = -1;
            put_on_top_of_deck(player, card_added);
        }         
        rearrange_top_x(player, player, number);
        hand_count[player]-=number;
    }
    return 0;
}

void creature_deck_search(int p, int selected_subtype, int value){

  if( p != AI ){
    int selected = -1;
    while( selected == -1){
          selected = show_deck( p, deck_ptr[p], 500, "Pick a card", 0, 0x7375B0 );
    }
    int *deck = deck_ptr[p];
    card_ptr_t* b = cards_ptr[ cards_data[ deck[selected] ].id ];
    int cmc = cards_data[deck[selected]].cc[0] + cards_data[deck[selected]].cc[1];
    if ( b->subtype1 == selected_subtype || b->subtype2 == selected_subtype){
        if( cmc <= value ){
           int card_added = add_card_to_hand(p, deck[selected] );
           remove_card_from_deck( p, selected );
           put_into_play(p, card_added);
        }
    }
  }
  else{
       int i;
       int *deck = deck_ptr[p];
       for(i = 0; i < count_deck(p); i++){
           int selected = i;
           card_ptr_t* b = cards_ptr[ cards_data[ deck[selected] ].id ];
           int cmc = cards_data[deck[selected]].cc[0] + cards_data[deck[selected]].cc[1];
           if ( b->subtype1 == selected_subtype || b->subtype2 == selected_subtype){
               if( cmc <= value ){
                  int card_added = add_card_to_hand(p, deck[selected] );
                  remove_card_from_deck( p, selected );
                  put_into_play(p, card_added);
                  i = count_deck(p);
               }
           }
       }


  }

}

int generic_subtype_searcher(int player, int card, event_t event, int sel_subtype, int val, int is_hunter){
  card_instance_t *instance = get_card_instance( player, card );

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && has_mana_multi(player, val, 0, 0, 0, 0, 0) ){
     if( !(is_sick(player, card)) && !(is_tapped(player, card)) ){
        return 1;
     }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     charge_mana_multi(player, val, 0, 0, 0, 0, 0);
     if( spell_fizzled != 1){
        tap_card(player, card);
        instance->info_slot = 66;
     }
  }

  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66 ){

          if( is_hunter == 1){
             creature_deck_search(player, sel_subtype, 20);
             shuffle(player);
          }
          else{
               val-=1;
               creature_deck_search(player, sel_subtype, val);
               shuffle(player);
          }
          instance->info_slot = 0;
  }

  return 0;
}

int card_ramosian_sergeant(int player, int card, event_t event){

  return generic_subtype_searcher(player, card, event, SUBTYPE_REBEL, 3, 0);
}

int card_defiant_falcon(int player, int card, event_t event){
  return generic_subtype_searcher(player, card, event, SUBTYPE_REBEL, 4, 0);
}

int card_ramosian_captain(int player, int card, event_t event){

  return generic_subtype_searcher(player, card, event, SUBTYPE_REBEL, 5, 0);
}

int card_lin_sivvi(int player, int card, event_t event){
  check_legend_rule(player, card, event);
  card_instance_t *instance = get_card_instance( player, card );

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( !(is_sick(player, card)) && !(is_tapped(player, card)) ){
        return 1;
     }
     else if( has_mana_multi(player, 3, 0, 0, 0, 0, 0) ){ 
             return 1;
     }
     else{
          return 0;
    }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
          int choice = -1;
          
          if( is_sick(player, card) || is_tapped(player, card) ){ 
             choice = do_dialog(player, player, card, -1, -1, " Rebel recycle\n Cancel", 0);
             choice++;
          }
          else if( !(has_mana_multi(player, 3, 0, 0, 0, 0, 0)) ){
                  choice = do_dialog(player, player, card, -1, -1, " Rebel search\n Cancel", 0);
                  if( choice != 0 ){
                     choice = 2;
                  }
          }
          else{
               choice = do_dialog(player, player, card, -1, -1, " Rebel search\n Rebel recycle\n Cancel", 0);
          }

          if(choice == 0){
            charge_mana( player, COLOR_COLORLESS, -1);
            int number = x_value;
            if( spell_fizzled != 1 ){
               instance->info_slot = 67;
               tap_card(player, card);
               instance->targets[1].card = number;
            }
          }

          if(choice == 1){
             charge_mana_multi(player, 3, 0, 0, 0, 0, 0);
             if(spell_fizzled != 1){
                int select = select_target_from_graveyard(player, player, 0, 0, SUBTYPE_REBEL, 0, 0, 0, 0, 0, -1, 0);
                if( select != -1){
                   instance->info_slot = 66;
                   instance->targets[0].card = select; 
                }
             }
          }

  }

  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && (instance->info_slot == 67 || instance->info_slot == 66) ){

          if( instance->info_slot == 67){
             creature_deck_search(player, SUBTYPE_REBEL, instance->targets[1].card);
             shuffle(player);
             instance->info_slot = 0;
          }
          else if( instance->info_slot == 66){
                  from_graveyard_to_deck(player, instance->targets[0].card, 2);
                  instance->info_slot = 0;
          }
          
  }

  return 0;
}

int card_ertai_wizard_adept(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);

  if(event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_sick(player, card)) && !(is_tapped(player, card)) ){
     int result =  card_daring_apprentice(player, card, event);
     if( result == 0 || ! has_mana_multi(player, 2, 0, 2, 0, 0, 0) ){
            return 0;
        }
     else{
          instance->targets[0].player = card_on_stack_controller;
          instance->targets[0].card = card_on_stack;
          return result;
     }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
          charge_mana_multi(player, 2, 0, 2, 0, 0, 0);
          if(spell_fizzled != 1){
             tap_card(player, card);
             instance->info_slot = 66;
          }
  }

  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
          kill_card(instance->targets[0].player, instance->targets[0].card, KILL_SACRIFICE);
          instance->info_slot = 0;
  }

  return 0;
}


int card_varchild_war_riders(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    rampage(player, card, event, 1);

  if( trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) && current_turn == player){
     if(event == EVENT_TRIGGER){
        event_result |= RESOLVE_TRIGGER_MANDATORY;
     }
     else if(event == EVENT_RESOLVE_TRIGGER){
             add_ccounter(player, card);
             int result = count_ccounters(player, card);
             instance->info_slot = result;
             int choice = do_dialog(player, player, card, -1, -1, " Pay Cumulative Upkeep\n Don't pay", 0);

             if( choice == 0){
                int i;
                for(i = 0; i < result; i++){
                    generate_token(1-player, "Survivor");
                }
             }

             if( choice == 1){
                kill_card(player, card, KILL_BURY);
             }
     }
  }

  return 0;
}

int card_vexing_sphinx(int player, int card, event_t event){
card_instance_t *instance = get_card_instance(player, card);

  if( trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) && current_turn == player){
     if(event == EVENT_TRIGGER){
        event_result |= RESOLVE_TRIGGER_MANDATORY;
     }
     else if(event == EVENT_RESOLVE_TRIGGER){
             add_ccounter(player, card);
             int result = count_ccounters(player, card);
             instance->info_slot = result;
             
             int ai_choice = 0;
             if( player == AI && result > 2 ){
                ai_choice = 1;
             }

             int choice = do_dialog(player, player, card, -1, -1, " Pay Cumulative Upkeep\n Don't pay", ai_choice);
             if( choice == 0){
                if( hand_count[player] < result ){
                   kill_card(player, card, KILL_BURY);
                }
                else{
                     int count=0;
                     while( count < result ){
                           discard(player, 0, 0);
                           count++;
                     }
                }
             }
             if( choice == 1){
                kill_card(player, card, KILL_SACRIFICE);
             }
     }
  }

  if( event == EVENT_GRAVEYARD_FROM_PLAY && affect_me(player, card) ){
     draw_cards(player, instance->info_slot);
  }

  return 0;
}

int card_fiery_justice(int player, int card, event_t event){
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
  td.preferred_controller = 1-player;

  if( event == EVENT_CAN_CAST){
     return 1;
  }

  if( event == EVENT_RESOLVE_SPELL && affect_me(player, card) ){
     int number = 0;
     while(number < 5 ){
           pick_target(&td, "TARGET_CREATURE_OR_PLAYER");
           if( valid_target(&td) ){
              damage_creature_or_player(player, card, event, 1, 3);
              number++;
           }
     }
     gain_life(1-player, 5);
     kill_card(player, card, KILL_DESTROY);
  }

  return 0;
}

int card_enlisted_wurm(int player, int card, event_t event){

  cascade(player, card, event, 0);  

  return 0;
}

int card_kavu_predator(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);
  
  if( comes_into_play(player, card, event) ){
     instance->targets[9].card = get_trap_condition(1-player, 7);
  }
  else if( get_trap_condition(1-player, 7) != instance->targets[9].card  ){
          if( instance->targets[9].card != -1 && get_trap_condition(1-player, 7) > instance->targets[9].card){
             int pump = get_trap_condition(1-player, 7) - instance->targets[9].card;
             int i;
             for(i = 0; i < pump; i++){  
                 add_1_1_counter(player, card);
             }
             instance->targets[9].card = get_trap_condition(1-player, 7);
          }
          else{
               instance->targets[9].card = get_trap_condition(1-player, 7);
          }
  }

  return 0;
}

int card_stormbind(int player, int card, event_t event){
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
  td.preferred_controller = 1-player;
  card_instance_t *instance = get_card_instance(player, card);

  if(event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( has_mana_multi(player, 2, 0, 0, 0, 0, 0) && hand_count[player] > 0 ){
        return 1;
     }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
          charge_mana_multi(player, 2, 0, 0, 0, 0, 0);
          if(spell_fizzled != 1){
             discard(player, 1, 0);
             pick_target(&td, "TARGET_CREATURE_OR_PLAYER");
             if( valid_target(&td) ){
                instance->info_slot = 66;
             }
          }
  }

  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
          if(valid_target(&td)){
             damage_creature_or_player(player, card, event, 2, 3);
          }
          instance->info_slot = 0;
  }

  return global_enchantment(player, card, event);
}

int card_grove_of_the_burnwillows(int player, int card, event_t event){
    if( event == EVENT_ACTIVATE ){
        int choice = do_dialog(player, player, card, -1, -1, " Add 1\n Add G or R \n Cancel", 0);
        if( choice == 0){
            tap_card(player, card);
            produce_mana(player, COLOR_COLORLESS, 1);
        }
        else if( choice == 1 ){
            int result = mana_producer(player, card, event);
            if(spell_fizzled != 1 ){
                gain_life(1-player, 1);
                return result;
            }
        }
        spell_fizzled = 1;
        return 0;
    }
    return mana_producer(player, card, event);
}

int card_lim_dul_vault(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);

  if( event == EVENT_CAN_CAST ){
     return 1;
  }

  if( event == EVENT_RESOLVE_SPELL && affect_me(player, card) ){
 
    if( player == AI ){
        int *deck = deck_ptr[player];
        int i;
        for(i = 0; i < 5; i++){
            deck[count_deck(player)] = deck[0];
            remove_card_from_deck(player, 0);
        }

     }
   
     else{
          int *deck = deck_ptr[player];
          int choice = -1;
          while( choice != 2 ){
                show_deck( player, deck_ptr[player], 5, "Here are the top 5 cards of your library", 0, 0x7375B0 );
                
                if( life[player] > 0){
                   choice = do_dialog(player, player, card, -1, -1, " Rearrange\n Pay 1 life and continue", 0);
                }
                else{
                     choice = 0;
                }

                if(choice == 0){
                   int i;

                   for(i = 0; i < 5; i++){
                       instance->targets[i].card = add_card_to_hand(player, deck[0]);
                       remove_card_from_deck(player, 0);
                   }

                   shuffle_vanguard(player, 0);
                   gain_life(player, 0); //to avoid crashing

                   for(i = 0; i < 5; i++){
                       put_on_top_of_deck(player, instance->targets[i].card);
                   }

                   rearrange_top_x(player, player, 5);
                   choice = 2;
                }

                if(choice == 1){
                   life[player]-=1;
                   int i;
                   for(i = 0; i < 5; i++){
                       deck[count_deck(player)] = deck[0];
                       remove_card_from_deck(player, 0);
                   }
                   choice = 3;
                }
          }
          kill_card(player, card, KILL_DESTROY);
     }
 }

  return 0;
}

int card_thawing_glaciers(int player, int card, event_t event){
  comes_into_play_tapped(player, card, event);
  card_instance_t *instance = get_card_instance(player, card);

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( has_mana_multi(player, 1, 0, 0, 0, 0, 0) && !(is_tapped(player, card)) ){
        return 1;
     }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
          charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
          if( spell_fizzled != 1){
             tap_card(player, card);
             instance->info_slot = 66;
          }
  }

  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
          instance->info_slot = 67;
          tutor_basic_land(player, 1, 1);
  }
     
  else if( instance->info_slot > 65 && eot_trigger(player, card, event) ){
          bounce_permanent(player, card);
  }

  return 0;
}

int card_dimishing_returns(int player, int card, event_t event){

  if( event == EVENT_CAN_CAST ){
     return 1;
  }

  if( event == EVENT_RESOLVE_SPELL && affect_me(player, card) ){
 
    int i;
    for(i = 0; i < 2; i++){

        int count = 0;
        while(count < active_cards_count[i] ){ 
              if( in_hand(i, count) ){
                 put_on_top_of_deck(i, count);
              }
              count++;
        }
        hand_count[i] = 0;

        count = 0;
        int *grave = graveyard_ptr[i];
        while(count < count_graveyard(i) ){ 
              int target = add_card_to_hand(i, grave[count]);
              remove_card_from_grave(i, count); 
              put_on_top_of_deck(i, target);
              count++;
        }

        shuffle_vanguard(i,0);
        gain_life(i, 0);

        if( i == player){
           int x;
           for(x = 0; x < 10; x++){
               rfg_top_card_of_deck(i);
           }
        }

        if( i == AI ){
           int amount = count_deck(i) - 5;
           if( amount > 7 ){
              amount = 7;
           }
           draw_cards(i, amount);
        }

        else{
             int number = choose_a_number(i, "How many cards you want to draw ?", 7);
             draw_cards(i, number);
        }

    }
    kill_card(player, card, KILL_DESTROY);

  }

  return 0;
}

int card_contagion(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);

    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_NONE);
    td.required_color = COLOR_TEST_BLACK;
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.zone = TARGET_ZONE_HAND;
    td.illegal_abilities = 0;

    target_definition_t td1;
    default_target_definition(player, card, &td1, TYPE_CREATURE);
    td1.allowed_controller = 2;
    td1.preferred_controller = 1-player;
    td1.allow_cancel = 0;

    if( event == EVENT_MODIFY_COST ){
        if( target_available(player, card, &td) > 1 && life[player] > 0){
            COST_COLORLESS -= 3;
            COST_BLACK -= 2;
        }
    }

    else if( event == EVENT_CAN_CAST && target_available(player, card, &td1) ){
            return 1;
    }

    else if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
        int pitch = 0;
        int choice = 1;
        int resolved = 0;

        if( target_available(player, card, &td) > 1 && life[player] > 0){
            pitch = 1;
        }

        if( pitch == 1 && has_mana_multi(player, 3, 2, 0, 0, 0, 0) ){
            char buffer[50];
            sprintf(buffer, " RFG a black card and lose 1\n Pay 3BB" );
            choice = do_dialog(player, player, card, -1, -1, buffer, 0);
        }
        else if(pitch == 1){
                choice = 0;
        }
        
        if( choice == 1 && pitch == 1){
            charge_mana_multi(player, 3, 2, 0, 0, 0, 0);
            if( spell_fizzled != 1 ){
               resolved = 1;
            }
        }
        else if(choice == 0){
            instance->state |= STATE_CANNOT_TARGET;
            if(!select_target(player, card, &td, "Choose a black card in hand", NULL)){
                spell_fizzled = 1;
            }
            else{
                life[player]--;                
                kill_card( player, instance->targets[0].card, KILL_DESTROY );
                rfg_card_from_grave(player, count_graveyard(player) - 1, -1 );
                instance->state &= ~STATE_CANNOT_TARGET;
                resolved = 1;
            }

        }
          
        if( resolved == 1){
           int x;
           int targets = 0;
           for(x = 0; x < 2; x++){
               pick_target(&td1, "TARGET_CREATURE");
               if( valid_target(&td1) ){
                  instance->targets[x+1].player = instance->targets[0].player;
                  instance->targets[x+1].card = instance->targets[0].card;
                  targets++;
               }
           }
           if( targets > 1 ){
              instance->info_slot = 66;
           }
        }
    }

    else if( event == EVENT_RESOLVE_SPELL && affect_me(player, card) && instance->info_slot == 66 ){

           int x;
           for(x = 0; x < 2; x++){
               if( validate_target(player, card, &td1, x+1)){
                  card_instance_t *target = get_card_instance(instance->targets[x+1].player, instance->targets[x+1].card);
                  target->counters++;
                  target->counter_power-=2;
                  target->counter_toughness--;
               }
           }
           kill_card(player, card, KILL_DESTROY);

    }

    return 0;
}

int card_scalpelexis(int player, int card, event_t event){
  
  if(event == EVENT_RESOLVE_TRIGGER && is_unblocked(player, card) ){
     if( ! affect_me(player, card) ){ return 0; }
     card_instance_t *instance = get_card_instance(player, card);

     int stop = -1;
     int count = 0;
     int *deck = deck_ptr[1-player];

     while( stop != 1){
           int x;
           int y;
           int check = 1;
           for(x = count; x < count+4; x++){
               for(y = x+1; y < count+4; y++){
                   if( deck[x] == deck[y] ){
                      check = 0;
                   }
               }
           }
           count+=4;
           stop = check;
    }

    int i;
    for(i=0;i<count;i++){
        rfg_top_card_of_deck(1-player);
    }
    
    instance->damage_source_player = -1;
    return 0;
  }
  else{
       return card_hypnotic_specter(player, card, event);
  }
}        


int card_mind_funeral(int player, int card, event_t event){

  if( event == EVENT_CAN_CAST ){
     return 1;
  }

  if( event == EVENT_RESOLVE_SPELL && affect_me(player, card) ){
     int *deck = deck_ptr[1-player]; 
     int cards_to_mill = 0;
     int lands = 0;
     int x = 0;
     while(lands < 4){
           if( cards_data[deck[x]].type & TYPE_LAND ){
              lands++;
           }
           cards_to_mill++;
           x++;
     }
     mill(1-player, cards_to_mill);
     kill_card(player, card, KILL_DESTROY);

  }

  return 0;
}


int card_guiltfeeder(int player, int card, event_t event){
  fear(player, card, event);

  if( event == EVENT_DECLARE_BLOCKERS && is_unblocked(player, card) ){
     life[1-player]-=count_graveyard(1-player);
  }

  return 0;
}

int card_nemesis_of_reason(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);

    if( event == EVENT_DECLARE_ATTACKERS && instance->state & STATE_ATTACKING ){
       mill(1-player, 10);
    }

  return 0;
}

int card_jotun_grunt(int player, int card, event_t event){

  if( trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) && current_turn == player ){
     if(event == EVENT_TRIGGER){
        event_result |= RESOLVE_TRIGGER_MANDATORY;
     }
     else if(event == EVENT_RESOLVE_TRIGGER){
                add_ccounter(player, card);
                int result = count_ccounters(player, card);
                if( count_graveyard(player) + count_graveyard(1-player) >= result * 2){
                   int choice = do_dialog(player, player, card, -1, -1, " Pay Cumulative Upkeep\n Don't pay", 0);
                   if( choice == 0){
                      int x;
                      for(x = 0; x < result; x++){
                          int dest = -1;
                          if( !(count_graveyard(1-player) >= 2) && count_graveyard(player) >= 2){
                             dest = player;
                          }
                          else if( count_graveyard(1-player) >= 2 && !(count_graveyard(player) >= 2) ){
                             dest = 1-player;
                          }
                          else if( count_graveyard(1-player) < 2 && count_graveyard(player) < 2 ){
                            kill_card(player, card, KILL_SACRIFICE);
                          }
                          else{
                               if( player == AI){
                                  dest = 1-player;
                               }
                               else{
                                    dest = do_dialog(player, player, card, -1, -1, " From your graveyard\n From your oppponent's graveyard", 0);
                               }
                          }
                          int y;
                          for(y = 0; y < 2; y++){
                             int select = 0;
                             if(player == HUMAN){
                                select = select_target_from_graveyard(player, dest, TYPE_ANY, 0, 0, 0, 0, 0, 0, 0, -1, 0);
                             }
                             from_graveyard_to_deck(dest, select, 2);
                          }
                     }
                   }
                   if( choice == 1){
                      kill_card(player, card, KILL_SACRIFICE);
                   }
                }
                else{ 
                     kill_card(player, card, KILL_SACRIFICE);
                }
     }
  }

  return 0;
  }

int card_plague_spitter(int player, int card, event_t event){

  if( upkeep_trigger(player, card, event) && current_turn == player ){
     damage_all(player, card, player,1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0);
     damage_all(player, card, 1-player,1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0);
  }

  if( event == EVENT_GRAVEYARD_FROM_PLAY && affect_me(player, card) && in_play(player, card) ){
     damage_all(player, card, player, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0);
     damage_all(player, card, 1-player,1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0);
  }
  
  return 0;
}

int card_void(int player, int card, event_t event){

  card_instance_t *instance = get_card_instance( player, card );
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE );
  td.zone = TARGET_ZONE_PLAYERS;

  if(event == EVENT_CAN_CAST){
     return 1;
  }

  else if( event == EVENT_CAST_SPELL && affect_me(player, card) ){ 
          pick_target(&td, "TARGET_PLAYER");
          if( valid_target(&td) ){
             instance->info_slot = 66;
          }
  }

  else if( event == EVENT_RESOLVE_SPELL && affect_me(player, card) && instance->info_slot == 66 ){
     
     int number = 0;
     if( player == AI ){
     }

     else{
          number = choose_a_number(player, "Choose a number", 13);
     }

     manipulate_all(player, TYPE_CREATURE, 0, 0, 0, 0, 0, 0, 0, number, 0, 1);
     manipulate_all(1-player, TYPE_CREATURE, 0, 0, 0, 0, 0, 0, 0, number, 0, 1);
     manipulate_all(player, TYPE_ARTIFACT, 0, 0, 0, 0, 0, 0, 0, number, 0, 1);
     manipulate_all(1-player, TYPE_ARTIFACT, 0, 0, 0, 0, 0, 0, 0, number, 0, 1);

     int opponent = instance->targets[0].player;
     int i;

     if( player == HUMAN && opponent == AI ){
        int cards_array[ 500 ];
        int hand_index = 0;
        for(i=0;i<active_cards_count[opponent]; i++){
            card_instance_t *hand_instance = get_card_instance(opponent, i);
            int id = hand_instance->internal_card_id;
            if( in_hand(opponent, i ) ){
               cards_array[hand_index++] = id;
            }
        }
        show_deck( player, cards_array, hand_count[opponent], "Hand Revealed", 0, 0x7375B0 );
     }

     for(i=0;i<active_cards_count[opponent]; i++){
         if( in_hand(opponent, i ) && !(is_what(opponent, i, TYPE_LAND)) ){
            int cc = get_cmc_by_id( get_id(opponent, i) );
            if( number == cc ){
               discard_card(opponent, i);
            }
         }
     }
        
     kill_card(player, card, KILL_DESTROY);
  }

  return 0;
}

int card_pyre_zombie(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance( player, card );

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
  td.preferred_controller = 1-player;

  if( event == EVENT_GRAVEYARD_ABILITY_UPKEEP && has_mana_multi(player, 1, 2, 0, 0, 0, 0) ){
     int choice = do_dialog(player, player, card, -1, -1," Return Pyre Zombie to hand\n Pass\n", 0);
     if( choice == 0 ){
        charge_mana_multi(player, 1, 2, 0, 0, 0, 0);
        if( spell_fizzled != 1){
           instance->state &= ~STATE_INVISIBLE;
           hand_count[player]++;
           return -1;    
        }
     }
     return -2;
  }

  if(event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( has_mana_multi(player, 1, 0, 0, 0, 2, 0) ){
        return 1;
     }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
          charge_mana_multi(player, 1, 0, 0, 0, 2, 0);
          if(spell_fizzled != 1){
             pick_target(&td, "TARGET_CREATURE_OR_PLAYER");
             if( valid_target(&td) ){
                kill_card(player, card, KILL_SACRIFICE);
                instance->info_slot = 66;
             }
          }
  }

  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
          if( valid_target(&td) ){
             damage_creature_or_player(player, card, event, 2, 3);
          }
          instance->info_slot = 0;
  }

  return 0;
}

int card_phyrexian_scuta(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance( player, card );

  if( event == EVENT_CAST_SPELL && affect_me(player, card) && life[player] > 2 ){
     int choice = do_dialog(player, player, card, -1, -1," Pay kicker\n Pass\n", 0);
     if( choice == 0 ){
        life[player]-=3;
        instance->info_slot = 66;
     }
  }
     
  else if( comes_into_play(player, card, event) && instance->info_slot == 66){
          add_1_1_counter(player, card);
          add_1_1_counter(player, card);
  }

  return 0;
}

int card_deserted_temple(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance( player, card );

  if( event == EVENT_COUNT_MANA && !(is_tapped(player, card)) && affect_me(player, card) ){
     declare_mana_available(player, COLOR_COLORLESS, 1 );
  }

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_tapped(player, card)) ){
     return 1;
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     int choice = do_dialog(player, player, card, -1, -1, " Add 1\n Untap target land\n Cancel", 0);

     if( choice == 0){
        tap_card(player, card);
        return mana_producer(player, card, event);
     }

     if( choice == 1 ){
        target_definition_t td1;
        default_target_definition(player, card, &td1, TYPE_LAND);
        td1.allowed_controller = 2;
        td1.preferred_controller = player;
        td1.allow_cancel = 0;

        tap_card(player, card);
        charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
        if( spell_fizzled != 1 && can_target(&td1) ){
           pick_target(&td1, "TARGET_LAND");           
           if( valid_target(&td1) ){
              untap_card( instance->targets[0].player, instance->targets[0].card );
           }

        }
     }
  }

  return 0;
}

int card_horizon_canopy(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance( player, card );
    if( event == EVENT_CAN_ACTIVATE ){
        if( life[player] <= 0 && (  paying_mana() || ! has_mana_multi(player, 2, 0, 0, 0, 0, 0) ) ){
            return 0;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        int choice = 0;
        if( life[player] > 0 && has_mana_multi(player, 2, 0, 0, 0, 0, 0) && ! paying_mana() ){
            choice = do_dialog(player, player, card, -1, -1, " Add G or W\n Sac and draw a card\n Cancel", 0);
        }
        else if( life[player] <= 0 ){
            choice = 1;
        }
        
        if( choice == 0){
            int result = mana_producer(player, card, event);
            if( spell_fizzled != 1 ){
                life[player]--;
                return result;
            }
        }
        else if( choice == 1 ){
            tap_card(player, card);
            charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
            if( spell_fizzled != 1){
                instance->info_slot = 1;
                kill_card(player, card, KILL_SACRIFICE);
            }
            else{
                untap_card(player, card);
            }
        }
        else if( choice == 2 ){
            spell_fizzled = 1;
        }
        return 0;
    }
    else if( event == EVENT_RESOLVE_ACTIVATION && instance->info_slot == 1 ){
        draw_a_card(player);
    }
    return mana_producer(player, card, event);
}

int card_petrified_field(int player, int card, event_t event){

  if( event == EVENT_COUNT_MANA && !(is_tapped(player, card)) && affect_me(player, card) ){
     declare_mana_available(player, COLOR_COLORLESS, 1 );
  }

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_tapped(player, card)) ){
     return 1;
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
    
     int choice = 0;
     if( count_graveyard_by_type(player, TYPE_LAND) > 0 ){
        choice = do_dialog(player, player, card, -1, -1, " Add 1\n Sac and return a land card to your hand\n Cancel", 0);
     }

     if( choice == 0){
        tap_card(player, card);      
        return mana_producer(player, card, event);
     }

     if( choice == 1 ){
        tap_card(player, card);
        int select = select_target_from_graveyard(player, player, TYPE_LAND, 0, 0, 0, 0, 0, 0, 0, -1, 0);
        kill_card(player, card, KILL_SACRIFICE);
        int *grave = graveyard_ptr[player];
        add_card_to_hand(player, grave[select]);
        remove_card_from_grave(player, select);
     }
  }

  return 0;
}

int card_rishadan_port(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance( player, card );

  target_definition_t td1;
  default_target_definition(player, card, &td1, TYPE_LAND);
  td1.allowed_controller = 2;
  td1.preferred_controller = 1-player;
  td1.allow_cancel = 0;

  if( event == EVENT_COUNT_MANA && !(is_tapped(player, card)) && affect_me(player, card) ){
     declare_mana_available(player, COLOR_COLORLESS, 1 );
  }

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_tapped(player, card)) ){
     return 1;
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     int ai_choice = 0;
   
     if( player == AI){
        if(count_permanents_by_type(player, card, TYPE_LAND) >= count_permanents_by_type(1-player, card, TYPE_LAND)){
        if( has_mana_multi(player, 1, 0, 0, 0, 0, 0) ){
            ai_choice = 1;
        }
        }
     }

     int choice = do_dialog(player, player, card, -1, -1, " Add 1\n Tap target land\n Cancel", ai_choice);

     if( choice == 0){
        tap_card(player, card);
        return mana_producer(player, card, event);
     }

     if( choice == 1 ){
        tap_card(player, card);
        charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
        if( spell_fizzled != 1 && can_target(&td1) ){
           pick_target(&td1, "TARGET_LAND");           
           if( valid_target(&td1) ){
              tap_card( instance->targets[0].player, instance->targets[0].card );
           }

        }
     }
  }

  return 0;
}

int card_vitu_ghazi(int player, int card, event_t event){

  if( event == EVENT_COUNT_MANA && !(is_tapped(player, card)) && affect_me(player, card) ){
     declare_mana_available(player, COLOR_COLORLESS, 1 );
  }

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_tapped(player, card)) ){
     return 1;
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     int ai_choice = 0;
   
     if( player == AI){
        if(count_permanents_by_type(player, card, TYPE_CREATURE) <= count_permanents_by_type(1-player, card, TYPE_CREATURE)){
        if( has_mana_multi(player, 2, 0, 0, 1, 0, 1) ){
            ai_choice = 1;
        }
        }
     }

     int choice = do_dialog(player, player, card, -1, -1, " Add 1\n Generate a Saproling\n Cancel", ai_choice);

     if( choice == 0){
        tap_card(player, card);
        return mana_producer(player, card, event);
     }

     if( choice == 1 ){
        tap_card(player, card);
        charge_mana_multi(player, 2, 0, 0, 1, 0, 1);
        if( spell_fizzled != 1){
           generate_token(player, "Saproling");
        }
     }
  }

  return 0;
}

int card_countryside_crusher(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);
  
  if( current_turn == player && upkeep_trigger(player, card, event) ){
     int stop = 0;
     int count = 0;
     while( stop != 1){
           int *deck = deck_ptr[player];
           if( cards_data[deck[count]].type & TYPE_LAND ){
              count++;
           }
           else{
                stop = 1;
           }
     }
     if( count > 0 ){
        mill(player, count);
     }

  }

  if( comes_into_play(player, card, event) ){
     instance->targets[9].card = count_graveyard_by_type(player, TYPE_LAND);
  }
  else if( count_graveyard_by_type(player, TYPE_LAND) > instance->targets[9].card  ){
          if( instance->targets[9].card != -1){
             add_1_1_counter(player, card);
             instance->targets[9].card = count_graveyard_by_type(player, TYPE_LAND);
          }
          else{
               instance->targets[9].card = count_graveyard_by_type(player, TYPE_LAND);
          }

  }

  else if( instance->targets[9].card > count_graveyard_by_type(player, TYPE_LAND) ){
          instance->targets[9].card = count_graveyard_by_type(player, TYPE_LAND);
  }

  return 0;
}

int card_fledgling_dragon(int player, int card, event_t event){

  if( count_graveyard(player) >= 7){
     if( (event == EVENT_POWER || event == EVENT_TOUGHNESS) && affect_me(player, card) ){
        event_result+=3;
     }
     return card_shivan_dragon(player, card, event);
  }

  return 0;
}

int card_stampeding_wildebeest(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);
  
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.allowed_controller = player;
  td.preferred_controller = player;
  td.allow_cancel = 0;
  td.required_color = COLOR_TEST_GREEN;
  td.illegal_abilities = 0;

  if( current_turn == player && can_target(&td) && upkeep_trigger(player, card, event)  ){
     pick_target(&td, "TARGET_CREATURE");
     if( valid_target(&td) ){
        bounce_permanent(instance->targets[0].player, instance->targets[0].card);
     }
  }

  return 0;
}

int card_accumulated_knowledge(int player, int card, event_t event){

  if( event == EVENT_CAN_CAST ){
     return 1;
  }
  else if( event == EVENT_RESOLVE_SPELL ){
     int number = count_graveyard_by_id(player, get_id_by_name("Accumulated Knowledge")) + count_graveyard_by_id(1-player, get_id_by_name("Accumulated Knowledge"));
     number++;
     draw_cards(player, number);
     kill_card(player, card, KILL_DESTROY);
  }

  return 0;
}

int recycling_land(int player, int card, event_t event, int recycling_type, int cless, int black, int blue, int green, int red, int white){

  if( event == EVENT_COUNT_MANA && !(is_tapped(player, card)) && affect_me(player, card) ){
     declare_mana_available(player, COLOR_COLORLESS, 1 );
  }

  if(event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_tapped(player, card)) ){
     return 1;
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
          int choice = 0;
          int ai_choice = 0;

          if(player == AI && has_mana_multi(player, cless, black, blue, green, red, white) ){
             if ( count_graveyard_by_type(player, recycling_type) > 0 ){
                 ai_choice = 1;
             }
          }

          if( has_mana_multi(player, cless, black, blue, green, red, white) ){
             if ( count_graveyard_by_type(player, recycling_type) > 0 ){
                 choice = do_dialog(player, player, card, -1, -1, " Add 1\n Recycle\n Cancel", ai_choice); 
             }
          }

          if( choice == 0){
             tap_card(player, card);
             return mana_producer(player, card, event);
          }

          if( choice == 1){
             tap_card(player, card);
             charge_mana_multi(player, cless, black, blue, green, red, white);
             if( spell_fizzled != 1){
                
                int select = select_target_from_graveyard(player, player, recycling_type, 0, 0, 0, 0, 0, 0, 0, -1, 0);
                from_graveyard_to_deck(player, select, 1);
             }
          }
  }

  return 0;
}


int card_volrath_stronghold(int player, int card, event_t event){
  check_legend_rule(player, card, event);

  return recycling_land(player, card, event, TYPE_CREATURE, 1, 1, 0, 0, 0, 0);
}

int card_academy_ruins(int player, int card, event_t event){
  check_legend_rule(player, card, event);

  return recycling_land(player, card, event, TYPE_ARTIFACT, 1, 0, 1, 0, 0, 0);
}

int card_rogue_elephant(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);
  
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_LAND);
  td.allowed_controller = player;
  td.preferred_controller = player;
  td.allow_cancel = 0;
  td.required_subtype = SUBTYPE_FOREST;
  td.illegal_abilities = 0;

  if( comes_into_play(player, card, event) ){
     if( can_target(&td) ){
        pick_target(&td, "TARGET_LAND");
        if( valid_target(&td) ){
           kill_card(instance->targets[0].player, instance->targets[0].card, KILL_SACRIFICE);
        }

     }
     else{
          kill_card(player, card, KILL_SACRIFICE);
     }
  }

  return 0;
}

int card_vine_dryad(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);

    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_NONE);
    td.required_color = COLOR_TEST_GREEN;
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.zone = TARGET_ZONE_HAND;
    td.illegal_abilities = 0;


    if( event == EVENT_MODIFY_COST ){
        if( target_available(player, card, &td)){
            COST_COLORLESS -= 3;
            COST_GREEN -= 1;
        }
    }

    else if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
        int pitch = 0;
        int choice = 1;

        if( target_available(player, card, &td) > 1){
            pitch = 1;
        }

        if( pitch == 1 && has_mana_multi(player, 3, 0, 0, 1, 0, 0) ){
            char buffer[50];
            sprintf(buffer, " RFG a green card\n Pay 3G" );
            choice = do_dialog(player, player, card, -1, -1, buffer, 0);
        }
        else if(pitch == 1){
                choice = 0;
        }
        
        if( choice == 1 && pitch == 1){
            charge_mana_multi(player, 3, 0, 0, 1, 0, 0);
        }

        else if(choice == 0){
            instance->state |= STATE_CANNOT_TARGET;
            if(!select_target(player, card, &td, "Choose a green card in hand", NULL)){
               spell_fizzled = 1;
               instance->state &= ~STATE_CANNOT_TARGET;
            }
            else{
                kill_card( player, instance->targets[0].card, KILL_DESTROY );
                rfg_card_from_grave(player, count_graveyard(player) - 1, -1 );
                instance->state &= ~STATE_CANNOT_TARGET;
            }

        }
          
    }

    return flash(player, card, event);
}

int card_timbermare(int player, int card, event_t event){
  haste(player, card);
  echo(player, card, event, 5, 0, 0, 1, 0, 0);  

  if( comes_into_play(player, card, event) ){
     manipulate_all(player, TYPE_CREATURE, 0, 0, 0, 0, 0, 0, 0, -1, 0, 6);
     manipulate_all(1-player, TYPE_CREATURE, 0, 0, 0, 0, 0, 0, 0, -1, 0, 6);
     untap_card(player, card);
  }

  return 0;
}

int vineyard_effect(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);

  if( current_phase == PHASE_MAIN1 && instance->info_slot == 66 ){
     produce_mana(current_turn, COLOR_GREEN, 2);
     instance->info_slot = 67;
  }

  if( eot_trigger(player, card, event) ){
     instance->info_slot = 66;
  }

  return 0;
}

int card_magus_of_the_vineyard(int player, int card, event_t event){

  vineyard_effect(player, card, event);

  return 0;
}

int card_evolution_charm(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.allowed_controller = 2;
  td.preferred_controller = player;

  if( event == EVENT_CAN_CAST ){
     return 1;
  }

  else if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
          int mode = 0;
        
          if( count_graveyard_by_type(player, TYPE_CREATURE) > 0 ){
             mode = 1;
          }

          if( can_target(&td) ){
             if( mode == 1){
                mode = 2;
             }
             else{
                  mode = 3;
             }
          }

          int choice = -1;
          int ai_choice = 0;
  
          if( mode == 0){
             choice = mode;
          }

          if( mode == 1){
             ai_choice = 1;
             choice = do_dialog(player, player, card, -1, -1, " Tutor basic land\n Return a creature from graveyard", ai_choice);
          }


          if( mode == 2){
             ai_choice = 1;
             choice = do_dialog(player, player, card, -1, -1, " Tutor basic land\n Return a creature from graveyard\n Give flying", ai_choice);
          }


          if( mode == 3){
             choice = do_dialog(player, player, card, -1, -1, " Tutor basic land\n Give flying", ai_choice);
             if( choice == 1){
                choice = 2;
             }
          }

          if( choice == 1){
             int select = select_target_from_graveyard(player, player, TYPE_CREATURE, 0, 0, 0, 0, 0, 0, 0, -1, 0);
             instance->targets[0].card = select;
          }


          if( choice == 2){
             pick_target(&td, "TARGET_CREATURE");
             if( !(valid_target(&td)) ){
                choice = -1;
             }
          }

          if( choice > -1 ){
             instance->info_slot = 66 + choice;
          }
  }

  else if( event == EVENT_RESOLVE_SPELL && affect_me(player, card) ){


          if( instance->info_slot == 66){
             tutor_basic_land(player, 0, 0);
          }

          if( instance->info_slot == 67){
             int *grave = graveyard_ptr[player];
             add_card_to_hand(player, grave[instance->targets[0].card]);
             remove_card_from_grave(player, instance->targets[0].card);
          }

          if( instance->info_slot == 68){
             if( valid_target(&td) ){
             pump_ability_until_eot(player, card, instance->targets[0].player, instance->targets[0].card, 0, 0, KEYWORD_FLYING);
             }
          }

          kill_card(player, card, KILL_DESTROY);

  }

  return 0;
}

int card_stonewood_invocation(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.allowed_controller = 2;
  td.preferred_controller = player;

  if( event == EVENT_CAN_CAST ){
     return 1;
  }

  else if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
          instance->state |= STATE_CANNOT_TARGET; ;
          pick_target(&td, "TARGET_CREATURE");
          if( valid_target(&td) ){
             pump_ability_until_eot(player, card, instance->targets[0].player, instance->targets[0].card, 5, 5, KEYWORD_SHROUD);
          }
  }

  else if( event == EVENT_RESOLVE_SPELL && affect_me(player, card) ){
          kill_card(player, card, KILL_DESTROY);

  }

  return 0;
}

int card_scryb_ranger(int player, int card, event_t event){

  card_instance_t *instance = get_card_instance(player, card);

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_LAND);
  td.allowed_controller = player;
  td.preferred_controller = player;
  td.required_subtype = SUBTYPE_FOREST;
  td.allow_cancel = 0;
  td.illegal_abilities = 0;

  target_definition_t td1;
  default_target_definition(player, card, &td1, TYPE_CREATURE);
  td.allowed_controller = 2;
  td.preferred_controller = player;
  td.allow_cancel = 0;
//  td.required_state = TARGET_STATE_TAPPED;

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( can_target(&td) && can_target(&td1) && instance->info_slot < 65){
        return 1;
     }
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     pick_target(&td, "TARGET_LAND");
     if( valid_target(&td) ){
        bounce_permanent(instance->targets[0].player, instance->targets[0].card);
        instance->info_slot = 65;
        pick_target(&td1, "TARGET_CREATURE");        
        if( valid_target(&td1) ){
           instance->info_slot = 66;
        }
     }
  }

  if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
     if( valid_target(&td1) ){
        untap_card(instance->targets[0].player, instance->targets[0].card);
     }
  }

  if( eot_trigger(player, card, event) ){
     instance->info_slot = 0;
  }

  return flash(player, card, event);
}

int card_segde_sliver(int player, int card, event_t event){
    // do the +1/+1 bit
    if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
        if( has_creature_type(affected_card_controller, affected_card, SUBTYPE_SLIVER) ){
            if( count_subtype(affected_card_controller, affected_card, get_hacked_subtype(player, card, SUBTYPE_SWAMP), 0 ) > 0 ){
                event_result++;
            }
        }
    }
     
    // do the regeneration bit
    card_instance_t *instance = get_card_instance(player, card);
    if( instance->info_slot == 1 ){
        return 0;
    }
    instance->info_slot = 1;
    if( is_creature_dead() && ( land_can_be_played & 0x200) ){
        int p=0;
        for(p=0;p<2;p++){
            int c=0;
            for(c=0;c< active_cards_count[p];c++){
                card_data_t card_d = get_card_data(p, c);
                if( (card_d.type & TYPE_CREATURE) && in_play(p, c) && has_creature_type(p, c, SUBTYPE_SLIVER) ){
                    card_instance_t *creature = get_card_instance(p, c);
                    if( creature->kill_code == KILL_DESTROY && has_mana(p, COLOR_BLACK, 1) ){
                        int choice = do_dialog(p, player, card, p, c, " Regenerate for B\n Do not regenerate", 0);
                        if( choice == 0 ){
                            charge_mana(p, COLOR_BLACK, 1);
                            if( spell_fizzled != 1 ){
                                regenerate_target(p, c);
                            }
                        }
                    }
                }
            }
        }
    }
    instance->info_slot = 0;
    return 0;
}

int card_zombie_master2(int player, int card, event_t event){
    // do the swampwalk bit
    if( event == EVENT_ABILITIES ){
        if( has_creature_type(affected_card_controller, affected_card, SUBTYPE_ZOMBIE) && ! affect_me(player, card) ){
            event_result |= get_hacked_walk(player, card, KEYWORD_SWAMPWALK);
        }
    }
     
    // do the regeneration bit
    card_instance_t *instance = get_card_instance(player, card);
    if( instance->info_slot == 1 ){
        return 0;
    }
    instance->info_slot = 1;
    if( is_creature_dead() && ( land_can_be_played & 0x200) ){
        int p=0;
        for(p=0;p<2;p++){
            int c=0;
            for(c=0;c< active_cards_count[p];c++){
                card_data_t card_d = get_card_data(p, c);
                if( !(p==player && c==card) && (card_d.type & TYPE_CREATURE) && in_play(p, c) && has_creature_type(p, c, SUBTYPE_ZOMBIE) ){
                    card_instance_t *creature = get_card_instance(p, c);
                    if( creature->kill_code == KILL_DESTROY && has_mana(p, COLOR_BLACK, 1) ){
                        int choice = do_dialog(p, player, card, p, c, " Regenerate for B\n Do not regenerate", 0);
                        if( choice == 0 ){
                            charge_mana(p, COLOR_BLACK, 1);
                            if( spell_fizzled != 1 ){
                                regenerate_target(p, c);
                            }
                        }
                    }
                }
            }
        }
    }
    instance->info_slot = 0;
    return 0;
}

int card_ward_sliver(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);

  if( comes_into_play(player, card, event) ){ 
     int k = select_a_color(player);
     int protection = 0;

     if( k == COLOR_TEST_BLACK ){
        protection = KEYWORD_PROT_BLACK;
     }

     if( k == COLOR_TEST_BLUE ){
        protection = KEYWORD_PROT_BLUE;
     }

     if( k == COLOR_TEST_GREEN ){
        protection = KEYWORD_PROT_GREEN;
     }

     if( k == COLOR_TEST_RED ){
        protection = KEYWORD_PROT_RED;
     }

     if( k == COLOR_TEST_WHITE ){
        protection = KEYWORD_PROT_WHITE;
     }

     instance->info_slot = protection;
  }

  if( event == EVENT_ABILITIES ){
        if( has_creature_type(affected_card_controller, affected_card, SUBTYPE_SLIVER) ){
           event_result |= instance->info_slot;
        }
  }

  return 0;
}

int count_untapped_nonsick_slivers(int player){
  int result = 0;
  int count = 0;
  while(count < active_cards_count[player]){
        if( is_what(player, count, TYPE_CREATURE) && has_subtype(player, count, SUBTYPE_SLIVER) ){
           if( !(is_tapped(player, count)) && !(is_sick(player, count)) && in_play(player, count)){
              result++;
           }
        }
        count++;
  }

  return result;
}


int card_gemhide_sliver(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.allowed_controller = player;
  td.preferred_controller = player;
  td.required_subtype = SUBTYPE_SLIVER;
  td.illegal_abilities = 0;
  td.illegal_state = TARGET_STATE_SUMMONING_SICK;

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && can_target(&td) ){
     if( count_untapped_nonsick_slivers(player) > 0 ){
        return 1;
     }
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     int stop = 0;
     while( stop != 1 ){
           pick_target(&td, "TARGET_CREATURE");
           if( valid_target(&td) && !(is_tapped(instance->targets[0].player, instance->targets[0].card)) ){
              tap_card(instance->targets[0].player, instance->targets[0].card);        
              instance->info_slot = 66;
              stop = 1;             
           }
     }
  }

  if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
     int color = choose_a_color(player, 3);
     produce_mana(player, color, 1);
     instance->info_slot = 0;
  }

  return 0;
}

int card_magma_sliver(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.allowed_controller = player;
  td.preferred_controller = player;
  td.required_subtype = SUBTYPE_SLIVER;
  td.illegal_abilities = 0;

  target_definition_t td1;
  default_target_definition(player, card, &td1, TYPE_CREATURE);
  td1.allowed_controller = 2;
  td1.preferred_controller = player;
  td1.required_subtype = SUBTYPE_SLIVER;

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( count_untapped_nonsick_slivers(player) > 0 && can_target(&td1) ){
        return 1;
     }
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     int stop = 0;
     while( stop != 1 ){
           pick_target(&td, "TARGET_CREATURE");
           if( valid_target(&td) && !(is_tapped(instance->targets[0].player, instance->targets[0].card)) ){
              if( !(is_sick(instance->targets[0].player, instance->targets[0].card)) ){
                 tap_card(instance->targets[0].player, instance->targets[0].card);        
                 stop = 1;             
              }
           }
     }

     pick_target(&td1, "TARGET_CREATURE");
     if( valid_target(&td1) ){
        instance->info_slot = 66;
     }

  }

  if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
     if( valid_target(&td1) ){
        int pump = count_subtype(player, card, SUBTYPE_SLIVER, 0);
        pump_until_eot(player, card, instance->targets[0].player, instance->targets[0].card, pump, 0);
     }
     instance->info_slot = 0;
  }

  return 0;
}

int card_telekinetik_sliver(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.allowed_controller = player;
  td.preferred_controller = player;
  td.required_subtype = SUBTYPE_SLIVER;
  td.illegal_abilities = 0;

  target_definition_t td1;
  default_target_definition(player, card, &td1, TYPE_PERMANENT);
  td1.allowed_controller = 2;
  td1.preferred_controller = 1-player;

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( count_untapped_nonsick_slivers(player) > 0 && can_target(&td1) ){
        return 1;
     }
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     int stop = 0;
     while( stop != 1 ){
           pick_target(&td, "TARGET_CREATURE");
           if( valid_target(&td) && !(is_tapped(instance->targets[0].player, instance->targets[0].card)) ){
              if( !(is_sick(instance->targets[0].player, instance->targets[0].card)) ){
                 tap_card(instance->targets[0].player, instance->targets[0].card);        
                 stop = 1;             
              }
           }
     }

     pick_target(&td1, "TARGET_PERMANENT");
     if( valid_target(&td1) ){
        instance->info_slot = 66;
     }

  }

  if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
     if( valid_target(&td1) ){
        tap_card(instance->targets[0].player, instance->targets[0].card);
     }
     instance->info_slot = 0;
  }

  return 0;
}

int card_synapse_sliver(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_DEAL_DAMAGE ){
        card_instance_t *damage= get_card_instance( affected_card_controller, affected_card);
        if( damage->internal_card_id == damage_card && damage->info_slot > 0){
            if( damage->damage_target_card == -1 && has_subtype(damage->damage_source_player, damage->damage_source_card, SUBTYPE_SLIVER) ){
                instance->info_slot++;
                instance->targets[0].player = damage->damage_target_player;
            }
        }
    }
    else if( comes_into_play(player, card, event) ){
        instance->info_slot = -1;
    }
    
    
    if(trigger_condition == TRIGGER_DEAL_DAMAGE && affect_me(player, card) && reason_for_trigger_controller == player && instance->info_slot > -1 ){
        if(event == EVENT_TRIGGER){
            event_result |= 2;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
                draw_cards(player, instance->info_slot+1);
                instance->info_slot = -1;
        }
    }
    return 0;
}

int card_psionic_sliver(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.allowed_controller = player;
  td.preferred_controller = player;
  td.required_subtype = SUBTYPE_SLIVER;
  td.illegal_abilities = 0;

  target_definition_t td1;
  default_target_definition(player, card, &td1, TYPE_CREATURE);
  td1.zone = TARGET_ZONE_CREATURE_OR_PLAYER;

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( count_untapped_nonsick_slivers(player) > 0 && can_target(&td1) ){
        return 1;
     }
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     int stop = 0;
     while( stop != 1 ){
           pick_target(&td, "TARGET_CREATURE");
           if( valid_target(&td) && !(is_tapped(instance->targets[0].player, instance->targets[0].card)) ){
              if( !(is_sick(instance->targets[0].player, instance->targets[0].card)) ){
                 tap_card(instance->targets[0].player, instance->targets[0].card);        
                 instance->targets[1].player = instance->targets[0].player;
                 instance->targets[1].card = instance->targets[0].card;
                 stop = 1;             
              }
           }
     }

     pick_target(&td1, "TARGET_CREATURE_OR_PLAYER");
     if( valid_target(&td1) ){
        instance->info_slot = 66;
     }

  }

  if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
     damage_creature_or_player(player, card, event, 2, 3);
     if( valid_target(&td1) ){
        damage_creature(instance->targets[1].player, instance->targets[1].card, 3, player, card);
     }
     instance->info_slot = 0;
  }

  return 0;
}

int card_necrotic_sliver(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.allowed_controller = player;
  td.preferred_controller = player;
  td.required_subtype = SUBTYPE_SLIVER;
  td.illegal_abilities = 0;

  target_definition_t td1;
  default_target_definition(player, card, &td1, TYPE_PERMANENT);
  td1.allowed_controller = 2;
  td1.preferred_controller = 1-player;

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( has_mana_multi(player, 3, 0, 0, 0, 0, 0) && can_target(&td1) ){
        return 1;
     }
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     charge_mana_multi(player, 3, 0, 0, 0, 0, 0);
     if(spell_fizzled != 1 ){
        pick_target(&td, "TARGET_CREATURE");
        if( valid_target(&td) ){
           kill_card(instance->targets[0].player, instance->targets[0].card, KILL_SACRIFICE);        
           pick_target(&td1, "TARGET_PERMANENT");
           if( valid_target(&td1) ){
              instance->info_slot = 66;
           }
        }
     }
  }

  if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
     if( valid_target(&td1) ){
        kill_card(instance->targets[0].player, instance->targets[0].card, KILL_DESTROY);
     }
     instance->info_slot = 0;
  }

  return 0;
}

int card_altar_of_dementia(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance( player, card );

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.allowed_controller = player;
  td.preferred_controller = player;
  td.illegal_abilities = 0;

  target_definition_t td1;
  default_target_definition(player, card, &td1, TYPE_CREATURE );
  td1.zone = TARGET_ZONE_PLAYERS;

  if( event == EVENT_CAN_CAST ){
     return 1;
  }

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && can_target(&td) ){
     return 1;
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     pick_target(&td, "LORD_OF_THE_PIT");
     if( valid_target(&td) ){
        int k = get_power(instance->targets[0].player, instance->targets[0].card);
        kill_card(instance->targets[0].player, instance->targets[0].card, KILL_SACRIFICE);
        pick_target(&td1, "TARGET_PLAYER");
        if( valid_target(&td1) ){
           instance->info_slot = k;
        }
     }
  }

  if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot > 0){
     mill(instance->targets[0].player, instance->info_slot);
     instance->info_slot = 0;
  }


  return 0;
}

int card_static_orb(int player, int card, event_t event){

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_PERMANENT);
  td.allowed_controller = current_turn;
  td.preferred_controller = current_turn;
  td.illegal_abilities = 0;
  td.required_state = TARGET_STATE_TAPPED;
  td.who_chooses = current_turn;

  card_instance_t *instance= get_card_instance(player, card);

  if( event == EVENT_CAN_CAST ){
     return 1;
  }

  if( event == EVENT_UNTAP && current_phase == PHASE_UNTAP && !(is_tapped(player, card)) ){
     card_instance_t *affected= get_card_instance(affected_card_controller, affected_card);
     affected->untap_status &= -4;    
  }

  if( upkeep_trigger(player, card, event) ){
     int i;
     for( i = 0; i < 2; i++){
         if( can_target(&td) ){
              pick_target(&td, "TARGET_PERMANENT");
              if( valid_target(&td) ){
                 untap_card(instance->targets[0].player, instance->targets[0].card);
              }
         }
     }
  }

  return 0;
}

int card_null_brooch(int player, int card, event_t event){

  card_instance_t *instance = get_card_instance(player, card);

  if( event == EVENT_CAN_CAST ){
     return 1;
  }

  if(event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_animated_and_sick(player, card)) && !(is_tapped(player, card)) ){
     int result = card_daring_apprentice(player, card, event);
     if( result == 0 || ! has_mana_multi(player, 2, 0, 0, 0, 0, 0) ){
            return 0;
     }
     else{ 
          card_instance_t *spell = get_card_instance(card_on_stack_controller, card_on_stack);
          if( !(cards_data[ spell->internal_card_id].type & TYPE_CREATURE) ){
             instance->targets[0].player = card_on_stack_controller;
             instance->targets[0].card = card_on_stack;
             return result;
          }
          else{
               return 0;
          }
     }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
          charge_mana_multi(player, 2, 0, 0, 0, 0, 0);
          if(spell_fizzled != 1){
             tap_card(player, card);
             discard_all(player);
             instance->info_slot = 66;
          }
  }

  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
          kill_card(instance->targets[0].player, instance->targets[0].card, KILL_SACRIFICE);
          instance->info_slot = 0;
  }

  return 0;
}

int card_metalworker(int player, int card, event_t event){

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_ARTIFACT);
  td.zone = TARGET_ZONE_HAND;
  td.illegal_abilities = 0;
  td.allowed_controller = player;
  td.preferred_controller = player;

  card_instance_t *instance = get_card_instance(player, card);

  if(event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( !(is_sick(player, card)) && !(is_tapped(player, card)) ){
        return 1;
     }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
          tap_card(player, card);
          int revealed = 0;
          int cards_array[ 500 ];
          int choice = do_dialog(player, player, card, -1, -1, " Auto mode\n Manual mode", 0);

          if( choice == 1){
             int stop = 0;
             while( target_available(player, card, &td) > 0 || stop != 1){
                   if( pick_target(&td, "TARGET_ARTIFACT") ){
                      if( valid_target(&td) ){
                         card_instance_t *rev_card = get_card_instance(player, instance->targets[0].card);
                         cards_array[revealed] = rev_card->internal_card_id;                   
                         instance->targets[revealed+1].card = instance->targets[0].card;
                         rev_card->state |= STATE_CANNOT_TARGET; 
                         revealed++;
                      } 
                   }
                   else{
                        stop = 1;
                   }
             }

             if( revealed > 0){
                int i;
                for(i=0;i<revealed; i++){
                    card_instance_t *crd = get_card_instance(player, instance->targets[i+1].card);
                    crd->state &= ~STATE_CANNOT_TARGET;
                }
             }
          }

          if( choice == 0){
             int i;
             for(i=0;i<active_cards_count[player]; i++){
                 card_data_t card_d = get_card_data(player, i);
                 if( (card_d.type & TYPE_ARTIFACT) && in_hand(player, i) ){
                    card_instance_t *rev_card = get_card_instance(player, i);
                    cards_array[revealed] = rev_card->internal_card_id;
                    revealed++;
                 }
             }
          }

          if( revealed > 0){
             show_deck( player, cards_array, revealed, "Cards revealed with Metalworker", 0, 0x7375B0 );
             int amount = revealed * 2;
             produce_mana(player, COLOR_COLORLESS, amount);   
          }
  }

  return 0;
}

int card_phyrexian_processor(int player, int card, event_t event){

  card_instance_t *instance = get_card_instance(player, card);

  if( event == EVENT_CAN_CAST ){
     return 1;
  }

  else if( comes_into_play(player, card, event) ){
   
          int number = 0;

          if(player == AI){     
                number = rand(life[AI]-1);
          }
          else{     
               number = choose_a_number(player, "How much life do you pay ?", life[player]-1);
          }
          life[player]-=number;
          instance->info_slot = number;
  }

  else if(event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_animated_and_sick(player, card)) ){ 
          if( !(is_tapped(player, card)) && has_mana_multi(player, 4, 0, 0, 0, 0, 0) ){
             return 1;
          }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
          charge_mana_multi(player, 4, 0, 0, 0, 0, 0);
          if(spell_fizzled != 1){
             tap_card(player, card);
             instance->targets[9].card = 66;
          }
  }

  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->targets[9].card == 66){
          if(instance->info_slot > 0){
             int minion = generate_token(player, "Minion");
             card_instance_t *min = get_card_instance(player, minion);
             min->info_slot = instance->info_slot;
             instance->targets[9].card = 0;
          }
  }

  return 0;
}

int card_minion(int player, int card, event_t event){

  card_instance_t *instance = get_card_instance(player, card);

  if( instance->info_slot > 0 ){
     if( (event == EVENT_POWER || event == EVENT_TOUGHNESS) && affect_me(player, card) ){
        event_result += instance->info_slot-1;
     }
  }

  return 0;
}

int card_engineered_explosives(int player, int card, event_t event){

  card_instance_t *instance = get_card_instance(player, card);

  if( event == EVENT_CAN_CAST ){
     return 1;
  }

  else if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
          int number = 0;
          int stop = 0;
          int colors[5];
          int paid[5];
          int ai_choice = 0; 
          int i;
          for(i =0; i < 5; i++){
              colors[i] = 0;
              paid[i] = 0;
          }

          while( stop != 1 ){
                int choice = do_dialog(player, player, card, -1, -1, " Pay B\n Payn U\n Pay G\n Pay R\n Pay W\n Finished", ai_choice);
                if( choice < 5 ){   
                   colors[choice] = 1;
                   charge_mana_multi(player, 0, colors[0], colors[1], colors[2], colors[3], colors[4]);
                   if(spell_fizzled != 1 && paid[choice] != 1){
                     number++;
                     paid[choice] = 1;
                     colors[choice] = 0;
                   }
                }
                else{
                     stop = 1;
                }
          }

          instance->info_slot = number;
  }

  else if( comes_into_play(player, card, event) ){
          set_counters(player, card, instance->info_slot);
  }

  else if(event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_animated_and_sick(player, card)) ){ 
          if( !(is_tapped(player, card)) && has_mana_multi(player, 2, 0, 0, 0, 0, 0) ){
             return 1;
          }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
          charge_mana_multi(player, 2, 0, 0, 0, 0, 0);
          if(spell_fizzled != 1){
             instance->targets[9].card = 66;
             instance->targets[10].card = count_counters(player, card);
             kill_card(player, card, KILL_SACRIFICE);
          }
  }

  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->targets[9].card == 66){
          manipulate_all(player, TYPE_LAND, 1, 0, 0, 0, 0, 0, 0, instance->targets[10].card, 0, 1);           
          manipulate_all(1-player, TYPE_LAND, 1, 0, 0, 0, 0, 0, 0, instance->targets[10].card, 0, 1);           
  }

  return 0;
}

int effect_kill_switch(int player, int card, event_t event ){
    card_instance_t *instance = get_card_instance(player, card);
    card_instance_t *affected = get_card_instance(instance->targets[8].player, instance->targets[8].card);

    if( event == EVENT_UNTAP && current_phase == PHASE_UNTAP && affect_me(instance->targets[8].player, instance->targets[8].card) ){
       if( is_tapped(instance->targets[9].player, instance->targets[9].card) ){
          affected->untap_status &= -4;
       }
    }

    if( leaves_play(instance->targets[9].player, instance->targets[9].card, event) ){
       kill_card(player, card, KILL_DESTROY);
    }

    return 0;
}

int card_kill_switch(int player, int card, event_t event){

  card_instance_t *instance= get_card_instance(player, card);

  if( event == EVENT_CAN_CAST ){
     return 1;
  }

  else if(event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_animated_and_sick(player, card)) ){ 
          if( !(is_tapped(player, card)) && has_mana_multi(player, 2, 0, 0, 0, 0, 0) ){
             return 1;
          }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
          charge_mana_multi(player, 2, 0, 0, 0, 0, 0);
          if(spell_fizzled != 1){
             tap_card(player, card); 
             instance->info_slot = 66;
          }
  }

  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
          manipulate_all(player, TYPE_ARTIFACT, 0, 0, 0, 0, 0, 0, 0, -1, 0, 6);           
          manipulate_all(1-player, TYPE_ARTIFACT, 0, 0, 0, 0, 0, 0, 0, -1, 0, 6);           
          int i;
          for(i = 0; i < 2; i++){
              int count = 0;
              while( count < active_cards_count[i]){
                    card_data_t card_d = get_card_data(i, count);
                    if( (card_d.type & TYPE_ARTIFACT) && in_play(i, count) ){
                       int legacy_card = create_targetted_legacy_effect(player, card, &effect_kill_switch, i, count);
                       card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
                       legacy_instance->targets[8].player = i;
                       legacy_instance->targets[8].card = count;
                       legacy_instance->targets[9].player = instance->parent_controller;
                       legacy_instance->targets[9].card = instance->parent_card;
                       if( i == instance->parent_controller && count == instance->parent_card ){
                          kill_card(i, legacy_card, KILL_DESTROY);
                       }
                    }
                    count++;
              }
          }
          instance->info_slot = 0;
  }

  return 0;
}

int card_slate_of_ancestry(int player, int card, event_t event){

  card_instance_t *instance= get_card_instance(player, card);

  if( event == EVENT_CAN_CAST ){
     return 1;
  }

  else if(event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_animated_and_sick(player, card)) ){ 
          if( !(is_tapped(player, card)) && has_mana_multi(player, 4, 0, 0, 0, 0, 0) ){
             return 1;
          }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
          charge_mana_multi(player, 4, 0, 0, 0, 0, 0);
          if(spell_fizzled != 1){
             tap_card(player, card); 
             discard_all(player);
             instance->info_slot = 66;
          }
  }

  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
          draw_cards(player, count_permanents_by_type(player, card, TYPE_CREATURE));
  }

  return 0;
}

int card_doubling_cube(int player, int card, event_t event){
    if(event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_animated_and_sick(player, card)) ){
        if( !(is_tapped(player, card)) && has_mana_multi(player, 3, 0, 0, 0, 0, 0) ){
            return 1;
        }
    }

    else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
        charge_mana_multi(player, 3, 0, 0, 0, 0, 0);
        if(spell_fizzled != 1){
            tap_card(player, card);
            int color, has_color;
            int colorless = 0;
            for(color = 6; color > 0;color--){
                has_color = 0;
                while( has_mana(player, color, has_color+1) ){
	                has_color++;
                }
                if( color == 6 ){
                    colorless = has_color;
                }
                else{
                    produce_mana(player, color, has_color);
                    colorless-=has_color;
                }
            }
            produce_mana(player, COLOR_COLORLESS, colorless);
//            spell_fizzled = 1;
        }
    }
    return 0;
}

int card_staff_of_domination(int player, int card, event_t event){

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.allowed_controller = 2;

  target_definition_t td1;
  default_target_definition(player, card, &td1, TYPE_CREATURE);
  td1.allowed_controller = player;
  td1.preferred_controller = player;
  td1.required_state = TARGET_STATE_TAPPED;

  target_definition_t td2;
  default_target_definition(player, card, &td1, TYPE_CREATURE);
  td1.allowed_controller = 1-player;
  td1.preferred_controller = 1-player;




  card_instance_t *instance= get_card_instance(player, card);

  if( event == EVENT_CAN_CAST ){
     return 1;
  }

  else if(event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_animated_and_sick(player, card)) ){ 
          if( has_mana_multi(player, 1, 0, 0, 0, 0, 0) ){
             return 1;
          }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){

          int choice = 0;
          int ai_choice = 0;
          int mode = 0;

          if( !(is_tapped(player, card)) ){

          if( has_mana_multi(player, 2, 0, 0, 0, 0, 0) ){
             ai_choice = 1;
             mode = 1;
          }

          if(has_mana_multi(player, 3, 0, 0, 0, 0, 0)  ){
             if( player == AI && target_available(player, card, &td1) > 0 ){
                ai_choice = 2;
                mode = 2;
             }
             else if( target_available(player, card, &td) > 0 ){
                     mode = 2;
             }
          }

          if(has_mana_multi(player, 4, 0, 0, 0, 0, 0)  ){
             if( player == AI && target_available(player, card, &td2) > 0 ){
                ai_choice = 3;
                mode = 3;
             }
             else if( target_available(player, card, &td) > 0 ){
                     mode = 3;
             }
          }

          if(has_mana_multi(player, 5, 0, 0, 0, 0, 0) ){
             ai_choice = 4;
             if( mode > 1 ){
                mode = 4; 
             }
             else{
                   ai_choice = 2;
                   mode = 5;
             }
          }

          if( mode == 1 ){
             choice = do_dialog(player, player, card, -1, -1, " Untap Staff of Domination\n Gain 1 life\n Cancel", ai_choice);
               if( choice == 2 ){
                  choice = -1;
               }

          }

          if( mode == 2 ){
             choice = do_dialog(player, player, card, -1, -1, " Untap Staff of Domination\n Gain 1 life\n Untap a creature\n Cancel", ai_choice);
             if( choice == 3 ){
                  choice = -1;
               }
}

          if( mode == 3 ){
             choice = do_dialog(player, player, card, -1, -1, " Untap Staff of Domination\n Gain 1 life\n Untap a creature\n Tap a creature\n Cancel", ai_choice);
               if( choice == 4 ){
                  choice = -1;
               }
          }

          if( mode == 4 ){
             choice = do_dialog(player, player, card, -1, -1, " Untap Staff of Domination\n Gain 1 life\n Untap a creature\n Tap a creature\n Draw 1 card\n Cancel", ai_choice);
               if( choice == 5 ){
                  choice = -1;
               }
          }


          if( mode == 5 ){
             choice = do_dialog(player, player, card, -1, -1, " Untap Staff of Domination\n Gain 1 life\nDraw 1 card\n Cancel", ai_choice);
               if( choice == 2 ){
                  choice = 4;
               }
               if( choice == 3 ){
                  choice = -1;
               }
          }
          }

          if( choice != -1 ){
          charge_mana_multi(player, choice+1, 0, 0, 0, 0, 0);
          if(spell_fizzled != 1){
             tap_card(player, card); 

             if( choice == 2){
                if(player == AI){
                   pick_target(&td1, "TARGET_CREATURE");
                   if( valid_target(&td1) ){
                      instance->info_slot = 66 + choice;
                   }
                }
                else{
                     pick_target(&td, "TARGET_CREATURE");
                     if( valid_target(&td) ){
                        instance->info_slot = 66 + choice;
                     }
                }
             }
             else if( choice == 3){
                     if(player == AI){
                        pick_target(&td2, "TARGET_CREATURE");
                        if( valid_target(&td2) ){
                           instance->info_slot = 66 + choice;
                        }
                     }
                     else{
                          pick_target(&td, "TARGET_CREATURE");
                          if( valid_target(&td) ){
                             instance->info_slot = 66 + choice;
                          }
                     }
             }
             else{
                  instance->info_slot = 66 + choice;
             }
          }
          }
  }

  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card)){

          if( instance->info_slot == 66){
             untap_card(player, instance->parent_card);
          }

          if( instance->info_slot == 67){
             gain_life(player, 1);
          }

          if( instance->info_slot == 68){
             if( valid_target(&td) ){
                untap_card(instance->targets[0].player, instance->targets[0].card);
             }
          }

          if( instance->info_slot == 69){
             if( valid_target(&td) ){
                tap_card(instance->targets[0].player, instance->targets[0].card);
             }
          }

          if( instance->info_slot == 70){
             draw_cards(player, 1);
          }
          instance->info_slot = 0;

  }

  return 0;
}

int effect_yosei(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( instance->targets[4].card != 2 ){ 
        instance->targets[4].card = 2;
        if( current_turn == instance->targets[9].player ){
            instance->targets[4].player = 2;
        }
    }
    
    if( event == EVENT_UNTAP && current_phase == PHASE_UNTAP && current_turn == instance->targets[9].player ){
        card_instance_t *affected= get_card_instance(affected_card_controller, affected_card);
        affected->untap_status &= -4;  
    }
    
    if( instance->targets[9].player == current_turn && instance->targets[4].player != 2 && eot_trigger(player, card, event )  ){
        kill_card(player, card, KILL_REMOVE);
    }
    else if( instance->targets[9].player == current_turn && instance->targets[4].player == 2 && eot_trigger(player, card, event ) ){
        instance->targets[4].player = 1; 
    }
    return 0;
}
  

int card_yosei(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);

  if( event == EVENT_GRAVEYARD_FROM_PLAY && affect_me(player, card) && in_play(player, card)  && instance->kill_code != KILL_REMOVE){

     target_definition_t td;
     default_target_definition(player, card, &td, TYPE_CREATURE );
     td.zone = TARGET_ZONE_PLAYERS;
     td.allow_cancel = 0;
     int p = -1;
     pick_target(&td, "TARGET_PLAYER");
     if(valid_target(&td) ){
        p = instance->targets[0].player;
        int legacy = create_legacy_effect(player, card, &effect_yosei );
        card_instance_t *leg = get_card_instance(player, legacy);
        leg->targets[9].player = p;
        if( current_turn == 1-player ){
           leg->targets[9].card = 2;
        }
        else{
             leg->targets[9].card = 1;
        }
     }

     if( p > -1){
        target_definition_t td1;
        default_target_definition(player, card, &td1, TYPE_PERMANENT );
        td1.allowed_controller = p;
        td1.preferred_controller = p;
        td1.illegal_state = TARGET_STATE_TAPPED;
        int stop = 0;
        int progress = 0;
        while( can_target(&td1) && stop !=1 && progress < 5){
              if( pick_target(&td1, "TARGET_PERMANENT") ){
                 if( valid_target(&td1) ){ 
                    tap_card(instance->targets[0].player, instance->targets[0].card);
                    progress++;
                 }
              }
              else{
                   stop=1;
              }
        }
     }
  }

  return 0;
}

int card_spectral_force(int player, int card, event_t event){

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_PERMANENT );
  td.allowed_controller = 1-player;
  td.preferred_controller = 1-player;
  td.required_color = COLOR_TEST_BLACK;
  td.illegal_abilities = 0;

  card_instance_t *instance = get_card_instance(player, card);

  if( event == EVENT_DECLARE_ATTACKERS && (instance->state & STATE_ATTACKING) && !(can_target(&td)) ){
     int legacy_card = create_targetted_legacy_effect(player, card, &effect_does_not_untap, player, card);
     card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
     legacy_instance->targets[0].player = player;
     legacy_instance->targets[0].card = card;
  }

  return 0;
}

int card_woodfall_primus(int player, int card, event_t event){

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_PERMANENT );
  td.allowed_controller = 2;
  td.preferred_controller = 1-player;
  td.illegal_type = TYPE_CREATURE;

  card_instance_t *instance = get_card_instance(player, card);

  if( comes_into_play(player, card, event) && can_target(&td) ){
     pick_target(&td, "TARGET_PERMANENT");
     if( valid_target(&td) ){
        kill_card(instance->targets[0].player, instance->targets[0].card, KILL_DESTROY);
     }
  }

  persist(player, card, event);

  return 0;
}

int card_murderous_redcap(int player, int card, event_t event){

  hybrid(player, card, event);
  persist(player, card, event);

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.zone = TARGET_ZONE_CREATURE_OR_PLAYER;

  if( comes_into_play(player, card, event) && can_target(&td) ){
     pick_target(&td, "TARGET_CREATURE_OR_PLAYER");
     if( valid_target(&td) ){
        int power = get_power(player, card);
        damage_creature_or_player(player, card, event, power, 3);
     }
  }

  return 0;
}

int card_rain_of_daggers(int player, int card, event_t event){

  if( event == EVENT_CAN_CAST ){
     return 1;
  }

  else if( event == EVENT_RESOLVE_SPELL ){
          int life_loss = count_permanents_by_type(1-player, card, TYPE_CREATURE) *  2;
          manipulate_all(1-player, TYPE_CREATURE, 0, 0, 0, 0, 0, 0, 0, -1, 0, 1);
          life[player]-=life_loss; 
          kill_card(player, card, KILL_DESTROY);

  }

  return 0;
}

int card_righteous_fury(int player, int card, event_t event){

  if( event == EVENT_CAN_CAST ){
     return 1;
  }

  else if( event == EVENT_RESOLVE_SPELL ){
          int life_gain = 0;
          int i;
          for(i = 0; i < 2; i++){
              int count = active_cards_count[i]-1;
              while( count > -1 ){
                    if( is_what(i, count, TYPE_CREATURE) && is_tapped(i, count) && in_play(i, count) ){
                       kill_card(i, count, KILL_DESTROY);
                       life_gain+=2;
                    }
                    count--;
              }
          }
          gain_life(player, life_gain);
          kill_card(player, card, KILL_DESTROY);

  }

  return 0;
}

int card_sea_drake(int player, int card, event_t event){

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_LAND );
  td.allowed_controller = player;
  td.preferred_controller = player;
  td.allow_cancel = 0;

  card_instance_t *instance = get_card_instance(player, card);

  if( comes_into_play(player, card, event) ){
     int i;
     for(i = 0; i < 2; i++ ){
         if( can_target(&td) ){
            pick_target(&td, "TARGET_LAND");
            if( valid_target(&td) ){
               bounce_permanent(instance->targets[0].player, instance->targets[0].card);
            }
         }
     }
  }

  return 0;
}

int card_imperial_recruiter(int player, int card, event_t event){

  if( comes_into_play(player, card, event) ){
          if( player != AI ){
             int selected = -1;
             while( selected == -1){
                   selected = show_deck( player, deck_ptr[player], 500, "Pick a card", 0, 0x7375B0 );
             }
             int *deck = deck_ptr[player];
             if( (cards_data[deck[selected]].type & TYPE_CREATURE) && (cards_data[deck[selected]].power < 3) ){
                add_card_to_hand(player, deck[selected] );
                remove_card_from_deck( player, selected );
             }
             gain_life(player, 0);
             shuffle(player);
          }
          else{
               int i;
               int *deck = deck_ptr[player];
               int max_cmc = 0;
               int max_index = 0;
               for(i = 0; i < count_deck(player); i++){
                   int selected = i;
                   if( (cards_data[deck[selected]].type & TYPE_CREATURE) && (cards_data[deck[selected]].power < 3) ){
                      int cmc = cards_data[deck[selected]].cc[0] + cards_data[deck[selected]].cc[1];
                      if( cmc > max_cmc ){
                         max_cmc = cmc;
                         max_index = selected;
                      }
                   }
               }
               add_card_to_hand(player, deck[max_index] );
               remove_card_from_deck( player, max_index );
               gain_life(player, 0);
               shuffle(player);
         }
  }

  return 0;
}

int card_cao_cao(int player, int card, event_t event){

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_tapped(player, card)) ){
     if( !(is_sick(player, card)) && current_phase < PHASE_DECLARE_ATTACKERS && current_turn == player){
        return 1;
     }
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     tap_card(player, card);
  }

  if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) ){
     int i;
     for(i = 0; i < 2; i++){
         discard(1-player, 0, 0);
     }
  }

  return 0;
}

int card_xiahou_dun(int player, int card, event_t event){

  card_instance_t *instance = get_card_instance(player, card);

  horsemanship(player, card, event);

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card)){
     if( current_phase < PHASE_DECLARE_ATTACKERS && current_turn == player){
        if( count_graveyard_by_color(player, COLOR_TEST_BLACK) > 0 ){
           return 1;
        }
     }
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     int selected = -1;
     if( player == AI ){
        int *graveyard = graveyard_ptr[player];
        int max_cmc = -1;
        int max_index = -1;
        int i;
        if( count_graveyard_by_color(player, COLOR_TEST_BLACK) > 0 ){
           for(i = 0; i < count_graveyard(player); i++){
               if( (graveyard[i] != -1) && (cards_data[  graveyard[i] ].color & COLOR_TEST_BLACK) ){
                  int cmc = cards_data[  graveyard[i] ].cc[0] + cards_data[  graveyard[i] ].cc[1];
                  if( cmc > max_cmc ){
                     max_cmc = cmc;
                     max_index = i;
                  } 
               }  
           }
        } 
        selected = max_index;
     }
     else{
          selected = select_target_from_graveyard(player, player, 0, 0, 0, 0, COLOR_TEST_BLACK, 0, 0, 0, -1, 0);
     }
     if( selected > -1){
        instance->targets[0].card = selected;
     }
     kill_card(player, card, KILL_SACRIFICE);
  }

  if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) ){
     int *grave = graveyard_ptr[player];
     int selected = instance->targets[0].card;
     add_card_to_hand(player, grave[selected] );
     remove_card_from_grave( player, selected );
  }

  return 0;
}

int card_hua_tou(int player, int card, event_t event){

  card_instance_t *instance = get_card_instance(player, card);

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_tapped(player, card)) ){
     if( !(is_sick(player, card)) && current_phase < PHASE_DECLARE_ATTACKERS && current_turn == player){
        if( count_graveyard_by_type(player, TYPE_CREATURE) > 0 ){
           return 1;
        }
     }
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     tap_card(player, card);
     int selected = -1;
     if( player == AI ){
        selected = ai_best_reanimator_target(player, TYPE_CREATURE);
     }
     else{
          selected = select_target_from_graveyard(player, player, TYPE_CREATURE, 0, 0, 0, 0, 0, 0, 0, -1, 0);
     }
     if( selected > -1){
        instance->targets[0].card = selected;
     }
  }

  if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) ){
     from_graveyard_to_deck(player, instance->targets[0].card, 1);
  }

  return 0;
}

int card_cold_eyed_selkie(int player, int card, event_t event){
  
  hybrid(player, card, event);

  card_instance_t *instance = get_card_instance(player, card);

  if(event == EVENT_RESOLVE_TRIGGER && is_unblocked(player, card) ){
     if( ! affect_me(player, card) ){ return 0; }
     int ai_choice = 0;
     if( player == AI && count_deck(player) < 10 ){
        ai_choice = 1;
     }
     int choice =  do_dialog(player, player, card, -1, -1, " Draw cards\n Pass", ai_choice);
     if( choice == 0){
        draw_cards(player, get_power(player, card));
     }
     instance->damage_source_player = -1;
     return 0;
  }
  else{
       return card_hypnotic_specter(player, card, event);
  }
}        

int card_darksteel_reactor(int player, int card, event_t event){

  indestructible(player, card, event);

  if( upkeep_trigger(player, card, event) && current_turn == player ){
     int choice =  do_dialog(player, player, card, -1, -1, " Put a counter on Darksteel Reactor\n Pass", 0);
     if( choice == 0 ){
        add_counter(player, card);
     }
  }

  if( count_counters(player, card) >= 20){
     if( count_cards_by_id(1-player, get_id_by_name("Platinum Angel")) < 1 ){
        lose_the_game( 1-player);
     }
  }

  return 0;
}

int card_yavimaya_elder(int player, int card, event_t event){

  if(event == EVENT_GRAVEYARD_FROM_PLAY && affect_me( player, card) && in_play(player, card) ){
     card_instance_t *elder = get_card_instance(player, card);
     if( elder->kill_code > 0 && elder->kill_code != KILL_REMOVE ){
        tutor_basic_land(player, 0, 0);
        tutor_basic_land(player, 0, 0);
     }
  }

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( has_mana(player, COLOR_COLORLESS, 2) ){
        return 1;
     }
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
    charge_mana(player, COLOR_COLORLESS, 2);
    if (spell_fizzled != 1 ){
        kill_card(player, card, KILL_SACRIFICE);
    }
  }

  if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) ){
     draw_cards(player, 1);
  }

  return 0;
}

int card_eternal_dragon(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance( player, card );

  if( event == EVENT_GRAVEYARD_ABILITY_UPKEEP ){ 
     if( has_mana_multi(player, 3, 0, 0, 0, 0, 2) ){  
        int choice = do_dialog(player, player, card, -1, -1," Return Eternal Dragon to hand\n Pass\n", 0);
        if( choice == 0 ){
           charge_mana_multi(player, 3, 0, 0, 0, 0, 2);
           if( spell_fizzled != 1){
              instance->state &= ~STATE_INVISIBLE;
              hand_count[player]++;
              return -1;    
           }
        }
        return -2;
     }
     else{
          return -2;
     }
  }

  return landcycling(player, card, event, 2, SUBTYPE_PLAINS, 0);
}

int card_tolaria_west(int player, int card, event_t event){

  comes_into_play_tapped(player, card, event);

  if( event == EVENT_COUNT_MANA && !(is_tapped(player, card)) && affect_me(player, card) ){
     declare_mana_available(player, COLOR_BLUE, 1 );
  }

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_tapped(player, card)) ){
     return 1;
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     return mana_producer(player, card, event);
  }

  return transmute(player, card, event, 1, 0, 2, 0, 0, 0, 0);
}

int card_decree_of_justice(int player, int card, event_t event){

    card_instance_t *instance = get_card_instance(player, card);

    if( event == EVENT_CAN_ACTIVATE_FROM_HAND && has_mana_multi(player, 2, 0, 0, 0, 0, 1) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE_FROM_HAND ){
        charge_mana_multi(player, 2, 0, 0, 0, 0, 1);
        if( spell_fizzled != 1 ){
            discard_card(player, card);
        }
    }
    else if( event == EVENT_REVOLVE_ACTIVATION_FROM_HAND && spell_fizzled != 1 ){
        draw_a_card(player);
        int tokens = 0;
        charge_mana(player, COLOR_COLORLESS, -1);
        if(spell_fizzled != 1 ){
           tokens = x_value;
        }
        if( tokens > 0 ){
           int i;
           for(i = 0; i < tokens; i++ ){
               generate_token(player, "Soldier");
           }
        }
    }
    else if(event == EVENT_CAN_CAST && has_mana_multi(player, 2, 0, 0, 0, 0, 2) ){
            return 1;
    }
    else if(event == EVENT_CAST_SPELL ){
            int angels = (x_value-2) / 2;
            instance->info_slot = angels;        
    
    }
    else if(event == EVENT_RESOLVE_SPELL ){
           int tokens = instance->info_slot;
           if( tokens > 0 ){
              int i;
              for(i = 0; i < tokens; i++ ){
                  generate_token(player, "Angel");
              }
           }
           kill_card(player, card, KILL_DESTROY);
    }
 
    return 0;
}

int card_call_of_the_herd(int player, int card, event_t event){
        
    if(event == EVENT_GRAVEYARD_ABILITY && has_mana_multi(player, 3,0, 0, 1, 0, 0) ){ 
       if( can_sorcery_be_played(player) ){
          return 1;
        }
    }
    else if( event == EVENT_PAY_FLASHBACK_COSTS ){
            charge_mana_multi(player, 3, 0, 0, 1, 0, 0);
    }
    else if( event == EVENT_CAN_CAST ){
            return 1;
    }
    else if(event == EVENT_RESOLVE_SPELL && affect_me(player, card) ){
            generate_token(player, "Elephant");
            if( get_flashback() ){
               kill_card(player, card, KILL_REMOVE);
            }
            else{
                 kill_card(player, card, KILL_DESTROY);
            }
    }
    return 0;    
}

int card_zombie_infestation(int player, int card, event_t event){

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && hand_count[player] > 1 ){
     return 1;
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     discard(player, 0, 0);
     discard(player, 0, 0);
  }

  if( event == EVENT_RESOLVE_ACTIVATION ){
     generate_token(player, "Zombie");
  }

  return global_enchantment(player, card, event);
}

int card_reckless_charge(int player, int card, event_t event){
        
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE );
  td.allowed_controller = 2;
  td.preferred_controller = player;
  td.allow_cancel = 0;

  card_instance_t *instance = get_card_instance(player, card);

  if( event == EVENT_GRAVEYARD_ABILITY && has_mana_multi(player, 2, 0, 0, 0, 1, 0) && can_target(&td) ){ 
       if( can_sorcery_be_played(player) ){
          return 1;
        }
    }
    else if( event == EVENT_PAY_FLASHBACK_COSTS ){
            charge_mana_multi(player, 2, 0, 0, 0, 1, 0);
    }
    else if( event == EVENT_CAN_CAST && can_target(&td) ){
            return 1;
    }
    else if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
            pick_target(&td, "TARGET_CREATURE");
    }
    else if(event == EVENT_RESOLVE_SPELL){
            if( valid_target(&td) ){
               pump_ability_until_eot(player, card, instance->targets[0].player, instance->targets[0].card, 3,0, KEYWORD_HASTE);
            }

            if( get_flashback() ){
               kill_card(player, card, KILL_REMOVE);
            }
            else{
                 kill_card(player, card, KILL_DESTROY);
            }
    }
    return 0;    
}

int card_aether_burst(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE );
  
    card_instance_t *instance = get_card_instance(player, card);

    if( event == EVENT_CAN_CAST && can_target(&td) ){
        return 1;
    }
    else if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
        int number = 1+count_graveyard_by_id(player, get_id_by_name("Aether Burst")) + count_graveyard_by_id(1-player, get_id_by_name("Aether Burst"));
        int targ = 0;
        int stop = 0;
        while( stop != 1 && can_target(&td) && targ < number ){
            if( pick_target(&td, "TARGET_CREATURE") ){
                instance->targets[targ+1] = instance->targets[0];
                card_instance_t *bursted = get_card_instance(instance->targets[0].player, instance->targets[0].card);
                bursted->state |= STATE_CANNOT_TARGET; 
                targ++;
            }
            else{
                spell_fizzled = 0;
                stop = 1;
            }
        }
        
        if( targ > 0 ){
            instance->targets[0] = instance->targets[targ];
        }
        instance->info_slot = targ;
        
        int i;
        for(i=0;i<targ; i++){
            card_instance_t *crd = get_card_instance(instance->targets[i].player, instance->targets[i].card);
            crd->state &= ~STATE_CANNOT_TARGET;
        }
    }
    else if( event == EVENT_RESOLVE_SPELL && affect_me(player, card) ){
        int number = instance->info_slot;
        int i;
        for(i=0;i<number; i++){
            instance->targets[0] = instance->targets[i];
            if( valid_target(&td) ){
                bounce_permanent(instance->targets[i].player, instance->targets[i].card);
            }
        }
        
        kill_card(player, card, KILL_DESTROY);
    }
    return 0;
}

int card_wild_mongrel(int player, int card, event_t event){

  card_instance_t *instance = get_card_instance(player, card);

  if(instance->targets[1].card > -1 ){
     if( event == EVENT_SET_COLOR && affect_me(player, card) ){
        event_result = 1 << (instance->targets[1].card ) ;
     }
     else if( eot_trigger(player, card, event) ){
            instance->targets[1].card = -1;
     }
  }

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && hand_count[player] > 0 ){
     return 1;
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     int choice = do_dialog(player, player, card, -1, -1, " Discard & Pump\n Discard, Pump & Change color \n Pass", 0);
     if( choice == 0 ){
        discard(player, 0, 0);
        instance->info_slot = 66;
     }
     else if( choice == 1 ){
             discard(player, 0, 0);
             instance->info_slot = 67;
     }
     else{
          instance->info_slot = 0;
     }
  }

  if( event == EVENT_RESOLVE_ACTIVATION ){

     if( instance->info_slot == 66 ){  
        pump_until_eot(player, card, player, instance->parent_card, 1, 1);
        instance->info_slot = 0;
     }

     if( instance->info_slot == 67 ){  
        pump_until_eot(player, card, player, instance->parent_card, 1, 1);
        card_instance_t *p_instance = get_card_instance(player, instance->parent_card);
        p_instance->targets[1].card = choose_a_color(player, 0);
     }

  }

  return 0;
}


int card_doubling_season(int player, int card, event_t event){

  return global_enchantment(player, card, event);
}

int card_ravens_crime(int player, int card, event_t event){
        
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE );
  td.zone = TARGET_ZONE_PLAYERS;
  td.allow_cancel = 0;

  target_definition_t td1;
  default_target_definition(player, card, &td1, TYPE_LAND );
  td1.zone = TARGET_ZONE_HAND;
  td1.allowed_controller = player;
  td1.preferred_controller = player;
  td1.illegal_abilities = 0;


  card_instance_t *instance = get_card_instance(player, card);

    if( event == EVENT_GRAVEYARD_ABILITY && has_mana_multi(player, 0, 1, 0, 0, 0, 0) ){
       if( can_target(&td) && can_target(&td1) && can_sorcery_be_played(player) ){
          return 1;
       }
    }
    else if( event == EVENT_PAY_FLASHBACK_COSTS ){
            charge_mana_multi(player, 0, 1, 0, 0, 0, 0);
            if(spell_fizzled != 1){
               pick_target(&td1, "TARGET_LAND");
               if( valid_target(&td1) ){
                  discard_card(player, instance->targets[0].card);            
               }
               else{
                    spell_fizzled = 1;
               }
            }
    }
    else if( event == EVENT_CAN_CAST && can_target(&td) ){
            return 1;
    }
    else if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
            pick_target(&td, "TARGET_PLAYER");
    }
    else if(event == EVENT_RESOLVE_SPELL){
            discard(instance->targets[0].player, 0, 0);
            if( get_flashback() ){
               kill_card(player, card, KILL_REMOVE);
            }
            else{
                 kill_card(player, card, KILL_DESTROY);
            }
    }
    return 0;    
}



int card_hermit_druid(int player, int card, event_t event){

  card_instance_t *instance = get_card_instance(player, card);

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_tapped(player, card)) && !(is_sick(player, card)) ){
     if( has_mana(player, COLOR_GREEN, 1)  ){
        return 1;
     }
  }

  if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     charge_mana(player, COLOR_GREEN, 1);
     if( spell_fizzled != 1){
        tap_card(player, card);
        instance->info_slot = 66;
     }
  }

  if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) ){

     if( instance->info_slot == 66 ){ 
        int *deck = deck_ptr[player];
        int stop = 0;
        int count = 0;
        while( stop != 1 && count <= count_deck(player) ){
              if( is_basic_land_by_id(cards_data[deck[count]].id) ){
                 stop = 1;
              }
              else{
                   count++;
              }
        }
     
        if( count > 0 ){
           mill(player, count);
        }

        add_card_to_hand(player, deck[0]);
        remove_card_from_deck(player, 0);
        instance->info_slot = 0;
     }

  }

  return 0;
}

int card_sutured_ghoul(int player, int card, event_t event){

  card_instance_t *instance = get_card_instance(player, card);

  if( in_play(player, card) && event == EVENT_POWER && affect_me(player,
card) && instance->targets[0].card > 0 ){
     event_result = instance->targets[0].card;
  }

  if( in_play(player, card) && event == EVENT_TOUGHNESS && affect_me(player, card) && instance->targets[1].card > 0 ){
     event_result = instance->targets[1].card;
  }

  if( comes_into_play(player, card, event) && count_graveyard_by_type(player, TYPE_CREATURE) > 0){
     int pow = 0;
     int tou = 0;
     int *grave = graveyard_ptr[player];
     if(player != AI ){
        int stop = 0;
        while( stop != 1 && count_graveyard_by_type(player,
TYPE_CREATURE) > 0 ){
              int selected;
              selected = show_deck( player, graveyard_ptr[player], count_graveyard(player), "Pick a card", 0, 0x7375B0 );
              if( cards_data[grave[selected]].type & TYPE_CREATURE ){
                 pow+=cards_data[grave[selected]].power;
                 tou+=cards_data[grave[selected]].toughness;
                 remove_card_from_grave(player, selected);
              }
              else{
                   stop = 1;
              }
        }
     }
     else{
          int i = 0;
          while( i < count_graveyard(player) ){
                 if( (cards_data[grave[i]].type & TYPE_CREATURE) && cards_data[grave[i]].id != get_id_by_name("Anger") ){
                    pow+=cards_data[grave[i]].power;
                    tou+=cards_data[grave[i]].toughness;
                    remove_card_from_grave(player, i);
                    i--;
                 }
                 i++;
          }
     }
     instance->targets[0].card = pow;
     instance->targets[1].card = tou;
  }

  return 0;
}


int card_gaea_blessing(int player, int card, event_t event){

  card_instance_t *instance = get_card_instance(player, card);

  if( event == EVENT_CAN_CAST ){
     return 1;
  }

  else if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
          int count = 0;
          int stop = 0;
          int cards[2] = { 0 };
          while(stop != 1 && count < 3 ){
                int selected = -1;
                selected = show_deck( player, graveyard_ptr[player], count_graveyard(player), "Pick a card", 0, 0x7375B0 );
                if( selected != -1 ){
                   if( count == 0 ){
                      cards[count] = selected;
                      count++;
                   }

                   else if( count == 1 && selected != cards[0]){
                           cards[count] = selected;
                           count++;
                   }

                   else if( count == 2 && selected != cards[0] && selected != cards[1] ){
                           cards[count] = selected;
                           count++;
                   }

                   else{
                        stop = 1;
                   }
                }
                else{
                     stop = 1;
                }
         }
            
         if( count > 1 ){
            int i;
            int swap = -1;
            int x;
            for(i = 0; i <= count-2; i++ ){
                for(x = 1; x <= count-1; x++ ){             
                    if( cards[i] > cards[x] ){
                       swap = cards[x];
                       cards[x] = cards[i];
                       cards[i] = swap;
                    }
                }
            }
         }
            

         if( count > 0 ){
            int y;
            for( y = count-1; y > -1; y--){
                instance->targets[y].card = cards[y];
            }
            instance->info_slot = count-1;
         }
  }

  else if( event == EVENT_RESOLVE_SPELL && affect_me(player, card) ){
          if( instance->info_slot > 0 ){
             int y;
             for( y = instance->info_slot; y > -1; y--){
                 from_graveyard_to_deck(player, instance->targets[y].card, 1);
             }
             gain_life(player, 0);
             shuffle(player);
          }
          draw_cards(player, 1);
          kill_card(player, card, KILL_DESTROY);
  }

  return 0;
}

int card_hunted_horror(int player, int card, event_t event){

  if( comes_into_play(player, card, event) ){
     generate_tokens(1-player, "HH Centaur", 2);
  }


  return 0;
}

int card_hunted_dragon(int player, int card, event_t event){

  haste(player, card);

  if( comes_into_play(player, card, event) ){
     generate_tokens(1-player, "HD Knight", 3);
  }

  return 0;
}

int card_ulasht(int player, int card, event_t event){

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE );
  td.allow_cancel = 0;

  card_instance_t *instance = get_card_instance(player, card);

  check_legend_rule(player, card, event);

  if( comes_into_play(player, card, event) ){
        add_1_1_counters(player, card, count_permanents_by_color(player, TYPE_CREATURE, COLOR_TEST_GREEN)-1);
        add_1_1_counters(player, card, count_permanents_by_color(player, TYPE_CREATURE, COLOR_TEST_RED)-1);
        instance->info_slot = 1;
  }
  else if(event == EVENT_TOUGHNESS && affect_me(player, card) && instance->info_slot == 0){
          event_result++;
  }

  else if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
          if( has_mana(player, COLOR_COLORLESS, 1) && count_counters(player, card) > 0 ){
             return 1;
          }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
     charge_mana(player, COLOR_COLORLESS, 1);
     if( spell_fizzled != 1){
        remove_1_1_counter(player, card);
        int ai_choice = 1;
        if( count_permanents_by_type(1-player, card, TYPE_CREATURE) > 0){
           ai_choice = 0;
        }

        int choice = do_dialog(player, player, card, -1, -1, " Damage creature\n Generate Saproling", 0);
        
        if(choice == 0){
           pick_target(&td, "TARGET_CREATURE");
        }

        instance->info_slot = 66+choice;
     }
  }

  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) ){

     if( instance->info_slot == 66 ){  
        damage_creature(instance->targets[0].player, instance->targets[0].card, 1, player, card);
        instance->info_slot = 1;
     }

     if( instance->info_slot == 67 ){  
        generate_token(player, "Saproling");
        instance->info_slot = 1;
     }

  }

  return 0;
}

int card_starstorm(int player, int card, event_t event){

    card_instance_t *instance = get_card_instance(player, card);

    if(event == EVENT_CAN_CAST){
       return 1;
    }
    else if(event == EVENT_CAST_SPELL && affect_me(player, card) ){
            instance->info_slot = x_value;        
    
    }
    else if(event == EVENT_RESOLVE_SPELL && affect_me(player, card) ){
            if( instance->info_slot > 0 ){
               damage_all(player, card, player, instance->info_slot, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0);
               damage_all(player, card, 1-player, instance->info_slot, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0);
            }
            kill_card(player, card, KILL_DESTROY);
    }
 
    return cycling(player, card, event, 3, 0, 0, 0, 0, 0);
}

int card_hallowed_burial(int player, int card, event_t event){

    if(event == EVENT_CAN_CAST){
       return 1;
    }
    else if(event == EVENT_RESOLVE_SPELL && affect_me(player, card) ){
            int i;
            for(i = 0; i < 2; i++ ){
                int *deck = deck_ptr[i];
                int count = active_cards_count[i];
                while( count > -1 ){
                      card_data_t card_d = get_card_data(i, count);  
                      if( (card_d.type & TYPE_CREATURE) && in_play(i, count) ){
                         put_on_top_of_deck(i, count);
                         deck[count_deck(i)] = deck[0];
                         remove_card_from_deck(i, 0);
                      }
                      count--;
                }
            }
            kill_card(player, card, KILL_DESTROY);
    }
 
    return 0;
}

int impulse_effect(int player, int amount, int whattodo){
//  whattodo = 0 --> Impulse-like effect (add the selected card to hand)
//  whattodo = 1 --> Impulse-like effect, but put the selected card on the top of library


  int *deck = deck_ptr[player];
  int card_added = -1;
  if( count_deck(player) < amount ){
      amount = count_deck(player);
  }
  if( count_deck(player) > 0 ){
     if( player == HUMAN ){
        int selected = -1;
        while( selected == -1 ){
              selected = show_deck( player, deck_ptr[player], amount, "Pick a card", 0, 0x7375B0 );
        }
        card_added = add_card_to_hand(player, deck[selected]);
        remove_card_from_deck(player, selected);
        amount--;

        if( amount > 1){
           int i;
           for( i = 0; i < amount; i++){
               deck[count_deck(player)] = deck[0];
               remove_card_from_deck(player, 0);
           }
        }
        if( whattodo == 1){
           put_on_top_of_deck(player, card_added);
        }
     }
     else{
          card_added = add_card_to_hand(player, deck[0]);
          remove_card_from_deck(player, 0);
          amount--;

          if( amount > 1){
             int i;
             for( i = 0; i < amount; i++){
                 deck[count_deck(player)] = deck[0];
                 remove_card_from_deck(player, 0);
           }
        }
     }
  }

  return card_added;
}

int card_impulse(int player, int card, event_t event){

    if(event == EVENT_CAN_CAST){
       return 1;
    }
    else if(event == EVENT_RESOLVE_SPELL && affect_me(player, card) ){
            impulse_effect(player, 4, 0);
            kill_card(player, card, KILL_DESTROY);
    }
 
    return 0;
}

int card_cream_of_the_crop(int player, int card, event_t event){
    if(event == EVENT_CAN_CAST ){
        return 1;
    }
    if(trigger_condition == TRIGGER_COMES_INTO_PLAY && affect_me( player, card ) && reason_for_trigger_controller == player && trigger_cause_controller == player ){
        card_instance_t *instance = get_card_instance(trigger_cause_controller, trigger_cause);
        if( in_play(trigger_cause_controller, trigger_cause) && cards_data[ instance->internal_card_id].type & TYPE_CREATURE ){
            if(event == EVENT_TRIGGER){
                event_result |= RESOLVE_TRIGGER_MANDATORY;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                    if( get_power(trigger_cause_controller, trigger_cause) ){
                       int choice = do_dialog(player, player, card, -1, -1, " Activate Cream of the Crop\n Pass", 0);
                       if(choice == 0){
                          impulse_effect(player, get_power(trigger_cause_controller, trigger_cause), 1);
                       }
                    }
            }
        }
    }
    return global_enchantment(player, card, event);
}

int card_cloudstone_curio(int player, int card, event_t event){

    card_instance_t *curio = get_card_instance(player, card);

    if(trigger_condition == TRIGGER_COMES_INTO_PLAY && affect_me( player, card ) && reason_for_trigger_controller == player && trigger_cause_controller == player ){
        card_instance_t *instance = get_card_instance(trigger_cause_controller, trigger_cause);
        if( in_play(trigger_cause_controller, trigger_cause) && cards_data[ instance->internal_card_id].type & TYPE_PERMANENT  && !(cards_data[ instance->internal_card_id].type & TYPE_ARTIFACT) ){
            if(event == EVENT_TRIGGER){
                event_result |= RESOLVE_TRIGGER_MANDATORY;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                    target_definition_t td;
                    default_target_definition(player, card, &td, TYPE_PERMANENT );
                    td.allowed_controller = player;
                    td.preferred_controller = player;
                    td.allow_cancel = 1;
                    if( pick_target(&td, "CURIO") ){
                       if( valid_target(&td) ){
                          card_instance_t *target = get_card_instance(player, curio->targets[0].card);
                          if( cards_data[ instance->internal_card_id].type & cards_data[ target->internal_card_id].type){
                             bounce_permanent(player, curio->targets[0].card);
                          }
                       }
                    }
            }
        }
    }

    return 0;
}

int wrp_effect(int player, int card, event_t event ){

  card_instance_t *instance = get_card_instance(player, card);

  deathtouch(instance->targets[2].player, instance->targets[2].card, event);

  if( leaves_play(instance->targets[1].player, instance->targets[1].card, event)  ){
     kill_card(player, card, KILL_REMOVE);
  }

  return 0;
}

int card_wren_run_packmaster(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( comes_into_play(player, card, event) ){
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE );
        td.allowed_controller = player;
        td.preferred_controller = player;
        td.required_subtype = SUBTYPE_ELF;
        
        instance->state |= STATE_CANNOT_TARGET;
        if( pick_target(&td, "TARGET_CREATURE") ){
            if( ! is_token(player, instance->targets[0].card) ){
                instance->info_slot = get_id(player, instance->targets[0].card );
                create_card_name_legacy(player, card, instance->info_slot );
            }
            kill_card(player, instance->targets[0].card, KILL_REMOVE);
        }
        else{
            kill_card(player, card, KILL_SACRIFICE);
        }
        instance->state &= ~STATE_CANNOT_TARGET;
    }
    else if( leaves_play(player, card, event) &&  instance->info_slot > 0){
        int card_added = add_card_to_hand(player, get_internal_card_id_from_csv_id( instance->info_slot ) );
        put_into_play(player, card_added);
    }
    else if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && has_mana_multi(player, 2, 0, 0, 1, 0, 0) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE && affect_me(player, card)){
        charge_mana_multi(player, 2, 0, 0, 1, 0, 0);
    }
    else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) ){
        generate_token(player, "Wolf");
    }
  
    int i;
    for(i=0;i<active_cards_count[player];i++){
        if( has_creature_type(player, i, SUBTYPE_WOLF) ){
            deathtouch(player, i, event);
        }
    }
  
    return 0;
}


