#include "manalink.h"

int card_vengevine(int player, int card, event_t event){
    // code required
    return 0;
}

int card_elvish_champion(int player, int card, event_t event){
    if( in_play(player, card) && ! affect_me(player, card) && has_creature_type(affected_card_controller, affected_card, SUBTYPE_ELF) ){
        if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
            event_result++;
        }
        else if(event == EVENT_ABILITIES ){
            event_result |= KEYWORD_FORESTWALK;
        }
    }
    return 0;
}

int card_spike_weaver(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    card_instance_t *instance = get_card_instance(player, card);
    if( comes_into_play(player, card, event) ){
        add_1_1_counters(player, card, 3);
        instance->info_slot = 1;
    }
    else if( instance->info_slot != 1 && event == EVENT_TOUGHNESS && affect_me(player, card) ){
        event_result++;
    }
    else if( event == EVENT_CAN_ACTIVATE ){
        if( has_mana_multi(player, 1, 0, 0, 0, 0, 0) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        if( count_counters(player, card) > 0 && has_mana_multi(player, 1, 0, 0, 0, 0, 0) ){
            int choice = 1;
            if( has_mana_multi(player, 2, 0, 0, 0, 0, 0) ){
                choice = do_dialog(player, player, card, -1, -1, " Move a counter\n Fog", 1);
            }
        
            if( choice == 0 ){
                charge_mana_multi(player, 2, 0, 0, 0, 0, 0);
                if( spell_fizzled != 1 ){
                    pick_target(&td, "TARGET_CREATURE");
                    instance->number_of_targets = 1;
                }
            }
            else if( choice == 1 ){
                charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
            }
        
            if( spell_fizzled != 1 ){
                remove_counter(player, card);
                instance->counter_power--;
                instance->counter_toughness--;
                instance->targets[1].player = choice;
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){    
        if( instance->targets[1].player == 1 ){
            card_fog(player, card, EVENT_RESOLVE_SPELL);
        }
        else if( valid_target(&td) ){
            add_1_1_counter(instance->targets[0].player, instance->targets[0].card);
        }
    }
    return 0;
}

int card_ant_queen(int player, int card, event_t event){
    if(event == EVENT_CAN_ACTIVATE){
        if( has_mana_multi(player, 1, 0, 0, 1, 0, 0) ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE){
        charge_mana_multi(player, 1, 0, 0, 1, 0, 0);
    }
    else if(event == EVENT_RESOLVE_ACTIVATION ) {
        generate_token(player, "Insect");
    }
    return 0;
}

int card_gaeas_herald(int player, int card, event_t event){
    if( event == EVENT_CAST_SPELL && in_play(player, card) ){
        card_instance_t *instance = get_card_instance(affected_card_controller, affected_card);
        if( cards_data[ instance->internal_card_id ].type & TYPE_CREATURE ){
            instance->state |= STATE_CANNOT_TARGET;
        }
    }
    if(trigger_condition == TRIGGER_COMES_INTO_PLAY && affect_me( player, card ) && reason_for_trigger_controller == player ){
        card_instance_t *instance = get_card_instance(trigger_cause_controller, trigger_cause);
        if(  cards_data[ instance->internal_card_id].type & TYPE_CREATURE  ){
            if(event == EVENT_TRIGGER){
                event_result |= RESOLVE_TRIGGER_MANDATORY;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                instance->state &= ~STATE_CANNOT_TARGET;
            }
        }
    }
    return 0;
}

int card_thorn_elemental(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_DEAL_DAMAGE && instance->info_slot == 1){
        card_instance_t *damage= get_card_instance( affected_card_controller, affected_card);
        if( damage->internal_card_id == damage_card ){
            if( damage->damage_target_card != -1 && damage->damage_source_player == player &&  damage->damage_source_card == card && damage->info_slot > 0 ){
                damage->damage_target_card = -1;
            }
        }
    }
    
    if( event == EVENT_DECLARE_BLOCKERS && instance->state & STATE_ATTACKING && ! is_unblocked(player, card)){
        instance->info_slot = do_dialog(player, player, card, -1, -1, " Deal damage normally\n Ignore Blocker", 0);
    }
    return 0;
}

int card_rhox(int player, int card, event_t event){
    card_thorn_elemental(player, card, event);
    if(event == EVENT_ACTIVATE ){
        PAY_MANA_COLORLESS = 2;
    }
    int result = regenerate_green(player, card, event);
    if( event == EVENT_CAN_ACTIVATE ){
        if( result &&  ( land_can_be_played & 0x200) ){
            if( has_mana_multi(player, 2, 0, 0, 1, 0, 0 ) ){
                return result;
            }
            else{
                return 0;
            }
        }
    }
    return 0;
}

int card_virulent_sliver(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_DEAL_DAMAGE ){
        card_instance_t *damage= get_card_instance( affected_card_controller, affected_card);
        if( damage->internal_card_id == damage_card && damage->info_slot > 0){
            if( damage->damage_target_card == -1 && has_subtype(damage->damage_source_player, damage->damage_source_card, SUBTYPE_SLIVER) ){
                instance->info_slot++;
                instance->targets[0].player = damage->damage_target_player;
            }
        }
    }
    else if( comes_into_play(player, card, event) ){
        instance->info_slot = -1;
    }
    
    
    if(trigger_condition == TRIGGER_DEAL_DAMAGE && affect_me(player, card) && reason_for_trigger_controller == player && instance->info_slot > -1 ){
        if(event == EVENT_TRIGGER){
            event_result |= 2;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            poison_counters[instance->targets[0].player]+=1+instance->info_slot;
            instance->info_slot = -1;
        }
    }
    return 0;
}

int card_wall_of_roots(int player, int card, event_t event){
    if( ! is_unlocked(player, card, event, 21) ){ return 0; }
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE ){
        if( instance->info_slot != 1 ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE ){
        instance->info_slot = 1;
        instance->counters++;
        instance->counter_toughness--;
        produce_mana(player, COLOR_GREEN, 1);
        spell_fizzled = 1; 
    }
    else if( event == EVENT_COUNT_MANA ){
        if( instance->info_slot != 1 && affect_me(player, card) ){
            declare_mana_available(player, COLOR_GREEN, 1);     
        }
    }
    else if( instance->info_slot == 1 && eot_trigger(player, card, event) ){
        instance->info_slot = 0;
    }
    return 0;
}

int card_tinder_wall(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        int choice = 0;
        if( in_play(player, card) && instance->blocking != 255 && has_mana(player, COLOR_RED, 1 ) ){
            choice = do_dialog(player, player, card, -1, -1, " Generate Mana\n Shoot a blocker", 0);
        }
        
        if( choice == 1 ){
            charge_mana(player, COLOR_RED, 1 );
            if( spell_fizzled == 1 ){ return 0; }
            instance->info_slot = instance->blocking;
            kill_card(player, card, KILL_SACRIFICE);
        }
        else{
            produce_mana(player, COLOR_RED, 2);
            kill_card(player, card, KILL_SACRIFICE);
            spell_fizzled = 1;
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        damage_creature(1-player, instance->info_slot, 2, player, card );
    }
    return 0;
}

int card_golgari_grave_troll(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_TOUGHNESS && instance->targets[0].card != 3 && affect_me(player, card)){ 
        event_result++;
    }
    else if(comes_into_play(player, card, event) == 1 ){
        int count = count_graveyard_by_type(player, TYPE_CREATURE);
        add_counters(player, card, count);
        instance->counter_power = count;
        instance->counter_toughness = count;
        instance->targets[0].card = 3;
    }
    else if( event == EVENT_GRAVEYARD_ABILITY ){
        return 6;
    }
    else if( event == EVENT_CAN_ACTIVATE && count_counters(player, card) == 0 ){
        return 0;
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        remove_counter(instance->parent_controller, instance->parent_card);
        instance->counter_power--;
        instance->counter_toughness--;
    }
    return regenerate(player, card, event, COLOR_COLORLESS, 1);
}

int card_quirion_dryad(int player, int card, event_t event){
    if( ! is_unlocked(player, card, event, 4) ){ return 0; }

    if(trigger_condition == TRIGGER_SPELL_CAST && player == affected_card_controller
       && player == reason_for_trigger_controller && player == trigger_cause_controller && card == affected_card )
    {
        card_instance_t *instance = get_card_instance(trigger_cause_controller, trigger_cause);
        card_data_t card_d = get_card_data(trigger_cause_controller, trigger_cause);
        if(  ( cards_data[ instance->internal_card_id].type & TYPE_ARTIFACT ) || ( cards_data[ instance->internal_card_id].type & TYPE_LAND ) ){
            return 0;
        }
        if( (card_d.color & COLOR_TEST_BLACK) | (card_d.color & COLOR_TEST_BLUE) | (card_d.color & COLOR_TEST_RED) | (card_d.color & COLOR_TEST_WHITE) ){     
            if(event == EVENT_TRIGGER){
                event_result |= RESOLVE_TRIGGER_MANDATORY;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                card_instance_t *instance_me = get_card_instance( player, card);
                instance_me->counters++;
                instance_me->counter_power++;
                instance_me->counter_toughness++;
            }
        }
    }         
    return 0;
}

int card_argothian_enchantress(int player, int card, event_t event){
    if(trigger_condition == TRIGGER_SPELL_CAST && player == affected_card_controller
       && player == reason_for_trigger_controller && player == trigger_cause_controller && card == affected_card )
    {
        card_instance_t *instance = get_card_instance(trigger_cause_controller, trigger_cause);
        if( cards_data[ instance->internal_card_id].type & TYPE_ENCHANTMENT){
            if(event == EVENT_TRIGGER){
                event_result |= RESOLVE_TRIGGER_MANDATORY;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                draw_a_card(player);
            }
        }
    } 
    return 0;
}

int card_elvish_archdruid(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_ELF;
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.illegal_abilities = 0;    
    int count = target_available(player, card, &td);
    if( event == EVENT_CAN_ACTIVATE ){
        if( ! is_tapped(player, card) && ! is_sick(player, card) ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE ){
        tap_card(player, card);
        produce_mana(player, COLOR_GREEN, count);
        spell_fizzled = 1;
    }
    else if( event == EVENT_COUNT_MANA ){
        if( ! is_tapped(player, card) && ! is_sick(player, card) && affect_me(player, card) ){
            declare_mana_available(player, COLOR_GREEN, count);     
        }
    }
    else if( affected_card_controller == player && has_creature_type(player, affected_card, SUBTYPE_ELF) && ! affect_me(player, card) ){
        if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
            event_result++;
        }
    }
    return 0;
}

int card_cloudthresher(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if(comes_into_play(player, card, event) == 1 ){
        int p;
        for( p = 0; p < 2; p++){
            int count = 0;
            while(count < active_cards_count[p]){
                card_data_t card_d = get_card_data(p, count);
                if((card_d.type & TYPE_CREATURE) && in_play(p, count)  ){
                    if( get_abilities(p, count, 52, -1) & KEYWORD_FLYING ){
                        damage_creature(p, count, 2, player, card);
                    }
                }
                count++;
            }
            damage_player(p, 2, player, card);
        }
        
        if( instance->targets[9].card == 1 ){
            kill_card(player, card, KILL_SACRIFICE);
        }
    }
    else if(event == EVENT_MODIFY_COST ){
        COST_GREEN-=2;
        instance->targets[9].player = 1;
    }
    else if(event == EVENT_CAST_SPELL ){
        if( instance->targets[9].player != 1 || ! affect_me(player, card) ){
            return 0;
        }
        int choice = 1;
        if( has_mana(player, COLOR_GREEN, 2) ){
            choice = do_dialog(player, player, card, -1, -1, " Pay 2 Green\n Sacrifice this", 0);
        }
        
        if( choice == 0 ){
            charge_mana(player, COLOR_GREEN, 2);
        }
        if( choice == 1 || spell_fizzled == 1){
            instance->targets[9].card = 1;
        }
    }
    return flash(player, card, event);
}

int card_quirion_ranger(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_LAND);
    td.required_subtype = SUBTYPE_FOREST;
    td.allowed_controller = player;
    td.preferred_controller = player;
    if( event == EVENT_CAN_ACTIVATE ){
        if( target_available(player, card, &td) && instance->info_slot < 1 ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE ){
        if( select_target(player, card, &td, "Choose a Forest to bounce", NULL) ){
            instance->info_slot = 1;
            bounce_permanent( instance->targets[0].player, instance->targets[0].card );
            target_definition_t td2;
            default_target_definition(player, card, &td2, TYPE_CREATURE);
            td2.allow_cancel = 0;
            select_target(player, card, &td2, "Choose a creature to untap", NULL);
        }
        else{
            spell_fizzled = 1;
        }
        
    }
    else if(event == EVENT_RESOLVE_ACTIVATION ){
        untap_card( instance->targets[0].player, instance->targets[0].card );
    }
    else if( current_phase > PHASE_DISCARD ){
        instance->info_slot = 0;
    }
    return 0;
}

int card_birchlore_rangers(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_ELF;
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.allow_cancel = 0;
    td.illegal_state = TARGET_STATE_TAPPED;
    if(event == EVENT_CAN_ACTIVATE){
        if( target_available(player, card, &td) >= 2  ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE ){
        int i = 0;
        for(i=0;i<2;i++){
            select_target(player, card, &td, "Choose an untapped Elf", NULL);
            tap_card( instance->targets[0].player, instance->targets[0].card );
        }
        produce_mana(player, choose_a_color(player, COLOR_RED), 1);
        spell_fizzled = 1;
    }
    else if( event == EVENT_COUNT_MANA ){
        if(  target_available(player, card, &td) >= 2 && affect_me(player, card) ){
             declare_mana_available_hex(player, COLOR_TEST_BLACK | COLOR_TEST_GREEN , 2);         
        }
    }
    return morph(player, card, event, 0, 0, 0, 1, 0, 0);
}

int card_bramblewood_paragon(int player, int card, event_t event){
    if( event == EVENT_ABILITIES && player == affected_card_controller){
        card_instance_t *instance = get_card_instance(affected_card_controller, affected_card);
        if( instance->counters > 0 && instance->counter_power > 0 && instance->counter_toughness > 0 ){
            event_result |= KEYWORD_TRAMPLE;
        }
    }
    else if(trigger_condition == TRIGGER_COMES_INTO_PLAY && affect_me( trigger_cause_controller, trigger_cause ) && reason_for_trigger_controller == affected_card_controller && trigger_cause_controller == player){
        if( affect_me(player, card) ){ return 0; }
        card_instance_t *instance = get_card_instance(trigger_cause_controller, trigger_cause);
        if( ( cards_data[ instance->internal_card_id].type  & TYPE_CREATURE ) && has_creature_type(trigger_cause_controller, trigger_cause, SUBTYPE_WARRIOR)){
            if(event == EVENT_TRIGGER){
                event_result |= RESOLVE_TRIGGER_MANDATORY;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                instance->counters++;
                instance->counter_power++;
                instance->counter_toughness++;
            }
        }
    }
    return 0;
}

int card_regal_force(int player, int card, event_t event){
    if(comes_into_play(player, card, event) == 1 ){
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.required_color = COLOR_TEST_GREEN;
        td.allowed_controller = player;
        td.illegal_abilities = 0;
        td.preferred_controller = player;
        draw_cards(player, target_available(player, card, &td));
    }
    return 0;
}

int card_heritage_druid(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_ELF;
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.allow_cancel = 0;
    td.illegal_state = TARGET_STATE_TAPPED;
    if(event == EVENT_CAN_ACTIVATE){
        if( target_available(player, card, &td) >= 3  ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE ){
        card_instance_t *instance = get_card_instance( player, card);
        int i = 0;
        for(i=0;i<3;i++){
            select_target(player, card, &td, "Choose an untapped Elf", NULL);
            tap_card( instance->targets[0].player, instance->targets[0].card );
        }
        produce_mana(player, COLOR_GREEN, 3);
        spell_fizzled = 1;
    }
    else if( event == EVENT_COUNT_MANA ){
        if(  target_available(player, card, &td) >= 3 && affect_me(player, card)){
            declare_mana_available(player, COLOR_GREEN, 3);     
        }
    }
    return 0;
}

int card_nettle_sentinel(int player, int card, event_t event){
    does_not_untap(player, card, event);
    if(trigger_condition == TRIGGER_SPELL_CAST && affect_me(player, card)
        && player == reason_for_trigger_controller && trigger_cause_controller == player )
    {
        card_instance_t *instance = get_card_instance(trigger_cause_controller, trigger_cause);
        if( cards_data[ instance->internal_card_id].color & COLOR_TEST_GREEN && ! ( cards_data[ instance->internal_card_id].type & TYPE_ARTIFACT) && ! ( cards_data[ instance->internal_card_id].type & TYPE_LAND)){
            if(event == EVENT_TRIGGER){
                event_result |= RESOLVE_TRIGGER_MANDATORY;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                untap_card(player, card);
            }
        }
    }
    return 0;
}

int card_priest_of_titania(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_ELF;
    td.illegal_abilities = 0;
    int count = target_available(player, card, &td);
    if( event == EVENT_CAN_ACTIVATE ){
        if( ! is_tapped(player, card) && ! is_sick(player, card) ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE ){
        tap_card(player, card);
        produce_mana(player, COLOR_GREEN, count);
        spell_fizzled = 1;
    }
    else if( event == EVENT_COUNT_MANA ){
        if( ! is_tapped(player, card) && ! is_sick(player, card) && affect_me(player, card) ){
            declare_mana_available(player, COLOR_GREEN, count);     
        }
    }
    return 0;
}

int card_saproling(int player, int card, event_t event){
    card_instance_t *instance= get_card_instance(player, card);
    if(comes_into_play(player, card, event) == 1 ){
        instance->info_slot = -1;
    }
    if( affect_me(player, card) && instance->info_slot != -1 ){
        if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
            if( ! in_play(player, instance->info_slot )){
                event_result--;
            }
            else{
                event_result += count_counters(player, instance->info_slot) - 1; 
            }
        }
    } 
    return 0;
}

int card_genesis(int player, int card, event_t event){
    card_instance_t *instance= get_card_instance(player, card);
    if( event == EVENT_GRAVEYARD_ABILITY_UPKEEP ){
        if( has_mana_multi(player, 2, 0, 0, 1, 0, 0 ) ){
            int choice = do_dialog(player, player, card, -1, -1," Return a creature\n Do not return a creature\n", 0);
            if( choice == 0 ){
                if( select_card_from_graveyard(player, card, player, TYPE_CREATURE ) != -1 ){
                    charge_mana_multi(player, 2, 0, 0, 1, 0, 0 );
                    if( spell_fizzled != 1 ){
                        card_instance_t *target = get_card_instance(instance->targets[0].player, instance->targets[0].card);
                        target->state &= ~STATE_INVISIBLE;
                        hand_count[player]++;
                        remove_card_from_grave(player, instance->info_slot);
                        return instance->info_slot;
                    }
                }
            }
        }
        return -2;
    }
    return 0;
}

int card_elvish_spirit_guide(int player, int card, event_t event){
    if( event == EVENT_CAN_ACTIVATE_FROM_HAND ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE_FROM_HAND ){
        // remove this from the game
        discard_card(player, card);
        rfg_card_from_grave(player, count_graveyard(player) - 1, -1 );
    }
    else if( event == EVENT_REVOLVE_ACTIVATION_FROM_HAND ){
        produce_mana(player, COLOR_GREEN, 1);
    }
    return 0;
}

int card_gorilla_titan(int player, int card, event_t event){
    if(event == EVENT_POWER || event == EVENT_TOUGHNESS){
        if( affect_me(player, card) && count_graveyard(player) == 0){
            event_result += 4;
        }
    }
    return 0;
}

int card_wirewood_symbiote(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.illegal_abilities = 0;
    td.allow_cancel = 0;
    td.required_subtype = SUBTYPE_ELF;
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE ){
        if( target_available(player, card, &td) && instance->targets[8].card != 3 ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        instance->targets[8].card = 3;
        select_target(player, card, &td, "Select an Elf you control", NULL);
        bounce_permanent(instance->targets[0].player, instance->targets[0].card);
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.allow_cancel = 0;
        if( target_available(player, card, &td) ){
            select_target(player, card, &td, "Select target creature", NULL);
        }   
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *parent = get_card_instance( instance->parent_controller, instance->parent_card  );      
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.allow_cancel = 0;
        if(validate_target(player, card, &td, 0)){
            untap_card( parent->targets[0].player, parent->targets[0].card );
        }        
    }
    else if( current_phase == PHASE_DISCARD ){
        instance->targets[8].card = 0;
    }
    return 0;
}


int card_noble_hierarch( int player, int card, event_t event){
    exalted(player, card, event);
    return card_birds_of_paradise(player, card, event);
}

int card_bringer_of_the_green_dawn(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if(event == EVENT_MODIFY_COST ){
        if( has_mana_multi(player, 0, 1, 1, 1, 1, 1 ) ){
            COST_COLORLESS-=7;
            COST_GREEN-=2;
            instance->targets[9].player = 1;
        }
    }
    else if(event == EVENT_CAST_SPELL ){
        if( instance->targets[9].player != 1 || ! affect_me(player, card) ){
            return 0;
        }
        int choice = 0;
        if( has_mana_multi(player, 0, 1, 1, 1, 1, 1 ) && has_mana_multi(player, 7, 0, 0, 2, 0, 0 ) ){
            char buffer[50];
            sprintf(buffer, " Pay WUBRG\n Pay 7BB" );
            choice = do_dialog(player, player, card, -1, -1, buffer, 0);
        }
        else if( has_mana_multi(player, 7, 0, 0, 2, 0, 0 ) ){
            choice = 1;
        }
        
        if( choice == 0 ){
            charge_mana_multi(player, 0, 1, 1, 1, 1, 1 );
        }
        else{
            charge_mana_multi(player, 7, 0, 0, 2, 0, 0 );
        }
    }
    if( player == current_turn && trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
        if(event == EVENT_TRIGGER){
            event_result |= RESOLVE_TRIGGER_MANDATORY;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            char buffer[50];
            sprintf(buffer, " Make a Dude\n Cancel" );
            int choice = 0;
            if( ! duh_mode(player) ){
                choice = do_dialog(player, player, card, -1, -1, buffer, 0);
            }
            if( choice == 0 ){
                generate_token(player, "Beast");
            }
        }
    }
    return 0;
}

/* Also used by Viridian Shaman */
int card_uktabi_orangutan(int player, int card, event_t event)
{
  card_instance_t *instance;
  target_definition_t td;

  STANDARD_CIP_CHECK;

  if(event == EVENT_TRIGGER)
    event_result |= 2;
  else if(event == EVENT_RESOLVE_TRIGGER)
  {
    default_target_definition(player, card, &td, TYPE_ARTIFACT);
    td.allow_cancel = 0;
    td.preferred_controller = 2;
    if(target_available(player, card, &td))
    {
      load_text(0, "TARGET_ARTIFACT");
      select_target(player, card, &td, text_lines[0], NULL);
      instance = get_card_instance(player, card);
      if(validate_target(player, card, &td, 0))
        kill_card(instance->targets[0].player, instance->targets[0].card, KILL_DESTROY);
      instance->number_of_targets = 0;
    }
  }

  return 0;
}


int card_werebear(int player, int card, event_t event){
  if(event == EVENT_POWER || event == EVENT_TOUGHNESS){
    if( affect_me(player, card) && has_threshold(player) ){
      event_result += 3;
    }
  }
  return card_llanowar_elves(player, card, event);
}


int card_nimble_mongoose(int player, int card, event_t event){
  if(event == EVENT_POWER || event == EVENT_TOUGHNESS){
    if( affect_me(player, card) && has_threshold(player) ){
      event_result += 2;
    }
  }
  return 0;
}


int card_deranged_hermit(int player, int card, event_t event)
{
    int i;
    echo(player, card, event, 3, 0, 0, 2, 0, 0);
    
    boost_creature_type(player, card, event, SUBTYPE_SQUIRREL, 1, 1, 0, 0);

    STANDARD_CIP_CHECK;

    if(event == EVENT_TRIGGER){
        event_result |= 2;
    }
    else if(event == EVENT_RESOLVE_TRIGGER){
        for (i=0; i< 4; i++){
            generate_token(player, "Squirrel");
        }
    }
    return 0;
}

int card_wrens_run_vanquisher(int player, int card, event_t event){
    buddy_creature(player, card, event, SUBTYPE_ELF);
    deathtouch(player, card, event);
    return 0;
}

int card_blastoderm(int player, int card, event_t event){
    fading(player, card, event, 3);
    return 0;
}

int card_terravore(int player, int card, event_t event){
    if(event == EVENT_POWER || event == EVENT_TOUGHNESS){
        if(affect_me(player, card ) ){
            int count = count_graveyard_by_type(HUMAN, TYPE_LAND);
            count += count_graveyard_by_type(AI, TYPE_LAND);
            event_result += count; 
        }
    }
    return 0;
} 

int card_tarmogoyf(int player, int card, event_t event){
    if(event == EVENT_POWER || event == EVENT_TOUGHNESS){
        if(affect_me(player, card ) ){
            int count = 0;
            if( count_graveyard_by_type(HUMAN, TYPE_LAND) > 0 || count_graveyard_by_type(AI, TYPE_LAND) > 0 ){
                count++;
            }
            if( count_graveyard_by_type(HUMAN, TYPE_CREATURE) > 0 || count_graveyard_by_type(AI, TYPE_CREATURE) > 0 ){
                count++;
            }
            if( count_graveyard_by_type(HUMAN, TYPE_ARTIFACT) > 0 || count_graveyard_by_type(AI, TYPE_ARTIFACT) > 0 ){
                count++;
            }
            if( count_graveyard_by_type(HUMAN, TYPE_INSTANT) > 0 || count_graveyard_by_type(AI, TYPE_INSTANT) > 0 || count_graveyard_by_type(HUMAN, TYPE_INTERRUPT) > 0 || count_graveyard_by_type(AI, TYPE_INTERRUPT) > 0  ){
                count++;
            }
            if( count_graveyard_by_type(HUMAN, TYPE_ENCHANTMENT) > 0 || count_graveyard_by_type(AI, TYPE_ENCHANTMENT) > 0 ){
                count++;
            }
            if( count_graveyard_by_type(HUMAN, TYPE_SORCERY) > 0  || count_graveyard_by_type(AI, TYPE_SORCERY) > 0  ){
                count++;
            }
            if( count_graveyard_tribal(HUMAN) > 0  || count_graveyard_tribal(AI) > 0  ){
                count++;
            }
            if( count_graveyard_planeswalker(HUMAN) > 0  || count_graveyard_planeswalker(AI) > 0  ){
                count++;
            }
            
            event_result += count; 
        }
    }
    return 0;
} 

int card_protean_hulk(int player, int card, event_t event){
    if(event == EVENT_GRAVEYARD_FROM_PLAY && affect_me( player, card) ){
        if( ! in_play(player, card) ){ return 0; } 
        card_instance_t *instance = get_card_instance(player, card);
        if( instance->targets[10].player == 1 ){ return 0; }
        if( instance->kill_code > 0 && instance->kill_code != KILL_REMOVE ){
            instance->targets[10].player = 1;
            int max_cmc = 6;   

            int i=0;
            while(i < 100){
                i++;
                if( player == AI && max_cmc < 2 ){
                    break;
                }
                
                int selected = pick_card_from_deck(player);
                if( selected != -1){
                    int *deck = deck_ptr[player];
                    int cmc = get_cmc_by_id( cards_data[ deck[selected] ].id  );
                    if ( cards_data[ deck[selected] ].type & TYPE_CREATURE && cmc <= max_cmc ){
                        int card_added = add_card_to_hand(player, deck[selected] );
                        put_into_play(player, card_added );
                        remove_card_from_deck(player, selected);
                        max_cmc -= cmc;
                        shuffle(player);
                    }
                }
                else{
                    break;
                }
            }
        }
    }
    return 0;
}

int card_primal_forcemage(int player, int card, event_t event){
    if( trigger_cause == card){ return 0; }
    if(trigger_cause_controller == player && trigger_condition == TRIGGER_COMES_INTO_PLAY && affect_me( trigger_cause_controller, trigger_cause ) && reason_for_trigger_controller == affected_card_controller){
        card_instance_t *instance = get_card_instance(trigger_cause_controller, trigger_cause);
        if( cards_data[ instance->internal_card_id].type & TYPE_CREATURE ){
            if(event == EVENT_TRIGGER){
                event_result |= RESOLVE_TRIGGER_MANDATORY;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                pump_until_eot(player, card, trigger_cause_controller, trigger_cause, 3, 3);
            }
        }
    }
    return 0;
}

int effect_lurker(int player, int card, event_t event){
    if( event == EVENT_ABILITIES ){
        event_result -= KEYWORD_SHROUD;
    }
    else if( eot_trigger(player, card, event) ){
        kill_card(player, card, KILL_REMOVE);
    }
    return 0;
}    

int card_lurker(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( current_turn == player && event == EVENT_DECLARE_ATTACKERS ){
        if( instance->state & STATE_ATTACKING ){
            create_targetted_legacy_effect(player, card, &effect_lurker, player, card);
        }
    }
    else if( current_turn == 1-player && event == EVENT_DECLARE_BLOCKERS ){
        if( instance->blocking > -1 && instance->blocking < 255 ){
            create_targetted_legacy_effect(player, card, &effect_lurker, player, card);
        }
    }
    return 0;
}

int effect_scarwood_hag(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( affect_me(instance->targets[0].player, instance->targets[0].card) ){
        if( event == EVENT_ABILITIES ){
            event_result -= KEYWORD_FORESTWALK;
        }
    }
    else if( eot_trigger(player, card, event) ){
        kill_card(player, card, KILL_REMOVE);
    }
    return 0;
}

int card_scarwood_hag(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td_give_fwalk;
    default_target_definition(player, card, &td_give_fwalk, TYPE_CREATURE);
    td_give_fwalk.preferred_controller = player;
    target_definition_t td_remove_fwalk;
    default_target_definition(player, card, &td_remove_fwalk, TYPE_CREATURE);
    td_remove_fwalk.preferred_controller = 1-player;
    if( event == EVENT_CAN_ACTIVATE ){
        if( !is_tapped(player, card) && !is_sick(player, card) && (target_available(player, card, &td_give_fwalk) || target_available(player, card, &td_remove_fwalk)) ){
            if( player == AI ){
                if( current_turn == player ){
                    int opp_has_forest = 0;
                    int z;
                    for( z=0; z<active_cards_count[1-player]; z++ ){
                        if( has_subtype(1-player, z, SUBTYPE_FOREST) ){
                            opp_has_forest = 1;
                            break;
                        }
                    }
                    if( opp_has_forest == 1 ){
                        return 1;
                    }
                }
                else if( current_turn == 1-player ){
                    int opp_has_fwalk = 0;
                    int y;
                    for( y=0; y<active_cards_count[1-player]; y++ ){
                        if( get_abilities(1-player, y, 52, -1) & KEYWORD_FORESTWALK ){
                            opp_has_fwalk = 1;
                            break;
                        }
                    }
                    if( opp_has_fwalk == 1 ){
                        return 1;
                    }
                }
            }
            else if( player == HUMAN ){
                return 1;
            }
        }
    }
    else if( event == EVENT_ACTIVATE ){
        int ai_choice = 0;
        if( player == AI ){
            if( current_turn == player ){
                ai_choice = 0;
            }
            else if( current_turn == 1-player ){
                ai_choice = 1;
            }
        }
        int choice = 1;
        if( has_mana(player, COLOR_GREEN, 4) ){
            choice = do_dialog(player, player, card, -1, -1, " Grant forestwalk\n Remove forestwalk", ai_choice);
        }
        if( choice == 0 ){
            charge_mana(player, COLOR_GREEN, 4);
            if( spell_fizzled == 1 ){ return 0; }
            if( !select_target(player, card, &td_give_fwalk, "Select target creature to give forestwalk to until end of turn.", NULL) ){
                spell_fizzled = 1;
            }
        }
        else if( choice == 1 ){
            if( player == AI ){
                td_remove_fwalk.required_abilities = KEYWORD_FORESTWALK;
            }
            if( !select_target(player, card, &td_remove_fwalk, "Select target creature to remove forestwalk from until end of turn.", NULL) ){
                spell_fizzled = 1;
            }
        }
        if( spell_fizzled != 1 ){
            tap_card(player, card);
            instance->number_of_targets = 1;
            instance->info_slot = choice;
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( valid_target(&td_give_fwalk) && instance->info_slot == 0 ){
            pump_ability_until_eot(player, card, instance->targets[0].player, instance->targets[0].card, 0, 0, KEYWORD_FORESTWALK);
        }
        else if( valid_target(&td_remove_fwalk) && instance->info_slot == 1 ){
            if( get_abilities(instance->targets[0].player, instance->targets[0].card, 52, -1) & KEYWORD_FORESTWALK ){
                int legacy_card = create_targetted_legacy_effect(player, card, &effect_scarwood_hag, instance->targets[0].player, instance->targets[0].card);
                card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
                legacy_instance->targets[0].player = instance->targets[0].player;
                legacy_instance->targets[0].card = instance->targets[0].card;
            }
            else {
                pump_until_eot(player, card, instance->targets[0].player, instance->targets[0].card, 0, 0);
            }
        }
    }
    return 0;
}

int card_spitting_slug(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_DECLARE_BLOCKERS ){
        if( instance->blocking > -1 && instance->blocking < 255 ){
            charge_mana_multi(player, 1, 0, 0, 1, 0, 0);
            if( spell_fizzled == 1 ){
                int leader = instance->blocking;
                pump_ability_until_eot(player, card, 1-player, leader, 0, 0, KEYWORD_FIRST_STRIKE);
                int i;
                for( i=0; i<active_cards_count[1-player]; i++ ){
                    card_instance_t *oba_instance = get_card_instance(1-player, i);
                    if( i != leader && oba_instance->state & STATE_ATTACKING && oba_instance->blocking == leader ){
                        pump_ability_until_eot(player, card, 1-player, i, 0, 0, KEYWORD_FIRST_STRIKE);
                    }
                }
            }
            else {
                pump_ability_until_eot(player, card, player, card, 0, 0, KEYWORD_FIRST_STRIKE);
            }
        }
        else if( instance->state & STATE_ATTACKING && !is_unblocked(player, card) ){
            charge_mana_multi(player, 1, 0, 0, 1, 0, 0);
            if( spell_fizzled == 1 ){
                int j;
                for( j=0; j<active_cards_count[1-player]; j++ ){
                    card_instance_t *blocker_instance = get_card_instance(1-player, j);
                    if( blocker_instance->blocking == card ){
                        pump_ability_until_eot(player, card, 1-player, j, 0, 0, KEYWORD_FIRST_STRIKE);
                    }
                }
            }
            else {
                pump_ability_until_eot(player, card, player, card, 0, 0, KEYWORD_FIRST_STRIKE);
            }
        }
    }
    return 0;
}

//int effect_whippoorwill(int player, int card, event_t event){
//    if(){}
//}

int card_whippoorwill(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    if( event == EVENT_CAN_ACTIVATE ){
        if( !is_tapped(player, card) && !is_sick(player, card) && has_mana(player, COLOR_GREEN, 2) && target_available(player, card, &td) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_GREEN, 2);
        if( spell_fizzled == 1 ){ return 0; }
        if( !select_target(player, card, &td, "Select target creature.", NULL) ){
            spell_fizzled = 1;
        }
        if( spell_fizzled != 1 ){
            tap_card(player, card);
            instance->number_of_targets = 1;
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int effect = create_legacy_effect_exe(player, card, LEGACY_EFFECT_DISINTEGRATE, instance->targets[0].player, instance->targets[0].card);
        card_instance_t *effect_instance = get_card_instance(instance->targets[0].player, effect);
        effect_instance->token_status = 0x800000;
        card_instance_t *target_instance = get_card_instance(instance->targets[0].player, instance->targets[0].card);
        target_instance->regen_status = 0x8000000;
//        int legacy_card = create_targetted_legacy_effect(player, card, &effect_whippoorwill, instance->targets[0].player, instance->targets[0].card);
//        card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
//        legacy_instance->targets[0].player = instance->targets[0].player;
//        legacy_instance->targets[0].card = instance->targets[0].card;
    }
    return 0;
}

int card_scarwood_bandits(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_ARTIFACT);
    if( comes_into_play(player, card, event) ){
        instance->number_of_targets = 0;
    }
    if( leaves_play(player, card, event) ){
        int x;
        for( x=0; x<instance->number_of_targets; x++ ){
            kill_card(instance->targets[x+1].player, instance->targets[x+1].card, KILL_DESTROY);
        }
    }
    if( event == EVENT_CAN_ACTIVATE ){
        if( !is_tapped(player, card) && !is_sick(player, card) && has_mana_multi(player, 2, 0, 0, 1, 0, 0) && target_available(player, card, &td) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 2, 0, 0, 1, 0, 0);
        if( spell_fizzled == 1 ){ return 0; }
        if( !select_target(player, card, &td, "Select target artifact.", NULL) ){
            spell_fizzled = 1;
        }
        if( spell_fizzled != 1 ){
            tap_card(player, card);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *parent = get_card_instance(instance->parent_controller, instance->parent_card);
        int choice = 1;
        if( has_mana(instance->targets[0].player, COLOR_ANY, 2) ){
            choice = do_dialog(instance->targets[0].player, player, card, -1, -1, " Counter ability (Pay 2)\n Don't counter ability", 0);
        }
        if( choice == 0 ){
            charge_mana(instance->targets[0].player, COLOR_COLORLESS, 2);
            spell_fizzled = 1;
            parent->number_of_targets--;
        }
        else if( choice == 1 ){
            if( !in_play(instance->parent_controller, instance->parent_card) ){
                spell_fizzled = 1;
            }
            if( valid_target(&td) && spell_fizzled != 1 ){
                int legacy_card = gain_control(player, card, instance->targets[0].player, instance->targets[0].card);
                if( legacy_card > -1 ){
                    parent->targets[parent->number_of_targets].player = player;
                    parent->targets[parent->number_of_targets].card = legacy_card;
                }
            }
            else {
                parent->number_of_targets--;
            }
        }
    }
    return 0;
}

int card_thornscape_battlemage(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE );
  td.zone = TARGET_ZONE_CREATURE_OR_PLAYER;

  target_definition_t td1;
  default_target_definition(player, card, &td1, TYPE_ARTIFACT);
  td.allowed_controller = 2;
  td.preferred_controller = 1-player;

    
  if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
          if(player != AI){
             if( target_available(player, card, &td1) > 0 && has_mana_multi(player, 0, 0, 0, 0, 0, 1) ){
                int choice = do_dialog(player, player, card, -1, -1, " Pay Red kicker\n Pay White kicker \n Pay both \n Do not pay kicker", 0);
                if( choice == 0 ){
                   charge_mana_multi(player, 0, 0, 0, 0, 1, 0);
                   if( spell_fizzled != 1 ){
                      instance->info_slot = 66;
                   }
                }

                if( choice == 1 ){
                   charge_mana_multi(player, 0, 0, 0, 0, 0, 1);
                   if( spell_fizzled != 1 ){
                      instance->info_slot = 67;
                   }
                }

                if( choice == 2 ){
                    charge_mana_multi(player, 0, 0, 0, 0, 1, 1);
                    if( spell_fizzled != 1 ){
                       instance->info_slot = 68;
                    }
                }

             }

             else if( has_mana_multi(player, 0, 0, 0, 0, 1, 0) ){
                     int choice = do_dialog(player, player, card, -1, -1, " Pay Red kicker\n Do not pay kicker", 0);
                     if( choice == 0 ){
                        charge_mana_multi(player, 0, 0, 0, 0, 1, 0);
                        if( spell_fizzled != 1 ){
                           instance->info_slot = 66;
                        }
                     }

             }
          }
          else{
               if( target_available(player, card, &td) && has_mana_multi(player, 0, 0, 0, 0, 1, 0) ){
                  charge_mana_multi(player, 0, 0, 0, 0, 1, 0);
                  if( spell_fizzled != 1 ){
                    instance->info_slot = 66;
                  }
               }
               if( target_available(player, card, &td1) && has_mana_multi(player, 0, 0, 0, 0, 0, 1) ){
                  charge_mana_multi(player, 0, 0, 0, 0, 0, 1);
                  if( spell_fizzled != 1 ){
                     if(instance->info_slot == 66){
                        instance->info_slot = 68;
                     }
                     else{
                          instance->info_slot = 67;
                     }
                  }
                }
          }

  }
  
  else if( comes_into_play( player, card, event ) == 1 ){
          if( instance->info_slot == 66 ){
             pick_target(&td, "TARGET_CREATURE_OR_PLAYER");
             if( valid_target(&td) ){
                damage_creature_or_player(player, card, event, 2, 3);
             }
          }

          if( instance->info_slot == 67 ){
             pick_target(&td1, "TARGET_ARTIFACT");
             if( valid_target(&td1) ){
                kill_card(instance->targets[0].player, instance->targets[0].card, KILL_DESTROY);
             }
          }

          if( instance->info_slot == 68 ){
             pick_target(&td, "TARGET_CREATURE_OR_PLAYER");
             if( valid_target(&td) ){
                damage_creature_or_player(player, card, event, 2, 3);
             }
             pick_target(&td1, "TARGET_ARTIFACT");
             if( valid_target(&td1) ){
                kill_card(instance->targets[0].player, instance->targets[0].card, KILL_DESTROY);
             }
          }
 }
    return 0;
}


int card_master_wild_hunt(int player, int card, event_t event){
  card_instance_t *instance = get_card_instance(player, card);
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.allowed_controller = 2;
  td.preferred_controller = 1-player;

  if( player == current_turn && trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
     if(event == EVENT_TRIGGER){
        event_result |= RESOLVE_TRIGGER_MANDATORY;
     }
     else if(event == EVENT_RESOLVE_TRIGGER){
             generate_token(player, "Wolf");
     }
   }

   else if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_tapped(player, card)) ){
           if( !(is_sick(player, card)) ){
              return 1;
           }
   }

   else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
           tap_card(player, card);
           int count = active_cards_count[player]-1;
           int total_damage = 0;
           while( count > -1 ){
                 card_data_t card_d = get_card_data(player, count);
                 if( card_d.id == 800 && in_play(player, count) && !(is_tapped(player, count)) ){
                    total_damage++;
                }   
                 count--;
           }
           if(total_damage > 0){
              pick_target(&td, "TARGET_CREATURE");
              instance->info_slot = total_damage;
           }                 
   }                 

   else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot > 0 && valid_target(&td) ){
           int mode = -1;
           if( 1-player == AI ){
              mode = 0;
           }
           else{
                mode = do_dialog(1-player, player, card, -1, -1, " Damaging : auto mode\n Damaging : manual mode", 0);

           }
           int incoming_damage = get_power(instance->targets[0].player, instance->targets[0].card);
           int count = active_cards_count[player]-1;
           while( count > -1 ){
//                 card_data_t card_d = get_card_data(player, count);
                 if( has_subtype(player, count, SUBTYPE_WOLF) && in_play(player, count) && !(is_tapped(player, count)) ){
                    tap_card(player, count);
                    damage_creature(instance->targets[0].player, instance->targets[0].card, get_power(player, count), player, count); 
                    if(mode == 0){
                       int wolfie = get_toughness(player, count);
                       if(incoming_damage >= wolfie){
                          damage_creature(player, count, wolfie,instance->targets[0].player, instance->targets[0].card );
                          incoming_damage-=wolfie; 
                       }
                       else if(incoming_damage > 0){
                            damage_creature(player, count, incoming_damage,instance->targets[0].player, instance->targets[0].card );
                            incoming_damage = 0;
                       }
                    }
                    if(mode == 1){
                       if(incoming_damage > 0){
                          int number = choose_a_number(player, "How many damages to this wolf ?", incoming_damage);
                          if(number > incoming_damage){
                             number = incoming_damage;
                          }   
                          damage_creature(player, count, number, instance->targets[0].player, instance->targets[0].card );
                          incoming_damage-=number;
                       }   
                    }   
                 }   
                 count--;
           }
    }                 


  return 0;
}

int card_mycoloth(int player, int card, event_t event){

 if( player == current_turn && trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
    if(event == EVENT_TRIGGER){
       event_result |= RESOLVE_TRIGGER_MANDATORY;
    }
    else if(event == EVENT_RESOLVE_TRIGGER){
            int i;       
            int p = count_counters(player, card);
            for(i=0;i<p;i++){
                generate_token (player, "Saproling");
            }
    }
 }

 if( comes_into_play(player, card, event) == 1 ){
    devour(player, card, event, 2);
 }

 return 0;
}

int card_sporesower_thallid(int player, int card, event_t event){

 if( player == current_turn && trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
    if(event == EVENT_TRIGGER){
       event_result |= RESOLVE_TRIGGER_MANDATORY;
    }
    else if(event == EVENT_RESOLVE_TRIGGER){
            int count = 0;
            while(count < active_cards_count[player]){
                  if( (has_subtype(player, count, SUBTYPE_FUNGUS)) && in_play(player, count) ){
                     add_ccounter(player, count);
                  }
                  count++;
            }
    }
  }

  else if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) && (count_ccounters(player, card) > 2) ){
          return 1;
  }

  else if(event == EVENT_ACTIVATE && affect_me(player, card) ){
          remove_ccounter(player, card);
          remove_ccounter(player, card);
          remove_ccounter(player, card);
  }

  else if(event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) ){
          generate_token (player, "Saproling");
  }

  return 0;
}

int card_thelon_of_havenwood(int player, int card, event_t event){
  check_legend_rule(player, card, event);
  card_instance_t *instance = get_card_instance(player, card);

  if(event == EVENT_POWER || event == EVENT_TOUGHNESS){
     if( has_subtype(affected_card_controller, affected_card, SUBTYPE_FUNGUS) && in_play(affected_card_controller, affected_card) ){
      event_result += count_ccounters(affected_card_controller, affected_card); 
      }
  }

  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( has_mana_multi(player, 0, 1, 0, 1, 0, 0) ){
        if ( count_graveyard_by_subtype(player, SUBTYPE_FUNGUS) > 0 || count_graveyard_by_subtype(1-player, SUBTYPE_FUNGUS) > 0){
            return 1; 
        }
     }
  }

  else if(event == EVENT_ACTIVATE && affect_me(player, card) ){
          charge_mana_multi(player, 0, 1, 0, 1, 0, 0);
          if(spell_fizzled != 1){
             if( player == AI ){
                int i, k;
                for(k = 0; k < 2; k++){
                    int *graveyard = graveyard_ptr[k];
                    for(i = 0; i < count_graveyard(k); i++){
                        card_ptr_t* b = cards_ptr[ cards_data[ graveyard[i] ].id ];
                        if( graveyard[i] != -1 && ( b->subtype1 == SUBTYPE_FUNGUS || b->subtype2 == SUBTYPE_FUNGUS ) ){
                           remove_card_from_grave(k, i);
                           instance->info_slot = 66;
                           i = count_graveyard(k);
                           k = 2;
                        }                     
                    }           
                }
             }              
             else{
                  int choice = do_dialog(player, player, card, -1,-1," From your graveyard\n From opponent's graveyard", 1);
                  int selected = -1; 
                  selected = select_target_from_graveyard(player, choice, TYPE_CREATURE, 0, SUBTYPE_FUNGUS, 0, 0, 0, 0, 0, -1, 0);
                  if( selected > -1){
                     remove_card_from_grave(choice, selected);
                     instance->info_slot = 66;
                  }
             }
         }
  }

  else if(event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66 ){
          manipulate_all(player, TYPE_CREATURE, 0, SUBTYPE_FUNGUS, 0, 0, 0, 0, 0, -1, 0, 13);
          manipulate_all(1-player, TYPE_CREATURE, 0, SUBTYPE_FUNGUS, 0, 0, 0, 0, 0, -1, 0, 13);
          instance->info_slot = 0;
  }

  return 0;
}

