#include "manalink.h"

int monocolor_hybrid(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    int card_color = cards_data[ instance->internal_card_id ].color;
    int color = 0;
    if( card_color & COLOR_TEST_BLACK ){
        color = COLOR_BLACK;
    }
    else if( card_color & COLOR_TEST_BLUE ){
        color = COLOR_BLUE;
    }
    else if( card_color & COLOR_TEST_GREEN ){
        color = COLOR_GREEN;
    }
    else if( card_color & COLOR_TEST_RED ){
        color = COLOR_RED;
    }
    else{
        color = COLOR_WHITE;
    }
       
    
    int colors[6];
    card_ptr_t* c = cards_ptr[ get_id( player, card ) ];
    int hybrid_cost = c->req_colorless / 2;
    int i;
    for(i=0;i<6;i++){
        colors[i]=0;
    }
    
    if( event == EVENT_MODIFY_COST ){
        for ( i =hybrid_cost;i>=0;i--){
            colors[ color ] = i;
            colors[ 0 ] = 2 * (hybrid_cost - i);        
            if( has_mana_multi( player, colors[0], colors[1], colors[2], colors[3], colors[4], colors[5] ) ){
                // make the spell free
                COST_COLORLESS -= c->req_colorless;
                return 0;
            }
        }
    }
    else if( event == EVENT_CAST_SPELL ){
        if( ! affect_me(player, card) ){ return 0; }
        //if( ! was_card_in_hand(player, card) ){ return 0; }
        for ( i =hybrid_cost;i>=0;i--){
            colors[ color ] = i;
            colors[ 0 ] = 2 * (hybrid_cost - i);  
            if( has_mana_multi( player, colors[0], colors[1], colors[2], colors[3], colors[4], colors[5]  ) ){
                cancel = 0; 
                charge_mana_multi( player, colors[0], colors[1], colors[2], colors[3], colors[4], colors[5]  );
                if( cancel != 1 ){ return 0; }
            }
        }
    }
    return 0;
}
        
        

int hybrid(int player, int card, event_t event){
    // determine what out 2 colors are based on the card color
    card_instance_t *instance = get_card_instance(player, card);
    int card_color = cards_data[ instance->internal_card_id ].color;
    
    int color1 = 0;
    int color2 = 0;
    if( card_color & COLOR_TEST_BLACK ){
        color1 = COLOR_BLACK;
    }
    if( card_color & COLOR_TEST_BLUE ){
        if( color1 ){
            color2 = COLOR_BLUE;
        }
        else{
            color1 = COLOR_BLUE;
        }
    }
    if( card_color & COLOR_TEST_GREEN ){
        if( color1 ){
            color2 = COLOR_GREEN;
        }
        else{
            color1 = COLOR_GREEN;
        }
    }
    if( card_color & COLOR_TEST_RED ){
        if( color1 ){
            color2 = COLOR_RED;
        }
        else{
            color1 = COLOR_RED;
        }
    }
    if( card_color & COLOR_TEST_WHITE ){
        color2 = COLOR_WHITE;
    }   
    
    int colors[6];
    card_ptr_t* c = cards_ptr[ get_id( player, card ) ];
    int hybrid_cost = c->req_blue + c->req_white + c->req_black + c->req_red + c->req_green;
    colors[0] = c->req_colorless;
    int i;
    for(i=1;i<6;i++){
        colors[i]=0;
    }
    
    if( event == EVENT_MODIFY_COST ){
        instance->targets[10].player = 2;
        for ( i =hybrid_cost;i>=0;i--){
            colors[ color1 ] = i;
            colors[ color2 ] = hybrid_cost - i;        
            if( has_mana_multi( player, colors[0], colors[1], colors[2], colors[3], colors[4], colors[5] ) ){
                // make the spell free
                COST_BLACK -= c->req_black;
                COST_BLUE -= c->req_blue;
                COST_GREEN -= c->req_green;
                COST_RED -= c->req_red;
                COST_WHITE -= c->req_white;
                COST_COLORLESS -= c->req_colorless;
                return 0;
            }
        }
    }
    else if( event == EVENT_CAST_SPELL ){
        if( ! affect_me(player, card) ){ return 0; }
        if( instance->targets[10].player != 2 ){ return 0; }
        
        for ( i =hybrid_cost;i>=0;i--){
            colors[ color1 ] = i;
            colors[ color2 ] = hybrid_cost - i;  
            if( has_mana_multi( player, colors[0], colors[1], colors[2], colors[3], colors[4], colors[5]  ) ){
                cancel = 0; 
                charge_mana_multi( player, colors[0], colors[1], colors[2], colors[3], colors[4], colors[5]  );
                if( cancel != 1 ){ return 0; }
            }
        }
    }
    return 0;
}

int has_figure_hybrid(int player, int number){
    int i;
    for ( i = number ;i>=0;i--){
        if( has_mana_multi( player, 0, 0, 0, 0, i, number - i  ) ){
            return 1;
        }
    }
    return 0;
}

int charge_figure_hybrid(int player, int number){
    int i;
    for ( i = number ;i>=0;i--){
        if( has_mana_multi( player, 0, 0, 0, 0, i, number - i  ) ){
            cancel = 0; 
            charge_mana_multi( player, 0, 0, 0, 0, i, number - i );
            if( cancel != 1 ){ return 0; }
        }
    }
    return 0;
}             

int has_mana_hybrid(int player, int number, int first_color, int second_color, int colorless){

    int i,x;
    int mana[5];

    for( x = 0 ;x < 5;x++){
        mana[x] = 0;
    }

    for ( i = number ;i>=0;i--){
         mana[first_color] = i;
         mana[second_color] = number - i;
        if( has_mana_multi( player, colorless, mana[0], mana[1], mana[2], mana[3], mana[4]) ){
            return 1;
        }
    }
    return 0;
}

int charge_mana_hybrid(int player, int number, int first_color, int second_color, int colorless){
    int i,x;
    int mana[5];

    for( x = 0 ;x < 5;x++){
        mana[x] = 0;
    }

    for ( i = number ;i>=0;i--){
         mana[first_color] = i;
         mana[second_color] = number - i;
         if( has_mana_multi( player, colorless, mana[0], mana[1], mana[2], mana[3], mana[4]) ){
            cancel = 0; 
            charge_mana_multi(  player, colorless, mana[0], mana[1], mana[2], mana[3], mana[4] );
            if( cancel != 1 ){ return 0; }
        }
    }
    return 0;
}             


int card_figure_of_destiny(int player, int card, event_t event){
    hybrid(player, card, event);
    
    card_instance_t *instance = get_card_instance( player, card);
    if( comes_into_play(player, card, event ) == 1 ){
        instance->info_slot = 0;
    }
    
    if( event == EVENT_CAN_ACTIVATE ){
        return has_figure_hybrid(player, 1);
    }
    else if(event == EVENT_ACTIVATE ){
        int choice = 0;
        if( has_figure_hybrid(player, 6) && instance->info_slot > 1 ){
            choice = do_dialog(player, player, card, -1, -1, " Become a 2/2\n Become a 4/4\n Become an 8/8\n", 2);
        }
        else if( has_figure_hybrid(player, 3) && instance->info_slot > 0 ){
            choice = do_dialog(player, player, card, -1, -1, " Become a 2/2\n Become a 4/4", 1);
        }
        
        if( choice == 0 ){
            charge_figure_hybrid(player, 1);
        }
        else if(choice == 1){
            charge_figure_hybrid(player, 3);
        }
        else if(choice == 2){
            charge_figure_hybrid(player, 6);
        }
        if( spell_fizzled != 1 ){
            instance->targets[0].card = choice;
        }
    }
    else if(event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *parent = get_card_instance( instance->parent_controller, instance->parent_card  );    
        parent->info_slot = parent->targets[0].card + 1;
    }
    else if( affect_me(player, card ) ){
        if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
            if( instance->info_slot == 1 ){
                event_result++;
            }
            else if( instance->info_slot == 2 ){
                event_result+=3;
            }
            else if( instance->info_slot == 3 ){
                event_result+=7;
            }
        }
        else if( event == EVENT_ABILITIES ){
            if( instance->info_slot == 3 ){
                event_result |= KEYWORD_FLYING;
                event_result |= KEYWORD_FIRST_STRIKE;
            }
        } 
    }
    return 0;
}

int card_manamorphose(int player, int card, event_t event){
    hybrid(player, card, event);
    if(event == EVENT_RESOLVE_SPELL ){  
        card_instance_t *instance = get_card_instance(player, card);
        instance->card_color = 0x3E; // any color
        instance->mana_color = 0x3E;
        add_one_mana_any_color(player, card, event);
        add_one_mana_any_color(player, card, event);
        draw_a_card(player);
        kill_card( player, card, KILL_SACRIFICE);
    }
    else if( event == EVENT_CAN_CAST ){
        return 1;
    }
    return 0;
}

int card_spectral_procession(int player, int card, event_t event){
    if(event == EVENT_CAN_CAST ){
        return 1;
    }
    else if(event == EVENT_RESOLVE_SPELL &&  cancel != 1){
        generate_token(player, "Spirit (white)");
        generate_token(player, "Spirit (white)");
        generate_token(player, "Spirit (white)");
        kill_card(player, card, KILL_DESTROY);
    }

    return monocolor_hybrid(player, card, event);
}

int card_flame_javelin(int player, int card, event_t event){
    monocolor_hybrid(player, card, event);
    if( spell_fizzled != 1 ){
        return card_lightning_blast(player, card, event);
    }
    return 0;
}


int card_wilt_leaf_cavaliers(int player, int card, event_t event){
    vigilance( player, card );
    return hybrid(player, card, event);
}

int card_tattermunge_maniac(int player, int card, event_t event){   
    hybrid(player, card, event);
    return attack_if_able(player, card, event);
}

int card_augury_adept(int player, int card, event_t event){
    hybrid(player, card, event);
    
    if(event == EVENT_RESOLVE_TRIGGER && is_unblocked(player, card) ){
        card_instance_t *instance = get_card_instance( player, card);
        if( ! affect_me(player, card) ){ return 0; }
        int *deck = deck_ptr[player];
        int card_added = add_card_to_hand(player, deck[0] );
        hand_count[player]++;
        remove_card_from_deck( player, 0 );
        int cmc = get_cmc(player, card_added);
        gain_life(player, cmc);
        if( player == AI ){
            reveal_card(player, player, card, player, card_added, "Reveals", 0);
        }
        instance->damage_source_player = -1;
        return 0;
    }
    else{
        return card_hypnotic_specter(player, card, event);
    }
    
    return 0;
}

int card_giant_solifuge(int player, int card, event_t event){
    hybrid(player, card, event);
    haste(player, card);
    return 0;
}

int card_boggart_ramgang(int player, int card, event_t event){
    hybrid(player, card, event);
    haste(player, card);
    wither(player, card, event);
    return 0;
}

int card_plumeveil(int player, int card, event_t event){
    hybrid(player, card, event);
    return flash(player, card, event);
}

int card_oversoul_of_dusk(int player, int card, event_t event){
    return hybrid(player, card, event);  
}

int card_wistful_selkie(int player, int card, event_t event){
    if(comes_into_play(player, card, event) == 1 ){
        draw_a_card(player);
    }
    return hybrid(player, card, event);  
}

int card_ashenmoor_gouger(int player, int card, event_t event){
    cannot_block(player, card, event);
    return hybrid(player, card, event);  
}

int card_wilt_leaf_liege(int player, int card, event_t event){
    if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
        if( affected_card_controller == player && ! affect_me(player, card) && in_play(player, card) ){
            //card_instance_t *affected = get_card_instance( affected_card_controller, affected_card );
            int color = get_color(affected_card_controller, affected_card);
            if( color & COLOR_TEST_GREEN ){
                event_result++;
            }
            if( color & COLOR_TEST_WHITE ){
                event_result++;
            }
        }
    }
    
    //&& trigger_cause == card && trigger_cause_controller == player
    //if( trigger_condition == TRIGGER_DISCARD  ){
    //    poison_counters[HUMAN]=4;
    //    life[HUMAN]=99;
    //}
    return hybrid(player, card, event);  
}

int card_kitchen_finks(int player, int card, event_t event){
    hybrid(player, card, event);
    
    card_instance_t *instance = get_card_instance( player, card);
    if( comes_into_play(player, card, event) == 1 ){
        gain_life(player, 2);
    }
    
    // if this dies, return it to play
    if(event == EVENT_GRAVEYARD_FROM_PLAY){
        if( affect_me( player, card) && in_play(player, card) ){
            if(instance->kill_code != KILL_REMOVE && instance->counter_power >= 0  ){
                int card_added = add_card_to_hand( player, get_internal_card_id_from_csv_id( get_id(player, card) ) );
                put_into_play(player, card_added);
                card_instance_t *new_instance = get_card_instance( player, card_added);
                new_instance->counters = 1;
                new_instance->counter_power--;
                new_instance->counter_toughness--; 
                instance->kill_code = KILL_REMOVE;
            }
        }
    }
    return 0;
}

int card_demigod_of_revenge(int player, int card, event_t event){
    hybrid(player, card, event);
    haste(player, card);
    if( event == EVENT_CAST_SPELL && affect_me(player, card) && cancel != 1 ){
        int *graveyard = graveyard_ptr[player];
        int i;
        int id = get_id(player, card);
        for(i = 0; i < count_graveyard(player); i++){
            if( cards_data[  graveyard[i] ].id == id  ){
                remove_card_from_grave(player, i); 
                int card_added = add_card_to_hand( player, get_internal_card_id_from_csv_id( id ) );
                put_into_play(player, card_added);
                i--;
            }
        }
    }
    return 0;
}

int card_fulminator_mage(int player, int card, event_t event){
    hybrid(player, card, event);
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_LAND);
    if(event == EVENT_CAN_ACTIVATE ){
        int p = 0;
        for(p=0;p<2;p++){
            int count = 0;
            while(count < active_cards_count[p]){
                card_data_t card_d = get_card_data(p, count);
                if( (card_d.type & TYPE_LAND)  && in_play(p, count) && ! is_basic_land(p, count) ){
                    return 1;
                }
                count++;
            }
        }
    }
    else if( event == EVENT_ACTIVATE ){
        while(1){
            if( ! select_target(player, card, &td, "Choose a nonbasic land.", NULL) ){
                spell_fizzled = 1;
                break;
            }
            if(! is_basic_land(instance->targets[0].player, instance->targets[0].card)){
                instance->info_slot = 1;
                kill_card(player, card, KILL_SACRIFICE);
                break;
            }
        }
    }
    else if(event == EVENT_RESOLVE_ACTIVATION ){
        instance = get_card_instance(player, card);
        if( instance->info_slot == 1 && validate_target(player, card, &td, 0) ){
            kill_card(instance->targets[0].player, instance->targets[0].card, KILL_DESTROY);
        }
        return 0;
    }
    else{
        return mana_producer(player, card, event);
    }
    return 0;
}

int card_balefire_liege(int player, int card, event_t event){
  
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE );
  td.zone = TARGET_ZONE_PLAYERS;
  td.allow_cancel = 0;

  hybrid(player, card, event);

  card_instance_t *liege = get_card_instance(player, card);

  if( in_play(player, card)){
     if(trigger_condition == TRIGGER_SPELL_CAST && player == affected_card_controller && player == reason_for_trigger_controller && player == trigger_cause_controller && card == affected_card ){
        card_instance_t *instance = get_card_instance(trigger_cause_controller, trigger_cause);
        if( !(cards_data[ instance->internal_card_id].type & TYPE_LAND) ){
        if( (cards_data[ instance->internal_card_id].color & COLOR_TEST_RED) || (cards_data[ instance->internal_card_id].color & COLOR_TEST_WHITE) ){
            if(event == EVENT_TRIGGER){
                event_result |= RESOLVE_TRIGGER_MANDATORY;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                int clr = cards_data[ instance->internal_card_id].color;
                if( (clr & COLOR_TEST_RED) && !(clr & COLOR_TEST_WHITE) ){
                    pick_target(&td, "TARGET_PLAYER");
                    if( valid_target(&td) ){
                        damage_player(liege->targets[0].player, 3, player, card);
                    }
                }
                if( !(clr & COLOR_TEST_RED) && (clr & COLOR_TEST_WHITE) ){
                    gain_life(player, 3);
                }
                if( (clr & COLOR_TEST_RED) && (clr & COLOR_TEST_WHITE) ){
                    gain_life(player, 3);
                    pick_target(&td, "TARGET_PLAYER");
                    if( valid_target(&td) ){
                       damage_player(liege->targets[0].player, 3, player, card);
                    }
                }
            }
        }
    } 
    } 
 
   if( (event== EVENT_POWER || event == EVENT_TOUGHNESS) && !(affect_me(player, card)) ){
     if( affected_card_controller == player){
        int col = get_color(affected_card_controller, affected_card);
        if( (col & COLOR_TEST_WHITE) && !(col & COLOR_TEST_RED) ){
           event_result++;
        }
        else if( !(col & COLOR_TEST_WHITE) && (col & COLOR_TEST_RED) ){
                event_result++;
        }
        else if( (col & COLOR_TEST_WHITE) && (col & COLOR_TEST_RED) ){
           event_result+=2;
        }
     }
  }
 } 
  return 0;
}

int card_deathbringer_liege(int player, int card, event_t event){
  
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE );
  td.allowed_controller = 2;
  td. preferred_controller = 1-player;

  hybrid(player, card, event);

  card_instance_t *liege = get_card_instance(player, card);

  if( in_play(player, card)){
     if(trigger_condition == TRIGGER_SPELL_CAST && player == affected_card_controller && player == reason_for_trigger_controller && player == trigger_cause_controller && card == affected_card ){
        card_instance_t *instance = get_card_instance(trigger_cause_controller, trigger_cause);
        if( !(cards_data[ instance->internal_card_id].type & TYPE_LAND) ){
        if( (cards_data[ instance->internal_card_id].color & COLOR_TEST_BLACK) || (cards_data[ instance->internal_card_id].color & COLOR_TEST_WHITE) ){
            if(event == EVENT_TRIGGER){
                event_result |= RESOLVE_TRIGGER_MANDATORY;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                    int clr = cards_data[ instance->internal_card_id].color;

                            if( (clr & COLOR_TEST_BLACK) && !(clr & COLOR_TEST_WHITE) ){
                               pick_target(&td, "TARGET_CREATURE");
                               if( valid_target(&td) && is_tapped(liege->targets[0].player, liege->targets[0].card) ){
                                  kill_card(liege->targets[0].player, liege->targets[0].card, KILL_DESTROY);
                               }
                            }

                            if( !(clr & COLOR_TEST_BLACK) && (clr & COLOR_TEST_WHITE) ){
                               pick_target(&td, "TARGET_CREATURE");
                               if( valid_target(&td) ){
                                  tap_card(liege->targets[0].player, liege->targets[0].card);
                               }
                            }

                            if( (clr & COLOR_TEST_BLACK) && (clr & COLOR_TEST_WHITE) ){
                               pick_target(&td, "TARGET_CREATURE");
                               if( valid_target(&td) ){
                                  tap_card(liege->targets[0].player, liege->targets[0].card);
                               }
                               pick_target(&td, "TARGET_CREATURE");
                               if( valid_target(&td) && is_tapped(liege->targets[0].player, liege->targets[0].card) ){
                                  kill_card(liege->targets[0].player, liege->targets[0].card, KILL_DESTROY);
                               }
                            }
           }
      }
   } 
 } 
 
  if( (event== EVENT_POWER || event == EVENT_TOUGHNESS) && !(affect_me(player, card)) ){
     if( affected_card_controller == player){
        int col = get_color(affected_card_controller, affected_card);
        if( (col & COLOR_TEST_WHITE) && !(col & COLOR_TEST_BLACK) ){
           event_result++;
        }
        else if( !(col & COLOR_TEST_WHITE) && (col & COLOR_TEST_BLACK) ){
                event_result++;
        }
        else if( (col & COLOR_TEST_WHITE) && (col & COLOR_TEST_BLACK) ){
           event_result+=2;
        }
     }
  }

  } 

  return 0;
}

int card_gilder_bairn(int player, int card, event_t event){

  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_PERMANENT );
  td.allowed_controller = 2;
  td.preferred_controller = player;
  td.allow_cancel = 0;

  hybrid(player, card, event);

  card_instance_t *instance= get_card_instance(player, card);


  if(event == EVENT_CAN_ACTIVATE && affect_me(player, card) && !(is_sick(player, card)) ){ 
          if( is_tapped(player, card) && has_mana_hybrid(player, 1, 1, 2, 2) ){
             return 1;
          }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card) ){
          charge_mana_hybrid(player, 1, 1, 2, 2);
          if(spell_fizzled != 1 ){
             pick_target(&td, "TARGET_PERMANENT");
             if( valid_target(&td)  ){
                untap_card(player, card); 
                instance->info_slot = 66;
             }
          }
  }

  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
          if( valid_target(&td) ){
             int a = count_counters(instance->targets[0].player, instance->targets[0].card);
             int b = count_ccounters(instance->targets[0].player, instance->targets[0].card);
             add_counters(instance->targets[0].player, instance->targets[0].card, a);
             add_ccounters(instance->targets[0].player, instance->targets[0].card, b);
             card_instance_t *target= get_card_instance(instance->targets[0].player, instance->targets[0].card);
             target->counter_power *= 2;  
             target->counter_toughness *= 2;  
               
             instance->info_slot = 0;
          }
  }

  return 0;
}


int card_creakwood_liege(int player, int card, event_t event){
    hybrid(player, card, event);
    if( (event== EVENT_POWER || event == EVENT_TOUGHNESS) && !(affect_me(player, card)) && in_play(player, card) ){
        if( affected_card_controller == player){
            int col = get_color(affected_card_controller, affected_card);
            if( col & COLOR_TEST_GREEN ){
                event_result++;
            }
            if( col & COLOR_TEST_BLACK ){
                event_result++;
            }
        }
    }
    if( current_turn == player && upkeep_trigger(player, card, event) ){
        generate_token(player, "Worm");
    }
    return 0;
 } 

 int card_womr_harvest(int player, int card, event_t event){
        
  target_definition_t td1;
  default_target_definition(player, card, &td1, TYPE_LAND );
  td1.zone = TARGET_ZONE_HAND;
  td1.allowed_controller = player;
  td1.preferred_controller = player;
  td1.illegal_abilities = 0;

  hybrid(player, card, event);

  card_instance_t *instance = get_card_instance(player, card);

    if( event == EVENT_GRAVEYARD_ABILITY && has_mana_hybrid(player, 3, 0, 2, 2) ){
       if( can_target(&td1) && can_sorcery_be_played(player) ){
          return 1;
       }
    }
    else if( event == EVENT_PAY_FLASHBACK_COSTS ){
            charge_mana_hybrid(player, 3, 0, 2, 2);
            if(spell_fizzled != 1){
               pick_target(&td1, "TARGET_LAND");
               if( valid_target(&td1) ){
                  discard_card(player, instance->targets[0].card);            
               }
               else{
                    spell_fizzled = 1;
               }
            }
    }
    else if( event == EVENT_CAN_CAST){
            return 1;
    }
    else if(event == EVENT_RESOLVE_SPELL){
            int number = count_graveyard_by_type(player, TYPE_LAND);
            int i;
            for( i = 0; i < number; i++ ){
                generate_token(player, "Worm");

            }

            if( get_flashback() ){
               kill_card(player, card, KILL_REMOVE);
            }
            else{
                 kill_card(player, card, KILL_DESTROY);
            }
    }
    return 0;    
}

int card_spitting_image(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE );

    target_definition_t td1;
    default_target_definition(player, card, &td1, TYPE_LAND );
    td1.zone = TARGET_ZONE_HAND;
    td1.allowed_controller = player;
    td1.preferred_controller = player;
    td1.illegal_abilities = 0;

    card_instance_t *instance = get_card_instance(player, card);

    hybrid(player, card, event);


    if( event == EVENT_GRAVEYARD_ABILITY && has_mana_hybrid(player, 2, 1, 2, 4) ){
       if( can_target(&td1) && can_target(&td) && can_sorcery_be_played(player) ){
          return 1;
       }
    }
    else if( event == EVENT_PAY_FLASHBACK_COSTS ){
            charge_mana_hybrid(player, 2, 1, 2, 4);
            if(spell_fizzled != 1){
               pick_target(&td1, "TARGET_LAND");
               if( valid_target(&td1) ){
                  discard_card(player, instance->targets[0].card);            
               }
               else{
                    spell_fizzled = 1;
               }
            }
    }

    else if( event == EVENT_CAN_CAST ){
            return target_available(player, card, &td);
    }

    else if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
        if( ! pick_target(&td, "TARGET_CREATURE") ){
            spell_fizzled = 1;
        }
    }
    else if( event == EVENT_RESOLVE_SPELL ){
            if( validate_target(player, card, &td, 0) ){
               generate_token_by_id(player, get_id(instance->targets[0].player, instance->targets[0].card) );
            }

            if( get_flashback() ){
               kill_card(player, card, KILL_REMOVE);
            }
            else{
                 kill_card(player, card, KILL_DESTROY);
            }
    }

    return 0;
}

