#include "manalink.h"

int attack_who_flag = -1;
int planeswalkers[10];

int planeswalker(int player, int card, event_t event, int loyalty){
    // if somehow this is not a planeswalker, bail out
    card_data_t card_d = get_card_data(player, card);
    card_ptr_t* c = cards_ptr[ card_d.id ];
    if( card_d.cc[2] != 9 ){
        return 0;
    }
    
    // die if duplicate planeswalker
    int i, p;
    int match = 0;
    int my_match = 0;
    
    if( affect_me(player, card) ){
        int id = get_id(player, card);
        if( id == get_id_by_name("Ajani Vengeant") ){ id = get_id_by_name("Ajani Goldmane"); } 
        if( id == get_id_by_name("Chandra Ablaze") ){ id = get_id_by_name("Chandra Nalaar"); } 
        if( id == get_id_by_name("Jace, the Mind Sculptor") ){ id = get_id_by_name("Jace Beleren"); } 
        if( id == get_id_by_name("Sarkhan the Mad") ){ id = get_id_by_name("Sarkhan Vol"); } 
        for(p=0;p<2;p++){
            for(i=0;i<active_cards_count[player];i++){
                int my_id = get_id(p, i);
                if( my_id == get_id_by_name("Ajani Vengeant") ){ my_id = get_id_by_name("Ajani Goldmane"); } 
                if( my_id == get_id_by_name("Chandra Ablaze") ){ my_id = get_id_by_name("Chandra Nalaar"); } 
                if( my_id == get_id_by_name("Jace, the Mind Sculptor") ){ my_id = get_id_by_name("Jace Beleren"); } 
                if( my_id == get_id_by_name("Sarkhan the Mad") ){ my_id = get_id_by_name("Sarkhan Vol"); } 
                if( in_play(p, i) && !( card == i && player == p ) && id == my_id ){
                    //if(life[AI]<100){ life[AI] = id; life[HUMAN] = card;}
                    if( in_play(player, card) ){
                        kill_card(p, i, KILL_SACRIFICE);
                    }
                    match = 1;
                    if( p == player ){
                        my_match = 1;
                    }
                }
            }
        }
        if( match == 1 && in_play(player, card) ){
            kill_card(player, card, KILL_SACRIFICE);
        }
    }
    
    if( event == EVENT_CAN_CAST ){
        if( player == AI && my_match == 1 ){
            return 0;
        }
        return 1;
    }
    

    
    if( ! in_play(player, card) ){ return 0; }
    
    card_instance_t *instance = get_card_instance(player, card);
    
    // once per turn... sorcery only
    if( event == EVENT_CAN_ACTIVATE ){
        if( can_sorcery_be_played(player) && instance->targets[9].card != 1 ){
            return 1;
        }    
    }
    else if( event == EVENT_ACTIVATE ){
        instance->targets[9].card = 1;
    }
    else if( current_phase == PHASE_DISCARD && current_turn == player ){
        instance->targets[9].card = 0;
        attack_who_flag = -1;
        
        for(i=0;i<active_cards_count[1-player];i++){
            card_instance_t *attacker = get_card_instance(1-player, i);
            attacker->targets[9].card = -1;
        }
    }
    
    // comes into play with some loyalty
    if( comes_into_play(player, card, event) == 1 ){
       add_counters(player, card, loyalty);
       instance->targets[9].player = 2;
    }
    
    // die if 0 loyalty
    if( count_counters(player, card) == 0 && instance->targets[9].player == 2 ){
        kill_card(player, card, KILL_SACRIFICE);
    }
    
    // when creatures attack, prompt for who they attack
    if( trigger_condition == TRIGGER_DECLARE_ATTACK && current_phase == PHASE_DECLARE_ATTACKERS && current_turn == 1-player){
        if( affect_me( trigger_cause_controller, trigger_cause ) && reason_for_trigger_controller == affected_card_controller  )
        {
            if(event == EVENT_TRIGGER && ( attack_who_flag == -1 || attack_who_flag == card ) ){
                event_result |= 2;
                attack_who_flag = card;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                char buffer[1500];
                sprintf(buffer, " Attack opponent\n" );
                int ai_choice = 1;
                if( life[player] < 10 ){
                    ai_choice = 0;
                }
                int count = 0;
                int walker_count = 0;
                int gideon_found = 0;
                while(count < active_cards_count[player]){
                    card_d = get_card_data(player, count);
                    c = cards_ptr[ card_d.id ];
                    if( card_d.cc[2] == 9 && in_play(player, count) ){
                        walker_count++;
                        planeswalkers[walker_count] = count; 
                        sprintf(buffer, "%s Attack %s\n", buffer, c->name );
                        card_instance_t *pw = get_card_instance(player, count);
                        if( pw->targets[3].player == 141 ){
                            ai_choice = walker_count;
                            gideon_found = 1;
                        }
                    }
                    count++;
                }
                
                card_instance_t *attacker = get_card_instance(affected_card_controller, affected_card);           
                
                                
                int choice = ai_choice;
                if( gideon_found == 0 || player == HUMAN ){
                    choice = do_dialog(1-player, affected_card_controller, affected_card, -1, -1, buffer, ai_choice);
                }
                if( choice > 0 ){
                    attacker->targets[9].card = planeswalkers[ choice ];
                }
            }
        }
    }
    
    // when creature deals damage to me, lose loyalty
    if( event == EVENT_DECLARE_BLOCKERS ){
        for(i=0;i<active_cards_count[1-player];i++){
            if( is_unblocked(1-player, i) ){
                card_instance_t *attacker = get_card_instance(1-player, i);
                if( attacker->targets[9].card == card ){
                    int result = create_legacy_effect_exe(1-player, i, LEGACY_EFFECT_ITH, 1-player, i);
                    card_instance_t *legacy_instance = get_card_instance(1-player, result);
                    legacy_instance->info_slot = 3;
                    attacker->targets[9].player = 3;
                }
            }
        }
    }
    else if( current_phase == PHASE_NORMAL_COMBAT_DAMAGE ){
        for(i=0;i<active_cards_count[1-player];i++){
            if( is_unblocked(1-player, i) && in_play(1-player, i) ){
                card_instance_t *attacker = get_card_instance(1-player, i);
                //if( life[HUMAN] == 20 ){ gain_life(HUMAN, - attacker->targets[9].card); }
                if( attacker->targets[9].card == card && attacker->targets[9].player == 3 ){
                    //if( life[AI] == 20 ){ gain_life(AI, 1+i); }
                
                    attacker->targets[9].card = -1;
                    attacker->targets[9].player = -1;
                    if( count_counters(player, card) < get_attack_power( 1-player, i ) ){
                        set_counters(player, card, 0);
                    }
                    else{
                        set_counters(player, card, count_counters(player, card) - get_attack_power( 1-player, i ) );
                    }
                }
            }
        }
    }
    
    // when damage is dealt to a player, choose to hit the walker instead
    if( event == EVENT_PREVENT_DAMAGE && affected_card_controller == player
        && current_phase != PHASE_NORMAL_COMBAT_DAMAGE && current_phase != PHASE_FIRST_STRIKE_DAMAGE)
    {
        
        card_instance_t *source = get_card_instance(affected_card_controller, affected_card);
        if( damage_card != source->internal_card_id || source->damage_source_player == player ){
            return 0;
        }
        if( source->damage_target_player != player || source->damage_target_card != -1 ){
            return 0;
        }
        
        if( source->info_slot <= 0 ){
            return 0;
        }
        card_d = get_card_data(player, card);
        c = cards_ptr[ card_d.id ];
        char buffer[100];
        sprintf(buffer, " Damage %s\n Do not damage Planeswalker", c->name );
        int ai_choice = 0;
        if( source->info_slot >= life[player] ){
            ai_choice = 1;
        }   
        int choice = do_dialog(1-player, affected_card_controller, affected_card, -1, -1, buffer, ai_choice);
        if( choice == 0 ){
            if( count_counters(player, card) < source->info_slot ){
                set_counters(player, card, 0);
            }
            else{
                set_counters(player, card, count_counters(player, card) - source->info_slot );
            }
            source->info_slot = 0;
        }
    }
    
    return global_enchantment(player, card, event);
}

int card_nicol_bolas_planeswalker(int player, int card, event_t event){
    int costs[3] = { 3, -2, -9};
    card_instance_t *instance = get_card_instance(player, card);
    instance->number_of_targets = 1;
    if( event == EVENT_ACTIVATE ){
        int choice = 0;      
        if( count_counters(player, card) >= 9 ){
            choice = do_dialog(player, player, card, -1, -1, " Kill a card\n Steal Creature\n Explode", 2);
        }
        else if( count_counters(player, card) >= 2 ){
            int ai_choice = rand(2);
            choice = do_dialog(player, player, card, -1, -1, " Kill a card\n Steal Creature", ai_choice);
        }
        instance->targets[10].player = choice;
        set_counters(player, card, count_counters(player, card) + costs[choice] );
        
        target_definition_t td;
        if( choice == 2 ){
            default_target_definition(player, card, &td, TYPE_CREATURE);
            td.zone = TARGET_ZONE_PLAYERS;
            td.allow_cancel = 0;
            select_target(player, card, &td, "Choose a target player", NULL);
        }    
        else if(choice == 1 ){
            default_target_definition(player, card, &td, TYPE_CREATURE);
            td.allow_cancel = 0;
            if( ! target_available(player, card, &td) ){
                spell_fizzled = 1;
                return 0;
            }
            select_target(player, card, &td, "Choose a target creature", NULL);
        }
        else{
            default_target_definition(player, card, &td, TYPE_PERMANENT);
            td.allow_cancel = 0;
            td.illegal_type = TYPE_CREATURE;
            if( ! target_available(player, card, &td) ){
                spell_fizzled = 1;
                return 0;
            }
            select_target(player, card, &td, "Choose a target non-creature", NULL);
        }    
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( instance->targets[10].player == 1 ){
            target_definition_t td;
            default_target_definition(player, card, &td, TYPE_CREATURE);
            if( valid_target(&td) ){
                card_aladdin2(player, card, event);
            }
        }
        else if( instance->targets[10].player == 0 ){
            kill_card(instance->targets[0].player, instance->targets[0].card, KILL_DESTROY);
        }
        else{
            int p = instance->targets[0].player;
            damage_player(p, 7, player, card);
            int i;
            for(i=0;i<7;i++){
                discard(p, 0, 0);
            }
            target_definition_t td;
            default_target_definition(player, card, &td, TYPE_PERMANENT);
            td.allowed_controller = p;
            td.preferred_controller = p;
            td.who_chooses = p;
            td.illegal_abilities = 0;
            td.allow_cancel = 0;
            for( i=0;i<7;i++){
                if( target_available(player, card, &td) ){
                    select_target(player, card, &td, "Choose a permanent to sacrifice", NULL);
                    int target = instance->targets[0].card;
                    kill_card( p, target, KILL_SACRIFICE );
                }
            }
        }
    }
    return planeswalker(player, card, event, 5);
}

int card_ajani_vengeant(int player, int card, event_t event){
    int costs[3] = { 1, -2, -7};
    card_instance_t *instance = get_card_instance(player, card);
    instance->number_of_targets = 1;
    target_definition_t td;

    if( event == EVENT_ACTIVATE ){
        int choice = 0;      
        if( count_counters(player, card) >= 7 ){
            choice = do_dialog(player, player, card, -1, -1, " Lock down card\n Lightning Helix\n Nuke Lands", 2);
        }
        else if( count_counters(player, card) >= 2 ){
            int ai_choice = rand(2);
            choice = do_dialog(player, player, card, -1, -1, " Lock down card\n Lightning Helix", ai_choice);
        }
        instance->targets[10].player = choice;
        set_counters(player, card, count_counters(player, card) + costs[choice] );
        
        if( choice == 0 ){
            default_target_definition(player, card, &td, TYPE_PERMANENT);
            td.allow_cancel = 0;
            select_target(player, card, &td, "Choose a permanent", NULL);
        }    
        else if( choice == 1 ){
                default_target_definition(player, card, &td, TYPE_CREATURE );
                td.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
                td.allow_cancel = 0;
                pick_target(&td, "TARGET_CREATURE_OR_PLAYER");
        }
        else {
            default_target_definition(player, card, &td, TYPE_CREATURE);
            td.zone = TARGET_ZONE_PLAYERS;
            td.allow_cancel = 0;
            select_target(player, card, &td, "Choose a target player", NULL);
        } 
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( instance->targets[10].player == 1 ){
              damage_creature_or_player(player, card, event, 3, 3);
              gain_life(player, 3);
        }
        else if( instance->targets[10].player == 0 ){
            int legacy_card = create_targetted_legacy_effect(player, card, &effect_does_not_untap, instance->targets[0].player, instance->targets[0].card);
            card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
            legacy_instance->targets[0].player = instance->targets[0].player;
            legacy_instance->targets[0].card = instance->targets[0].card;
        }
        else{
            
            int p = instance->targets[0].player;
            int i;
            for(i=0;i<active_cards_count[p];i++){
                card_data_t card_d = get_card_data(p, i);
                if((card_d.type & TYPE_LAND) && in_play(p, i)){
                    kill_card(p, i, KILL_DESTROY);
                }
            }
        }
    }
    return planeswalker(player, card, event, 3);
}

int effect_elspeth_knight_errant(int player, int card, event_t event ){
    card_instance_t *instance = get_card_instance(player, card);
    if( affect_me(instance->targets[0].player, instance->targets[0].card ) ){
        if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
            event_result += 3;
        }
        else if( event == EVENT_ABILITIES ){
            event_result |= KEYWORD_FLYING;
        }
    }
    else if( eot_trigger(player, card, event ) ){
        kill_card(player, card, KILL_REMOVE);
    }
    return 0;
}
   
int effect_elspeth_knight_errant_ultimate(int player, int card, event_t event ){
    card_instance_t *inst = get_card_instance(player, card);
    inst->targets[18].player = 282;
    
    if( affected_card_controller == player ){
        card_instance_t *instance= get_card_instance(affected_card_controller, affected_card);
        if( ! ( cards_data[instance->internal_card_id ].type & TYPE_CREATURE )){
            indestructible( affected_card_controller, affected_card, event );
        }
    }
    
    return 0;
}

int card_elspeth_knight_errant(int player, int card, event_t event){
    int costs[3] = { 1, 1, -8};
    card_instance_t *instance = get_card_instance(player, card);
    instance->number_of_targets = 1;
    if( event == EVENT_ACTIVATE ){
        int choice = 0;      
        int ai_choice = rand(2);
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        if( player == AI ){
            td.allowed_controller = player;
            td.preferred_controller = player;
        }
        td.allow_cancel = 0;
        if( count_counters(player, card) >= 8 ){
            choice = do_dialog(player, player, card, -1, -1, " Make a guy\n Pump a guy\n Indestructible Time", ai_choice);
        }
        else if( can_target( &td ) ){
            choice = do_dialog(player, player, card, -1, -1, " Make a guy\n Pump a guy", ai_choice);
        }

        instance->targets[10].player = choice;
        set_counters(player, card, count_counters(player, card) + costs[choice] );
        
        if( choice == 1 ){
            pick_target(&td, "TARGET_CREATURE" );
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( instance->targets[10].player == 0 ){
            generate_token(player, "Soldier");
        }
        else if( instance->targets[10].player == 1 ){
            int legacy_card = create_targetted_legacy_effect(player, card, &effect_elspeth_knight_errant, instance->targets[0].player, instance->targets[0].card);
            card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
            legacy_instance->targets[0].player = instance->targets[0].player;
            legacy_instance->targets[0].card = instance->targets[0].card;
        }
        else{
            create_legacy_effect(player, card, &effect_elspeth_knight_errant_ultimate );
        }
    }
    return planeswalker(player, card, event, 4);
}

int effect_sarkhan_vol(int player, int card, event_t event ){
    card_instance_t *instance = get_card_instance(player, card);
    if( affect_me(instance->targets[0].player, instance->targets[0].card ) ){
        if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
            event_result ++;
        }
        haste(instance->targets[0].player, instance->targets[0].card);
    }
    else if( eot_trigger(player, card, event ) ){
        kill_card(player, card, KILL_REMOVE);
    }
    return 0;
}

int card_sarkhan_vol(int player, int card, event_t event){
    int costs[3] = { 1, -2, -6};
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.allow_cancel = 0;
    card_instance_t *instance = get_card_instance(player, card);
    instance->number_of_targets = 1;
    if( event == EVENT_ACTIVATE ){
        int choice = 0;      
        if( count_counters(player, card) >= 6 ){
            choice = do_dialog(player, player, card, -1, -1, " Pump creatures\n Steal Creature\n Make Dragon Army", 2);
        }
        else if( count_counters(player, card) > 2 && can_target(&td) ){
            choice = do_dialog(player, player, card, -1, -1, " Pump creatures\n Steal Creature", 0);
        }
        instance->targets[10].player = choice;
        set_counters(player, card, count_counters(player, card) + costs[choice] );
        
        if( choice == 1 ){
            if( can_target(&td) ){
                default_target_definition(player, card, &td, TYPE_CREATURE);
                td.allow_cancel = 0;
                pick_target(&td, "TARGET_CREATURE");
            }
            else{
                spell_fizzled = 1;
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( instance->targets[10].player == 1 ){
            untap_card(instance->targets[0].player, instance->targets[0].card);
            
            int sum = get_sum(player, TYPE_CREATURE);
            int legacy = gain_control(player, card, instance->targets[0].player, instance->targets[0].card);
            if( legacy > -1 ){
                sum = get_sum(player, TYPE_CREATURE) - sum;
            }
            else{
                sum = instance->targets[0].card;
            }
            
            int legacy_card = create_targetted_legacy_effect(player, card, &effect_threaten, instance->targets[0].player, instance->targets[0].card);
            card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
            legacy_instance->targets[0].player = player;
            legacy_instance->targets[0].card = sum;
            legacy_instance->targets[1].card = legacy;
        }
        else if( instance->targets[10].player == 0 ){
            int p = player;
            int count = 0;
            while(count < active_cards_count[p]){
                card_data_t card_d = get_card_data(p, count);
                if((card_d.type & TYPE_CREATURE) && in_play(p, count)){                
                    int legacy_card = create_targetted_legacy_effect(player, card, &effect_flamekin_zealot, p, count);
                    card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
                    legacy_instance->targets[0].player = p;
                    legacy_instance->targets[0].card = count;
                }
                count++;
            }
        }
        else{
            int i=0;
            for(i=0;i<5;i++){
                generate_token(player, "Dragon");
            }
        }
    }
    return planeswalker(player, card, event, 4);
}

int effect_tezzeret_the_seeker(int player, int card, event_t event ){
    card_instance_t *instance = get_card_instance(player, card);
    if( instance->targets[3].player < 0 ){
        instance->targets[3].player = 1;
        card_animate_artifact55(player, card, EVENT_RESOLVE_SPELL );       
    }
    else{
        if( affect_me(instance->targets[0].player, instance->targets[0].card) ){
            if( event == EVENT_CHANGE_TYPE  ){
                event_result = instance->dummy3;
                instance->token_status |= 0x40u;
            }
        }   
    }
    
    if( eot_trigger(player, card, event ) ){
        kill_card(player, card, KILL_REMOVE);
    }
    return 0;
}

int card_tezzeret_the_seeker(int player, int card, event_t event){
    if( ! is_unlocked(player, card, event, 24) ){ return 0; }
    int costs[3] = { 1, 0, -5};
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_ARTIFACT);
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_ACTIVATE ){
        int choice = 0;      
        if( count_counters(player, card) >= 5 ){
            choice = do_dialog(player, player, card, -1, -1, " Untap Artifacts\n Tutor\n Animate Artifacts", 2);
        }
        else if( count_counters(player, card) ){
            choice = do_dialog(player, player, card, -1, -1, " Untap Artifacts\n Tutor", 0);
        }
        instance->number_of_targets = 0;
        instance->targets[10].player = choice;
        set_counters(player, card, count_counters(player, card) + costs[choice] );
        
        if( choice == 0 ){
            if( pick_target(&td, "TARGET_ARTIFACT") ){
                instance->targets[1].player = instance->targets[0].player;
                instance->targets[1].card = instance->targets[0].card;
                pick_target(&td, "TARGET_ARTIFACT");
            }
            spell_fizzled = 0;
        }
        else if( choice == 1 ){
            int number = -1;
            while( number > count_counters(player, card) || number < 0 ){
                number = choose_a_number(player, "Use how much loyalty?", count_counters(player, card));
            }
            set_counters(player, card, count_counters(player, card) - number );
            instance->targets[11].card = number;
        }    
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( instance->targets[10].player == 1 ){
            int selected = pick_card_from_deck(player);
            if( selected != -1){
                int *deck = deck_ptr[player];
                int cmc = get_cmc_by_id( cards_data[ deck[selected] ].id  );
                if ( cards_data[ deck[selected] ].type & TYPE_ARTIFACT && cmc <= instance->targets[11].card ){
                    int card_added = add_card_to_hand(player, deck[selected] );
                    put_into_play(player, card_added );
                    remove_card_from_deck(player, selected);
                    shuffle(player);
                }
            }
        }
        else if( instance->targets[10].player == 0 ){
            int i;
            for(i=0;i<instance->number_of_targets;i++){
                if( validate_target(player, card, &td, i) ){
                    untap_card( instance->targets[i].player, instance->targets[i].card );
                }
            }
        }
        else if( instance->targets[10].player == 2 ){
            int p = player;
            int count = 0;
            while(count < active_cards_count[p]){
                card_data_t card_d = get_card_data(p, count);
                if((card_d.type & TYPE_ARTIFACT) && in_play(p, count)){                
                    if( card_d.type & TYPE_CREATURE ){
                        pump_until_eot(player, card, p, count, 5-card_d.power, 5-card_d.toughness);
                    }
                    else{
                        int legacy_card = create_targetted_legacy_effect(player, card, &effect_tezzeret_the_seeker, p, count);
                        card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
                        legacy_instance->targets[0].player = p;
                        legacy_instance->targets[0].card = count;
                    }
                }
                count++;
            }
        }
    }
    return planeswalker(player, card, event, 4);
}


