#include "manalink.h"

int card_jaya_ballard_task_mage(int player, int card, event_t event){
    check_legend_rule(player, card, event);
    
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_PERMANENT);
    td.required_color = COLOR_TEST_BLUE;
    
    target_definition_t td1;
    default_target_definition(player, card, &td1, TYPE_CREATURE);
    td1.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
    
    if( event == EVENT_CAN_ACTIVATE && ! is_sick(player, card) && ! is_tapped(player, card) && has_mana(player, COLOR_RED, 1) && hand_count[player] > 0 ){
        if( ( player == AI || ! can_target(&td) ) && ! has_mana_multi(player, 1, 0, 0, 0, 1, 0) ){
            return 0;
        }
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        int choice = do_dialog(player, player, card, -1, -1, " Kill a blue permanent\n Deal 3 to any target\n Deal 6 to everything\n Cancel", 1);
        instance->info_slot = choice;
        instance->number_of_targets = 0;
        if( choice == 0 ){
            if( can_target(&td) && has_mana(player, COLOR_RED, 1) ){
                charge_mana(player, COLOR_RED, 1);
                if( spell_fizzled != 1 ){
                    if( pick_target(&td, "TARGET_PERMANENT") ){
                        tap_card(player, card);
                        discard(player, 0, 0);
                        return 0;
                    }
                }
            }
        }
        else if( choice == 1 ){
            if( has_mana_multi(player, 1, 0, 0, 0, 1, 0) ){
                charge_mana_multi(player, 1, 0, 0, 0, 1, 0);
                if( spell_fizzled != 1 ){
                    if( pick_target(&td1, "TARGET_CREATURE_OR_PLAYER") ){
                        tap_card(player, card);
                        discard(player, 0, 0);
                        return 0;
                    }
                }
            }
        }
        else if( choice == 2 ){
            if( has_mana_multi(player, 5, 0, 0, 0, 2, 0) ){
                charge_mana_multi(player, 5, 0, 0, 0, 2, 0);
                if( spell_fizzled != 1 ){
                    tap_card(player, card);
                    discard(player, 0, 0);
                    return 0;
                }
            }
        }
        spell_fizzled = 1;        
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( instance->info_slot == 0 ){
            if( valid_target(&td) ){
                kill_card(instance->targets[0].player, instance->targets[0].card, KILL_DESTROY );
            }
        }
        else if( instance->info_slot == 1 ){
            if( valid_target(&td1) ){
                damage_creature_or_player(player, card, event, 3, 3);   
            }
        }
        else if( instance->info_slot == 2 ){
            int p;
            for( p = 0; p < 2; p++){
                damage_player(p, 6, player, card); 
                int count = active_cards_count[p];
                while(count >= 0 ){
                    card_data_t card_d = get_card_data(p, count);
                    if( in_play(p, count) && (card_d.type & TYPE_CREATURE) ){
                        damage_creature(p, count, 6, player, card);
                    }
                    count--;
                }
            }
        }
    }
    return 0;
}

int card_dwarven_blastminer(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_LAND);
    card_instance_t *instance = get_card_instance(player, card);
    if( in_play(player, card) && instance->info_slot < 1 ){
        if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 2, 0, 0, 0, 1, 0) && ! is_tapped(player, card) && ! is_sick(player, card) ){
            int p;
            for(p=0;p<2;p++){
                int count = 0;
                while(count < active_cards_count[p]){
                    card_data_t card_d = get_card_data(HUMAN, count);
                    if( (card_d.type & TYPE_LAND)  && in_play(p, count) && ! is_basic_land(p, count) ){
                        return 1; 
                    }
                    count++;
                }
            };
        }
        else if( event == EVENT_ACTIVATE ){
            while(spell_fizzled != 1){
                if( ! select_target(player, card, &td, "Choose a nonbasic land.", NULL) ){
                    spell_fizzled = 1;
                    return 0;
                }
                if(! is_basic_land(instance->targets[0].player, instance->targets[0].card)){
                    charge_mana_multi(player, 2, 0, 0, 0, 1, 0);
                    if( spell_fizzled != 1 ){
                        tap_card(player, card);
                        break;
                    }
                }
            }
        }
        else if( event == EVENT_RESOLVE_ACTIVATION && valid_target(&td) ){
            kill_card(instance->targets[0].player, instance->targets[0].card, KILL_DESTROY);
        }
        return 0;
    
    }
    else{
        return morph(player, card, event, 0, 0, 0, 0, 1, 0);
    }
}

int card_kiki_jiki_mirror_breaker(int player, int card, event_t event){
    if( ! is_unlocked(player, card, event, 17) ){ return 0; }
    card_instance_t *instance = get_card_instance(player, card);
    haste(player, card);
    check_legend_rule(player, card, event);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.preferred_controller = player;
    td.allowed_controller = player;
    if( event == EVENT_CAN_ACTIVATE ){
        if( ! is_tapped(player, card) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        tap_card(player, card);
        if( ! select_target(player, card, &td, "Select target nonlegendary creature", NULL) ){
            untap_card(player, card);
            spell_fizzled = 1;
        }
        else if( has_creature_type( instance->targets[0].player, instance->targets[0].card, SUBTYPE_LEGEND ) ){
            untap_card(player, card);
            spell_fizzled = 1;
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int token = generate_token_by_id(player, get_id( instance->targets[0].player, instance->targets[0].card ) );
        
        int legacy_card = create_targetted_legacy_effect(player, card, &effect_sneak_attack, player, token);
        card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
        legacy_instance->targets[0].player = player;
        legacy_instance->targets[0].card = token;
                
        haste(player, token);
    }
    return 0;
}

int card_goblin_king(int player, int card, event_t event){
    boost_creature_type(player, card, event, SUBTYPE_GOBLIN, 1, 1, KEYWORD_MOUNTAINWALK, 0);
    return 0;
}

int card_grim_lavamancer(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE ){
        if( count_graveyard(player) > 1 && ! is_tapped(player, card) && ! is_sick(player, card) && has_mana(player, COLOR_RED, 1) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_RED, 1);
        if( spell_fizzled == 1 ){ return 0; }
        
        int i=0;
        int *grave = graveyard_ptr[player];
        while( i < 2 ){
            int selected = show_deck( player, grave, 500, "Pick a card", 0, 0x7375B0 );
            if( selected != -1){
                remove_card_from_grave(player, selected);
                i++;
            }
        }
        tap_card(player, card);
            
        // choose a target to shoot
        instance->number_of_targets = 1;
        target_definition_t td1;
        default_target_definition(player, card, &td1, TYPE_CREATURE );
        td1.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
        td1.allow_cancel = 0;
        select_target(player, card, &td1, "Select target creature or player", NULL);
        instance->number_of_targets = 1;
    }
    else if(event == EVENT_RESOLVE_ACTIVATION ){
        damage_creature_or_player(player, card, event, 2, 3);    
    }
    
    return 0;
}

int card_goblin_welder(int player, int card, event_t event){
    if( ! is_unlocked(player, card, event, 5) ){ return 0; }
    
    target_definition_t td0;
    default_target_definition(player, card, &td0, TYPE_ARTIFACT);
    td0.allowed_controller = player;
    td0.preferred_controller = player;
    
    target_definition_t td1;
    default_target_definition(player, card, &td1, TYPE_ARTIFACT);
    td1.allowed_controller = 1-player;
    td1.preferred_controller = 1-player;
    
    card_instance_t *instance = get_card_instance(player, card);
    if(event == EVENT_CAN_ACTIVATE){
        if( is_sick(player, card) || is_tapped(player, card) ){ return 0; }
        if( ( count_graveyard_by_type(player, TYPE_ARTIFACT) > 0 && target_available(player, card, &td0) )
            || 
            ( count_graveyard_by_type(1-player, TYPE_ARTIFACT) > 0  && target_available(player, card, &td1) ))
        {
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE ){
        if( ! affect_me(player, card) ){ return 0; }
        int mine_ok = 0;
        int choice = 0;
        if( count_graveyard_by_type(player, TYPE_ARTIFACT) > 0 && target_available(player, card, &td0) ){
            mine_ok = 1;
        }
        if( count_graveyard_by_type(1-player, TYPE_ARTIFACT) > 0 && target_available(player, card, &td1)  ){
            if( mine_ok == 0 ){
                choice = 1;
            }
            else{
                choice = do_dialog(player, player, card, -1, -1, " From My Grave\n From Opponent's Grave", 0);
            }
        }
        
        // first choose the target in play
        if( choice == 0 ){
            if( ! select_target(player, card, &td0, "Select target artifact you control", NULL) ){
                spell_fizzled = 1;
            }
        }
        else{
            if( ! select_target(player, card, &td1, "Select target artifact opponent controls", NULL) ){
                spell_fizzled = 1;
            }
        }
        if( spell_fizzled == 1 ){
            return 0;
        }
        
        int p = instance->targets[0].player;
        int c = instance->targets[0].card;
        
        // now choose a card from the grave
        if( player == AI ){ choice = 1-choice; }
        
        int card_added = -1;
        while(1){
            int selected = show_deck( player, graveyard_ptr[choice], 500, "Pick a card", 0, 0x7375B0 );
            if( selected != -1){
                int *grave = graveyard_ptr[choice];
                if ( cards_data[ grave[selected] ].type & TYPE_ARTIFACT ){
                    card_added =  add_card_to_hand(choice, grave[selected] );
                
                    instance->targets[0].player = choice;
                    instance->targets[0].card = card_added;
                    instance->info_slot = selected;
                
                    card_instance_t *target = get_card_instance(player, card_added);
                    target->state |= STATE_INVISIBLE;
            
                    break;
                }
            }
            else{
                break;
            }      
        }
        if( card_added == -1 ){
            spell_fizzled = 1;
            return 0;
        }
        
        tap_card(player, card);
        
        instance->number_of_targets = 2;
        instance->targets[1].player = p;
        instance->targets[1].card = c;
    }
    else if(event == EVENT_RESOLVE_ACTIVATION){
        // is the grave the same?
        int *grave = graveyard_ptr[instance->targets[1].player];
        if( cards_data[ grave[ instance->info_slot ] ].id != get_id(instance->targets[0].player, instance->targets[0].card) ){
            spell_fizzled = 1;
        }
        
        // is the artifact still in play?
        if( ! in_play(instance->targets[1].player, instance->targets[1].card ) ){
            spell_fizzled = 1;
        }
        
        if( spell_fizzled == 1 ){
            return 0;
        }
        kill_card(instance->targets[1].player, instance->targets[1].card, KILL_SACRIFICE);
        put_into_play(instance->targets[0].player, instance->targets[0].card);
        remove_card_from_grave(instance->targets[1].player, instance->info_slot); 
    }
    return 0;
}

int card_gorilla_shaman(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_ARTIFACT );
    td.illegal_type = TYPE_CREATURE;
    card_instance_t *instance= get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE ){
        if(target_available(player, card, &td)){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        if( select_target(player, card, &td, "Select a non-creature artifact", NULL) ){
            int cost = get_cmc( instance->targets[0].player, instance->targets[0].card );
            if( has_mana(player, COLOR_COLORLESS, 2 * cost + 1) ){
                charge_mana(player, COLOR_COLORLESS, 2 * cost + 1 );
            }
            else{
                spell_fizzled = 1;
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION  && spell_fizzled != 1 ){
        kill_card( instance->targets[0].player, instance->targets[0].card, KILL_DESTROY );
    }
    return 0;
}

int card_squee_goblin_nabob(int player, int card, event_t event){
    card_instance_t *instance= get_card_instance(player, card);
    check_legend_rule(player, card, event);
    if( event == EVENT_GRAVEYARD_ABILITY_UPKEEP ){
        int choice = 0;
        if( ! duh_mode(player) ){
            do_dialog(player, player, card, -1, -1," Return Squee to hand\n Leave Squee be\n", 0);
        }
        if( choice == 0 ){
            instance->state &= ~STATE_INVISIBLE;
            hand_count[player]++;
            return -1;
        }
        else{
            return -2;
        }
    }
    return 0;
}

int card_gempalm_incinerator(int player, int card, event_t event){
    int result = cycling(player, card, event, 1, 0, 0, 0, 1, 0);
    
    if( event == EVENT_ACTIVATE_FROM_HAND && spell_fizzled != 1 ){
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.preferred_controller = 2;
        if(target_available(player, card, &td)){
            load_text(0, "TARGET_CREATURE");
            if( ! select_target(player, card, &td, text_lines[0], NULL) ){
                spell_fizzled = 0;
                card_instance_t *instance = get_card_instance(player, card);
                instance->targets[0].player = -1;
            }
        }
    }
    else if( event == EVENT_REVOLVE_ACTIVATION_FROM_HAND && spell_fizzled != 1 ){
        card_instance_t *instance = get_card_instance(player, card);
        if( instance->targets[0].player != -1 ){
            // count the goblins in play
            target_definition_t td;
            default_target_definition(player, card, &td, TYPE_ANY);
            td.required_subtype = SUBTYPE_GOBLIN;
            td.allowed_controller = player;
            td.preferred_controller = player;
            int amount = target_available(player, card, &td);
        
            // shoot the chosen creature
            damage_creature(instance->targets[0].player, instance->targets[0].card, amount, player, card);
            instance->number_of_targets = 0;
        }
    }
    return result;
}

int card_simian_spirit_guide(int player, int card, event_t event){
    if( event == EVENT_CAN_ACTIVATE_FROM_HAND ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE_FROM_HAND ){
        // remove this from the game        
        put_on_top_of_deck(player, card );
        rfg_top_card_of_deck(player);    
    }
    else if( event == EVENT_REVOLVE_ACTIVATION_FROM_HAND ){
        produce_mana(player, COLOR_RED, 1);
    }
    return 0;
}

int card_anger(int player, int card, event_t event){
    haste(player, card );
    if( event == EVENT_GRAVEYARD_ABILITY ){
        if( affected_card_controller == player && in_play(affected_card_controller, affected_card) ){
            target_definition_t td;
            default_target_definition(player, card, &td, TYPE_LAND);
            td.required_subtype = SUBTYPE_MOUNTAIN;
            td.allowed_controller = player;
            td.preferred_controller = player;
            td.illegal_abilities = 0;
            if( target_available(player, card, &td) || count_cards_by_id(HUMAN, get_id_by_name("SPAT") ) > 0 ) {
                haste( affected_card_controller, affected_card );
            }
        }
    }
    return 0;
}

int card_skirk_prospector(int player, int card, event_t event){
    target_definition_t td;
    card_instance_t *instance;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_GOBLIN;
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.illegal_abilities = 0;
    instance = get_card_instance(player, card);
    if(event == EVENT_CAN_ACTIVATE ){
        if( target_available(player, card, &td) ) {
            return 1; 
        }
        return 0;   
    }
    else if(event == EVENT_ACTIVATE ){
        if( select_target(player, card, &td, "Sacrifice a Goblin", NULL)){
            kill_card(instance->targets[0].player, instance->targets[0].card, KILL_SACRIFICE );
            produce_mana(player, COLOR_RED, 1);
        }
        spell_fizzled = 1;
    } 
    return 0;
}

int is_goblin(int player, int card){
    if( has_subtype(player, card, SUBTYPE_GOBLIN )){
        return 1;
    }
    return 0;
}

int card_akroma_angel_of_fury(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( instance->info_slot < 1 ){
        cannot_be_countered(player, card, event);
    }
    if( in_play(player, card) && instance->info_slot < 1 ){
        check_legend_rule(player, card, event);
        if( event == EVENT_CAN_ACTIVATE && has_mana(player, COLOR_RED, 1) ){
            return 1;
        }
        else if( event == EVENT_ACTIVATE ){
            charge_mana(player, COLOR_RED, 1);
            if( spell_fizzled != 1 ){
                instance->targets[2].player = 3;
            }
        }
        else if( event == EVENT_RESOLVE_ACTIVATION && instance->targets[2].player == 3 ){
            instance->targets[2].player = 0;
            pump_until_eot(player, instance->parent_card, player, instance->parent_card, 1, 0);
        }
        return 0;
    
    }
    else{
        return morph(player, card, event, 3, 0, 0, 0, 3, 0);
    }
}

int card_goblin_sharpshooter( int player, int card, event_t event){
    does_not_untap(player, card, event);
    card_instance_t *instance= get_card_instance(player, card);
    if(event == EVENT_GRAVEYARD_FROM_PLAY){
        if( ! in_play(affected_card_controller, affected_card) ){ return 0; } 
        card_instance_t *affected= get_card_instance(affected_card_controller, affected_card);
        if( affected->kill_code != 4) {
            if( cards_data[ affected->internal_card_id ].type & TYPE_CREATURE ){
                instance->targets[11].player = 1;
            }
        }
    }
    
    if( resolve_graveyard_trigger(player, card, event) == 1 ){
        untap_card(player, card);
        instance->targets[11].player = 0;
    }
    return card_prodigal_sorcerer(player, card, event);
}

int card_goblin_ringleader( int player, int card, event_t event){
    haste(player, card);
    if( comes_into_play(player, card, event ) == 1 ){
        int i=0;
        int *deck = deck_ptr[player];
        for(i=0;i<4;i++){
            int card_added = add_card_to_hand(player, deck[0] );
            reveal_card(player, player, card, player, card_added, "Reveals...", 0);
            if( is_goblin( player, card_added ) ){
                remove_card_from_deck( player, 0 );
                hand_count[player]++;
            }
            else{
                put_top_card_of_deck_to_bottom(player);
                card_instance_t *target = get_card_instance(player, card_added);
                target->state |= STATE_INVISIBLE;
            }
        }
    }
    return 0;
}

int card_goblin_matron( int player, int card, event_t event){
    if( comes_into_play(player, card, event ) == 1 ){
        tutor(player, TYPE_ANY, &is_goblin, TUTOR_HAND );
    }
    return 0;
}

int card_goblin_piledriver( int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_DECLARE_ATTACKERS && instance->state & STATE_ATTACKING ){
        // Calculate number of attacking goblins
        int count = 0;
        int attacking = 0;
        while(count < active_cards_count[player]){
            card_instance_t *affected = get_card_instance(player, count);
            if( ( affected->state & STATE_ATTACKING ) && count != card ){
                if( has_creature_type(player, count, SUBTYPE_GOBLIN) ){
                    attacking++;
                }
            }
            count++;
        }
        pump_until_eot(player, card, player, card, 2*attacking, 0);    
    }
    return 0;
}

int card_covetous_dragon( int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_ARTIFACT);
    td.illegal_abilities = 0;
    td.allowed_controller = player;
    td.preferred_controller = player;
    if( ! target_available(player, card, &td) ){
        kill_card(player, card, KILL_SACRIFICE);
    }
    return 0;
}

int card_goblin_lackey (int player, int card, event_t event){
    if(event == EVENT_RESOLVE_TRIGGER && is_unblocked(player, card) ){
        if( ! affect_me(player, card) ){ return 0; }
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_PERMANENT);
        td.zone = TARGET_ZONE_HAND;
        td.required_subtype = SUBTYPE_GOBLIN;
        td.illegal_abilities = 0;
        td.allowed_controller = player;
        td.preferred_controller = player;
        card_instance_t *instance = get_card_instance( player, card);
        if( select_target(player, card, &td, "Choose a Goblin to put into play", NULL) ){
            put_into_play(player, instance->targets[0].card);
            hand_count[player]--;
        }
        instance->damage_source_player = -1;
        return 0;
    }
    else{
        return card_hypnotic_specter(player, card, event);
    }
}        

int card_ogre_arsonist(int player, int card, event_t event)
{
  card_instance_t *instance;
  target_definition_t td;

  STANDARD_CIP_CHECK;

  if(event == EVENT_TRIGGER)
    event_result |= 2;
  else if(event == EVENT_RESOLVE_TRIGGER)
  {
    default_target_definition(player, card, &td, TYPE_LAND);
    td.allow_cancel = 0;
    if(target_available(player, card, &td))
    {
      select_target(player, card, &td, "Select target land", NULL);
      instance = get_card_instance(player, card);
      if(validate_target(player, card, &td, 0))
        kill_card(instance->targets[0].player, instance->targets[0].card, KILL_DESTROY);
      instance->number_of_targets = 0;
    }
  }

  return 0;
}


static int cip_damage_creature(int player, int card, event_t event, int amount){
  card_instance_t *instance;
  target_definition_t td;

  STANDARD_CIP_CHECK;

  if(event == EVENT_TRIGGER)
    event_result |= 2;
  else if(event == EVENT_RESOLVE_TRIGGER)
  {
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.allow_cancel = 0;
    if(target_available(player, card, &td))
    {
      load_text(0, "TARGET_CREATURE");
      select_target(player, card, &td, text_lines[0], NULL);
      instance = get_card_instance(player, card);
      if(validate_target(player, card, &td, 0))
        damage_creature(instance->targets[0].player, instance->targets[0].card, amount, player, card);
      instance->number_of_targets = 0;
    }
  }

  return 0;
}


int card_flametongue_kavu(int player, int card, event_t event){
    return cip_damage_creature(player, card, event, 4);
}


int card_fire_imp(int player, int card, event_t event){
    return cip_damage_creature(player, card, event, 2);
}


int card_balduvian_horde(int player, int card, event_t event){
  int did_discard = 0, choice;
  char buffer[50];

  STANDARD_CIP_CHECK;

  if(event == EVENT_TRIGGER)
    event_result |= 2;
  else if(event == EVENT_RESOLVE_TRIGGER)
  {
    if(hand_count[player] > 0)
    {
      load_text(0, "BALDUVIAN_HORDE");
      sprintf(buffer, " %s\n %s", text_lines[0], text_lines[1]);
      choice = do_dialog(player, player, card, -1, -1, buffer, 0);
      if(choice == 0)
      {
        discard(player, 1, 0);
        did_discard = 1;
      }
    }

    if(!did_discard)
      kill_card(player, card, KILL_SACRIFICE);
  }

  return 0;
}

int card_goblin_warchief(int player, int card, event_t event){
    if(!has_creature_type(affected_card_controller, affected_card, SUBTYPE_GOBLIN ))    {
        return 0;
    }
    if( affected_card_controller != player)    {
        return 0;
    }
    if(event == EVENT_MODIFY_COST_GLOBAL )    {
        COST_COLORLESS--;
    }
    if( in_play(affected_card_controller, affected_card) ){
        haste( affected_card_controller, affected_card );
    }
    return 0;
}


int card_heart_sliver(int player, int card, event_t event)
{
    if(!has_creature_type(affected_card_controller, affected_card, SUBTYPE_SLIVER )){
        return 0;
    }
    haste( affected_card_controller, affected_card );
    return 0;
}


int card_kobold_drill_sergeant(int player, int card, event_t event)
{
  boost_creature_type(player, card, event, SUBTYPE_KOBOLD, 0, 1, KEYWORD_TRAMPLE, BCT_CONTROLLER_ONLY);
  return 0;
}


int card_tahngarth_talruum_hero(int player, int card, event_t event)
{
  target_definition_t td;
  card_instance_t *instance, *target, *parent;
  int power1, power2;

  check_legend_rule(player, card, event);
  vigilance(player, card);

  if((event == EVENT_CAN_ACTIVATE) || (event == EVENT_ACTIVATE) || (event == EVENT_RESOLVE_ACTIVATION))
  {
    default_target_definition(player, card, &td, TYPE_CREATURE);

    if(event == EVENT_CAN_ACTIVATE)
    {
      if(has_mana(player, COLOR_ANY, 2) && has_mana(player, COLOR_RED, 1)
         && target_available(player, card, &td)  && ! is_tapped(player, card) && ! is_sick(player, card))
        return 1;
      else
        return 0;
    }
    else if(event == EVENT_ACTIVATE)
    {
      charge_mana_multi(player, 1, 0, 0, 0, 1, 0);
      if(spell_fizzled != 1)
      {
        load_text(0, "TARGET_CREATURE");
        if(select_target(player, card, &td, text_lines[0], NULL))
          tap_card(player, card);
        else
          spell_fizzled = 1;
      }
    }
    else
    {
      if(validate_target(player, card, &td, 0))
      {
        instance = get_card_instance(player, card);
        target = get_card_instance(instance->targets[0].player, instance->targets[0].card);
        power1 = get_power(instance->parent_controller, instance->parent_card);
        power2 = get_power(instance->targets[0].player, instance->targets[0].card);
        damage_creature(instance->targets[0].player, instance->targets[0].card, power1,
                        instance->parent_controller, instance->parent_card);
        damage_creature(instance->parent_controller, instance->parent_card, power2,
                        instance->targets[0].player, instance->targets[0].card);
      }
      else
        spell_fizzled = 1;

      instance = get_card_instance(player, card);
      parent = get_card_instance(instance->parent_controller, instance->parent_card);
      parent->number_of_targets = 0;
    }
  }

  return 0;

}

void make_gobbos(int player){
    generate_token(player, "Goblin");
    generate_token(player, "Goblin");
    generate_token(player, "Goblin");
}

int card_siege_gang_commander(int player, int card, event_t event){
    target_definition_t td;
    card_instance_t *instance;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_GOBLIN;
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.allow_cancel = 0;
    td.illegal_abilities = 0;
    
    instance = get_card_instance(player, card);
    
    if(event == EVENT_CAN_ACTIVATE ){
        if( can_target(&td) && has_mana_multi( player, 1, 0, 0, 0, 1, 0 ) ) {
            return 1; 
        }
        return 0;   
    }
    else if(event == EVENT_ACTIVATE ){
        charge_mana_multi( player, 1, 0, 0, 0, 1, 0 );
        if( spell_fizzled != 1 ){
            select_target(player, card, &td, "Sacrifice a Goblin", NULL);
            kill_card(instance->targets[0].player, instance->targets[0].card, KILL_SACRIFICE );
            
            default_target_definition(player, card, &td, TYPE_CREATURE );
            td.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
            td.allow_cancel = 0;
            pick_target(&td, "TARGET_CREATURE_OR_PLAYER");
        }
    }
    else if(event == EVENT_RESOLVE_ACTIVATION && spell_fizzled != 1){
        damage_creature_or_player(player, card, event, 2, 3);
    }
    else if( comes_into_play(player, card, event) == 1 ){
        make_gobbos(player);
    }
  
    return 0;
}

int card_magnivore(int player, int card, event_t event){
    haste(player, card);
    if(event == EVENT_POWER || event == EVENT_TOUGHNESS){
        if(affect_me(player, card ) ){
            int count = count_graveyard_by_type(HUMAN, TYPE_SORCERY);
            count += count_graveyard_by_type(AI, TYPE_SORCERY);
            event_result += count; 
        }
    }
    return 0;
}   

int card_avalanche_riders(int player, int card, event_t event){
    haste( player, card );
    echo(player, card, event, 3, 0, 0, 0, 1, 0);
    return card_ogre_arsonist(player, card, event);
}

int card_hellspark_elemental(int player, int card, event_t event){
    card_ball_lightning(player, card, event);
    return unearth(player, event, 1, 0, 0, 0, 1, 0); 
}

int card_two_headed_dragon(int player, int card, event_t event){
    card_two_headed_giant_of_foriys(player, card, event);
    minimum_blockers(player, card, event, 2);
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 1, 0) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 1, 0);
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *instance = get_card_instance(player, card);
        pump_until_eot(player, card, player, instance->parent_card, 2, 0);
    }
    return 0; 
}

int card_goblin_wizard(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t goblin_in_play;
    default_target_definition(player, card, &goblin_in_play, TYPE_PERMANENT);
    goblin_in_play.zone = TARGET_ZONE_IN_PLAY;
    goblin_in_play.required_subtype = SUBTYPE_GOBLIN;
    goblin_in_play.preferred_controller = player;
    target_definition_t goblin_in_hand;
    default_target_definition(player, card, &goblin_in_hand, TYPE_PERMANENT);
    goblin_in_hand.zone = TARGET_ZONE_HAND;
    goblin_in_hand.required_subtype = SUBTYPE_GOBLIN;
    goblin_in_hand.illegal_abilities = 0;
    goblin_in_hand.allowed_controller = player;
    goblin_in_hand.preferred_controller = player;
    if( event == EVENT_CAN_ACTIVATE ){
        if( player == AI ){
            if( ( !is_tapped(player, card) && !is_sick(player, card) && target_available(player, card, &goblin_in_hand) ) || ( target_available(player, card, &goblin_in_play) && has_mana(player, COLOR_RED, 1) ) ){
                return 1;
            }
        }
        else if( player == HUMAN ){
            if( ( !is_tapped(player, card) && !is_sick(player, card) ) || ( target_available(player, card, &goblin_in_play) && has_mana(player, COLOR_RED, 1) ) ){
                return 1;
            }
        }
    }
    else if( event == EVENT_ACTIVATE ){
        int choice;
        instance->info_slot = 0;
        if( !target_available(player, card, &goblin_in_play) || !has_mana(player, COLOR_RED, 1) ){
            tap_card(player, card);
            instance->info_slot = 1;
        }
        else if( is_tapped(player, card) || is_sick(player, card) ){
            charge_mana(player, COLOR_RED, 1);
            if( spell_fizzled == 1 ){ return 0; }
            if( !select_target(player, card, &goblin_in_play, "Select target Goblin", NULL) ){
                spell_fizzled = 1;
            }
            if( spell_fizzled != 1 ){
                instance->number_of_targets = 1;
                instance->info_slot = 2;
            }
        }
        else {
            int ai_choice = 0;
            if( player == AI ){
                if( !target_available(player, card, &goblin_in_hand) ){
                    ai_choice = 1;
                }
            }
            choice = do_dialog(player, player, card, -1, -1, " Put a Goblin into play\n Give a Goblin prot. from white\n Cancel", ai_choice);
            if( choice == 0 ){
                tap_card(player, card);
            }
            else if( choice == 1 ){
                charge_mana(player, COLOR_RED, 1);
                if( spell_fizzled == 1){ return 0; }
                if( !select_target(player, card, &goblin_in_play, "Select target Goblin", NULL) ){
                    spell_fizzled = 1;
                }
                if( spell_fizzled != 1 ){
                    instance->number_of_targets = 1;
                }
            }
            else if( choice == 2 ){
                spell_fizzled = 1;
            }
            if( spell_fizzled != 1 ){
                instance->info_slot = choice + 1;
            }
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( instance->info_slot == 1 ){
            if( target_available(player, card, &goblin_in_hand) ){
                if( !select_target(player, card, &goblin_in_hand, "Choose a Goblin to put into play", NULL) ){
                    spell_fizzled = 1;
                }
                else {
                    put_into_play(player, instance->targets[0].card);
                    hand_count[player]--;
                }
            }
        }
        else if( instance->info_slot == 2 ){
            pump_ability_until_eot(player, card, instance->targets[0].player, instance->targets[0].card, 0, 0, KEYWORD_PROT_WHITE);
        }
    }
    return 0;
}

int card_orc_general(int player, int card, event_t event){
    card_instance_t *orcgeneral = get_card_instance(player, card);
    target_definition_t another_orc;
    default_target_definition(player, card, &another_orc, TYPE_CREATURE);
    another_orc.zone = TARGET_ZONE_IN_PLAY;
    another_orc.required_subtype = SUBTYPE_ORC;
    another_orc.allowed_controller = player;
    another_orc.preferred_controller = player;
    another_orc.illegal_abilities = 0;
    target_definition_t goblin;
    default_target_definition(player, card, &goblin, TYPE_CREATURE);
    goblin.zone = TARGET_ZONE_IN_PLAY;
    goblin.required_subtype = SUBTYPE_GOBLIN;
    goblin.allowed_controller = player;
    goblin.preferred_controller = player;
    goblin.illegal_abilities = 0;
    if( event == EVENT_CAN_ACTIVATE ){
        if( ( !is_tapped(player, card) && !is_sick(player, card) && can_target(&another_orc) >= 2 ) || ( !is_tapped(player, card) && !is_sick(player, card) && target_available(player, card, &goblin) ) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        int choice = -1;
        int ai_choice = 1;
//        if( player == AI ){
//        }
        if( can_target(&another_orc) >= 2 && target_available(player, card, &goblin) ){
            choice = do_dialog(player, player, card, -1, -1, " Sacrifice another Orc\n Sacrifice a Goblin", ai_choice);
        }
        if( choice == 0 || !target_available(player, card, &goblin) ){
            orcgeneral->state |= STATE_CANNOT_TARGET;
            if( !select_target(player, card, &another_orc, "Select another Orc to sacrifice", NULL) ){
                orcgeneral->state &= ~STATE_CANNOT_TARGET;
                spell_fizzled = 1;
            }
        }
        else if( choice == 1 || can_target(&another_orc) < 2 ){
            if( !select_target(player, card, &goblin, "Select target Goblin to sacrifice", NULL) ){
                spell_fizzled = 1;
            }
        }
        if( spell_fizzled != 1 ){
            orcgeneral->state &= ~STATE_CANNOT_TARGET;
            orcgeneral->number_of_targets = 1;
            tap_card(player, card);
            kill_card(player, orcgeneral->targets[0].card, KILL_SACRIFICE);
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int p;
        int c;
        for( p=0; p<2; p++ ){
            for( c=0; c<active_cards_count[p]; c++ ){
                if( ( in_play(p, c) && has_creature_type(p, c, SUBTYPE_ORC) ) || ( in_play(p, c) && has_creature_type(p, c, SUBTYPE_GOBLIN) ) ){
                    if( !(p == orcgeneral->parent_controller && c == orcgeneral->parent_card) ){
                        pump_until_eot(player, card, p, c, 1, 1);
                    }
                }
            }
        }
    }
    return 0;
}

int card_hell_thunder(int player, int card, event_t event){
    card_ball_lightning(player, card, event);
    return unearth(player, event, 4, 0, 0, 0, 1, 0); 
}

int card_ryusei(int player, int card, event_t event){
  check_legend_rule(player, card, event);

  if( graveyard_from_play(player, card, event) ){
     int p;
     for( p = 0; p < 2; p++){
         int count = 0;
         while(count < active_cards_count[p]){
               card_data_t card_d = get_card_data(p, count);
               if( (card_d.type & TYPE_CREATURE) && in_play(p, count) && !(card_d.static_ability & KEYWORD_FLYING) ){
                  damage_creature(p, count, 5, player, card);
               }
               count++;
         }
     }


  }

  return 0;
}

