#include "manalink.h"

int card_words_of_war(int player, int card, event_t event){
    if( has_mana_multi(player, 1, 0, 0, 0, 0, 0) && trigger_condition == TRIGGER_REPLACE_CARD_DRAW && affect_me(player, card) && reason_for_trigger_controller == player){
        if(event == EVENT_TRIGGER){
            event_result |= 1;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
            if( spell_fizzled != 1 ){
                target_definition_t td;
                default_target_definition(player, card, &td, TYPE_CREATURE);
                td.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
                if( pick_target(&td, "TARGET_CREATURE_OR_PLAYER") ){
                    suppress_draw = 1;
                    damage_creature_or_player(player, card, event, 2, 3); 
                }
            }
        }
    }
    return global_enchantment(player, card, event);
}

int card_furnace_of_rath(int player, int card, event_t event){
    if( event == EVENT_DEAL_DAMAGE ){
        card_instance_t *damage= get_card_instance( affected_card_controller, affected_card);
        if( damage->internal_card_id == damage_card ){
            if( damage->info_slot > 0 ){
                damage->info_slot *= 2;
            }
        }
    }
    return global_enchantment(player, card, event);
}

int effect_sneak_attack(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( affect_me(instance->targets[0].player, instance->targets[0].card) ){
        haste( instance->targets[0].player, instance->targets[0].card );
    }
    else if( eot_trigger(player, card, event ) ){
        kill_card(instance->targets[0].player, instance->targets[0].card, KILL_SACRIFICE);
        kill_card(player, card, KILL_REMOVE);
    }
    return 0;
}

int card_sneak_attack (int player, int card, event_t event){
    if( event == EVENT_CAN_CAST ){
        return 1;
    }
    else if(event == EVENT_CAN_ACTIVATE ){
        if(has_mana(player, COLOR_RED, 1)){
            return 1;
        }
    } 
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_RED, 1);
    }
    else if(event == EVENT_RESOLVE_ACTIVATION ){
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.allowed_controller = player;
        td.preferred_controller = player;
        td.zone = TARGET_ZONE_HAND;
        td.illegal_abilities = 0;
        if( target_available(player, card, &td) ){
            if( select_target(player, card, &td, "Choose a creature in hand", NULL)){
                card_instance_t *instance = get_card_instance(player, card);
                put_into_play( player, instance->targets[0].card );
                hand_count[player]--;
                
                int legacy_card = create_targetted_legacy_effect(player, card, &effect_sneak_attack, player, instance->targets[0].card);
                card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
                legacy_instance->targets[0].player = player;
                legacy_instance->targets[0].card = instance->targets[0].card;
            }
        }
    }
    return global_enchantment(player, card, event);
}

int card_honden_of_infinite_rage (int player, int card, event_t event){
    check_legend_rule(player, card, event);
    if( current_turn == player && upkeep_trigger(player, card, event) ){
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
        td.allow_cancel = 0;
        load_text(0, "TARGET_CREATURE_OR_PLAYER");
        select_target(player, card, &td, text_lines[0], NULL);
        damage_creature_or_player(player, card, event, count_shrines(player, card), 3);
    }
    return global_enchantment(player, card, event);
}

