#include "manalink.h"

int card_devestating_dreams(int player, int card, event_t event){
    card_instance_t *instance= get_card_instance(player, card);
    if( event == EVENT_CAN_CAST ){
        return 1;
    }
    else if(event == EVENT_CAST_SPELL ){
        if( ! affect_me(player, card) ){ return 0; }
        int number = hand_count[player] + 1;
        while( number > hand_count[player] ){
            number = choose_a_number(player, "Discard how many cards?", hand_count[player]);
        }
        int i;
        for(i=0;i<number;i++){
            discard(player, 1, 1);
        }
        instance->info_slot = number;
    } 
    else if(event == EVENT_RESOLVE_SPELL ){
        int p, j, i;
        target_definition_t td;
        for(j=0;j<2;j++){
            p = player;
            if( j == 1){ p = 1-player; }
            
            // sac a land
            default_target_definition(player, card, &td, TYPE_LAND);
            td.illegal_abilities = 0;
            td.allowed_controller = p;
            td.preferred_controller = p;
            td.who_chooses = p;
            td.allow_cancel = 0;
            for(i=0;i<instance->info_slot;i++){
                if( can_target(&td) ){
                    select_target(player, card, &td, "Sacrifice a Land", NULL);
                    kill_card(instance->targets[0].player, instance->targets[0].card, KILL_SACRIFICE);
                }
            }
             
        }
        
        for( p = 0; p < 2; p++){
            int count = active_cards_count[p];
            while(count >= 0 ){
                card_data_t card_d = get_card_data(p, count);
                if( in_play(p, count) && (card_d.type & TYPE_CREATURE) ){
                    damage_creature(p, count, instance->info_slot, player, card);
                }
                count--;
            }
        }
        
        kill_card(player, card, KILL_DESTROY);
    }
    return 0;
}

int card_lava_spike(int player, int card, event_t event){
    arcane(player, card, event);
    return card_lava_spike_exe(player, card, event);
}

int card_hammer_of_bogardan(int player, int card, event_t event){
    card_instance_t *instance= get_card_instance(player, card);
    if( event == EVENT_GRAVEYARD_ABILITY_UPKEEP ){
        if( ! has_mana_multi(player, 2, 0, 0, 0, 3, 0) ){
            return -2;
        }
        int choice = do_dialog(player, player, card, -1, -1," Return Hammer to hand\n Leave Hammer be\n", 0);
        if( choice == 0 ){
            charge_mana_multi(player, 2, 0, 0, 0, 3, 0);
            if( spell_fizzled != 1 ){
                instance->state &= ~STATE_INVISIBLE;
                hand_count[player]++;
                return -1;
            }
            return -2;
        }
        else{
            return -2;
        }
    }
    return card_volcanic_hammer(player, card, event);
}

int card_desperate_ritual(int player, int card, event_t event){
    arcane(player, card, event);
    if( event == EVENT_CAN_CAST ){
        return 1;
    }
    else if( event == EVENT_RESOLVE_SPELL ){
        produce_mana(player, COLOR_RED, 3);
        if( ! in_hand(player, card) ){
            kill_card(player, card, KILL_DESTROY);
        }
    }
    else if( event == EVENT_CAN_SPLICE ){
        return has_mana_multi(player, 1, 0, 0, 0, 1, 0);
    }
    else if( event == EVENT_SPLICE ){
        charge_mana_multi(player, 1, 0, 0, 0, 1, 0);
    }
    return 0;
}

int card_smash_to_smithereens(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_ARTIFACT);
    if( event == EVENT_CAN_CAST ){
        if(  target_available(player, card, &td) ){
            return 1;
        }
    }
    else if( event == EVENT_CAST_SPELL ){
        if( ! affect_me(player, card) ){ return 0; }
        if( ! select_target(player, card, &td, "Select target artifact", NULL) ){
            spell_fizzled = 1;
        }
    }
    else if( event == EVENT_RESOLVE_SPELL ){
        card_instance_t *instance = get_card_instance(player, card);
        if(validate_target(player, card, &td, 0)){
            damage_player(instance->targets[0].player, 3, player, card);
            kill_card( instance->targets[0].player, instance->targets[0].card, KILL_DESTROY );
        }
        kill_card(player, card, KILL_DESTROY);
    }
    return 0;
}

int card_incinerate(int player, int card, event_t event){
    if(event == EVENT_RESOLVE_SPELL){
        if( spell_fizzled != 1 ){
            card_instance_t *instance = get_card_instance(player, card);
            if( instance->targets[0].card > -1 ){
                int effect = create_legacy_effect_exe(player, card, LEGACY_EFFECT_HURR, instance->targets[0].player, instance->targets[0].card);
                card_instance_t *effect_instance = get_card_instance(instance->targets[0].player, effect);
                effect_instance->token_status =0x800000;
                card_instance_t *target_instance = get_card_instance(instance->targets[0].player, instance->targets[0].card);
                target_instance->regen_status = 0x8000000;
            }
        }
    }
    int result =  card_lightning_bolt(player, card, event);
    return result;
}

int card_tribal_flames(int player, int card, event_t event){
    //card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_CAST ){
        return 1;
    } 
    else if( event == EVENT_CAST_SPELL ){
        if(! affect_me(player, card)){ return 0; }
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE );
        td.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
        load_text(0, "TARGET_CREATURE_OR_PLAYER");
        if(!select_target(player, card, &td, text_lines[0], NULL)){
            spell_fizzled = 1;
        }
    }
    else if(event == EVENT_RESOLVE_SPELL ){
        damage_creature_or_player(player, card, event, count_domain(player, card), 3);
        kill_card(player, card, KILL_DESTROY );
    }
    return 0;
}

int card_volcanic_fallout(int player, int card, event_t event){
    if(event == EVENT_CAST_SPELL ){
        card_instance_t *instance = get_card_instance(player, card);
        instance->state |= STATE_CANNOT_TARGET;
    }
    else if( event == EVENT_RESOLVE_SPELL ){
        damage_player(HUMAN, 2, player, card);
        damage_player(AI, 2, player, card);
    }
    return card_pyroclasm(player, card, event);
}

int card_burning_wish(int player, int card, event_t event){
    return generic_wish(player, card, event, TYPE_SORCERY, 84 );
}

int card_goblin_lore(int player, int card, event_t event){
    if(event == EVENT_CAN_CAST){
        return 1;
    }
    else if(event == EVENT_RESOLVE_SPELL){
        draw_cards(player, 4);
        int i;
        for(i = 0; i < 3; i++){
            discard(player, 1, 0);
        }
        kill_card(player, card, KILL_BURY);
    }
    return 0;
}

int card_browbeat(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance( player, card );
    if(event == EVENT_CAN_CAST ){
        return 1;
    }
    else if(event == EVENT_CAST_SPELL ){
        if( ! affect_me(player, card) ){ return 0; }
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.zone = TARGET_ZONE_PLAYERS;
        if( ! select_target(player, card, &td, "Choose a target player", NULL) ){
            spell_fizzled = 1;
        }
    }
    else if(event == EVENT_RESOLVE_SPELL ){
        int p;
        int AI_choice = 1;
        if(life[AI] > 9 && player != AI ){
            AI_choice = 0;
        }
        for(p=0;p<2;p++){
            int choice = do_dialog(p, player, card, -1, -1, " Take 5\n No Thanks", AI_choice);
            if(choice == 0){
                instance->info_slot = 1;
                damage_player(p, 5, player, card);
            }
        }
        if( instance->info_slot != 1 ){
            draw_cards(instance->targets[0].player, 3);
        }
        kill_card(player, card, KILL_DESTROY);
    }
    return 0;
}

int is_goblin_tutor(int player, int card ){
    card_instance_t *instance = get_card_instance( player, card );
    if( cards_data[ instance->internal_card_id ].id == 1813 ){
        return 1;
    }
    return 0;
}

int card_goblin_tutor(int player, int card, event_t event){
    if(event == EVENT_CAN_CAST){
        return 1;
    }
    else if(event == EVENT_RESOLVE_SPELL){
        int roll = rand(6) + 1;
        int type = 0;;
        if( roll == 1 ){
            reveal_card(player, player, card, player, card, "You rolled 1, no effect", 1);
        }
        else if( roll == 2 ){
            reveal_card(player, player, card, player, card, "You rolled 2, search for Goblin Tutor", 1);
            tutor(player, TYPE_INSTANT, &is_goblin_tutor, TUTOR_HAND );
        }
        else if( roll == 3 ){
            reveal_card(player, player, card, player, card, "You rolled 3, find an Enchantment", 1);
            type = TYPE_ENCHANTMENT;
        }
        else if( roll == 4 ){
            reveal_card(player, player, card, player, card, "You rolled 4, find an Artifact", 1);
            type = TYPE_ARTIFACT;
        }
        else if( roll == 5 ){
            reveal_card(player, player, card, player, card, "You rolled 5, find a Creature", 1);
            type = TYPE_CREATURE;
        }
        else if( roll == 6 ){
            reveal_card(player, player, card, player, card, "You rolled 6, find an Instant or Sorcery", 1);
            type = TYPE_INSTANT | TYPE_SORCERY | TYPE_INTERRUPT;
        }
        
        if( roll > 2 ){
            type_tutor(player, card, EVENT_RESOLVE_SPELL, type, 0, 0, 0);
        }
        kill_card(player, card, KILL_DESTROY);
    }
    return 0;
}

int card_hidetsugus_second_rite(int player, int card, event_t event){   
    if( event == EVENT_CAN_CAST ){
        return 1;
    }
    else if(event == EVENT_CAST_SPELL ){
        if( ! affect_me(player, card) ){ return 0; }
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.zone = TARGET_ZONE_PLAYERS;
        if( ! select_target(player, card, &td, "Choose a target player", NULL) ){
            spell_fizzled = 1;
        }
    }
    else if(event == EVENT_RESOLVE_SPELL ){
        card_instance_t *instance = get_card_instance(player, card);
        int target = instance->targets[0].player;
        if( life[ target ] == 10 ){
            damage_player(target, 10, player, card);
        }
        kill_card(player, card, KILL_DESTROY);
    }
    return 0;
}

int card_fireblast(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_LAND);
    td.required_subtype = SUBTYPE_MOUNTAIN;
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.illegal_abilities = 0;
    td.allow_cancel = 0;
    
    if( event == EVENT_MODIFY_COST ){
        if( target_available(player, card, &td) > 1 ){
            COST_COLORLESS-=4;
            COST_RED-=2;
        }
    }
    else if(event == EVENT_CAST_SPELL ){
        int pitch = 0;
        int choice = 1;
        if( ! affect_me(player, card) ){
            return 0;
        }
        if( target_available(player, card, &td) > 1 ){
            pitch = 1;
        }
        if( pitch == 1 && has_mana_multi(player, 4, 0, 0, 0, 2, 0) ){
            char buffer[50];
            sprintf(buffer, " Sacrifice 2 Mountains\n Pay 4RR" );
            choice = do_dialog(player, player, card, -1, -1, buffer, 1);
        }
        else if(pitch == 1){
            choice = 0;
        }
        
        if( choice == 1 && pitch == 1){
            charge_mana_multi(player, 4, 0, 0, 0, 2, 0);
        }
        else if(choice == 0){
            card_instance_t *instance = get_card_instance(player, card);
            int i;    
            for(i=0;i<2;i++){
                select_target(player, card, &td, "Sacrifice a Mountain", NULL);
                int target = instance->targets[0].card;
                kill_card( player, target, KILL_SACRIFICE );
            }
        }
        default_target_definition(player, card, &td, TYPE_CREATURE );
        td.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
        td.allow_cancel = 0;
        load_text(0, "TARGET_CREATURE_OR_PLAYER");
        if(!select_target(player, card, &td, text_lines[0], NULL)){
            spell_fizzled = 1;
        }
        return 0;
    }
    return card_lightning_blast(player, card, event);
}

int card_thoughts_of_ruin(int player, int card, event_t event){    
    if( event == EVENT_RESOLVE_SPELL ){  
        int p, i;
        target_definition_t td;
        for(i=0;i<2;i++){
            p = player;
            if( i == 1){ p = 1-player; }
                      
            // sac a land
            default_target_definition(player, card, &td, TYPE_LAND);
            td.illegal_abilities = 0;
            td.allowed_controller = p;
            td.preferred_controller = p;
            td.who_chooses = p;
            td.allow_cancel = 0;
            int j;
            for(j=0;j<hand_count[player];j++){
                if( target_available(player, card, &td) ){
                    select_target(player, card, &td, "Sacrifice a Land", NULL);
                    card_instance_t *instance = get_card_instance(player, card);
                    kill_card(instance->targets[0].player, instance->targets[0].card, KILL_SACRIFICE);
                }
            }
             
        }
        kill_card(player, card, KILL_DESTROY);
    }
    else if ( event == EVENT_CAN_CAST ){
        return 1;
    }
    return 0;
}

int card_price_of_progress(int player, int card, event_t event){
    int p;
    if(event == EVENT_CAN_CAST){
        return 1;
    }
    else if(event == EVENT_RESOLVE_SPELL){
        for( p = 0; p < 2; p++){
            int count = 0;
            int damage = 0;
            while(count < active_cards_count[p]){
                card_data_t card_d = get_card_data(p, count);
                if( (card_d.type & TYPE_LAND)  && in_play(p, count) && ! is_basic_land(p, count) ){
                    damage += 2;
                }
                count++;
            }
            damage_player(p, damage, player, card);  
        }
        kill_card(player, card, KILL_BURY);
    }
    return 0;
}

int card_gamble(int player, int card, event_t event){
  int result = card_demonic_tutor(player, card, event);
  if( event == EVENT_RESOLVE_SPELL ){
    discard(player, 1, 1);
  }
  return result;
}

int card_goblin_grenade(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_GOBLIN;
    td.allowed_controller = player;
    td.preferred_controller = player;

    card_instance_t *instance = get_card_instance(player, card);
    
    if(event == EVENT_CAN_CAST && target_available(player, card, &td)){
        return 1; 
    }
    else if(event == EVENT_CAST_SPELL ){
        if(!affect_me(player, card)){ return 0; }
        if(!select_target(player, card, &td, "Sacrifice a Goblin", NULL)){
            spell_fizzled = 1;
        }
        else{
            kill_card(instance->targets[0].player, instance->targets[0].card, KILL_SACRIFICE );
            
            default_target_definition(player, card, &td, TYPE_CREATURE );
            td.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
            td.allow_cancel = 0;
            load_text(0, "TARGET_CREATURE_OR_PLAYER");
            if(!select_target(player, card, &td, text_lines[0], NULL)){
                spell_fizzled = 1;
            }
        }
    }
    else if(event == EVENT_RESOLVE_SPELL ){
        damage_creature_or_player(player, card, event, 5, 3);
        kill_card(player, card, KILL_DESTROY);
    }
    return 0;
}



int card_rite_of_flame(int player, int card, event_t event){
    if(event == EVENT_CAN_CAST ){
        return 1; 
    }
    else if(event == EVENT_RESOLVE_SPELL ){
        int count = count_graveyard_by_id(HUMAN, 1730);
        count += count_graveyard_by_id(AI, 1730);
        produce_mana(player, COLOR_RED, 2 + count );
        kill_card(player, card, KILL_DESTROY);
    }
    return 0;
}

int card_obliterate(int player, int card, event_t event){
    if(event == EVENT_CAST_SPELL && affect_me(player, card) ){
        card_instance_t *instance = get_card_instance(player, card);
        instance->state |= STATE_CANNOT_TARGET;
    }
    return card_jokulhaups(player, card, event);
}

int card_fork(int player, int card, event_t event){
    int result =  card_fork_orig(player, card, event);
    if(event == EVENT_CAN_CAST ){
        if( result == 0 ){
            return 0;
        }
        card_data_t card_d = get_card_data(card_on_stack_controller, card_on_stack);
        if( card_d.type & TYPE_CREATURE ){
            return 0;
        }
    }
    return result;
}
    
int card_dragonstorm(int player, int card, event_t event){
    int *deck = deck_ptr[player];
    if(event == EVENT_CAN_CAST ){
        return 1; 
    } 
    else if(event == EVENT_CAST_SPELL ){
        if( ! affect_me(player, card) ){ return 0; }
        int i;
        for(i=0;i<get_storm_count();i++){
            int selected = pick_card_from_deck(player);
            if( selected != -1){
                card_data_t card_d = cards_data[deck[selected]];    
                card_ptr_t* c = cards_ptr[card_d.id];
                if(card_d.type & TYPE_CREATURE && (c->subtype1 == SUBTYPE_DRAGON || c->subtype2 == SUBTYPE_DRAGON)){
                    int card_added = add_card_to_hand(player, deck[selected] );
                    put_into_play(player, card_added);
                    remove_card_from_deck( player, selected );
                }
            }
        }
        shuffle(player);
    }
    else if(event == EVENT_RESOLVE_SPELL ){
        int selected = pick_card_from_deck(player);
        if( selected != -1){
            card_data_t card_d = cards_data[deck[selected]];    
            card_ptr_t* c = cards_ptr[card_d.id];
            if(card_d.type & TYPE_CREATURE && (c->subtype1 == SUBTYPE_DRAGON || c->subtype2 == SUBTYPE_DRAGON)){
                int card_added = add_card_to_hand(player, deck[selected] );
                put_into_play(player, card_added);
                remove_card_from_deck( player, selected );
            }
        }
        shuffle(player);
        kill_card(player, card, KILL_DESTROY);
    }
    return 0;
}

int card_empty_the_warrens(int player, int card, event_t event){
    if(event == EVENT_CAN_CAST ){
        return 1; 
    } 
    else if(event == EVENT_CAST_SPELL ){
        if( ! affect_me(player, card) ){ return 0; }
        int i;
        for(i=0;i<get_storm_count();i++){
             generate_token(player, "Goblin" );
             generate_token(player, "Goblin" );
        }
    }
    else if(event == EVENT_RESOLVE_SPELL ){
        generate_token(player, "Goblin" );
        generate_token(player, "Goblin" );
        kill_card(player, card, KILL_DESTROY);
    }
    return 0;
}

int card_burning_inquiry(int player, int card, event_t event){

  if(event == EVENT_CAN_CAST && affect_me(player, card) ){
     return 1;
  }

  else if(event == EVENT_RESOLVE_SPELL && affect_me(player, card) ){
          int i;
          for(i = 0; i < 2; i++){
              draw_cards(i, 3);
              int k;
              int size = 3;
              if(hand_count[i] < size) {
                 size = hand_count[i];
              }
              for(k = 0; k < size; k++){
                  discard(i, 1, 0); 
              }
          }
          kill_card(player, card, KILL_DESTROY);
  }

  return 0;
}


