#include "manalink.h"
int simple_dialog(int player, int card, const char* string){     
    char buffer[20];
    load_text(0, string);
    sprintf(buffer, " %s\n %s", text_lines[0], text_lines[1]);
    return do_dialog(player, player, card, -1, -1, buffer, 0);
}        


int cmc_is_one(int player, int card){
    if( get_cmc(player, card) <= 1 ){
        return 1;
    }
    return 0;
}

int card_auriok_salvagers(int player, int card, event_t event){
    int *grave = graveyard_ptr[player];
    if( event == EVENT_CAN_ACTIVATE && has_mana_multi(player, 1, 0, 0, 0, 0, 1) ){
        // check grave for artifact with CMC <= 1
        int i;
        for(i=0;i<count_graveyard(player);i++){
            card_data_t card_d = cards_data[ grave[i]  ]; 
            if( ( card_d.type & TYPE_ARTIFACT ) && get_cmc_by_internal_id( grave[i] ) <= 1 ){
                return 1;
            }
        }
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 1);
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int card_added = -1;
        while(1){
            int selected = show_deck( player, graveyard_ptr[player], 500, "Pick an artifact with CMC 1 or less", 0, 0x7375B0 );
            if( selected != -1){
                if ( ( cards_data[ grave[selected] ].type & TYPE_ARTIFACT ) && get_cmc_by_internal_id( grave[selected] ) <= 1  ){
                    card_added =  add_card_to_hand(player, grave[selected] );
                    remove_card_from_grave(player, selected);
                    return 0;
                }
            }        
        }
    }
    return 0;
}        
        
int card_exalted_angel(int player, int card, event_t event){
    lifelink(player, card, event);
    return morph(player, card, event, 2, 0, 0, 0, 0, 2);
}

int card_whipcorder(int player, int card, event_t event){
    return card_master_decoy(player, card, event) + morph(player, card, event,0, 0, 0, 0, 0, 1);
}

int card_oracles_attendants(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance( player, card );
    int result = 0;
        target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    if( event == EVENT_CAN_ACTIVATE || event == EVENT_ACTIVATE ){
        result = card_samite_healer(player, card, event);
    }
    if( event == EVENT_ACTIVATE && spell_fizzled != 1 ){
        // Choose a target creature too
        instance->targets[1].player = instance->targets[0].player;
        instance->targets[1].card = instance->targets[0].card;
        pick_target(&td, "TARGET_CREATURE");
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *source = get_card_instance(instance->targets[1].player, instance->targets[1].card);
        if( damage_card != source->internal_card_id ){
            return 0;
        }
        if( source->damage_target_player == instance->targets[0].player
            && source->damage_target_card == instance->targets[0].card )
        {
            source->damage_target_player = player;
            source->damage_target_card = instance->parent_card;
        }
    }
    return result;     
}
    
int effect_blinding_angel(int player, int card, event_t event){
    if( player != current_turn && eot_trigger(player, card, event) ){
        kill_card(player, card, KILL_SACRIFICE );
    }
    else if( event == EVENT_ATTACK_LEGALITY && player != current_turn  ){
        event_result = 1;
    }
    return 0;
}

int card_blinding_angel(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( current_turn == player && ( current_phase == PHASE_FIRST_STRIKE_DAMAGE || current_phase == PHASE_NORMAL_COMBAT_DAMAGE ) ){
        if( event == EVENT_RESOLVE_TRIGGER ){
            if(!affect_me(player, card)){ return  0; }
            if( ! is_unblocked( player, card) ){ return 0; }
            create_legacy_effect(player, card, &effect_blinding_angel );
            instance->damage_source_player = -1;
        }
        else{
            card_hypnotic_specter(player, card, event);
        }
    }
    return 0;
}

int card_jareth_leonine_titan(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    check_legend_rule(player, card, event);
    if( event == EVENT_CAN_ACTIVATE ){
        return has_mana(player, COLOR_WHITE, 1);
    }
    else if( event == EVENT_ACTIVATE ){
        charge_mana(player, COLOR_WHITE, 1);
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        int ai_choice = get_deck_color(player, 1-player);
        int color = choose_a_color(player, ai_choice);
        int keyword = KEYWORD_PROT_BLACK;
        if( color == 2 ){
            keyword = KEYWORD_PROT_BLUE;
        }
        else if( color == 3 ){
            keyword = KEYWORD_PROT_GREEN;
        }
        else if( color == 4 ){
            keyword = KEYWORD_PROT_RED;
        }
        else if( color == 5 ){
            keyword = KEYWORD_PROT_WHITE;
        }
        pump_ability_until_eot(player, card, instance->parent_controller, instance->parent_card, 0, 0, keyword );
    }
    else if( event == EVENT_DECLARE_BLOCKERS ){
        if( instance->blocking > -1 && instance->blocking < 255 ){
            pump_until_eot(player, card, player, card, 7, 7 );
        }
    }
    return 0;

}

int card_essence_sliver(int player, int card, event_t event){
    if( ! is_unlocked(player, card, event, 28) ){ return 0; }
    int p, j;
    for(p=0;p<2;p++){
        for(j=0;j<active_cards_count[p];j++){
            if( has_subtype(p, j, SUBTYPE_SLIVER) ){
                lifelink(p, j, event);
            }
        }
    }
    return 0;
}

int card_magus_of_the_tabernacle(int player, int card, event_t event){
    if( trigger_condition == TRIGGER_COMES_INTO_PLAY ){
        return 0;
    }
    return card_the_tabernacle_at_pendrell_vale(player, card, event);
}

void double_strike(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    
    // determine this creature's combat buddy
    if( current_phase == PHASE_FIRST_STRIKE_DAMAGE ){
        int buddy = -2;
        if(  instance->state & STATE_ATTACKING ){
            buddy = -1;
            int count = 0;
            while(count < active_cards_count[1-player]){
                if(in_play(1-player, count) ){
                    card_instance_t *instance2 = get_card_instance( 1-player, count);
                    if( instance2->blocking == card ){
                        buddy = count;
                        break;
                    }
                }
                count++;
            }
        }
        else if( instance->blocking > -1 && instance->blocking < 255 ){
            buddy = instance->blocking;
        }
        instance->targets[8].card = buddy;
        poison_counters[AI] = buddy;   
    }
    else if( current_phase == PHASE_NORMAL_COMBAT_DAMAGE ){
        poison_counters[HUMAN] = 1;
    if( instance->targets[8].card != -2 ){
        if( instance->targets[8].card == -1 ){
            instance->targets[8].card = -2;
            damage_player(1-player, get_power( player, card ), player, card); 
        }
        else if( instance->targets[8].card > -1 && in_play(1-player, instance->targets[8].card) ){
            life[HUMAN] = instance->targets[8].card;
            damage_creature(1-player, instance->targets[8].card, get_power( player, card ), player, card);
            instance->targets[8].card = -2;
        }
    }}
    else if( event == EVENT_ABILITIES ){
        event_result |= KEYWORD_FIRST_STRIKE;
    }
}

int card_baneslayer_angel(int player, int card, event_t event){
    lifelink(player, card, event);
    if(event == EVENT_BLOCK_LEGALITY ){
        if(player == attacking_card_controller && card == attacking_card ){
            if( has_creature_type(affected_card_controller, affected_card, SUBTYPE_DRAGON)
                || has_creature_type(affected_card_controller, affected_card, SUBTYPE_DEMON) )
            {
                event_result = 1;
            }   
        }      
    }
    else if( event == EVENT_ABILITIES ){
        if( ! affect_me(player, card) ){ return 0; }
        if( current_turn == 1-player && (current_phase == PHASE_FIRST_STRIKE_DAMAGE || current_phase == PHASE_NORMAL_COMBAT_DAMAGE ) ){
            card_instance_t *instance = get_card_instance(player, card);
            if( instance->blocking < 0 ||instance->blocking > 100 ){ return 0; }
            if( has_subtype(1-player, instance->blocking, SUBTYPE_DRAGON)
                 || has_subtype(1-player, instance->blocking, SUBTYPE_DEMON )    
                 )
            {
                event_result |= KEYWORD_PROT_BLACK;
                event_result |= KEYWORD_PROT_RED;
                event_result |= KEYWORD_PROT_BLUE;
                event_result |= KEYWORD_PROT_GREEN;
                event_result |= KEYWORD_PROT_WHITE;
                event_result |= KEYWORD_PROT_ARTIFACTS;
            }    
        }
    }
    return 0;
}

int card_sanctum_gargoyle( int player, int card, event_t event){
    colored_artifact(player, card, event);
    return card_sanctum_gargoyle_exe( player, card, event);
}

int card_veteran_armorsmith( int player, int card, event_t event){
    if( affected_card_controller == player && has_creature_type(player, affected_card, SUBTYPE_SOLDIER) && ! affect_me(player, card) && in_play(player, card) ){
        if( event == EVENT_TOUGHNESS ){
            event_result++;
        }
    }
    return 0;
}

int card_veteran_swordsmith( int player, int card, event_t event){
   if( affected_card_controller == player && has_creature_type(player, affected_card, SUBTYPE_SOLDIER) && ! affect_me(player, card) && in_play(player, card) ){
        if( event == EVENT_POWER ){
            event_result++;
        }
    }
    return 0;
}

int card_field_marshal( int player, int card, event_t event){
   if( has_creature_type(affected_card_controller, affected_card, SUBTYPE_SOLDIER) && ! affect_me(player, card) && in_play(player, card) ){
        if( event == EVENT_POWER || event == EVENT_TOUGHNESS){
            event_result++;
        }
        else if( event == EVENT_ABILITIES ){
            event_result |= KEYWORD_FIRST_STRIKE;
        }
    }
    return 0;
}

int card_captain_of_the_watch( int player, int card, event_t event){
    if( comes_into_play(player, card, event) == 1 ){
        generate_token(player, "Soldier");
        generate_token(player, "Soldier");
        generate_token(player, "Soldier");
    }
    
    vigilance(player, card );
    if( affected_card_controller == player && has_creature_type(player, affected_card, SUBTYPE_SOLDIER) && ! affect_me(player, card) && in_play(player, card) ){
        vigilance(player, affected_card);
        if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
            event_result++;
        }
    }
    
    if( leaves_play(player, card, event) == 1 ){
        int i;
        for(i=0;i<active_cards_count[player];i++){
            card_instance_t *creature = get_card_instance(player, i);
            creature->state &= ~STATE_VIGILANCE;
        }
    }
    
    return 0;
}

int card_preeminent_captain( int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_DECLARE_ATTACKERS && instance->state & STATE_ATTACKING ){
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_PERMANENT);
        td.zone = TARGET_ZONE_HAND;
        td.required_subtype = SUBTYPE_SOLDIER;
        td.illegal_abilities = 0;
        td.allowed_controller = player;
        td.preferred_controller = player;
        if( select_target(player, card, &td, "Choose a Soldier to put into play", NULL) ){
            put_into_play(player, instance->targets[0].card);
            hand_count[player]--;
        }
        card_instance_t *target_instance = get_card_instance(player, instance->targets[0].card);
        tap_card(player, instance->targets[0].card);
        target_instance->state |= STATE_ATTACKING;
    }
    return 0;
}


int card_serra_avatar(int player, int card, event_t event){
    if( affect_me(player, card) && ( event == EVENT_POWER || event == EVENT_TOUGHNESS ) ){
        event_result += life[player];
    }
    else if( event == EVENT_GRAVEYARD_ABILITY ){
        remove_card_from_grave(player, card);
        int *deck = deck_ptr[player];
        deck[ count_deck(player) ] = get_internal_card_id_from_csv_id(get_id_by_name("Serra Avatar")); 
        shuffle(player);
    }
    return 0;
}

int card_reveillark(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if(event == EVENT_CAST_SPELL ){
        if( ! affect_me(player, card) ){ return 0;  }
        int choice = 1;
        if( has_mana(player, COLOR_COLORLESS, 1) ){
            choice = do_dialog(player, player, card, -1, -1, " Pay 1 and sacrifice this\n Don't Evoke", 1);
        }
        
        if( choice == 0 ){
            charge_mana(player, COLOR_COLORLESS, 1);
            if( spell_fizzled != 1 ){
                instance->info_slot = 1;
            }
        }
    }
    else if( leaves_play(player, card, event) == 1  ){
        int *grave = graveyard_ptr[player];
        int i;
        for(i=0;i<2;i++){
            int selected = show_deck( player, grave, 500, "Pick a creature with power <= 2", 0, 0x7375B0 );
            if( selected != -1){
                card_data_t card_d = cards_data[ grave[selected] ];
                if( card_d.power <= 2 && card_d.type & TYPE_CREATURE ){
                    int card_added =  add_card_to_hand(player, grave[selected] );
                    put_into_play(player, card_added );
                    remove_card_from_grave(player, selected);
                }
            }
        }
    }
    else if( comes_into_play(player, card, event) == 1 && instance->info_slot == 1 ){
        int *grave = graveyard_ptr[player];
        int i;
        for(i=0;i<2;i++){
            int selected = show_deck( player, grave, 500, "Pick a creature with power <= 2", 0, 0x7375B0 );
            if( selected != -1){
                card_data_t card_d = cards_data[ grave[selected] ];
                if( card_d.power <= 2 && card_d.type & TYPE_CREATURE ){
                    int card_added =  add_card_to_hand(player, grave[selected] );
                    put_into_play(player, card_added );
                    remove_card_from_grave(player, selected);
                }
            }
        }
        kill_card(player, card, KILL_SACRIFICE);
    }
    return 0;
}

int card_ranger_of_eos(int player, int card, event_t event){
    if( comes_into_play(player, card, event) == 1 ){
        int card_added = tutor(player, TYPE_CREATURE, &cmc_is_one, TUTOR_HAND );
        if( card_added > -1 ){
            tutor(player, TYPE_CREATURE, &cmc_is_one, TUTOR_HAND );
        }
    }
    return 0;
}

int card_ancestors_chosen(int player, int card, event_t event){
  STANDARD_CIP_CHECK;

  if(event == EVENT_TRIGGER)
    event_result |= 2;
  else if(event == EVENT_RESOLVE_TRIGGER)
    gain_life(player, count_graveyard(player));

  return 0;
}
  
int card_pearl_dragon(int player, int card, event_t event){
    if(event == EVENT_CAN_ACTIVATE){
        if( has_mana_multi( player, 1, 0, 0, 0, 0, 1 )  ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE){
        int turn = current_turn;
        PAY_MANA_COLORLESS = 1;
        current_turn = AI;
        card_aven_flock(player, card, event);
        current_turn = turn;
    }
    else{
        return card_aven_flock(player, card, event);
    }
    return 0;
}

int card_soltari_trooper(int player, int card, event_t event){
    shadow(player, card, event);
    card_instance_t *instance = get_card_instance( player, card);
    if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
        if( ! affect_me(player, card) ){ return 0; }
        if( instance->state & STATE_ATTACKING ){
            instance->targets[8].card = 1;
        }
        if( instance->targets[8].card == 1 ){
            event_result++;    
        }
    }
    else if( current_phase == PHASE_DISCARD || comes_into_play(player, card, event) == 1){
        instance->targets[8].card = 0;  
    }
    return 0;
}

int card_wall_of_reverence(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if(current_turn == player && eot_trigger(player, card, event) ){
        if(! affect_me(player, card)){ return 0; }
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.allowed_controller = player;
        td.preferred_controller = player;
        
        // auto select the most powerful creature
        if( duh_mode(player) ){
            int i;
            int best_power = -1;
            int best_index = -1;
            instance->targets[0].player = player;
            for(i=-1;i<active_cards_count[player];i++){
                instance->targets[0].card = i;
                instance->number_of_targets = 0;
                if( valid_target(&td) && get_power(player, i) > best_power ){
                    best_power = get_power(player, i);
                    best_index = i;
                }
            }
            if( best_power > 0 ){
                instance->targets[0].card = best_index;
                gain_life(player, get_power(instance->targets[0].player, instance->targets[0].card) );
            }
        }
        else{
            if( select_target(player, card, &td, "Select a Creature you control", NULL) ){
                gain_life(player, get_power(instance->targets[0].player, instance->targets[0].card) );
            }
        }
    }
    return 0;
}

int card_akrasan_squire( int player, int card, event_t event){
    return exalted(player, card, event);
}

int card_battlegrace_angel( int player, int card, event_t event){
    exalted(player, card, event);
    card_instance_t *instance = get_card_instance(player, card);
    if( instance->targets[8].card == 1 ){
        lifelink( player, instance->targets[9].card, event );
    }
    return 0;
}


int card_soraya_the_falconer(int player, int card, event_t event)
{
  target_definition_t td;
  card_instance_t *instance, *target, *parent;
  int tmp;

  check_legend_rule(player, card, event);
  boost_creature_type(player, card, event, SUBTYPE_BIRD, 1, 1, 0, BCT_INCLUDE_SELF);

  if((event == EVENT_CAN_ACTIVATE) || (event == EVENT_ACTIVATE) || (event == EVENT_RESOLVE_ACTIVATION))
  {
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.required_subtype = SUBTYPE_BIRD;
    td.preferred_controller = player;

    if(event == EVENT_CAN_ACTIVATE)
    {
      if(has_mana(player, COLOR_ANY, 2) && has_mana(player, COLOR_WHITE, 1)
         && target_available(player, card, &td))
        return 1;
      else
        return 0;
    }
    else if(event == EVENT_ACTIVATE)
    {
      charge_mana_multi(player, 1, 0, 0, 0, 0, 1);
      if(spell_fizzled != 1)
      {
        load_text(0, "SORAYA");
        if(!select_target(player, card, &td, text_lines[0], NULL))
          spell_fizzled = 1;
      }
    }
    else
    {
      if(validate_target(player, card, &td, 0))
      {
        instance = get_card_instance(player, card);
        target = get_card_instance(instance->targets[0].player, instance->targets[0].card);
        target->regen_status = (1 << 27);
        tmp = ability_effect_keyword(instance->targets[0].player, instance->targets[0].card);
        if(tmp != -1)
        {
          parent = get_card_instance(player, tmp);
          parent->info_slot = KEYWORD_BANDING;
        }
      }
      else
        spell_fizzled = 1;

      instance = get_card_instance(player, card);
      parent = get_card_instance(instance->parent_controller, instance->parent_card);
      parent->number_of_targets = 0;
    }
  }

  return 0;
}

int card_academy_rector  (int player, int card, event_t event){
    if(event == EVENT_GRAVEYARD_FROM_PLAY){
        if( affect_me( player, card) && in_play(player, card) ){
            card_instance_t *instance = get_card_instance( player, card);
            if(instance->kill_code != KILL_REMOVE ){
                int choice = simple_dialog(player, card, "ACADEMY_RECTOR");
                if(choice == 0){            
                    int selected = pick_card_from_deck(player);
                    if( selected != -1){
                        int *deck = deck_ptr[player];
                        if ( cards_data[ deck[selected] ].type & TYPE_ENCHANTMENT ){
                            int card_added = add_card_to_hand(player, deck[selected] );
                            put_into_play(player, card_added );
                            remove_card_from_deck(player, selected);
                        }
                    
                    }
                    shuffle(player);
                    instance->kill_code = KILL_REMOVE;
                }
            }
        }
    }
    return 0;
}

int card_goldmeadow_stalwart(int player, int card, event_t event){
    return buddy_creature(player, card, event, SUBTYPE_KITHKIN);
}

void make_kithkin(int player){
    generate_token(player, "Kithkin Soldier");
    generate_token(player, "Kithkin Soldier");
    generate_token(player, "Kithkin Soldier");
}

int card_cloudgoat_ranger(int player, int card, event_t event){
    if( event == EVENT_CAN_ACTIVATE || event == EVENT_ACTIVATE ){
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.required_subtype = SUBTYPE_KITHKIN;
        td.allowed_controller = player;
        td.preferred_controller = player;
        td.allow_cancel = 0;
        td.illegal_state = TARGET_STATE_TAPPED;
        td.illegal_abilities = 0;
        if(event == EVENT_CAN_ACTIVATE){
           if( target_available(player, card, &td) >= 3 ){
                return 1;
            }
        }
        else if(event == EVENT_ACTIVATE){
            card_instance_t *instance = get_card_instance( player, card);
            int i = 0;
            for(i=0;i<3;i++){
                select_target(player, card, &td, "Choose an untapped Kithkin", NULL);
                tap_card( instance->targets[0].player, instance->targets[0].card );
            }
        }
    }
    else if(event == EVENT_RESOLVE_ACTIVATION){
        card_instance_t *instance = get_card_instance( player, card);
        card_instance_t *parent = get_card_instance(instance->parent_controller, instance->parent_card);
        if( parent->targets[9].card < 1 ){
            parent->targets[9].card = 1;
        }
        else{
            parent->targets[9].card++;
        }
    }
    else if( comes_into_play(player, card, event) == 1 ){
        make_kithkin(player);
    }
    else if( current_phase == PHASE_DISCARD ){
        card_instance_t *instance = get_card_instance(player, card);
        instance->targets[9].card = 0;  
    }
    else if( affect_me(player, card) ){
        card_instance_t *instance = get_card_instance(player, card);
        if(event == EVENT_POWER && instance->targets[9].card > 0){
            event_result += 2 * instance->targets[9].card;
        }
        else if(event == EVENT_ABILITIES && instance->targets[9].card > 0){
            event_result |= KEYWORD_FLYING;
        }
    }
    return 0;
}

int card_ivory_guardians(int player, int card, event_t event){
    if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
        if( get_id(affected_card_controller, affected_card ) == get_id(player, card)){ 
            target_definition_t td;
            default_target_definition(player, card, &td, TYPE_PERMANENT);
            td.required_color = COLOR_TEST_RED;
            td.allowed_controller = 1-player;
            td.preferred_controller = 1-player;
            if( target_available(player, card, &td) ){
                event_result++;
            }
        }
    }
    return 0;
}

int card_preacher(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.who_chooses = 1 - player;
    td.allowed_controller = 1 - player;
    td.preferred_controller = 1 - player;
    td.allow_cancel = 0;
    if( (!is_tapped(player, card) && instance->targets[0].card != -1) || (leaves_play(player, card, event) && instance->targets[0].card != -1) ){
        instance->targets[0].card = -1;
        kill_card(player, instance->info_slot, KILL_DESTROY);
    }
    if( event == EVENT_CAN_ACTIVATE ){
        if( !is_tapped(player, card) && !is_sick(player, card) && target_available(player, card, &td) ){
            return 1;
        }
    }
    else if( event == EVENT_ACTIVATE ){
        select_target(player, card, &td, "Select target creature for Preacher to gain control of", NULL);
        tap_card(player, card);
        instance->number_of_targets = 1;
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        if( !in_play(instance->parent_controller, instance->parent_card) || !is_tapped(instance->parent_controller, instance->parent_card) ){
            spell_fizzled = 1;
        }
        if( valid_target(&td) && spell_fizzled != 1 ){
            int legacy = gain_control(player, card, instance->targets[0].player, instance->targets[0].card);
            if( legacy > -1 ){
                card_instance_t *parent = get_card_instance(instance->parent_controller, instance->parent_card);
                parent->info_slot = legacy;
            }
        }
    }
    else {
        return card_tawnoss_weaponry(player, card, event);
    }
    return 0;
}

int card_knight_of_the_white_orchid(int player, int card, event_t event){

  if( comes_into_play(player, card, event) == 1 && count_permanents_by_type(player, card, TYPE_LAND) < count_permanents_by_type(1-player, card, TYPE_LAND) ){
     int count = 0;
     while(count++<50){
           int selected = pick_card_from_deck(player);
           if( selected != -1){
              int *deck = deck_ptr[player];
              card_ptr_t* b = cards_ptr[ cards_data[ deck[selected] ].id ];
              if ( cards_data[ deck[selected] ].type == TYPE_LAND && (b->subtype1 == SUBTYPE_PLAINS || b->subtype2 == SUBTYPE_PLAINS) ){
                  int card_added = add_card_to_hand(player, deck[selected] );
                  remove_card_from_deck( player, selected );
                  put_into_play(player, card_added);
                  shuffle(player);
                  break;
              }
           }
           else{
                break;
           }      
     }      
  }      

    return 0;
}

int card_karmic_guide(int player, int card, event_t event){
  echo(player, card, event, 3, 0, 0, 0, 0, 2);

  if( comes_into_play(player, card, event) == 1 && count_graveyard_by_type(player, TYPE_CREATURE) > 0 ){
     int selected = -1;  
     if ( player == AI ){
         selected = ai_best_reanimator_target(player, TYPE_CREATURE);
     }
     else{ 
          selected = select_target_from_graveyard(player, player, TYPE_CREATURE, 0, 0, 0, 0, 0, 0, 0, -1, 0);
     }
     reanimate_permanent(player, card, player, selected, 0, 0);
  }

    return 0;
}


