#include "manalink.h"

int multikicker(int player, int card, event_t event, int colorless, int black, int blue, int green, int red, int white){
    card_instance_t *instance = get_card_instance(player, card);
    if(instance->info_slot < 0){
        instance->info_slot = 0;
    }
    if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
        int choice = 0;
        instance->info_slot = 0;
        while( has_mana_multi(player, colorless, black, blue, green, red, white) && spell_fizzled != 1 && choice == 0){
            choice = do_dialog(player, player, card, -1, -1, " Pay Kicker\n Do not pay kicker", 0);  
            if( choice == 0 ){
                charge_mana_multi(player, colorless, black, blue, green, red, white);
                if( spell_fizzled != 1 ){
                    instance->info_slot++;
                }
            }
        }
    }
    return 0;
}

int multikicked(int player, int card){
    card_instance_t *instance = get_card_instance(player, card);
    return instance->info_slot;
}

int card_celestial_colonnade(int player, int card, event_t event){
    comes_into_play_tapped(player, card, event);
    return manland_normal(player, card, event, 3, 0, 1, 0, 0, 1, "Celestial Colonnade Animated");
}

int card_celestial_colonnade_animated(int player, int card, event_t event){
    vigilance(player, card);
    return manland_animated(player, card, event, 3, 0, 1, 0, 0, 1, "Celestial Colonnade");
}

int card_creeping_tar_pit(int player, int card, event_t event){
    comes_into_play_tapped(player, card, event);
    return manland_normal(player, card, event, 1, 1, 1, 0, 0, 0, "Creeping Tar Pit Animated");
}

int card_creeping_tar_pit_animated(int player, int card, event_t event){
    unblockable(player, card, event);
    return manland_animated(player, card, event, 1, 1, 1, 0, 0, 0, "Creeping Tar Pit");
}

int card_stirring_wildwood(int player, int card, event_t event){
    comes_into_play_tapped(player, card, event);
    return manland_normal(player, card, event, 1, 0, 0, 1, 0, 1,   "Stirring Wildwood Animated");
}

int card_stirring_wildwood_animated(int player, int card, event_t event){
    return manland_animated(player, card, event, 1, 0, 0, 1, 0, 1, "Stirring Wildwood");
}

int effect_raging_ravine(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    card_instance_t *parent = get_card_instance(instance->targets[0].player, instance->targets[0].card);
    if( event == EVENT_DECLARE_ATTACKERS && parent->state & STATE_ATTACKING ){
        add_1_1_counter( instance->targets[0].player, instance->targets[0].card );   
    }
    else if( eot_trigger(player, card, event) ){
        kill_card(player, card, KILL_SACRIFICE);
    }
    return 0;
}

int card_raging_ravine(int player, int card, event_t event){
    comes_into_play_tapped(player, card, event);
    if( event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *instance = get_card_instance(player, card);
        create_targetted_legacy_effect(player, card, &effect_raging_ravine, player, instance->parent_card);
    }
    return manland_normal(player, card, event, 2, 0, 0, 1, 1, 0, "Raging Ravine Animated");
}

int card_raging_ravine_animated(int player, int card, event_t event){
    if( event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *instance = get_card_instance(player, card);
        create_targetted_legacy_effect(player, card, &effect_raging_ravine, player, instance->parent_card);
    }
    return manland_animated(player, card, event, 2, 0, 0, 1, 1, 0, "Raging Ravine");
}

int card_lavaclaw_reaches(int player, int card, event_t event){
    comes_into_play_tapped(player, card, event);
    return manland_normal(player, card, event, 1, 1, 0, 0, 1, 0, "Lavaclaw Reaches Animated");
}

int card_lavaclaw_reaches_animated(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAN_ACTIVATE ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE ){
        int choice = do_dialog(player, player, card, -1, -1, " +X/+0\n Other Ability \n Cancel", 0);
        if( choice == 0 ){
            charge_mana( player, COLOR_COLORLESS, -1);
            instance->targets[0].card = x_value;
            instance->targets[0].player = 3;
            return 0;
        }
        else if( choice == 2 ){
            spell_fizzled = 1;
            return 0;
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION && instance->targets[0].player == 3 ){
        card_instance_t *parent = get_card_instance(player, instance->parent_card);
        parent->targets[0].player = 0;
        pump_until_eot(player, card, player, instance->parent_card, instance->targets[0].card, 0);
        return 0;   
    }
    return manland_animated(player, card, event, 2, 0, 0, 1, 1, 0, "Raging Ravine");
}

int card_deaths_shadow(int player, int card, event_t event){
    if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
        if( affect_me(player, card) ){
            event_result -= life[player];
        }
    }
    return 0;
}

int card_treasure_hunt(int player, int card, event_t event){
    if( event == EVENT_CAN_CAST ){
        return 1;
    }
    else if( event == EVENT_RESOLVE_SPELL ){
        int *deck = deck_ptr[player];
        int i=0;
        while(i<500 && deck[i] != -1 ){
            card_data_t card_d = cards_data[ deck[i] ]; 
            if( ! ( card_d.type & TYPE_LAND ) ){
                if( player == AI ){
                    show_deck( HUMAN, deck_ptr[player], i+1, "These cards were revealed by Treasure Hunt", 0, 0x7375B0 );
                }
                i++;
                break;
            }
            i++;    
        }
        int j;
        for(j=0;j<i;j++){
            add_card_to_hand(player,  deck[0] );
            hand_count[player]++;
            remove_card_from_deck( player, 0 );
        }
        kill_card(player, card, KILL_DESTROY);
    }
    return 0;
}

int card_lodestone_golem(int player, int card, event_t event){
    if(event == EVENT_MODIFY_COST_GLOBAL ){
        card_data_t card_d = get_card_data(affected_card_controller, affected_card);
        if(! (card_d.type & TYPE_LAND) && ! (card_d.type & TYPE_ARTIFACT)){
            COST_COLORLESS++;
        }
    }
    return 0;
}

int card_novablast_wurm( int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_DECLARE_ATTACKERS && instance->state & STATE_ATTACKING ){
        int p;
        for( p = 0; p < 2; p++){
            int count = 0;
            while(count < active_cards_count[p]){
                card_data_t card_d = get_card_data(p, count);
                if((card_d.type & TYPE_CREATURE) && in_play(p, count) && ! (p==player && count == card) ){
                    kill_card( p, count, KILL_DESTROY );
                }
                count++;
            }
        }         
    }
    return 0;
}

int card_dragonmaster_outcast( int player, int card, event_t event){
    if(current_turn == player && count_permanents_by_type(player, card, TYPE_LAND) > 5 && upkeep_trigger(player, card, event)){
        generate_token(player, "Dragon (5/5)");
    }
    return 0;
}

int card_kalastria_highborn(int player, int card, event_t event){
    card_instance_t *instance= get_card_instance(player, card);
    if(event == EVENT_GRAVEYARD_FROM_PLAY){
        if( ! in_play(affected_card_controller, affected_card) ){ return 0; } 
        card_instance_t *affected= get_card_instance(affected_card_controller, affected_card);
        if(affected_card_controller == player && affected->kill_code != 4) {
            if( has_subtype(affected_card_controller, affected_card, SUBTYPE_VAMPIRE) ){
                if( instance->targets[11].player < 0 ){
                    instance->targets[11].player = 0;
                }
                instance->targets[11].player++;
            }
        }
    }
    
    if( resolve_graveyard_trigger(player, card, event) == 1 ){
        int i;
        for(i=0;i<instance->targets[11].player;i++){
            if( has_mana(player, COLOR_BLACK, 1) && do_dialog(player, player, card, -1, -1, " Pay B to drain for 2\n Do not pay", 0) == 0 ){
                charge_mana(player, COLOR_BLACK, 1 );
                if( spell_fizzled != 1 ){
                    life[opp] -=2;
                    life[player]+=2;
                }
            }
        }
        instance->targets[11].player = 0;
    }
    
    // same thing happens if I leave play
    if(event == EVENT_GRAVEYARD_FROM_PLAY){
        if( affect_me( player, card) && in_play(player, card) ){
            if(instance->kill_code != KILL_REMOVE && has_mana(player, COLOR_BLACK, 1) && do_dialog(player, player, card, -1, -1, " Pay B to drain for 2\n Do not pay", 0) == 0  ){
                charge_mana(player, COLOR_BLACK, 1 );
                if( spell_fizzled != 1 ){
                    life[opp] -=2;
                    life[player]+=2;
                }
            }
        }
    }
    
    return 0;
}

int card_chain_reaction(int player, int card, event_t event){
    if( event == EVENT_CAN_CAST ){
        return 1;
    }
    else if( event == EVENT_RESOLVE_SPELL ){
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.illegal_abilities = 0;
        int num = target_available(player, card, &td);
        int p;
        for( p = 0; p < 2; p++){
            int count = 0;
            while(count < active_cards_count[p]){
                card_data_t card_d = get_card_data(p, count);
                if((card_d.type & TYPE_CREATURE) && in_play(p, count) && ! (p==player && count == card) ){
                    damage_creature(p, count, num, player, card);
                }
                count++;
            }
        }         
        kill_card(player, card, KILL_DESTROY);
    }
    return 0;
}

int card_halimar_depths(int player, int card, event_t event){
    comes_into_play_tapped(player, card, event);
    if( comes_into_play(player, card, event) ){
        rearrange_top_x(player, player, 3);
    }
    return mana_producer_fixed(player, card, event, COLOR_BLUE);
}

int card_everflowing_chalice(int player, int card, event_t event){
    // do not let teh AI cast this for 0
    if( player == AI && event == EVENT_MODIFY_COST && ! has_mana_multi(AI, 2, 0, 0, 0, 0, 0) ){
        COST_COLORLESS += 2;
    }
    
    multikicker(player, card, event, 2, 0, 0, 0, 0, 0);
    if( multikicked(player, card) && comes_into_play(player, card, event) ){
        add_ccounters(player, card, multikicked(player, card) );
    }
    
    // generate mana
    int active = 1;
    if( is_tapped(player, card) || is_animated_and_sick(player, card ) ){
        active = 0;
    }
    if( event == EVENT_COUNT_MANA && active && affect_me(player, card) ){
        declare_mana_available(player, COLOR_COLORLESS, count_ccounters(player, card));
    }
    else if(event == EVENT_CAN_ACTIVATE ){
        return active;
    }
    else if(event == EVENT_ACTIVATE && active ){
        tap_card(player, card);
        produce_mana(player, COLOR_COLORLESS, count_ccounters(player, card));
        spell_fizzled = 1;
    }
    return 0;
}

int card_joraga_war_caller(int player, int card, event_t event){
    multikicker(player, card, event, 1, 0, 0, 1, 0, 0);
    if( multikicked(player, card) && comes_into_play(player, card, event) ){
        int i;
        for( i=0;i<multikicked(player, card);i++){
            add_1_1_counter(player, card);
        }
    }
    else if( affected_card_controller == player && has_creature_type(player, affected_card, SUBTYPE_ELF) && ! affect_me(player, card) ){
        if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
            event_result+=count_counters(player, card);
        }
    }
    return 0;
}

int card_wolfbriar_elemental(int player, int card, event_t event){
    multikicker(player, card, event, 0, 0, 0, 1, 0, 0);
    if( multikicked(player, card) && comes_into_play(player, card, event) ){
        int i=0;
        for(i=0;i<multikicked(player, card);i++){
            generate_token(player, "Wolf");
        }
    }
    return 0;
}

int card_slavering_nulls(int player, int card, event_t event){
    if( count_subtype(player, card, SUBTYPE_SWAMP, 0) ){
        return card_abyssal_specter(player, card, event);
    }
    return 0;
}

int card_leatherback_baloth(int player, int card, event_t event){
    if( ! is_unlocked(player, card, event, 38) ){ 
        kill_card(player, card, KILL_SACRIFICE);
    }
    return 0;
}

int card_urge_to_feed(int player, int card, event_t event){
    target_definition_t td1;
    default_target_definition(player, card, &td1, TYPE_CREATURE);
    
    if( event == EVENT_CAN_CAST && can_target(&td1) ){
        return 1;
    }
    else if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
        pick_target(&td1, "TARGET_CREATURE");
    }
    else if( event == EVENT_RESOLVE_SPELL  ){
        if(  valid_target(&td1) ){
            card_instance_t *instance= get_card_instance(player, card);
            pump_until_eot(player, card, instance->targets[0].player, instance->targets[0].card, -3, -3);
        
            target_definition_t td;
            default_target_definition(player, card, &td, TYPE_CREATURE);
            td.required_subtype = SUBTYPE_VAMPIRE;
            td.allowed_controller = player;
            td.preferred_controller = player;
            td.illegal_abilities = 0;
            td.illegal_state = TARGET_STATE_TAPPED;
            while( can_target(&td) && spell_fizzled != 1 ){
                if( select_target(player, card, &td, "Choose an untapped Vampire to tap", NULL) ){
                    tap_card( instance->targets[0].player, instance->targets[0].card );
                    add_1_1_counter( instance->targets[0].player, instance->targets[0].card  );
                }
                else{
                    spell_fizzled = 1;
                }
            }  
        }
        kill_card(player, card, KILL_DESTROY);  
    }
    return 0;
}

int card_jace_the_mind_sculptor(int player, int card, event_t event){
    int costs[4] = { 2, 0, -1, -12 };
    card_instance_t *instance = get_card_instance(player,card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.allow_cancel = 0;
    if ( event == EVENT_ACTIVATE ) {
        int choice;
        instance->number_of_targets = 0;
        if ( count_counters(player, card) >= 12 ) {
            choice = do_dialog(player, player, card, -1, -1,  " Scry/Fateseal 1\n Brainstorm\n Unsummon\n Exile Library\n", 3);
        }
        else {
            choice = do_dialog(player, player, card, -1, -1, " Scry/Fateseal 1\n Brainstorm\n Unsummon\n", 1);
        }
        
        // cancel selection if unsummon was chosen without a creature in play
        if( choice == 2 && ! can_target(&td) ){
            spell_fizzled = 1;
            return 0;
        }
            
        instance->targets[10].player = choice;
        set_counters(player, card, count_counters(player, card) + costs[choice] );
        if ( choice == 0 || choice == 3 ) {
            td.zone = TARGET_ZONE_PLAYERS;
            pick_target(&td, "TARGET_PLAYER");
        }
        else if( choice == 2 ){
            pick_target(&td, "TARGET_CREATURE");
        }
    }
    else if ( event == EVENT_RESOLVE_ACTIVATION ) {
        if ( instance->targets[10].player == 0 ) {
            int choice;
            show_deck( player, deck_ptr[instance->targets[0].player], 1, "Jace Reveals...", 0, 0x7375B0 );
            choice = do_dialog(player, player, card, -1, -1, " Top\nBottom\n", 1);
            if ( choice == 1 ){
                put_top_card_of_deck_to_bottom(instance->targets[0].player);
            }
        }   
        else if ( instance->targets[10].player == 1 ) {
            draw_cards(player, 3);
            int i;
            default_target_definition(player, card, &td, TYPE_ANY);
            td.zone = TARGET_ZONE_HAND;
            td.illegal_abilities = 0;
            td.allow_cancel = 0;
            td.allowed_controller = player;
            td.preferred_controller = player;
            for(i=0;i<2;i++){
                select_target(player, card, &td, "Choose a card to put on deck", NULL);
                put_on_top_of_deck(player, instance->targets[0].card);
                hand_count[player]--;
            }
        }
        else if ( instance->targets[10].player == 2 && valid_target(&td) ) {
            bounce_permanent(instance->targets[0].player, instance->targets[0].card);
        }
        else if ( instance->targets[10].player == 3 ){
            int p = instance->targets[0].player;
            while( count_deck(p) > 0 ){
                rfg_top_card_of_deck(p);
            }
            int i=0;
            while( i < active_cards_count[p] ){
                if( in_hand(p, i) ){
                    put_on_top_of_deck(p, i);
                }
                i++;
            }
            shuffle(p);
        }
   }
   return planeswalker(player, card, event, 3);
}

int card_stoneforge_mystic( int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_ARTIFACT);
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.illegal_abilities = 0;
    td.zone = TARGET_ZONE_HAND;
    td.required_subtype = SUBTYPE_EQUIPMENT;
        
    if( comes_into_play(player, card, event ) == 1 ){
        int count = 0;
        int *deck = deck_ptr[player];
        while(count++<50){
            int selected = pick_card_from_deck(player);
            if( selected != -1){
                card_data_t card_d = cards_data[deck[selected]];    
                card_ptr_t* c = cards_ptr[card_d.id];
                if(c->subtype1 == SUBTYPE_EQUIPMENT || c->subtype2 == SUBTYPE_EQUIPMENT){
                    add_card_to_hand(player, deck[selected] );
                    hand_count[player]++;
                    remove_card_from_deck( player, selected );
                    break;
                }
            }
            else{
                break;
            }
        }
        gain_life(player, 0);
        shuffle(player);
    }
    else if(event == EVENT_CAN_ACTIVATE){
        if( ! is_tapped(player, card) && has_mana_multi(player, 1, 0, 0, 0, 0, 1) && ! is_sick(player, card) && can_target(&td) ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE){
        charge_mana_multi(player, 1, 0, 0, 0, 0, 1);
        if( spell_fizzled != 1 ){
            tap_card( player, card);
        }
        return 0;
    }
    else if(event == EVENT_RESOLVE_ACTIVATION ){
        if( select_target(player, card, &td, "Choose an Equipment to put into play", NULL) ){
            card_instance_t *instance= get_card_instance(player, card);
            put_into_play(player, instance->targets[0].card);
            hand_count[player]--;
        }
    }
    return 0;
}

int card_eye_of_ugin(int player, int card, event_t event){
    check_legend_rule(player, card, event);
    if(event == EVENT_MODIFY_COST_GLOBAL && affected_card_controller == player ){
        int p = affected_card_controller;
        int c = affected_card;
           if(has_subtype(p, c, SUBTYPE_ELDRAZI) && is_colorless(p, c) ){        
            COST_COLORLESS-=2;
        }
    }
    
    if(event == EVENT_CAN_ACTIVATE ){
        if( ! is_tapped(player, card) && has_mana_multi(player, 7, 0, 0, 0, 0, 0) ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE ){
        charge_mana_multi(player, 7, 0, 0, 0, 0, 0);
        if( spell_fizzled != 1 ){
            tap_card(player, card);
        }
    }    
    else if(event == EVENT_RESOLVE_ACTIVATION ){
        int count = 0;
        while(count++<50){
            int selected = pick_card_from_deck(player);
            if( selected != -1){
                int *deck = deck_ptr[player];
                if ( cards_data[ deck[selected] ].type & TYPE_CREATURE ){
                    card_ptr_t* c = cards_ptr[ cards_data[ deck[selected] ].id ];
                    if( c->req_black + c->req_blue + c->req_green + c->req_white + c->req_red == 0 ){
                        add_card_to_hand(player, deck[selected] );
                        remove_card_from_deck( player, selected );
                        hand_count[player]++;
                        break;
                    }
                }
            }
            else{
                break;
            }      
        }
        gain_life(player, 0);
        shuffle(player);
    }
    return 0;  
}

int card_arbor_elf(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_LAND);
    td.required_subtype = SUBTYPE_FOREST;
        
    if(event == EVENT_CAN_ACTIVATE ){
        if( ! is_tapped(player, card) && ! is_sick(player, card) && can_target(&td) ){
            return 1;
        }
    }
    else if(event == EVENT_ACTIVATE ){
        if( pick_target(&td, "TARGET_LAND") ){
            tap_card(player, card);
        }
    }    
    else if(event == EVENT_RESOLVE_ACTIVATION ){
        if( valid_target(&td) ){
            card_instance_t *instance = get_card_instance(player,card);
            untap_card(instance->targets[0].player, instance->targets[0].card );
        }
    }
    return 0;  
}

int card_searing_blaze(int player, int card, event_t event){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE );
    if( event == EVENT_CAN_CAST && can_target(&td) ){
        return 1;
    } 
    else if( event == EVENT_CAST_SPELL ){
        if(! affect_me(player, card)){ return 0; }
        pick_target(&td, "TARGET_CREATURE");
    }
    else if(event == EVENT_RESOLVE_SPELL ){
        int amount = 1;
        if( get_trap_condition(player, 12) > 0 ){
            amount = 3;
        }
        
        card_instance_t *instance = get_card_instance(player, card);
        if( valid_target(&td) ){
            damage_creature(instance->targets[0].player, instance->targets[0].card, amount, player, card);
        }
        damage_player(instance->targets[0].player, amount, player, card);
        kill_card(player, card, KILL_DESTROY );
    }
    return 0;
}

