#include "manalink.h"

int challenge_round = 0;
int unlocked[50];
int did_init[100];
int unlocked_challenge[100];
int opponent_turns = 0;
int challenge1 = -1;
int challenge2 = -1;
int challenge3 = -1;
int challenge4 = -1;

char unlock_codes[][10] = {
    "", "magic", "mtg", "jabber", "begin", "goodwork", "master", "quitter", "nuts", "hardy", 
    "routish", "headache", "buuurp", "bondage", "annoying", "wired", "shiny", "keeks", "", "", "",
    "diane", "james", "tricia", "greg", "christine", "me", "ryan", "owen", "dylan", "katie",
    "onna", "monna", "poeia", "clean", "patch", "oath", "nerds", "willy", "wonka"
};

int lock_ids[] = {
    -1, 1972, 1888, 1901, 1903, 1895, 1957, 711, 0, 553,
    624, 1954, 1894, 729, 712, 724, 722, 718, -1, -1, -1,
    641, 633, 634, 639, 636, 644, 632, 646, 648, 1963,
    911, -1, 787, 926, 654, 655, 0, 19, 246, 0,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1
};
 
int get_challenge_round(void){
    return challenge_round;
}

int check_type(type_t type){
    target_definition_t td;
    default_target_definition(0, 0, &td, type);
    td.allowed_controller = AI;
    td.preferred_controller = AI;
    td.illegal_abilities = 0;
    if( target_available(0, 0, &td) == 5 ){
        td.allowed_controller = HUMAN;
        td.preferred_controller = HUMAN;
        if( target_available(0, 0, &td) == 1 ){
            return 1;
        }
    }
    return 0;
}

void apply_challenge_10_to_1(int player, int card, event_t event){
    if( player != HUMAN ){ return; }
    
    int round = gauntlet_round - 1;
    int success = 0;
    if( round == 59 && check_type(TYPE_LAND) ){
        success = 1;  
    }
    else if( round == 60 ){
        int ai_ok=0;
        int human_ok=0;
        int count = 0;
        while(count < active_cards_count[AI]){
            card_data_t card_d = get_card_data(AI, count);
            if((card_d.type & TYPE_CREATURE) && in_play(AI, count) && get_power(AI, count) == 5 ){
                ai_ok = 1;
            }
            count++;
        }
        count = 0;
        while(count < active_cards_count[HUMAN]){
            card_data_t card_d = get_card_data(HUMAN, count);
            if((card_d.type & TYPE_CREATURE) && in_play(HUMAN, count) && get_power(HUMAN, count) == 1 ){
                human_ok = 1;
            }
            count++;
        }
        if( ai_ok == 1 && human_ok == 1 ){
            success = 1;  
        }
    }
    else if( round == 61 && count_graveyard(HUMAN) == 1 && count_graveyard(AI) == 5 ){
        success = 1;  
    }
    else if( round == 62 && life[HUMAN] == 1 && life[AI] == 5 ){
        success = 1;  
    }
    else if( round == 63 && hand_count[HUMAN] == 1 && hand_count[AI] == 5 ){
        success = 1;  
    }
    else if( round == 64 && count_deck(HUMAN) == 1 && count_deck(AI) == 5 ){
        success = 1;  
    }
    else if( round == 65 && count_rfg(HUMAN) == 1 && count_rfg(AI) == 5 ){
        success = 1;  
    }
    else if( round == 66 && check_type(TYPE_CREATURE) ){
        success = 1;  
    }
    else if( round == 67 ){
        // keep track of consecutive turns
        if(trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
            if(event == EVENT_TRIGGER){
                event_result |= 2;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                if(current_turn==HUMAN){
                    opponent_turns = 0;
                }
                else{
                    opponent_turns++;
                    if( opponent_turns == 5 ){
                        success = 1;
                    }
                }
            }
        }    
                
    }
    else if( round == 68 && check_type(TYPE_ARTIFACT) ){
        success = 1;  
    }
    else if( round == 69 && count_cards_by_id(HUMAN, 528) == 1 &&  count_cards_by_id(AI, 528) == 5 ){
        success = 1;  
    }
    
    if( success == 1 ){
        poison_counters[HUMAN] = 1;
        unlocked_challenge[round] = 2;
    }
}

void apply_challenge_10_to_1_upkeep(void){
    int round = gauntlet_round - 1;
    //if( life[HUMAN] == 20 ){ gain_life(HUMAN, round); }
    if(round > 59 && unlocked_challenge[round-1] != 2 ){
        do_dialog(0, 0, 0, -1, -1, "Sorry, you did not meet the victory condition for the previous round.", 1);
        lose_the_game(HUMAN);
    }
    
    if( unlocked_challenge[round] < 1 ){
        unlocked_challenge[round] = 1;
        if( round == 59 ){
            do_dialog(0, 0, 0, -1, -1, "Before you can win this challenge, you must control 1 land while your opponent has 5.", 1);
        }
        else if( round == 60 ){
            do_dialog(0, 0, 0, -1, -1, "Before you can win this challenge, you must control a 1/1 while your opponent has a 5/5.", 1);
        }
        else if( round == 61 ){
            do_dialog(0, 0, 0, -1, -1, "Before you can win this challenge, you must have 1 card in the graveyard while your opponent has 5.", 1);
        }
        else if( round == 62 ){
            do_dialog(0, 0, 0, -1, -1, "Before you can win this challenge, you must have 1 life while your opponent has 5.", 1);
        }
        else if( round == 63 ){
            do_dialog(0, 0, 0, -1, -1, "Before you can win this challenge, you must have 1 card in hand while your opponent has 5.", 1);
        }
        else if( round == 64 ){
            do_dialog(0, 0, 0, -1, -1, "Before you can win this challenge, you must have 1 card in your deck while your opponent has 5.", 1);
        }
        else if( round == 65 ){
            do_dialog(0, 0, 0, -1, -1, "Before you can win this challenge, you must have 1 card exiled while your opponent has 5.", 1);
        }
        else if( round == 66 ){
            do_dialog(0, 0, 0, -1, -1, "Before you can win this challenge, you must have 1 creature while your opponent has 5.", 1);
        }
        else if( round == 67 ){
            do_dialog(0, 0, 0, -1, -1, "Before you can win this challenge, your opponent must take 5 consecutive turns.", 1);
        }
        else if( round == 68 ){
            do_dialog(0, 0, 0, -1, -1, "Before you can win this challenge, you must have 1 artifact while your opponent has 5.", 1);
        }
        else if( round == 69 ){
            do_dialog(0, 0, 0, -1, -1, "An 11th challenge... how unfair.\nBefore you can win this challenge, you must have 1 Strip Mine while your opponent has 5.", 1);
        }
    }
}

int warp_card(int type, const char* text){
    while(1){
        if( unknown728574 != 1 ){
            int card_id = choose_a_card(text, -1, -1);
            if( cards_data[ card_id ].type & type ){
                int card_added = add_card_to_hand( HUMAN, card_id );
                hand_count[HUMAN]++;
                return card_added;
            }
        }
    }
    return -1;
}
            
int get_card_human(const char* name){
    int card_added = add_card_to_hand( HUMAN, get_internal_card_id_from_csv_id( get_id_by_name(name)  ) );
    put_into_play(HUMAN, card_added);
    return card_added;
}

int get_card(int id){
    int card_added = add_card_to_hand( AI, get_internal_card_id_from_csv_id( id  ) );
    put_into_play(AI, card_added);
    return card_added;
}

void apply_challenge_not_my_deck_upkeep(void){
    // Replace every non-land with another card of the same casting cost
    int count = 0;
    while( count < active_cards_count[HUMAN]){
        if(! in_play(HUMAN, count) ){
            put_on_top_of_deck(HUMAN, count);
        }
        count++;
    }
    hand_count[HUMAN] = 0;
    int *deck = deck_ptr[HUMAN];
    int i;
    for(i=0;i<count_deck(HUMAN);i++){
        card_ptr_t* c = cards_ptr[ cards_data[ deck[i] ].id ];
        
        int attempts = 0;
        int card_found = deck[i];
        
        // do not replace lands
        if( cards_data[ deck[i] ].type & TYPE_LAND ){
            attempts = 4000;
        }
        while( attempts++ < 4000){
            int card = get_random_card();
            int id = get_internal_card_id_from_csv_id( card );
            card_ptr_t* c1 = cards_ptr[ card];
            if( ! ( cards_data[ id ].type & TYPE_LAND ) &&  c->req_colorless == c1->req_colorless && c->req_black == c1->req_black && c->req_blue == c1->req_blue && 
                  c->req_green == c1->req_green && c->req_red == c1->req_red && c->req_white == c1->req_white ){
                attempts = 4000;
                card_found = id;
            }
        }
        deck[i] = card_found;
    }
    draw_cards(HUMAN, 7);
    poison_counters[HUMAN]=1;
    return;
}

void apply_challenge_puzzle_upkeep(void){
    int round = gauntlet_round - 1;
    
    if( challenge1 == 8 ){
        if ( poison_counters[HUMAN]==0 ){
            apply_challenge_not_my_deck_upkeep();
        }
        return;
    }
    
    // Remove our hand and deck
    if( challenge1 == 7){
        int count = 0;
        while( count < active_cards_count[HUMAN]){
            if(! in_play(HUMAN, count) ){
                put_on_top_of_deck(HUMAN, count);
            }
            count++;
        }
        hand_count[HUMAN] = 0;
        int *deck = deck_ptr[HUMAN];
        int i;
        for(i=0;i<10;i++){
            deck[i] = get_internal_card_id_from_csv_id( get_id_by_name("Swamp"));
        }
        deck[10]=-1;
        
        while( count < active_cards_count[AI]){
            if(! in_play(AI, count) ){
                put_on_top_of_deck(AI, count);
            }
            count++;
        }
        hand_count[HUMAN] = 0;
        deck = deck_ptr[AI];
        for(i=0;i<60;i++){
            deck[i] = get_internal_card_id_from_csv_id( get_id_by_name("Swamp"));
        }
        
        
    }
    
    // Add free cards to hand
    int* deck = deck_ptr[AI];
    if( round == 70 ){
        life[AI]=8;
        life[HUMAN]=9;
        get_card_human("Swamp");
        get_card_human("Swamp");
        do_dialog(0, 0, 0, -1, -1, "Win the game before your 2nd main phase.  You may add 2 Sorcery and 1 Creature to your hand.\n\nWarning: the next round requires you to win in your upkeep, so you probably want to set a stop there.", 1);
        warp_card(TYPE_SORCERY, "Choose sorcery #1");
        warp_card(TYPE_SORCERY, "Choose sorcery #2");
        warp_card(TYPE_CREATURE, "Choose a creature");
    } 
    else if( round == 71 ){
        life[AI]=8;
        get_card_human("Badlands");
        get_card_human("Plateau");
        do_dialog(0, 0, 0, -1, -1, "Win the game before your draw step.  You may add 2 instants to your hand.", 1);
        warp_card(TYPE_INSTANT | TYPE_INTERRUPT, "Choose instant #1");
        warp_card(TYPE_INSTANT | TYPE_INTERRUPT, "Choose instant #2");
    }
    else if( round == 72 ){
        deck[2]=-1;
        do_dialog(0, 0, 0, -1, -1, "Win the game before your draw step.  You may add any 4 cards to your hand.", 1);
        warp_card(TYPE_ANY, "Choose card #1");
        warp_card(TYPE_ANY, "Choose card #2");
        warp_card(TYPE_ANY, "Choose card #3");
        warp_card(TYPE_ANY, "Choose card #4");
    }
    else if( round == 73 ){
        life[AI]=72;
        deck[30]=-1;
        get_card_human("Island");
        get_card_human("Island");
        get_card_human("Island");
        get_card_human("Island");
        get_card_human("Island");
        get_card_human("Island");
        get_card_human("Island");
        get_card_human("Island");
        get_card( get_id_by_name("Wall of Air") );
        do_dialog(0, 0, 0, -1, -1, "Win the game before your 2nd main phase.  You may add any 3 non-artifacts cards to your hand.", 1);
        warp_card(~TYPE_ARTIFACT, "Choose card #1");
        warp_card(~TYPE_ARTIFACT, "Choose card #2");
        warp_card(~TYPE_ARTIFACT, "Choose card #3");
    }
    else if( round == 74 ){
        life[AI]=72;
        get_card_human("Mox Sapphire");
        get_card_human("Mox Sapphire");
        get_card_human("Mox Ruby");
        get_card_human("Mox Ruby");
        get_card_human("Mox Ruby");
        get_card_human("Mox Ruby");
        get_card_human("Mox Ruby");
        do_dialog(0, 0, 0, -1, -1, "Win the game before your 2nd main phase.  You may add any 3 non-artifacts cards to your hand.", 1);
        warp_card(~TYPE_ARTIFACT, "Choose card #1");
        warp_card(~TYPE_ARTIFACT, "Choose card #2");
        warp_card(~TYPE_ARTIFACT, "Choose card #3");
    }
    else if( round == 75 ){
        life[AI]=22;
        do_dialog(0, 0, 0, -1, -1, "Win the game before your 2nd main phase.  You may add 4 creatures, 1 instant, and 1 artifact to your hand.", 1);
        warp_card(TYPE_CREATURE, "Choose creature #1");
        warp_card(TYPE_CREATURE, "Choose creature #2");
        warp_card(TYPE_CREATURE, "Choose creature #3");
        warp_card(TYPE_CREATURE, "Choose creature #4");
        warp_card(TYPE_INSTANT | TYPE_INTERRUPT, "Choose an instant");
        warp_card(TYPE_ARTIFACT, "Choose an artifact");
    }
    else if( round == 76 ){
        life[AI]=12;
        get_card_human("Taiga");
        get_card_human("Crucible of Worlds");
        add_card_to_hand( HUMAN, get_internal_card_id_from_csv_id( get_id_by_name("Fireball")  ) );
        do_dialog(0, 0, 0, -1, -1, "Win the game before your 2nd main phase.  You may add an enchantment and an artifact to your hand.", 1);
        warp_card(TYPE_ENCHANTMENT, "Choose an enchantment");
        warp_card(TYPE_ARTIFACT, "Choose an artifact");
    }
    else if( round == 77 ){
        life[HUMAN]=1;
        life[AI]=36;
        do_dialog(0, 0, 0, -1, -1, "Win the game before your 2nd main phase.  You may add 3 creatures, 1 instant, 1 enchantment, and 1 artifact to your hand.", 1);
        warp_card(TYPE_CREATURE, "Choose creature #1");
        warp_card(TYPE_CREATURE, "Choose creature #2");
        warp_card(TYPE_CREATURE, "Choose creature #3");
        warp_card(TYPE_INSTANT | TYPE_INTERRUPT, "Choose an instant");
        warp_card(TYPE_ENCHANTMENT, "Choose an enchantment");
        warp_card(TYPE_ARTIFACT, "Choose an artifact");
    }
    else if( round == 78 ){
        life[AI]=16;
        get_card_human("Badlands");
        get_card_human("Badlands");
        get_card_human("Badlands");
        get_card_human("Badlands");
        add_card_to_hand( HUMAN, get_internal_card_id_from_csv_id( get_id_by_name("Eye of Ugin")  ) );
        do_dialog(0, 0, 0, -1, -1, "Win the game before your 2nd main phase.  You may add any 2 cards to your hand.", 1);
        warp_card(TYPE_ANY, "Choose card #1");
        warp_card(TYPE_ANY, "Choose card #2");
    }
    else if( round == 79 ){
        life[AI]=34;
        get_card_human("Swamp");
        get_card_human("Forest");
        get_card_human("Forest");
        do_dialog(0, 0, 0, -1, -1, "Win the game before your 2nd main phase.  You may add 1 creature and 3 sorcery to your hand.", 1);
        warp_card(TYPE_CREATURE, "Choose a creature");
        warp_card(TYPE_SORCERY, "Choose sorcery #1");
        warp_card(TYPE_SORCERY, "Choose sorcery #2");
        warp_card(TYPE_SORCERY, "Choose sorcery #3");
       
    }
}


void apply_challenge_vanguard(void){
    int avatars[] = { 1883, 1874, 611, 1871, 1865, 1873, 1875, 1878, 1868, 1877 };
    if( challenge_round > 9 && challenge_round < 20 ){
        generate_token_by_id(AI, avatars[challenge_round - 10 ]);
        if( challenge_round == 12 ){
            generate_token_by_id(HUMAN, 611);
        }
        else if( challenge_round == 19 ){
            generate_token_by_id(HUMAN, 1883 );
        }
    }   
    
}

void apply_challenge_onslaught(void){
    int cards[] = { 1137, 1480, 1441, 1863, 1921, 996, 249, 1070, 829, 1100 };
    int round = gauntlet_round-1;
    //gain_life(AI, 2);
    if( round >= 29 && round < 39 ){
        play_spell_for_free(AI, cards[round - 29 ]);
    }   
    
    // chaos orb
    if( challenge4 == 0 ){
        int i;
        int count = 0;
        for(i=0;i<active_cards_count[HUMAN];i++){
            if( in_play(HUMAN, i) && get_id(HUMAN, i) != 1847){ count++; }
        }
        if( count > 0 ){
            int r = rand(count);
            count = 0;
            for(i=0;i<active_cards_count[HUMAN];i++){
                if( in_play(HUMAN, i) && get_id(HUMAN, i) != 1847 ){
                    if( count == r ){
                        if( challenge_round < 3 ){
                            tap_card(HUMAN, i);
                        }
                        else if( challenge_round < 6 ){
                            bounce_permanent(HUMAN, i);
                        }
                        else{
                            kill_card(HUMAN, i, KILL_REMOVE);
                        }
                    }
                    count++;
                }
            }
        }
    }
    
    // pit fighting
    if( challenge4 == 1 && rand(3) == 1 ){
        generate_token_by_id(AI, 742);
    }
    
}

int is_unlocked(int player, int card, event_t event, int unlock_level){
    return 1;
    if( zendikar() ){
        return 1;
    }
    char buffer[200];
            
    if( player == AI || unlocked[unlock_level] == 1){
        return 1;
    }
    if( unlocked[unlock_level] == 2 && lock_ids[unlock_level] != -1 ){
        card_ptr_t* c = cards_ptr[ lock_ids[unlock_level] ];
        if( unlock_level >= 10 && unlock_level < 20 ){ unlock_level++; }
        int challenge_number = unlock_level % 10;
        int challenge_set = 1+(unlock_level - challenge_number)/10;
        if( event != 0 ){
            if( comes_into_play(player, card, event) == 1 || event == EVENT_RESOLVE_ACTIVATION ){
                sprintf(buffer, " You must unlock this card \nby completing challenge\nset %d number %d", challenge_set, challenge_number );
                do_dialog(player, player, card , -1, -1, buffer, 0);   
            }
        }
        sprintf(c->name, "Locked: chal %d #%d", challenge_set, challenge_number);
        //fprintf(file1, "already known as locked %d\n", unlocked[unlock_level] ); 
        return 0;
    }
    
    sprintf(buffer, "Faces//%s.jat", unlock_codes[unlock_level]);
    FILE *file = fopen(buffer, "r"); 
    if( file != NULL  ){
        fclose(file);
        unlocked[unlock_level] = 1;
        return 1;
    }

    if( event != 0 && comes_into_play(player, card, event) == 1 && lock_ids[unlock_level] != -1){
        if( unlock_level >= 10 && unlock_level < 20 ){ unlock_level++; }
        int challenge_number = unlock_level % 10;
        int challenge_set = 1+(unlock_level - challenge_number)/10;
        sprintf(buffer, " You must unlock this card \nby completing challenge\nset %d number %d", challenge_set, challenge_number );
        do_dialog(player, player, card , -1, -1, buffer, 0);   
    }
    //fprintf(file1, "setting check to failed %d\n", unlocked[unlock_level] ); 
    unlocked[unlock_level] = 2;
    
    //fclose(file1); 
    return 0;
}

int get_challenge2(void){
    return challenge2;
}

int get_challenge3(void){
    return challenge3;
}

int get_challenge4(void){
    return challenge4;
}

int is_beta_land(int id){
    if( id == 188 || id == 189 || id == 212 || id == 216 || id == 254 
     || id == 91 || id == 12 || id == 241 || id == 252
     || id == 126 || id == 258 || id == 266
     || id == 239 || id == 9
     || id == 164  ){
        return 1;
    }
    return 0;
}

int is_challenge_card(int id){
    int i;
    for(i=0;i<40;i++){
        if( lock_ids[i] == id ){
            return 1;
        }
    }
    return 0;
}

int is_steal_effect(int id){
    if( id == 392 || id == 3 || id == 1722 || id == 44 || id == 1341 
     || id == 1325 || id == 591 || id == 234 || id == 985
     || id == 867 || id == 92 || id == 1271 || id == 1432
     || id == 39 || id == 263 || id == 1000
     || id == 47 || id == 1306 
     || id == 630 || id == 627 || id == 1053
     || id == 952 || id == 446 || id == 392
     || id == 625 || id == 815
      ){
        return 1;
    }
    return 0;
}

void check_challenge2_deck_legality(void){
    int *deck = deck_ptr[HUMAN];
    int i, j;
    int result = -1;
    if( challenge2 == 4 || challenge4 == 8 ){
        // deck too small
        if( count_deck(HUMAN) < 85 ){
            result = 0;
        }
        for(i=0;i<count_deck(HUMAN);i++){
            for(j=i+1;j<count_deck(HUMAN);j++){
                if( deck[i] == deck[j] ){
                    result = i;
                }
            }
        }
    }
    
    int exception = 0;
    int counts[10];
    for(i=0;i<10;i++){
        counts[i] = 0;
    }
    for(i=0;i<count_deck(HUMAN);i++){
        // Check challenge 1 decks
        if( gauntlet_round >= 71 && ! is_beta_land( cards_data[ deck[i] ].id )  ){
            result = i;
        }
        
        // Check challenge2 decks
        if( challenge2 == 5 && ! ( cards_data[ deck[i] ].type & TYPE_ARTIFACT ) ){
            result = i;
        }
        else if( challenge2 == 6 && ! ( cards_data[ deck[i] ].type & TYPE_LAND ) ){
            result = i;
        }
        else if( challenge2 == 7 && ! ( cards_data[ deck[i] ].type & TYPE_CREATURE ) ){
            result = i;
        }
        else if( challenge2 == 2 && ( cards_data[ deck[i] ].cc[0] + cards_data[ deck[i] ].cc[1] < 4 ) && ! ( cards_data[ deck[i] ].type & TYPE_LAND ) ){
            result = i;
        }
        
        // check challenge 3 decks
        if( challenge3 == 0 && cards_data[ deck[i] ].subtype != 0 && ! is_beta_land( cards_data[ deck[i] ].id )  ){
            exception++;
            if( exception > 4 ){
                result = i;
            }
        }
        else if( challenge3 == 1 && ! ( cards_data[ deck[i] ].type & TYPE_ENCHANTMENT ) && ! is_beta_land( cards_data[ deck[i] ].id )  ){
            result = i;
        }
        else if( challenge3 == 1 && cards_data[ deck[i] ].cc[2] == 9 ){
            result = i;
        }
        else if( challenge3 == 2 && ! ( cards_data[ deck[i] ].type & TYPE_SORCERY ) && ! is_beta_land( cards_data[ deck[i] ].id )  ){
            result = i;
        }
        else if( challenge3 == 3 && cards_data[ deck[i] ].cc[2] != 9  && ! is_beta_land( cards_data[ deck[i] ].id )  ){
            exception++;
            if( exception > 6 ){
                result = i;
            }
        }
        else if( challenge3 == 4 && ! (cards_data[ deck[i] ].type & (TYPE_INSTANT | TYPE_INTERRUPT))  && ! is_beta_land( cards_data[ deck[i] ].id )  ){
            result = i;
        }
        else if( challenge3 == 5 && ! is_steal_effect( cards_data[ deck[i] ].id ) && ! is_beta_land( cards_data[ deck[i] ].id )  ){
            exception++;
            if( exception > 4 ){
                result = i;
            }
        }
        else if( challenge3 == 6 && ! ( cards_data[ deck[i] ].type & TYPE_ARTIFACT ) && ! is_beta_land( cards_data[ deck[i] ].id )  ){
            result = i;
        }
        else if( challenge3 == 6 && ( cards_data[ deck[i] ].type & TYPE_CREATURE )  ){
            result = i;
        }
        else if( challenge3 == 7 && ! is_beta_land( cards_data[ deck[i] ].id ) ){
            int cmc = cards_data[ deck[i] ].cc[0] + cards_data[ deck[i] ].cc[1];
            if( cmc < 1 || cmc > 10 ){
                result = i;

            }
            else{
                counts[cmc-1]++;
            }
        }
        
        // check challenge 4 decks
        card_ptr_t* c = cards_ptr[ cards_data[ deck[0] ].id ];
        card_ptr_t* c1 = cards_ptr[ cards_data[ deck[i] ].id ];
        if( challenge4 == 4 && memcmp(c->name, c1->name, 1 ) != 0 ){
            result = i;
        }
        else if( challenge4 == 5 && ! ( is_beta_land( cards_data[ deck[i] ].id)  || is_challenge_card( cards_data[ deck[i] ].id ) ) ){
            result = i;
        }
        else if( challenge4 == 7 && ! ( is_beta_land( cards_data[ deck[i] ].id)  ||  cards_data[ deck[i] ].code_pointer == 0x401000 ) ){
            char buffer[50];
            sprintf(buffer, " Card: %s, Code: %d", c1->name, cards_data[ deck[i] ].code_pointer );
            do_dialog(0,0,0, -1, -1, buffer, 0);
            result = i;
        }
    }

    if( challenge3 == 7 && result == -1 ){
        // update the counts for human's hand too
        for( i=0;i<active_cards_count[HUMAN];i++){
            card_instance_t *instance = get_card_instance(HUMAN, i);
            int id = instance->internal_card_id;
            int cmc = cards_data[ id ].cc[0] + cards_data[ id ].cc[1];
            if( cmc > 0 && cmc < 11 ){
                counts[cmc-1]++;
            }
        }
        result = -1;
        for(i=0;i<10;i++){
            if( counts[i] != 4 ){
                result = 12;
            }
        }
    }
    
    if( result > -1 ){
        lose_the_game(HUMAN);
    }
    
}

void set_challenge_round_to_0(void){
    challenge_round = 0;
    int i;
    for(i=0;i<50;i++){
        did_init[i]=0;
    }
}
void set_challenge_round(void){
    // jump ahead if we already completed some rounds
    int choice = 0;
    int player= HUMAN;
    if( gauntlet_round == 0 ){ challenge_round = 0; } 
    if( challenge_round == 0 ){
        choice = do_dialog(player, 0,0, -1, -1, " Challenge Set 1\n Challenge Set 2\n Challenge Set 3\n Challenge Set 4", 0);    
        
        char u1[10]; sprintf(u1, "%s", "");
        char u2[10]; sprintf(u2, "%s", "");
        char u3[10]; sprintf(u3, "%s", "");
        char u4[10]; sprintf(u4, "%s", "");
        char u5[10]; sprintf(u5, "%s", "");
        char u6[10]; sprintf(u6, "%s", "");
        char u7[10]; sprintf(u7, "%s", "");
        char u8[10]; sprintf(u8, "%s", "");
        char u9[10]; sprintf(u9, "%s", "");
        char u10[10]; sprintf(u9, "%s", "");
        char buffer[1000];
        int index_choice[4] = {1, 10, 21, 31};
        int index = index_choice[choice];
        if( is_unlocked(0, 0, 0, index) ){ sprintf(u1, "%s", " (unlocked)"); }
        if( is_unlocked(0, 0, 0, index+1) ){ sprintf(u2, "%s", " (unlocked)"); }
        if( is_unlocked(0, 0, 0, index+2) ){ sprintf(u3, "%s", " (unlocked)"); }
        if( is_unlocked(0, 0, 0, index+3) ){ sprintf(u4, "%s", " (unlocked)"); }
        if( is_unlocked(0, 0, 0, index+4) ){ sprintf(u5, "%s", " (unlocked)"); }
        if( is_unlocked(0, 0, 0, index+5) ){ sprintf(u6, "%s", " (unlocked)"); }
        if( is_unlocked(0, 0, 0, index+6) ){ sprintf(u7, "%s", " (unlocked)"); }
        if( is_unlocked(0, 0, 0, index+7) ){ sprintf(u8, "%s", " (unlocked)"); }
        if( is_unlocked(0, 0, 0, index+8) ){ sprintf(u9, "%s", " (unlocked)"); }
        if( is_unlocked(0, 0, 0, index+9) ){ sprintf(u10, "%s", " (unlocked)"); }
            
        if( choice == 0 ){
            sprintf(buffer, " Tribal Trials%s\n Vanguard Vengeance%s\n Chipping Away%s\n Onslaught%s\n Shandalar 2.0%s\n BANNED!%s\n 5:1 Odds%s\n Magic: The Puzzling%s\n That's Not My Deck!%s", u1, u2, u3, u4, u5, u6, u7, u8, u9);
            choice = do_dialog(player, 0,0, -1, -1, buffer, 0);    
            challenge1 = choice;
            challenge_round = 10 * choice;
            if( challenge_round > 20 && choice != 7 && choice != 8 ){ challenge_round--; }
            
            if( choice == 8 ){
                check_challenge2_deck_legality();
            }
            
            if( jatill() && challenge_round == 59 ){ 
                unlocked_challenge[64] = 2;
                unlocked_challenge[68] = 2;
                challenge_round = 69; 
            }
        
            if( challenge_round > 0 ){
                gauntlet_round = challenge_round + 1;
            }
        }
        else if( choice == 1 ){
            sprintf(buffer, " Super Mulligan%s\n What Hand?%s\n That's Big...%s\n Epic%s\n There can be only one%s\n March of the Machines%s\n Land Ho!%s\n Dude...%s", u1, u2, u3, u4, u5, u6, u7, u8);
            choice = do_dialog(player, 0,0, -1, -1, buffer, 0); 
            challenge2 = choice;
            check_challenge2_deck_legality();
        }
        else if( choice == 2 ){
            sprintf(buffer, " Gather No Moss%s\n Enchanted Evening%s\n Master Warlock%s\n Urza Wannabe%s\n Instant Gratification%s\n Gimme!%s\n March of the Machines 2%s\n Easy as 1, 2, 3...%s\nThe Perfect Storm%s\nSliver Nation%s", u1, u2, u3, u4, u5, u6, u7, u8, u9, u10);
            
            choice = do_dialog(player, 0,0, -1, -1, buffer, 0); 
            challenge3 = choice;
            check_challenge2_deck_legality();
        }
        else if( choice == 3 ){
            sprintf(buffer, " Chaos Orb%s\n Pit Fighting%s\n Life's a Lich%s\n Cascade%s\n ABC's%s\n Challenge Challenge%s\n Enchanted%s\n Programmer's Delight %s\n Enter the Dragon %s", u1, u2, u3, u4, u5, u6, u7, u8, u9 );
            choice = do_dialog(player, 0,0, -1, -1, buffer,  0); 
            challenge4 = choice;
            check_challenge2_deck_legality();
        }
    }
}

void challenge_mode_upkeep(int from_vanguard){
    if( did_init[gauntlet_round]==1){
        return;
    }
    
    // super mulligan
    if( challenge2 == 0){
        gain_life(HUMAN, 4);
        int count = 0;
        while( count < active_cards_count[HUMAN]){
            if(! in_play(HUMAN, count) ){
                put_on_top_of_deck(HUMAN, count);
            }
            count++;
        }
        hand_count[HUMAN] = 0;
    }
       
    // for the first 10 games, lose 2 life per game
    if( challenge_round >= 20 && challenge_round < 29 ){
        life[HUMAN] -= 2+2*(challenge_round%10);
        life[AI] += 2+2*(challenge_round%10);
    }
    
    // in the shandalar rounds, mess up life totals
    if( challenge_round >= 39 && challenge_round < 44 ){
        life[HUMAN] = 10;
        life[AI] = 50;  
    }
       
    // set the decks for each round
    if( challenge_round < 10 && challenge2 == -1 && challenge3 == -1 && challenge4 == -1 ){
        set_opponent_deck( challenge_round + 1 );
    }
    else if( challenge4 == 1 && challenge_round == 0 ){
        set_opponent_deck( 1 );    
    }
    else if( challenge4 == 1 && challenge_round == 1 ){
        set_opponent_deck( 9 );    
    }
    else if( challenge4 == 1 && challenge_round == 2 ){
        set_opponent_deck( 5 );    
    }
    else if( challenge4 == 1 && challenge_round == 3 ){
        set_opponent_deck( 2 );    
    }
    else if( challenge4 == 1 && challenge_round == 4 ){
        set_opponent_deck( 13 );    
    }
    else if( challenge4 == 1 && challenge_round == 5 ){
        set_opponent_deck( 8 );    
    }
    else if( challenge4 == 1 && challenge_round == 6 ){
        set_opponent_deck( 16 );    
    }
    else if( challenge4 == 1 && challenge_round == 7 ){
        set_opponent_deck( 6 );    
    }
    else if( challenge3 == 9  ){
        set_opponent_deck( 21 );
    }
    else if( challenge_round == 8 && challenge3 > -1 && challenge3 != 5  ){
        set_opponent_deck( 20 );
    }
    
    // enchanted challenge
    else if( challenge4 == 6 && challenge_round == 0 ){
        set_opponent_deck( 14 );    
    }
    else if( challenge4 == 6 && challenge_round == 1 ){
        set_opponent_deck( 23 );    
    }
    else if( challenge4 == 6 && challenge_round == 2 ){
        set_opponent_deck( 13 );    
    }
    else if( challenge4 == 6 && challenge_round == 3 ){
        set_opponent_deck( 3 );    
    }
    else if( challenge4 == 6 && challenge_round == 4 ){
        set_opponent_deck( 22 );    
    }
    else if( challenge4 == 6 && challenge_round == 5 ){
        set_opponent_deck( 24 );    
    }
    else if( challenge4 == 6 && challenge_round == 6 ){
        set_opponent_deck( 18 );    
    }
    else if( challenge4 == 6 && challenge_round == 7 ){
        set_opponent_deck( 16 );    
    }
    else if( challenge4 == 6 && challenge_round == 8 ){
        set_opponent_deck( 20 );
    }
    else if( challenge4 == 7 && challenge_round == 8 ){
        set_opponent_deck( 20 );
    }
   
    
    else if( challenge_round == 11 ){
        set_opponent_deck(11); 
    }
    else if( challenge_round == 13 ){
        set_opponent_deck(12); 
    }
    else if( challenge_round == 14 ){
        set_opponent_deck(13); 
    }
    else if( challenge_round == 15 ){
        set_opponent_deck(6); 
    }
    else if( challenge_round == 16 ){
        set_opponent_deck(14); 
    }
    else if( challenge_round == 17 ){
        set_opponent_deck(2); 
    }
    else if( challenge_round == 18 ){
        set_opponent_deck(8); 
    }
    else if( challenge_round == 19 ){
        set_opponent_deck(15); 
    }
    else if( challenge_round == 28 ){
        set_opponent_deck(17); 
    }
    else if( challenge_round == 30 ){
        set_opponent_deck(13); 
    }
    else if( challenge_round == 32 ){
        set_opponent_deck(6); 
    }
    else if( challenge_round == 34 ){
        set_opponent_deck(1); 
    }
    else if( challenge_round == 37 ){
        set_opponent_deck(14); 
    }
    else if( challenge_round == 38 ){
        set_opponent_deck(99); 
    } 
    else if( challenge_round == 39 ){
        set_opponent_deck(5); 
    }
    else if( challenge_round == 40 ){
        set_opponent_deck(9); 
    }
    else if( challenge_round == 41 ){
        set_opponent_deck(8); 
    }
    else if( challenge_round == 42 ){
        set_opponent_deck(7); 
    }
    else if( challenge_round == 43 ){
        set_opponent_deck(2); 
    }
    else if( challenge_round == 44 ){
        set_opponent_deck(14); 
    }
    else if( challenge_round == 47 ){
        set_opponent_deck(4); 
    }
    else if( challenge_round == 48 ){
        set_opponent_deck(99); 
    }
    else if( challenge_round == 49 ){
        set_opponent_deck(15); 
    }
    else if( challenge_round == 50 ){
        set_opponent_deck(9); 
    }
    else if( challenge_round == 51 ){
        set_opponent_deck(12); 
    }
    else if( challenge_round == 52 ){
        set_opponent_deck(13); 
    }
    else if( challenge_round == 53 ){
        set_opponent_deck(11); 
    }
    else if( challenge_round == 54 ){
        set_opponent_deck(4); 
    }
    else if( challenge_round == 55 ){
        set_opponent_deck(10); 
    }
    else if( challenge_round == 56 ){
        set_opponent_deck(14); 
    }
    else if( challenge_round == 57 ){
        set_opponent_deck(8); 
    }
    else if( challenge_round == 58 ){
        set_opponent_deck(18); 
    }
    else if( challenge_round == 68 ){
        set_opponent_deck(98); 
    }
    else if( challenge_round == 69 ){
        set_opponent_deck(97); 
    }
    else if( challenge_round > 69 && challenge_round < 80 ){
        set_opponent_deck(99); 
    }
    else{
        set_opponent_deck( rand(27) + 1 );
    }
    
    // start the game with some card in play
    int start_game_card[100];
    int i;
    for(i=0;i<100;i++){
        start_game_card[i] = -1;
    }
    start_game_card[0] = 703;
    start_game_card[1] = 1993;
    start_game_card[2] = 1441;
    start_game_card[3] = 1458;
    start_game_card[4] = 1565;
    start_game_card[5] = 1863;
    start_game_card[6] = 1564;
    start_game_card[7] = 1692;
    start_game_card[8] = 1556;
    start_game_card[9] = 1438;
    if( start_game_card[challenge_round] != -1 && challenge2 == -1 && challenge3 == -1 && challenge4 == -1 ){
        get_card( start_game_card[challenge_round] );
    }
    else if( challenge_round == 39 ){
        get_card(340);
        get_card(456);
    }
    else if( challenge_round == 40 ){
        get_card(213);
        get_card(620);
    }
    else if( challenge_round == 41 ){
        get_card(101);
        get_card(155);
    }
    else if( challenge_round == 42 ){
        get_card(94);
        get_card(803);
    }
    else if( challenge_round == 43 ){
        get_card(117);
        get_card(661);
    }
    else if( challenge_round == 44 ){
        get_card(812);
        get_card(1308);
    }
    else if( challenge_round == 45 ){
        get_card(18);
        get_card(535);
    }
    else if( challenge_round == 46 ){
        get_card(503);
        get_card(503);
    }
    else if( challenge_round == 47 ){
        get_card(299);
        get_card(536);
    }
    else if( challenge_round == 48 ){
        get_card(1744);
        get_card(1745);
        get_card(1747);
        get_card(1748);
        get_card(1749);
        get_card(492);
    }
    else if( challenge3 == 9 && challenge_round == 0 ){
        get_card(1385);
    }
    else if( challenge3 == 9 && challenge_round == 1 ){
        get_card(1377);
    }
    else if( challenge3 == 9 && challenge_round == 2 ){
        get_card(1380);
    }
    else if( challenge3 == 9 && challenge_round == 3 ){
        get_card(1381);
    }
    else if( challenge3 == 9 && challenge_round == 4 ){
        get_card(1378);
    }
    else if( challenge3 == 9 && challenge_round == 5 ){
        get_card(996);
    }
    else if( challenge3 == 9 && challenge_round == 6 ){
        get_card(1438);
    }
    else if( challenge3 == 9 && challenge_round == 7 ){
        get_card(1382);
        get_card(1392);
    }
    else if( challenge3 == 9 && challenge_round == 8 ){
        get_card(1938);
        get_card(1938);
    }
    
    // pit challenge 
    else if( challenge4 == 1 && challenge_round == 0 ){
        get_card(1008);
    }
    else if( challenge4 == 1 && challenge_round == 1 ){
        get_card(651);
    }
    else if( challenge4 == 1 && challenge_round == 2 ){
        get_card(1842);
    }
    else if( challenge4 == 1 && challenge_round == 3 ){
        get_card(1226);
    }
    else if( challenge4 == 1 && challenge_round == 4 ){
        get_card(1268);
    }
    else if( challenge4 == 1 && challenge_round == 5 ){
        get_card(1269);
    }
    else if( challenge4 == 1 && challenge_round == 6 ){
        get_card(1603);
    }
    else if( challenge4 == 1 && challenge_round == 7 ){
        get_card(151);
        get_card(742);
        get_card(742);
        get_card(742);
    }
    else if( challenge4 == 1 && challenge_round > 7 ){
        for(i=0;i<challenge_round-3;i++){
            get_card(742);
        }
    }
    if( challenge4 == 1 ){
        get_card(299); // blood moon
        get_card(746); // presense of the master
    }
    // lich challenge
    else if( challenge4 == 2 ){
        int card_added = add_card_to_hand( HUMAN, get_internal_card_id_from_csv_id( 141  ) );
        put_into_play(HUMAN, card_added);
        card_added = add_card_to_hand( HUMAN, get_internal_card_id_from_csv_id( 140  ) );
        put_into_play(HUMAN, card_added);
        card_added = add_card_to_hand( HUMAN, get_internal_card_id_from_csv_id( 140  ) );
        put_into_play(HUMAN, card_added);
    }
    // enchanting challenge
    if( challenge4 == 6 && ( challenge_round == 0 || challenge_round == 8 ) ){
        get_card(654);
    }
    if( challenge4 == 6 && (challenge_round == 2 || challenge_round == 8 ) ){
        get_card(299);
    }
    if( challenge4 == 6 && (challenge_round == 3 || challenge_round == 8 ) ){
        get_card(726);
    }
    if( challenge4 == 6 && (challenge_round == 4  || challenge_round == 8 )){
        get_card(494);
        get_card(494);
        get_card(494);
        get_card(494);
    }
    if( challenge4 == 6 && (challenge_round == 5 || challenge_round == 8 ) ){
        get_card(155);
    }
    if( challenge4 == 6 && (challenge_round == 6 || challenge_round == 8 ) ){
        for(i=1;i<6;i++){
            int card_added = get_card(134); // karma
            card_instance_t *instance = get_card_instance(AI, card_added);
            instance->hack_mode = i * 0x100;
        }
    }
    if( challenge4 == 6 && (challenge_round == 7 || challenge_round == 8 ) ){
        get_card(33);
        get_card(34);
        get_card(35);
        get_card(36);
        get_card(37);
    }
    if( challenge4 == 6 && (challenge_round == 1 || challenge_round == 8 ) ){
        get_card(732);
    }
    else if( challenge4 == 7 && challenge_round == 8 ){
        get_card( get_id_by_name("Glorious Anthem") );
    }
    
    // Enter the Dragon challenge
    else if( challenge4 == 8 && challenge_round == 0 ){
        get_card( get_id_by_name("Emerald Dragonfly") );
    }
    else if( challenge4 == 8 && challenge_round == 1 ){
        get_card( get_id_by_name("Dragon's Claw") );
    }
    else if( challenge4 == 8 && challenge_round == 2 ){
        get_card( get_id_by_name("Dragonmaster Outcast") );
    }
    else if( challenge4 == 8 && challenge_round == 3 ){
        get_card( get_id_by_name("Rukh Egg") );
    }
    else if( challenge4 == 8 && challenge_round == 4 ){
        get_card( get_id_by_name("Dragon Engine") );
    }
    else if( challenge4 == 8 && challenge_round == 5 ){
        get_card( get_id_by_name("Dragon Whelp") );
    }
    else if( challenge4 == 8 && challenge_round == 6 ){
        get_card( get_id_by_name("Hunted Dragon") );
    }
    else if( challenge4 == 8 && challenge_round == 7 ){
        get_card( get_id_by_name("Shivan Dragon") );
    }
    else if( challenge4 == 8 && challenge_round == 8 ){
        get_card( get_id_by_name("Arcades Sabboth") );
        get_card( get_id_by_name("Nicol Bolas") );
        get_card( get_id_by_name("Chromium") );
        get_card( get_id_by_name("Palladia-Mors") );
        get_card( get_id_by_name("Vaevictis Asmadi") );
    }
    
    // free scorpion
    if( gauntlet_round < 60 && is_unlocked(HUMAN, 0, EVENT_CAN_CAST, 32) ){
        int card_added = add_card_to_hand( HUMAN, get_internal_card_id_from_csv_id( 742  ) );
        put_into_play(HUMAN, card_added);
    }
    
    /*
    if( ! is_unlocked(0, 0, 0, 29) ){
        poison_counters[HUMAN] = 1+challenge3;
        if( challenge3 == 8 ){
            life[HUMAN] = 21+challenge_round;
            if( challenge_round == 1 ){
                life[AI] = 2;    
            }
        } 
    }
    */
    
    // unlock cards every 10th round or so
    int unlock_id = 0;
    if( challenge_round == 10 && challenge2 == -1  && challenge3 == -1 && challenge1 == 0 && challenge4 == -1){
        unlock_id = 1;
    }
    else if( challenge2 > -1 && challenge_round == 10 ){
        unlock_id = 10 + challenge2;
    }
    else if( challenge3  > -1 && challenge_round == 9 ){
        unlock_id = 21 + challenge3;
    }
    else if( challenge4 > -1 && challenge_round == 9 ){
        unlock_id = 31 + challenge4;
    }
    else if( challenge_round == 20 && challenge1 == 1){
        unlock_id = 2;
    }
    else if( challenge_round == 29 && challenge1 == 2){
        unlock_id = 3;
    }
    else if( challenge_round == 39 && challenge1 == 3 ){
        unlock_id = 4;
    }
    else if( challenge_round == 49 && challenge1 == 4){
        unlock_id = 5;
    }
    else if( challenge_round == 59 && challenge1 == 5){
        unlock_id = 6;
    }
    else if( challenge_round == 70 && unlocked_challenge[69] == 2 && challenge1 == 6){
        unlock_id = 7;
    }
    else if( gauntlet_round == 81 && challenge1 == 7){
        unlock_id = 8;
    }
    else if( gauntlet_round == 91 && challenge1 == 8){
        unlock_id = 9;
    }
   
    if( unlock_id > 0 ){
        char buffer[200];
        
        if( challenge4 == 1 && challenge_round == 9 ){
            sprintf(buffer, "You have unleashed the power of the pit!");
        }
        else if( challenge4 == 6 && challenge_round == 9 ){
            sprintf(buffer, "You have become an auramancer!");
        }
        else{
            card_ptr_t* c = cards_ptr[ lock_ids[unlock_id] ];
            sprintf(buffer, "You have unlocked a card: %s", c->full_name);
        }
        do_dialog(0,0,0,-1, -1, buffer, 0);
        
        sprintf(buffer, "Faces//%s.jat", unlock_codes[unlock_id]);
        FILE *file = fopen(buffer, "w"); 
        fprintf(file, "%d", 1 );   
        fclose(file); 
        if( ! ( challenge4 > -1 && challenge4 == 1 && challenge_round == 9 ) ){
            lose_the_game(HUMAN);
        }
    }
    
    did_init[gauntlet_round] = 1;
    challenge_round++;
}

void add_card(int card, int quantity){
    card = get_internal_card_id_from_csv_id(card);
    int i,j;
    int *deck = deck_ptr[AI];
    for(i=0;i<500;i++){
        if( deck[i] == -1 ){
            for(j=0;j<quantity;j++){
                deck[j+i] = card;
            }
            break;
        }
    }
}

void add_card_by_name(const char *  card_name, int quantity){
    add_card( get_id_by_name(card_name), quantity);
}

void set_opponent_deck(int deck_id){
    int i;
    int count = 0;
    while( count < active_cards_count[AI]){
        if(! in_play(AI, count) ){
            put_on_top_of_deck(AI, count);
        }
        count++;
    }
            
    int *deck = deck_ptr[AI];
    for(i=0;i<500;i++){
        deck[i] = -1;
    }
    
    
    if( deck_id == 1 ){
        // kobolds
        add_card(701, 4);
        add_card(702, 4);
        add_card(703, 4);
        add_card(704, 4);
        add_card(603, 4);
        add_card(605, 4);
        add_card(135, 3);
        add_card(96, 3);
        add_card(114, 4);
        add_card(145, 4);
        add_card(164, 22);
    }
    else if( deck_id == 2 ){
        // zombies
        add_card(1735, 4);
        add_card(1836, 4);
        add_card(8, 4);
        add_card(1993, 4);
        add_card(1076, 4);
        add_card(1566, 4);
        add_card(1051, 4);
        add_card(55, 4);
        add_card(1157, 4);
        add_card(239, 24);
    }
    else if( deck_id == 3 ){
        // faeries 
        add_card(1441, 4);
        add_card(1460, 4);
        add_card(1770, 4);
        add_card(1419, 4);
        add_card(1994, 4);
        add_card(44, 4);
        add_card(1846, 4);
        add_card(1931, 4);
        add_card(48, 4);
        add_card(258, 4);
        add_card(1487, 4);
        add_card(126, 8);
        add_card(239, 4);
        add_card(1488, 4);
    }
    else if( deck_id == 4 ){
        // kithkin 
        add_card(1414, 4);
        add_card(1933, 4);
        add_card(1458, 4);
        add_card(1288, 4);
        add_card(1466, 4);
        add_card(1464, 4);
        add_card(1562, 4);
        add_card(51, 4);
        add_card(1453, 4);
        add_card(188, 24);
    }
    else if( deck_id == 5 ){
        // merfolk
        add_card(150, 4);
        add_card(48, 4);
        add_card(1359, 4);
        add_card(1420, 4);
        add_card(1459, 4);
        add_card(1717, 4);
        add_card(1565, 4);
        add_card(1729, 4);
        add_card(1738, 4);
        add_card(1750, 4);
        add_card(126, 20);
    }
    else if( deck_id == 6 ){
        // rats
        add_card(1863, 30);
        add_card(55, 4);
        add_card(1734, 4);
        add_card(165, 1);
        add_card(166, 1);
        add_card(167, 1);
        add_card(168, 1);
        add_card(169, 1);
        add_card(239, 17);
    }
    else if( deck_id == 7 ){
        // elves
        add_card(107, 4);
        add_card(1024, 4);
        add_card(1564, 4);    
        add_card(998, 4);
        add_card(149, 4);
        add_card(1461, 4);
        add_card(1360, 4);
        add_card(1463, 2);
        add_card(1192, 2);
        add_card(1473, 4);      
        add_card(1293, 4);
        add_card(1474, 4);
        add_card(740, 1);
        add_card(91, 11);
        add_card(212, 4);
    }
    else if( deck_id == 8 ){
        // goblins
        add_card(102, 1);
        add_card(164, 18);
        add_card(1692, 4);
        add_card(1354, 4);
        add_card(1716, 2);
        add_card(1763, 4);
        add_card(1798, 4);
        add_card(1809, 2);
        add_card(1858, 4);
        add_card(1859, 1);
        add_card(1563, 4);
        add_card(1860, 4);
        add_card(1728, 4);
        add_card(1914, 4);
    }
    else if( deck_id == 9 ){
        // soldiers
        add_card(51, 4);
        add_card(1556, 2);
        add_card(1555, 4);
        add_card(1327, 4);
        add_card(1559, 4);
        add_card(1495, 4);
        add_card(1560, 4);
        add_card(1558, 4);
        add_card(1562, 4);
        add_card(1451, 4);
        add_card(188, 22);
    }
    else if( deck_id == 10 ){
        // slivers
        add_card(1392, 4);
        add_card(1377, 4);
        add_card(1386, 4);
        add_card(1382, 4);
        add_card(1375, 4);
        add_card(48, 4);
        add_card(1717, 4);
        add_card(1750, 4);
        add_card(1391, 2);
        add_card(165, 1);
        add_card(166, 1);
        add_card(167, 1);
        add_card(168, 1);
        add_card(169, 1);
        add_card(1, 1);
        add_card(249, 1);
        add_card(17, 1);
        add_card(212, 2);
        add_card(254, 4);
        add_card(252, 4);
        add_card(1488, 4);
        add_card(1473, 4);
    }
    else if( deck_id == 11 ){
        // grow
        add_card(1903, 4);
        add_card(1920, 4);
        add_card(1733, 4);
        add_card(312, 4);
        add_card(1905, 4);
        add_card(1717, 4);
        add_card(1750, 4);
        add_card(499, 4);
        add_card(1683, 4);
        add_card(1684, 4);
        add_card(252, 4);
        add_card(126, 4);
        add_card(91, 4);
        add_card(1487, 4);
        add_card(1473, 4);
    }
    else if( deck_id == 12 ){
        // sharuum
        add_card(1882, 4);
        add_card(1881, 4);
        add_card(1880, 4);
        add_card(1879, 4);
        add_card(81, 4);
        add_card(588, 4);
        add_card(726, 4);
        add_card(1440, 4);
        add_card(1718, 4);
        add_card(1520, 2);
        add_card(258, 4);
        add_card(254, 4);
        add_card(216, 4);
        add_card(1876, 4);
        add_card(1488, 4);
        add_card(1487, 2);
    }
    else if( deck_id == 13 ){
        // spawnwrithe
        add_card(1096, 4);
        add_card(1480, 4);
        add_card(851, 4);
        add_card(1476, 4);
        add_card(97, 4);
        add_card(599, 4);
        add_card(1243, 4);
        add_card(149, 4);
        add_card(1293, 4);
        add_card(740, 2);
        add_card(91, 22); 
    }
    else if( deck_id == 14 ){
        // turbofog
        add_card(88, 4);
        add_card(114, 4);
        add_card(507, 4);
        add_card(289, 4);
        add_card(503, 4);
        add_card(290, 4);
        add_card(212, 4);
        add_card(672, 4);
        add_card(1521, 4);
        add_card(1473, 4);
        add_card(710, 2);
        add_card(1497, 2);
        add_card(1499, 4);
        add_card(188, 6); 
        add_card(91, 6); 
    }
    else if( deck_id == 15 ){
        // gold creatures
        add_card(1369, 4);
        add_card(1357, 4);
        add_card(1224, 4);
        add_card(1225, 4);
        add_card(1741, 4);
        add_card(1244, 4);
        add_card(1368, 4);
        add_card(212, 4);
        add_card(254, 4);
        add_card(252, 4);
        add_card(241, 1);
        add_card(189, 1);
        add_card(1488, 4);
        add_card(1473, 4); 
        add_card(1474, 2); 
        add_card(1862, 4);
        add_card(1861, 4);
    }
    else if( deck_id == 16 ){
        // burn
        add_card(145, 4);
        add_card(593, 4);
        add_card(367, 4);
        add_card(1417, 4);
        add_card(1290, 4);
        add_card(1263, 4);
        add_card(1254, 4);
        add_card(386, 4);
        add_card(164, 16);
        add_card(1762, 4);
        add_card(1830, 4);
        add_card(1727, 4);
    }
    else if( deck_id == 17 ){
        // 2-land white
        add_card(1239, 4);
        add_card(213, 4);
        add_card(1558, 4);
        add_card(1288, 4);
        add_card(1466, 4);
        add_card(1822, 4);
        add_card(1823, 4);
        add_card(1824, 4);
        add_card(1825, 4);
        add_card(1933, 4);
        add_card(1414, 4);
        add_card(64, 4);
        add_card(1016, 4);
        add_card(188, 2); 
        add_card(167, 1); 
        add_card(17, 1);
        add_card(1458, 4);
    }    
    else if( deck_id == 18 ){
        // no land
        add_card(165, 1);
        add_card(166, 1);
        add_card(167, 1);
        add_card(168, 1);
        add_card(169, 1);
        add_card(310, 1);
        add_card(17, 1);
        add_card(230, 1);
        add_card(1718, 4);
        add_card(55, 4);
        add_card(1734, 4);
        add_card(1775, 4);
        add_card(1424, 1);
        add_card(117, 4);
        add_card(132, 4);
        add_card(434, 4);
        add_card(81, 4);
        add_card(1208, 4);
        add_card(1955, 4);
        add_card(592, 4);
        add_card(18, 4);
        add_card(110, 3);
    }
    else if( deck_id == 19 ){
        // workshop
        add_card(165, 1);
        add_card(166, 1);
        add_card(167, 1);
        add_card(168, 1);
        add_card(169, 1);
        add_card(132, 4);
        add_card(17, 1);
        add_card(230, 1);
        add_card(894, 1);
        add_card(157, 1);
        add_card(538, 4);
        add_card(1, 1);
        add_card(249, 1);
        add_card(250, 1);
        add_card(62, 1);
        add_card(55, 4);
        add_card(438, 1);
        add_card(510, 4);
        add_card(528, 1);
        add_card(258, 4);
        add_card(1728, 4);
        add_card(287, 4);
        add_card(119, 2);
        add_card(529, 4);
        add_card(1351, 1);
        add_card(1487, 4);
        add_card(317, 1);
        add_card(309, 1);
        add_card(1520, 1);
        add_card(1488, 1);
        add_card(333, 1);
        add_card(331, 1);
    }
    else if( deck_id == 20 ){
        // clone human deck
        i=0;
        int *deck2 = deck_ptr[HUMAN];
        while(deck2[i] > -1 ){
            add_card( cards_data[ deck2[i++] ].id , 1);
        }
        for( i=0;i<active_cards_count[HUMAN];i++){
            card_instance_t *instance = get_card_instance(HUMAN, i);
            int id = instance->internal_card_id;
            add_card(cards_data[ id ].id , 1);
        }
    }
    else if( deck_id == 21 ){
        // faster slivers
        add_card(165, 1);
        add_card(167, 1);
        add_card(169, 1);
        add_card(17, 1);
        add_card(1, 1);
        add_card(249, 1);
        add_card(1377, 4);
        add_card(1386, 4);
        add_card(1392, 4);
        add_card(1382, 4);
        add_card(1385, 4);
        add_card(1938, 4);
        add_card(1717, 4);
        add_card(1750, 4);
        add_card(254, 4);
        add_card(212, 4);
        add_card(254, 4);
        add_card(1834, 4);
        add_card(252, 4);
        add_card(1917, 2);
    }
    else if( deck_id == 22 ){
        // vampires
        add_card(1969, 4);
        add_card(1132, 4);
        add_card(617, 4);
        add_card(614, 4);
        add_card(1103, 4);
        add_card(1088, 4);
        add_card(1513, 4);
        add_card(1510, 4);
        add_card(1089, 2);
        add_card(1625, 4);
        add_card(1959, 4);
        add_card(239, 16);
        add_card(8, 2);
    }
    else if( deck_id == 23 ){
        // viseling
        add_card(165, 1);
        add_card(166, 1);
        add_card(167, 1);
        add_card(168, 1);
        add_card(169, 1);
        add_card(17, 1);
        add_card(230, 1);
        add_card(457, 4);
        add_card(18, 4);
        add_card(114, 4);
        add_card(1521, 4);
        add_card(287, 4);
        add_card(1164, 4);
        add_card(145, 4);
        add_card(593, 4);
        add_card(1254, 4);
        add_card(164, 13);
        add_card(510, 4);
    }
    else if( deck_id == 24 ){
        // big burn
        add_card(155, 4);
        add_card(1248, 4);
        add_card(96, 4);
        add_card(1124, 4);
        add_card(358, 4);
        add_card(84, 4);
        add_card(65, 4);
        add_card(116, 4);
        add_card(1243, 4);
        add_card(1474, 4);
        add_card(1634, 4);
        add_card(164, 10);
        add_card(241, 4);
        add_card(984, 4);
    }
    else if( deck_id == 25 ){
        // awwfinity
        add_card_by_name("Ancestral Recall", 1);
        add_card_by_name("Arcbound Worker", 4);
        add_card_by_name("Black Lotus", 1);
        add_card_by_name("Frogmite", 4);
        add_card_by_name("Lodestone Golem", 4);
        add_card_by_name("Master of Etherium", 4);
        add_card_by_name("Mox Emerald", 1);
        add_card_by_name("Mox Jet", 1);
        add_card_by_name("Mox Pearl", 1);
        add_card_by_name("Mox Ruby", 1);
        add_card_by_name("Mox Sapphire", 1);
        add_card_by_name("Sol Ring", 1);
        add_card_by_name("Su-Chi", 1);
        add_card_by_name("Time Walk", 1);
        add_card_by_name("Thoughtcast", 4);
        add_card_by_name("Darksteel Citadel", 4);
        add_card_by_name("Seat of the Synod", 4);
        add_card_by_name("Tolarian Academy", 1);
        add_card_by_name("Mishra's Workshop", 4);
        add_card_by_name("Island", 6);
        add_card_by_name("Myr Enforcer", 4);
        add_card_by_name("Broodstar", 4);
    }
    else if( deck_id == 26 ){
        // yggdrasil b/g
        add_card_by_name("Maelstrom Pulse", 4);
        add_card_by_name("Spiritmonger", 4);
        add_card_by_name("Shriekmaw", 3);
        add_card_by_name("Verdant Catacombs", 4);
        add_card_by_name("Bayou", 4);
        add_card_by_name("Overgrown Tomb", 4);
        add_card_by_name("Birds of Paradise", 4);
        add_card_by_name("Swamp", 4);
        add_card_by_name("Urborg", 1);
        add_card_by_name("Forest", 3);
        add_card_by_name("Vampire Nighthawk", 4);
        add_card_by_name("Visara the Dreadful", 1);
        add_card_by_name("Mox Emerald", 1);
        add_card_by_name("Mox Jet", 1);
        add_card_by_name("Ravenous Baloth", 4);
        add_card_by_name("Scute Mob", 4);
        add_card_by_name("Black Lotus", 1);
        add_card_by_name("Gatekeeper of Malakir", 4);
        add_card_by_name("Harmonize", 3);
        add_card_by_name("Beacon of Unrest", 1);
        add_card_by_name("Pendelhaven", 1);
    }
    else if( deck_id == 27 ){
        // nykotorian zoo
        add_card_by_name("Mox Emerald", 1);
        add_card_by_name("Mox Pearl", 1);
        add_card_by_name("Mox Ruby", 1);
        add_card_by_name("Black Lotus", 1);
        add_card_by_name("Wild Nacatl", 4);
        add_card_by_name("Kird Ape", 4);
        add_card_by_name("Path to Exile", 4);
        add_card_by_name("Tarmogoyf", 4);
        add_card_by_name("Wheel of Fortune", 1);
        add_card_by_name("Qasali Pridemage", 4);
        add_card_by_name("Lightning Bolt", 4);
        add_card_by_name("Lightning Helix", 2);
        add_card_by_name("Fireblast", 1);
        add_card_by_name("Chain Lightning", 4);
        add_card_by_name("Forest", 1);
        add_card_by_name("Plains", 1);
        add_card_by_name("Mountain", 1);
        add_card_by_name("Plateau", 3);
        add_card_by_name("Taiga", 2);
        add_card_by_name("Savannah", 1);
        add_card_by_name("Wooded Foothills", 3);
        add_card_by_name("Windswept Heath", 3);
        add_card_by_name("Arid Mesa", 3);
        add_card_by_name("Figure of Destiny", 2);
        add_card_by_name("Grim Lavamancer", 4);
    }
    else if( deck_id == 97 ){
        // all kobolds
        add_card(251, 199);       
    }
    else if( deck_id == 98 ){
        // all strip mines
        add_card(528, 199);
    }
    else if( deck_id == 99 ){
        // all land
        add_card(164, 199);
    }
    if( deck_id == 18 ){
        shuffle_vanguard(AI, 0);
        int id = get_internal_card_id_from_csv_id( 166 );
        for(i=0;i<60;i++){
            if( deck[i] == id ){
                deck[i] = deck[0];
                deck[0] = id;
                break;
            }
        }
    }
    else if(deck_id != 97 ){
        shuffle_vanguard(AI, 1);
    }
    draw_cards(AI, 7);
    hand_count[AI] = 7;             
}

