#include "manalink.h"

int count_graveyard_by_id(int player, int id){
  int *graveyard = graveyard_ptr[player];
  int count = 0;
  int i;

  for(i = 0; i < 500; i++)
    if(graveyard[i] != -1 && cards_data[  graveyard[i] ].id == id )
      count++;

  return count;
}

int count_graveyard_tribal(int player){
    int *graveyard = graveyard_ptr[player];
    int count = 0;
    int i;

    for(i = 0; i < 500; i++){
        card_data_t card_d = cards_data[ graveyard[i] ];
        card_ptr_t* c = cards_ptr[card_d.id];
        if(graveyard[i] != -1 && ! ( cards_data[  graveyard[i] ].type & TYPE_CREATURE ) ){
            if( c->subtype1 == SUBTYPE_TRIBAL || c->subtype2 == SUBTYPE_TRIBAL ){
                count++;
            }
        }
    }      
    return count;
}

int count_graveyard_planeswalker(int player){
    int *graveyard = graveyard_ptr[player];
    int count = 0;
    int i;

    for(i = 0; i < 500; i++){
        card_data_t card_d = cards_data[ graveyard[i] ];
        if(graveyard[i] != -1 && card_d.cc[2] == 9 && card_d.type & TYPE_ENCHANTMENT){
            count++;
        }
    }      
    return count;
}

// Count the number of cards in a zone
int count_zone(int player, int* zone){
  int *graveyard = zone;
  int count = 0;
  int i;

  for(i = 0; i < 500; i++)
    if(graveyard[i] != -1)
      count++;

  return count;
}

int count_deck(int player){
    return count_zone(player, deck_ptr[player]);
}

int count_graveyard(int player){
    return count_zone(player, graveyard_ptr[player]);
}

int count_rfg(int player){
    return count_zone(player, rfg_ptr[player]);
}

void purge_rfg(int player){
    int *rfg = rfg_ptr[player];
    rfg[count_rfg(player) - 1] = -1;
}

int count_zone_by_type(int player, int type, int* zone){
  int *graveyard = zone;
  int count = 0;
  int i;

  for(i = 0; i < 500; i++)
    if(graveyard[i] != -1 && cards_data[  zone[i] ].type & type )
      count++;

  return count;
}

int count_graveyard_by_type(int player, int type){
    if( type == TYPE_ENCHANTMENT ){
        return count_zone_by_type(player, type, graveyard_ptr[player])
                - count_graveyard_planeswalker(player);
    }
    return count_zone_by_type(player, type, graveyard_ptr[player]);
}

int count_deck_by_type(int player, int type){
    return count_zone_by_type(player, type, deck_ptr[player]);
}
