#include "manalink.h"

extern int mulligans_complete[2];
int vanguard_avatar[2];
int cards_in_hand_this_turn[2][100];
int settings[12];
int turn_count = 0;
event_t actual_event = -1;
int flashback = 0;
int in_draft = 0;
int momir = 0;
int testing = 0;
int challenge = 0;
int free_spell_card = -1;
int free_spell_player = -1;

/*
Setting List:
0 - AutoMill
1 - UnlimitedMana 
2 - AutoHaste
3 - QuickStart
4 - CrippleAI
5 - CheckDeckLegality
6 - ChallengeMode
7 - SmartTarget
8/9 - settings checked
10 - alphabetize deck
11 - duh mode

*/
int get_setting(int thing){
    return settings[thing];
}

void set_draft(void){
    in_draft = 1;
    momir = 0;
    opponent_skill = 3;
}

int get_draft(void){
    return in_draft;
}

void set_momir(void){
    momir = 1;
    in_draft = 0;
    testing = 0;
    opponent_skill = 3;
}

int get_momir(void){
    return momir;
}

void set_testing(void){
    momir = 0;
    in_draft = 0;
    testing = 1;
    opponent_skill = 3;
}

int get_testing(void){
    return testing;
}

void set_none(void){
    momir = 0;
    in_draft = 0;
    testing = 0;
    opponent_skill = 3;
}

int get_challenge(void){
    return challenge;
}

void set_challenge(int m){
    challenge = m;
    set_challenge_round_to_0();
    ante = 0;
}

int check_deck_legality(void){      
    int vintage_legal = 1;
    int legacy_legal = 1;
    int illegal_card = -1;
    int restricted_cards[] = {1, 10, 17, 499, 1886, 30, 1890, 62, 1923, 1850, 80, 1577, 
                              331, 438, 1898, 1424, 894, 157, 1900, 1084, 165, 166, 167, 168, 169, 352, 1705, 312, 
                              202, 230, 528, 441, 1351, 248, 249, 250, 317, 1909, 333, 282, 309, 1910, 1704, 43};
    
    int banned_cards[] =     {1, 10, 17, 30, 1890, 62, 1850, 80, 1395, 1751,
                              331, 438, 1898, 1424, 894, 157, 1900, 165, 166, 167, 168, 169, 1705,  
                              230, 528, 1351, 248, 249, 250, 317, 282, 309, 1910, 1704,
                              398, 18, 720, 162, 510, 1902, 1714, 1342, 43, 352};
                              
    int unlimited_allowed[] = { 188, 164, 239, 126, 91, 1863 };
    
    int always_banned_cards[] = { 43 };
    
    int *deck = deck_ptr[HUMAN];
    int new_deck[500];
    int i, j;
    j=0;
    for(i = 0; i < 500; i++){
        new_deck[i] = -1;
    }
    for(i = 0; i < 500; i++){
        if( deck[i] > -1 ){
            new_deck[i] = cards_data[ deck[i] ].id;
        }
        else{
            new_deck[i] = -1;
            j = i;
            i = 500;
        }
    }
    int count = 0;
    /*
    while( count < active_cards_count[HUMAN]){
        if(! in_play(HUMAN, count) ){
            new_deck[j++] = get_id(HUMAN, count);
        }
        count++;
    }
    */
    
    // deck too small
    if( count_deck(HUMAN) < 52 && gauntlet_round == 0 ){
        return 0;
    }
    
    for(i=0;i<2000;i++){
        count = 0;
        for(j = 0;j<500;j++){
            if( new_deck[j] == i ){ count++; }
        }
        
        if( count > 4 ){
            int valid = 0;
            for(j = 0;j<6;j++){
                if( unlimited_allowed[j] == i ){
                    valid = 1;
                } 
            }
            if( ! valid ) {
                int card_added =  add_card_to_hand(HUMAN, get_internal_card_id_from_csv_id(i)  );
                card_instance_t *target = get_card_instance(HUMAN, card_added);
                target->state |= STATE_INVISIBLE;
                return card_added;
            }
        }

        if( vintage_legal && count > 1 ){
            for(j = 0;j<100;j++){
                if( restricted_cards[j] == i ){
                    vintage_legal = 0;
                    illegal_card = i;
                } 
                if( restricted_cards[j] == 1704 ){ j = 100; }
            }
        }
        
        if( legacy_legal && count > 0 ){
            for(j = 0;j<100;j++){
                if( banned_cards[j] == i ){
                    legacy_legal = 0;
                    illegal_card = i;
                } 
                if( banned_cards[j] == 1342 ){ j = 100; }
            }
        }
        
        if( count > 0 ){
            for(j = 0;j<1;j++){
                if( always_banned_cards[j] == i ){
                    legacy_legal = 0;
                    vintage_legal = 0;
                    illegal_card = i;    
                }
            }
        }
    }
                              
    if( legacy_legal || vintage_legal ){
        return -1;
    }
    int card_added =  add_card_to_hand(HUMAN, get_internal_card_id_from_csv_id(illegal_card)  );
    card_instance_t *target = get_card_instance(HUMAN, card_added);
    target->state |= STATE_INVISIBLE;
    return card_added;
}

void pregame(void){
    turn_count = 0;
    
    int i;
    for(i=0;i<50;i++){ is_unlocked(0, 0, 0, i); }  

    // set a variable if there are any vanguard avatars in the deck
    int p;
    for(p=0;p<2;p++){
        mulligans_complete[p] = 0;
        int *deck = deck_ptr[p];
        for(i = 0; i < 500; i++){
            if(deck[i] != -1 && cards_data[  deck[i] ].cc[2] == 3  ){
                //if( cards_data[  deck[i] ].id != get_id_by_name("* Elder Dragon Highlander") || is_unlocked(0, 0, 0, 39) ){
                    vanguard_avatar[p] = cards_data[  deck[i] ].id;
                //}
            }
        }
    }   
    
    // if the draft file exists, then add the draft avatar
    if( get_draft() ){
        vanguard_avatar[HUMAN] = 1884;
        vanguard_avatar[AI] = 1884;
        in_draft = 0;
    }
    else if( get_momir() ){
        vanguard_avatar[HUMAN] = 611;
        vanguard_avatar[AI] = 611;
    }
    
   
    // default settings to off
    for(i=0;i<10;i++){
        settings[i] = 0;
    }
    
    // if the config file exists, then read in the config settings
    char buffer[50];
    FILE* file = fopen("config.txt", "r");
    if( file != NULL && settings[9] < 1 ){
        settings[9] = 1;
        while( fscanf(file, "%s", buffer) == 1 ){
            if( strcmp(buffer, "AlphabetizeDeck:1") == 0 ){
                settings[10] = 1;
            }
            else if( strcmp(buffer, "DuhMode:1") == 0 ){
                settings[11] = 1;
            }
        }
        fclose(file);
    }
        
    // if the challenge file exists, then add the challenge flag   
    if( get_challenge() ){
        settings[6] = 1;
    }
    
    // if the config file exists, then read in the config settings
    file = fopen("config.txt", "r");
    if( file != NULL && settings[9] < 2 ){
        settings[9] = 2;
        while( fscanf(file, "%s", buffer) == 1 ){
            if( strcmp(buffer, "AutoMill:1") == 0 ){
                settings[0] = 1;
            }
            else if( strcmp(buffer, "UnlimitedMana:1") == 0 ){
                settings[1] = 1;
            }
            else if( strcmp(buffer, "AutoHaste:1") == 0 ){
                settings[2] = 1;
            }
            else if( strcmp(buffer, "Debug:1") == 0 && settings[6] != 1){
                debug_mode = 1;
                trace_mode = 0;
            }    
            else if( strcmp(buffer, "QuickStart:1") == 0 ){
                settings[3] = 1;
            }
            else if( strcmp(buffer, "CrippleAI:1") == 0 ){
                settings[4] = 1;
            }
            else if( strcmp(buffer, "CheckDeckLegality:1") == 0 ){
                settings[5] = 1;
            }
            else if( strcmp(buffer, "ChallengeMode:1") == 0 ){
                settings[6] = 1;
            }
            else if( strcmp(buffer, "SmartTarget:1") == 0 ){
                settings[7] = 1;
            }
        }
        fclose(file);
    }
    
    // if we are testing, turn on crippleAI, autohaste, unlimited mana, and
    // quickstart and automill
    if( get_testing() ){
        settings[0] = 1;
        settings[1] = 1;
        settings[2] = 1;
        settings[3] = 1;
        settings[4] = 1;
    }
}

int quick_start(void){
    if( vanguard_avatar[HUMAN] ){
        return 1;
    }
    return get_setting(3);
}

int fake_random(int num){
    return 0;
}


void vanguard_check(void){
    // put the vanguard avatars into play 
    int p;
    for(p=0;p<2;p++){
        if( vanguard_avatar[p] > 0 && ! get_setting(6) ){
            generate_token_by_id(p, vanguard_avatar[p] );      
        }
        else if( p == 0 && get_setting(6) ){
            apply_challenge_vanguard();
        }
        vanguard_avatar[p] = 0;
    }
}

// Perform any upkeep triggers for cards in the graveyard
void resolve_graveyard_upkeep_triggers(int player, int card, event_t event ){
    card_instance_t *instance= get_card_instance(player, card);
    int i;
    if( current_phase <= PHASE_MAIN1 && current_turn == player ){
        int ability_found = 0;
        int grave_count = count_graveyard(player);
        int *graveyard = graveyard_ptr[player];
        for(i=0;i<grave_count;i++){
            card_data_t card_d = cards_data[ graveyard[i] ];            
            if( card_d.cc[2] == 5 || card_d.id == get_id_by_name("Eternal Dragon") ){
                ability_found = 1;
            }
        }
        
        // if any abilities were found, do the upkeep trigger
        if( ability_found ){
            if(trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
                if(event == EVENT_TRIGGER){
                    event_result |= 2;
                }
                else if(event == EVENT_RESOLVE_TRIGGER){
                    for(i=0;i<grave_count;i++){
                        card_data_t card_d = cards_data[ graveyard[i] ];            
                        if( card_d.cc[2] == 5 || card_d.id == get_id_by_name("Eternal Dragon") ){
                            // put a copy of the card into your hand
                            int card_added =  add_card_to_hand(player, graveyard[i] );
                
                            instance->number_of_targets = 1;
                            card_instance_t *target = get_card_instance(player, card_added);
                            target->state |= STATE_INVISIBLE;
                            
                            int (*ptFunction)(int, int, event_t) = (void*)card_d.code_pointer;
                            int result = ptFunction(player, card_added, EVENT_GRAVEYARD_ABILITY_UPKEEP);
                            if( result == -1 ){ // this card is removed
                                remove_card_from_grave(player, i);
                                i--;
                            }
                            else if( result == -2 ){ // -2 means no card is removed
                                obliterate_card(player, card_added);
                            }
                            else{  // another card was removed
                                obliterate_card(player, card_added);
                                remove_card_from_grave(player, result);
                                if( result <= i ){
                                    i--;
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}

// Perform any upkeep triggers for cards in the graveyard
void keep_turn_count(int player, int card, event_t event ){
    if( comes_into_play(player, card, event) == 1 && player == HUMAN){
        turn_count = 0;  // turn count 
    }
    if( turn_count == 0 && eot_trigger(player, card, event) == 1  ){
        turn_count = 1;
    }
}

int effect_unearth(int player, int card, event_t event ){
    card_instance_t *instance = get_card_instance(player, card);
    int p = instance->targets[0].player;
    int c = instance->targets[0].card;
    haste(p, c);
    
    if( leaves_play(p, c, event) ){ 
        add_card_to_rfg(p, get_id(p, c) );
    }
    else if( eot_trigger(player, card, event) ){
        kill_card(p, c, KILL_REMOVE);
    }
    return 0;
}

void resolve_dredge_triggers(int player, int card, event_t event ){
    int i;
 
    // Check for dredge
    if(trigger_condition == TRIGGER_REPLACE_CARD_DRAW && affect_me(player, card) && reason_for_trigger_controller == player){
        // see if there are any cards to dredge
        int grave_count = count_graveyard(player);
        int *graveyard = graveyard_ptr[player];
        int ability_found = 0;
        char buffer[500];
        sprintf(buffer, " Cancel\n" );
        for(i=0;i<grave_count;i++){
            card_data_t card_d = cards_data[ graveyard[i] ];   
            if( card_d.cc[2] == 6 ){
                int (*ptFunction)(int, int, event_t) = (void*)card_d.code_pointer;
                int result = ptFunction(player, 0, EVENT_GRAVEYARD_ABILITY); 
                if( count_deck(player) >= result ){
                    ability_found = 1;
                    card_ptr_t* c = cards_ptr[ card_d.id ];
                    sprintf(buffer, "%s Dredge %s\n", buffer, c->name );
                }
            }
        }
        
        if( ability_found ){
            if(event == EVENT_TRIGGER){
                event_result |= 2;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                int choice = do_dialog(player, player, card, -1, -1, buffer, 1);
                if( choice != 0 ){
                   int valid = 0;
                   for(i=0;i<grave_count;i++){
                        card_data_t card_d = cards_data[ graveyard[i] ];    
                        if( card_d.cc[2] == 6 ){
                            int (*ptFunction)(int, int, event_t) = (void*)card_d.code_pointer;
                            int result = ptFunction(player, 0, EVENT_GRAVEYARD_ABILITY);
                            if( count_deck(player) >= result && ++valid == choice ){
                                mill( player, result );
                                int card_added =  add_card_to_hand(player, graveyard[i] );
                                put_on_top_of_deck(player, card_added);
                                remove_card_from_grave(player, i);
                            }
                        }
                    }
                }
            }
        }     
    }
}

int activate_cards_in_hand(int player, int card, event_t event ){
    card_instance_t *instance= get_card_instance(player, card);
    
    // look for cards in hand that have abilities
    int i;
    if( event == EVENT_CAN_ACTIVATE ){
        //return 1;
        for(i=0;i<active_cards_count[player]; i++){
            card_instance_t *hand_instance = get_card_instance(player, i);
            if( ! ( hand_instance->state & STATE_INVISIBLE ) && ! ( hand_instance->state & STATE_IN_PLAY )  ){
                int id = hand_instance->internal_card_id;
                if( id > -1 ){
                    if( cards_data[id].cc[2] == 4 ){
                        int (*ptFunction)(int, int, event_t) = (void*)cards_data[id].code_pointer;
                        if( ptFunction(player, i, EVENT_CAN_ACTIVATE_FROM_HAND ) ){
                            return 1;
                        }
                    }
                }         
            }
        }
        
        // also check for cards in the graveyard
        int *graveyard = graveyard_ptr[player];
        for(i=0;i<count_graveyard(player);i++){
            card_data_t card_d = cards_data[ graveyard[i] ]; 
            if( card_d.cc[2] == 9 || card_d.id == get_id_by_name("Viscera Dragger") || card_d.cc[2] == 10 || card_d.id == get_id_by_name("Worm Harvest") || card_d.id == get_id_by_name("Spitting Image") ){
                int (*ptFunction)(int, int, event_t) = (void*)card_d.code_pointer;
                if( ptFunction(player, i, EVENT_GRAVEYARD_ABILITY ) ){
                    return 1;
                }
            }   
        }
    }
    else if( event == EVENT_ACTIVATE ){
        char buffer[500];
        sprintf(buffer, " Cancel\n" );
        for(i=0;i<active_cards_count[player]; i++){
            card_instance_t *hand_instance = get_card_instance(player, i);
            if( ! ( hand_instance->state & STATE_INVISIBLE ) && ! ( hand_instance->state & STATE_IN_PLAY )  ){
                int id = hand_instance->internal_card_id;
                if( id > -1 ){
                    if( cards_data[id].cc[2] == 4 ){
                        int (*ptFunction)(int, int, event_t) = (void*)cards_data[id].code_pointer;
                        if( ptFunction(player, i, EVENT_CAN_ACTIVATE_FROM_HAND ) ){
                            card_ptr_t* c = cards_ptr[ get_id(player, i) ];
                            sprintf(buffer, "%s Activate %s\n", buffer, c->name );
                        }
                    }
                }         
            }
        }
        
        // also check for cards in the graveyard
        int *graveyard = graveyard_ptr[player];
        for(i=0;i<count_graveyard(player);i++){
            if( can_legally_play(player, graveyard[i] ) ){
                card_data_t card_d = cards_data[ graveyard[i] ]; 
                if( card_d.cc[2] == 9 || card_d.id == get_id_by_name("Viscera Dragger") || card_d.cc[2] == 10 || card_d.id == get_id_by_name("Worm Harvest") || card_d.id == get_id_by_name("Spitting Image") ){
                    int (*ptFunction)(int, int, event_t) = (void*)card_d.code_pointer;
                    if( ptFunction(player, i, EVENT_GRAVEYARD_ABILITY ) ){
                        card_ptr_t* c = cards_ptr[ card_d.id ];
                        if( card_d.type & TYPE_CREATURE ){
                            sprintf(buffer, "%s Unearth %s\n", buffer, c->name );
                        }
                        else if(card_d.cc[2] == 10 || card_d.id == get_id_by_name("Worm Harvest") || card_d.id == get_id_by_name("Spitting Image") ){
                                sprintf(buffer, "%s Retrace %s\n", buffer, c->name );
                        }
                        else{
                             sprintf(buffer, "%s Flashback %s\n", buffer, c->name );
                        }
                    }
                }
            }   
        }
        
        int choice = do_dialog(player, player, card, -1, -1, buffer, 1);
        if( choice != 0 && spell_fizzled != 1 ){
            // pay the costs for the selected card
        
            int valid = 0;
            for(i=0;i<active_cards_count[player]; i++){
                card_instance_t *hand_instance = get_card_instance(player, i);
                if( ! ( hand_instance->state & STATE_INVISIBLE ) && ! ( hand_instance->state & STATE_IN_PLAY )  ){
                    int id = hand_instance->internal_card_id;
                    if( id > -1 ){
                        if( cards_data[id].cc[2] == 4 ){
                            int (*ptFunction)(int, int, event_t) = (void*)cards_data[id].code_pointer;
                            if( ptFunction(player, i, EVENT_CAN_ACTIVATE_FROM_HAND) && ++valid == choice ){
                                int result = ptFunction(player, i, EVENT_ACTIVATE_FROM_HAND);
                                            
                                // result = 2 when a card was cycled
                                if( result == 2 ){
                                    activate_astral_slide();
                                }
                                
                                instance->targets[4].card = cards_data[id].code_pointer;
                                
                                instance->targets[0].card = hand_instance->targets[0].card;
                                instance->targets[0].player = hand_instance->targets[0].player;
                                instance->targets[1].player = 1;
                            }
                        }
                    }
                }         
            }
            
            // also check for cards in the graveyard
            for(i=0;i<count_graveyard(player);i++){
                if( can_legally_play(player, graveyard[i] ) ){
                    card_data_t card_d = cards_data[ graveyard[i] ]; 
                    if( card_d.cc[2] == 9 || card_d.id == get_id_by_name("Viscera Dragger") || card_d.cc[2] == 10 || card_d.id == get_id_by_name("Worm Harvest") || card_d.id == get_id_by_name("Spitting Image") ){
                        int (*ptFunction)(int, int, event_t) = (void*)card_d.code_pointer;
                        if( ptFunction(player, i, EVENT_GRAVEYARD_ABILITY ) && ++valid == choice ){
                            ptFunction(player, i, EVENT_PAY_FLASHBACK_COSTS);
                            if( spell_fizzled != 1 ){
                                instance->targets[4].card = cards_data[graveyard[i]].code_pointer;
                                instance->targets[0].card = card_d.id;
                                instance->targets[1].player = -1;
                                if(card_d.type & TYPE_CREATURE ){
                                   remove_card_from_grave(player, i);
                                }
                                else if(card_d.cc[2] != 10 ){
                                    if( ! ( card_d.id == get_id_by_name("Worm Harvest") || card_d.id == get_id_by_name("Spitting Image") )){
                                        rfg_card_from_grave(player, i, -1);
                                    }
                                }
                            }
                        }
                    }
                }
            }   
        }
        else{
            spell_fizzled = 1;
        }
    }
    else if( event == EVENT_RESOLVE_ACTIVATION ){
        // call the code for the activated card
        int internal_id = get_internal_card_id_from_csv_id( instance->targets[0].card );
        if( instance->targets[1].player >= 0 ){
            int (*ptFunction)(int, int, event_t) = (void*)instance->targets[4].card;
            ptFunction(player, card, EVENT_REVOLVE_ACTIVATION_FROM_HAND);
        }
        else if(cards_data[ internal_id ].type & TYPE_CREATURE ) {
            // unearth (and other reanimation)
            int card_added = add_card_to_hand( player, internal_id );
            if( get_id(player, card_added) != get_id_by_name("Magma Phoenix") ){
                put_into_play(player, card_added);
                if( get_id(player, card_added) == get_id_by_name("Reassembling Skeleton") ){
                    tap_card(player, card_added);
                }
                else{
                    convert_to_token(player, card_added);
                    create_targetted_legacy_effect(player, card_added, &effect_unearth, player, card_added);
                }
            }

        }
        else{
            // flashback
            flashback = 1;
            play_spell_for_free(player, instance->targets[0].card);
            flashback = 0;
        }
    }
    return 0;
}

int get_flashback(void){
    return flashback;
}

int was_card_in_hand(int player, int card){
    return 1; // comment out this code since track_hand is so slow
    int i=0;
    while( cards_in_hand_this_turn[player][i] != -1){
        if( cards_in_hand_this_turn[player][i++] == card ){
            return 1;
        } 
    }
    return 0;
}

void track_hand(int player, int card, event_t event ){
    int i;
    if( comes_into_play(player, card, event) == 1 && player == HUMAN){
        for(i=0;i<100;i++){
            cards_in_hand_this_turn[HUMAN][i] = -1;
            cards_in_hand_this_turn[AI][i] = -1;
        }
    }
    
    int p;
    for (p=0;p<2;p++){
        for(i=0;i<active_cards_count[p]; i++){
            card_instance_t *card_instance = get_card_instance(p, i);
            if( ! ( card_instance->state & STATE_INVISIBLE ) && ! ( card_instance->state & STATE_IN_PLAY )  ){
                int j=0;
                while( cards_in_hand_this_turn[p][j] != -1 && j < 100 ){
                    if( cards_in_hand_this_turn[p][j] == i ){
                        break;
                    }    
                    j++;
                }
                cards_in_hand_this_turn[p][j] = i;
            }        
        }
    }
     
    if( current_phase == PHASE_DISCARD ){
        for(i=0;i<100;i++){
            cards_in_hand_this_turn[HUMAN][i] = -1;
            cards_in_hand_this_turn[AI][i] = -1;
        }
    } 
}

void keep_storm_count(int player, int card, event_t event ){
    card_instance_t *instance= get_card_instance(player, card);
    if( comes_into_play(player, card, event) == 1 && player == HUMAN){
        instance->targets[18].player = 141; //indicate this card
        instance->targets[18].card = 0;  // storm count 
    }
    
    // keep track of storm count
    if(trigger_condition == TRIGGER_SPELL_CAST && affect_me(player, card)
       && player == reason_for_trigger_controller && player == HUMAN)
    {
        card_instance_t *played= get_card_instance(trigger_cause_controller, trigger_cause);
        if( ! ( cards_data[ played->internal_card_id].type & TYPE_LAND )  ){
            if(event == EVENT_TRIGGER){
                event_result |= RESOLVE_TRIGGER_MANDATORY;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                increment_storm_count(); 
            }
        }
    }
    
    if( current_phase == PHASE_DISCARD ){
        instance->targets[18].card = 0;
        set_counters(player, card, 0);
    } 
}

event_t get_actual_event(void){
    return actual_event;
}

void static_graveyard_abilities(int player, int card, event_t event ){
    // look for cards in graveyard that have static abilities
    int i=0;
    int *graveyard = graveyard_ptr[player];
    int bloodghast_count = 0;
    for(i = 0; i < count_graveyard(player); i++){
        card_data_t card_d = cards_data[ graveyard[i] ];            
        if( card_d.cc[2] > 0 ){
            actual_event = event;
            int (*ptFunction)(int, int, event_t) = (void*)card_d.code_pointer;
            ptFunction(player, i, EVENT_GRAVEYARD_ABILITY);
        }
        if( card_d.id == get_id_by_name("Bloodghast") ){
            bloodghast_count++;
        }
    }
    
    // return any bloodghasts to play on landfall
    if( bloodghast_count > 0 && landfall(player, card, event) ){
        for(i = 0; i < count_graveyard(player); i++){
            card_data_t card_d = cards_data[ graveyard[i] ];            
            if( card_d.id == get_id_by_name("Bloodghast") ){
                int choice = do_dialog(player, player, card, -1, -1, " Return Bloodghast to play\n Do not return", 0);
                if( choice == 0 ){
                    rfg_card_from_grave(player, i, -1);
                    int card_added = add_card_to_hand(player, get_internal_card_id_from_csv_id( get_id_by_name("Bloodghast") ) );
                    put_into_play(player, card_added);
                    i--;
                }  
            }
        }
    }
}

int initial_upkeep_triggers(int player, int card, event_t event ){
    
    // deal with serum powder and leyline
    if( player == HUMAN && trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) && turn_count == 0  ){
        
        if(event == EVENT_TRIGGER){
            event_result |= RESOLVE_TRIGGER_MANDATORY;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            int i;
            int p = HUMAN;
            int choice = 1;
            int serum_found = 1;
            if( ! is_unlocked(player, card, event, 7) ){ serum_found = 0; }
            while( serum_found == 1 ){
                serum_found = 0;
                for(i=0;i<active_cards_count[p];i++){
                    if( in_hand(p, i) && get_id(p, i ) == 711 ){
                        choice = do_dialog(p, p, i, -1, -1, " Take Serum Powder Mulligan\n Keep Hand", 0);
                        serum_found = 1;
                        break;
                    }
                }
                if( serum_found == 0 || choice == 1 ){
                    break;
                }
                
                int hand_size = 0;
                for(i=0;i<active_cards_count[player];i++){
                    if( in_hand(player, i) ){
                        hand_size++;
                        kill_card(player, i, KILL_DESTROY);
                        rfg_card_from_grave(player, 0, -1);
                    }
                }
        
                // proceed with normal mulliganning
                int cards = hand_size;
                while(cards > 0 ){
                    // draw the appropriate number of cards
                    shuffle_vanguard(player, 1);
                    draw_cards(player, cards);
                    hand_count[player] = cards;
                        
                    // allow the choice to mulligan
                    choice = do_dialog(player, player, card, -1, -1, " Keep\n Mulligan", 0);
                    if( choice == 1 ){
                        cards--;
                    }
                    else{
                        break;
                    }       
                        
                    // put your hand back into the deck
                    int count = active_cards_count[player] -1;
                    int returned = 0;
                    while( returned < hand_count[player]){
                        if(! in_play(player, count) ){
                            put_on_top_of_deck(player, count);
                            returned++;
                        }
                        count--;
                    }
                }       
            }
            
            
        }
    }
    
    // leyline of the void
    if( turn_count == 0 ){
        int i;
        int found = 0;
        for(i=0;i<active_cards_count[player];i++){  
            int id = get_id(player, i );
            if( in_hand(player, i) && ( id == get_id_by_name("Leyline of the Void") || id == get_id_by_name("Leyline of Sanctity") || id == get_id_by_name("Leyline of Punishment") || id == get_id_by_name("Leyline of Vitality")  ) ){
                found = 1;
            }
        }        
        if( found == 1 && upkeep_trigger(player, card, event) ){
            for(i=0;i<active_cards_count[player];i++){  
                int id = get_id(player, i );
                if( in_hand(player, i) && ( id == get_id_by_name("Leyline of the Void") || id == get_id_by_name("Leyline of Sanctity") || id == get_id_by_name("Leyline of Punishment") || id == get_id_by_name("Leyline of Vitality")  ) ){
                    int choice = do_dialog(player, player, i, -1, -1, " Put Leyline into play\n Leave it in hand", 0);
                    if( choice == 0 ){
                        put_into_play(player, i);
                        hand_count[player]--;
                    }
                }
            }   
        }          
    }
    
    // deal with challenges
    if( get_setting(6)  && (get_challenge4() == 0 || get_challenge4() == 1 ||(gauntlet_round >= 29 && gauntlet_round < 40) || (gauntlet_round >= 59)) && current_turn == HUMAN ){
        if( player == HUMAN && trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
            if(event == EVENT_TRIGGER){
                event_result |= RESOLVE_TRIGGER_MANDATORY;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                if( get_challenge4() == 0 || get_challenge4() == 1 || (gauntlet_round >= 29 && gauntlet_round < 40) ){
                    apply_challenge_onslaught();
                }
                else if(gauntlet_round >= 59 && gauntlet_round < 70){
                    apply_challenge_10_to_1_upkeep();
                }
                else if(gauntlet_round >= 70){
                    apply_challenge_puzzle_upkeep();
                }
            }
        }
    }
    

    if( get_setting(8) != 1 && ( get_setting(0) || get_setting(4) || get_setting(5) || (get_setting(6) == 1)) ){
        if( player == HUMAN && trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
            if(event == EVENT_TRIGGER){
                event_result |= RESOLVE_TRIGGER_MANDATORY;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                settings[8] = 1;
                if(get_setting(0) ){
                    if( count_deck(HUMAN) > 30 ){
                        mill(HUMAN, 30);
                        mill(AI, 30);
                        settings[0] = 0;
                    }
                }
                if( get_setting(4) ){
                    // put every card back into the deck
                    int count = 0;
                    while( count < active_cards_count[AI]){
                        if(! in_play(AI, count) ){
                            put_on_top_of_deck(AI, count);
                        }
                        count++;
                    }
                    hand_count[AI] = 0;
                    settings[4] = 0;
                }
                if( get_setting(5) != -1 && ( get_setting(5) > 0 || get_setting(6) == 1 ) && get_challenge_round() != 19){
                    settings[5] = -1;
                    int illegal_card = check_deck_legality();
                    if ( illegal_card > -1 && poison_counters[HUMAN]== 0){
                        //gain_life(HUMAN, get_challenge_round());
                        if( get_setting(6) ){
                            lose_the_game(HUMAN);
                        }
                        else{
                            reveal_card(0,0,illegal_card,0, illegal_card, "Your deck is not legal.", 0);
                            lose_the_game(HUMAN);
                        }
                        
                    }
                    if( zendikar() || custom() ){
                        lose_the_game(HUMAN);
                    }
                }
                if( get_setting(6) == 1 ){
                    debug_mode = 0;
                    challenge_mode_upkeep(0);
                    settings[6]++;
                }
            }
        }
    }
    return 0;
}

void debug_settings(int player, int card, event_t event){  
    // if we are in challenge mode, make sure all the debug settings are off
    if( get_setting(6) ){
        if( debug_mode == 1 || get_setting(0) || get_setting(1) || get_setting(2) || get_setting(4) || game_number > 0 ){
            if( !  jatill() ){
                do_dialog(HUMAN, player, card, -1, -1, "Invalid Settings", 0);
                lose_the_game(HUMAN);
            }
        }
        
        if( gauntlet_round < 30 && (( gauntlet_round - get_challenge_round() > 1)  || ( get_challenge_round() - gauntlet_round > 1))  ){
            char buffer[500];
            sprintf(buffer, " gauntlet: %d, challenge: %d", gauntlet_round , get_challenge_round());
            do_dialog(HUMAN, player, card, -1, -1, buffer, 0);
            lose_the_game(HUMAN);
        }
        
        /*
        if(  count_cards_by_id(HUMAN, 1847) == 0 && current_phase > PHASE_UPKEEP){
            do_dialog(HUMAN, player, card, -1, -1, "No rules engine", 0);
            lose_the_game(HUMAN);
        }
        */
    }
    
    // give each play unlimited mana
    if( get_setting(1) == 1 ){ 
        int p, c;
        for(p=0;p<2;p++){
            for(c=0;c<6;c++){
                if( ! has_mana(p, c, 10) ) {
                    produce_mana(p, c, 10);
                }
            }
        }
    }

    // give all creatures haste
    if( get_setting(2) == 1 ){ 
        haste(affected_card_controller, affected_card);
    }
}

int effect_challenge3(int player, int card, event_t event ){
    if( eot_trigger(player, card, event) ){
        life[HUMAN]=0;
    }
    return 0;
}

int gauntlet_settings(int player, int card, event_t event ){
    if( ! get_setting(6) ){
        return 0;
    }
    
    // during the pit challenge, legends have shroud
    if( get_challenge4() == 1 && event == EVENT_ABILITIES ){
        if( has_creature_type(affected_card_controller, affected_card, SUBTYPE_LEGEND ) ){
            event_result |= KEYWORD_SHROUD;   
        }
    }
    
    // during the enchanted challenge, enchantments are indestrictible
    if( get_challenge4() == 6 ){
        int c=0;
        for(c=0;c< active_cards_count[AI];c++){
            card_data_t card_d = get_card_data(AI, c);
            if((card_d.type & TYPE_ENCHANTMENT) && in_play(AI, c)){
                indestructible(AI, c, event);
            }
        }
    }
    
    // if we won the enchanted challenge, your enchantments are indestrictible
    if( event == EVENT_GRAVEYARD_FROM_PLAY && is_unlocked(HUMAN, card, event, 37) ){
        int c=0;
        for(c=0;c< active_cards_count[HUMAN];c++){
            card_data_t card_d = get_card_data(HUMAN, c);
            if((card_d.type & TYPE_ENCHANTMENT) && in_play(HUMAN, c)){
                indestructible(HUMAN, c, event);
            }
        }
    }
    
    if( (( gauntlet_round >= 71 && gauntlet_round <= 80 ) || get_challenge2() == 1 ) && player == HUMAN){
        skip_your_draw_step(player, event);
    }
    
    if( get_challenge2() == 3 ){
        card_instance_t *instance = get_card_instance(player, card);
        if(event == EVENT_MODIFY_COST_GLOBAL && instance->targets[3].card == 1 && player == HUMAN ){
            card_data_t card_d = get_card_data(affected_card_controller, affected_card);
            if( affected_card_controller == player){
                if(! (card_d.type & TYPE_LAND) ){
                    COST_COLORLESS+=49;
                }
            }
        }
    
        // keep track of spells played
        if(trigger_condition == TRIGGER_SPELL_CAST && affect_me(player, card)
            && player == reason_for_trigger_controller )
        {
            card_instance_t *played= get_card_instance(trigger_cause_controller, trigger_cause);
            if( instance->targets[3].card == -1 &&  trigger_cause_controller == player && ! ( cards_data[ played->internal_card_id].type & TYPE_LAND ) ){
                if(event == EVENT_TRIGGER){
                    event_result |= RESOLVE_TRIGGER_MANDATORY;
                }
                else if(event == EVENT_RESOLVE_TRIGGER){
                    instance->targets[3].card = 1;         
                }    
            }
        }
    }
    
    if( get_challenge3() == 8 ){
        if(trigger_condition == TRIGGER_SPELL_CAST && affect_me(player, card)
            && player == reason_for_trigger_controller && trigger_cause_controller == HUMAN && player == HUMAN)
        {
            card_instance_t *played= get_card_instance(trigger_cause_controller, trigger_cause);
            if( ! ( cards_data[ played->internal_card_id].type & TYPE_LAND ) ){
                if(event == EVENT_TRIGGER){
                    event_result |= RESOLVE_TRIGGER_MANDATORY;
                }
                else if(event == EVENT_RESOLVE_TRIGGER){
                    create_legacy_effect(player, card, &effect_challenge3 );         
                }    
            }
        }
    }
    else if( get_challenge4() == 3 ){
        if(trigger_condition == TRIGGER_SPELL_CAST && affect_me(player, card)
            && player == reason_for_trigger_controller && trigger_cause_controller == AI && player == AI)
        {
            card_instance_t *played= get_card_instance(trigger_cause_controller, trigger_cause);
            if( ! ( cards_data[ played->internal_card_id].type & TYPE_LAND ) ){
                if(event == EVENT_TRIGGER){
                    event_result |= RESOLVE_TRIGGER_MANDATORY;
                }
                else if(event == EVENT_RESOLVE_TRIGGER){
                    cascade(trigger_cause_controller, trigger_cause, EVENT_CAST_SPELL, 1);        
                }    
            }
        }
    }
    
    int round = get_challenge_round() - 1;
    
    // end the game if the time limit for puzzle challenge is over
    if( ( gauntlet_round == 72 || gauntlet_round == 73 ) && current_turn == HUMAN && current_phase == PHASE_MAIN1 ){
        life[HUMAN]=0;
        poison_counters[HUMAN]=10;
    }
    else if( gauntlet_round > 70 && gauntlet_round < 81 && current_turn == HUMAN && eot_trigger(player, card, event) ){
        life[HUMAN]=0;
        poison_counters[HUMAN]=10;
    }
    
    if( round < 49 || gauntlet_round > 59 ){ return 0; }
    
    if(event == EVENT_MODIFY_COST_GLOBAL ){
        card_instance_t *instance = get_card_instance( affected_card_controller, affected_card);      
        int type = cards_data[ instance->internal_card_id ].type;
        
        if( round == 49 && ( instance->card_color & COLOR_TEST_BLACK ) && ! ( type & TYPE_LAND ) && ! ( type & TYPE_ARTIFACT ) ){
            COST_COLORLESS+=49;
        }  
        else if( round == 50 && ! ( type & TYPE_LAND ) && ! ( type & TYPE_ARTIFACT )&&instance->card_color & COLOR_TEST_BLUE ){
            COST_COLORLESS+=49;
        }  
        else if( round == 51 && ! ( type & TYPE_LAND ) && ! ( type & TYPE_ARTIFACT )&&instance->card_color & COLOR_TEST_GREEN ){
            COST_COLORLESS+=49;
        }  
        else if( round == 52 && ! ( type & TYPE_LAND ) && ! ( type & TYPE_ARTIFACT )&&instance->card_color & COLOR_TEST_RED ){
            COST_COLORLESS+=49;
        }  
        else if( round == 53 && ! ( type & TYPE_LAND ) && ! ( type & TYPE_ARTIFACT )&& instance->card_color & COLOR_TEST_WHITE ){
            COST_COLORLESS+=49;
        } 
        else if( round == 54 && type & TYPE_ARTIFACT ){
            COST_COLORLESS+=49;
        } 
        else if( round == 55 && type & TYPE_ENCHANTMENT ){
            COST_COLORLESS+=49;
        }   
        else if( round == 56 && type & TYPE_CREATURE ){
            COST_COLORLESS+=49;
        }   
        else if( round == 57 && ( ( type & TYPE_INSTANT) || ( type & TYPE_INTERRUPT ) || ( type & TYPE_SORCERY ))  ){
            COST_COLORLESS+=49;
        }   
        else if( round == 58 && type & TYPE_LAND ){
            COST_COLORLESS+=49;
        }     
    }
    return 0;
}

void elspeth_ability(int player, int card, event_t event ){
    
    // indestructible creatures
    int p=0;
    for(p=0;p<2;p++){
        int count = 0;
        while(count < active_cards_count[p]){
            card_instance_t *inst= get_card_instance(p, count);
            if( inst->targets[18].player == 282 ){
                int c=0;
                for(c=0;c< active_cards_count[p];c++){
                    card_data_t card_d = get_card_data(player, c);
                    if((card_d.type & TYPE_CREATURE) && in_play(p, c)){
                        indestructible(p, c, event);
                    }
                }
            }
            count++;
        }
    }
}

int play_spell_for_free(int player, int id){
    
    int internal_id = get_internal_card_id_from_csv_id( id );
    int card_added = add_card_to_hand( player, internal_id );
    
    free_spell_player = player;
    free_spell_card = card_added;
    card_data_t card_d = cards_data[ internal_id ];   
    
    if( put_card_on_stack(player, card_added, 0) ){
        put_card_on_stack(player, card_added, 1);
        put_card_on_stack3(player, card_added) ;
        
        if(  card_d.type & TYPE_LAND ){
            land_can_be_played |= 1;
        }
    }
    else if( can_legally_play(player, internal_id) ){
        play_spell_for_free_orig(player, card_added);
    }
    else{
        obliterate_card(player, card_added);
    }
    free_spell_card = -1;
    
    return card_added;
}

void modify_costs_for_free_spell(event_t event){
    if( event == EVENT_MODIFY_COST_GLOBAL && free_spell_card != -1 ){
        if( affect_me(free_spell_player, free_spell_card ) ){
            card_ptr_t* c = cards_ptr[ get_id(free_spell_player, free_spell_card) ];
            COST_BLACK -= c->req_black;
            COST_BLUE -= c->req_blue;
            COST_GREEN -= c->req_green;
            COST_RED -= c->req_red;
            COST_WHITE -= c->req_white;
            COST_COLORLESS -= c->req_colorless;
        }
    }
}

int effect_discard_trigger(int player, int card, event_t event ){
    card_instance_t *instance = get_card_instance(player,card);
    if( instance->targets[0].player != 6 ){
        return 0;
    }
    
    int *grave = graveyard_ptr[player];
    int grave_count = count_graveyard(player);
    int id = grave[grave_count-1];
    if( instance->targets[0].card == id ){
        grave[grave_count-1] = -1;
        int card_added = add_card_to_hand(player, id );
        put_into_play(player, card_added);
        kill_card(player, card, KILL_DESTROY);
    }
    else if( eot_trigger(player, card, event) ){
        kill_card(player, card, KILL_DESTROY);
    }
    return 0;
 }         
     
void discard_triggers(int player, int card, event_t event ){
    //return;
    if( affect_me(player, card) && reason_for_trigger_controller == player && trigger_condition == TRIGGER_DISCARD  && player == trigger_cause_controller && current_phase <= PHASE_MAIN2 ){
         card_instance_t *discarded = get_card_instance(trigger_cause_controller, trigger_cause);
         if(  get_id(player, trigger_cause) == get_id_by_name("Wilt-Leaf Liege") || get_id(player, trigger_cause) == get_id_by_name("Obstinate Baloth") ){
            int p = 1-player;
            int count = 0;
            while(count < active_cards_count[p]){
                card_instance_t *this_instance = get_card_instance(p, count);
                if( get_id(p, count) != 1847 && ( this_instance->state & STATE_IN_PLAY ) && ! ( cards_data[ this_instance->internal_card_id ].type & TYPE_PERMANENT )   ){
                    if(this_instance->targets[6].player != 99 ){
                        this_instance->targets[6].player = 99;                    
                        int effect_card = create_legacy_effect(player, card, &effect_discard_trigger );
                        card_instance_t *effect = get_card_instance(player, effect_card);
                        effect->targets[0].card = discarded->internal_card_id;
                        effect->targets[0].player = 6;
                        //life[HUMAN] = count;
                        return;    
                    }                         
                }
                count++;
            }
        }
    }    
    return;
}   
            
int card_rules_engine(int player, int card, event_t event ){
    initial_upkeep_triggers(player, card, event);
    check_trap_conditions(player, card, event);
    keep_storm_count(player, card, event);
    keep_turn_count(player, card, event);
    gauntlet_settings(player, card, event);
    apply_challenge_10_to_1(player, card, event);
    resolve_dredge_triggers(player, card, event);
    resolve_graveyard_upkeep_triggers(player, card, event);
    static_graveyard_abilities(player, card, event);
    debug_settings(player, card, event);   
    bridge_from_below(player, card, event);
    elspeth_ability(player, card, event);    
    krovikan_horror(player, card, event);
    discard_triggers(player, card, event);
    modify_costs_for_free_spell(event);
    return activate_cards_in_hand(player, card, event);
}

void game_startup(void){
    if( get_setting(6) ){
        set_challenge_round();
    }
    vanguard_check();
    
    // if the config file exists, then check rules engine settings
    FILE *file = fopen("config.txt", "r");
    if( file != NULL ){
        char buffer[50];
        while( fscanf(file, "%s", buffer) == 1 ){
            if( memcmp(buffer, "RulesEngine:0", 13) == 0 ){
                fclose(file);
                return;
            }
        }
        fclose(file);
    }
    
    generate_token_by_id(HUMAN, 1847); // rules engine
    generate_token_by_id(AI, 1847); // rules engine
    return;
}

