#include "manalink.h"

void echo(int player, int card, event_t event, int colorless, int black, int blue, int green,
          int red, int white)
{
    card_instance_t *instance = get_card_instance(player, card);
    if( current_phase == PHASE_DRAW && player == current_turn){
        instance->targets[9].card = 77;
    }

    if( player != current_turn || current_phase != PHASE_UPKEEP ){
        return;
    }

    if(instance->targets[9].card < 10 ){
        if( event == EVENT_SETUP_UPKEEP_COSTS ){
            instance->upkeep_green = green;
            instance->upkeep_colorless = colorless;
            instance->upkeep_red = red;
            instance->upkeep_white = white;
            instance->upkeep_black = black;
            instance->upkeep_blue = blue;
        }
        card_palladia_mors(player, card, event);
    }
}

void fading(int player, int card, event_t event, int fading_counters){
    if( ! affect_me(player, card) ){
        return;
    }
    
    if( comes_into_play(player, card, event) == 1 ){
        set_counters(player, card, fading_counters);       
    }
    else if(event == EVENT_RESOLVE_TRIGGER ){
        if( count_counters(player, card) <= 0 ){
            kill_card(player, card, KILL_SACRIFICE);
        }
        remove_counter(player, card);
    }
    else{
        //lazy man's way of setting up an upkeep trigger
        card_phyrexian_arena(player, card, event);
    }
}

void basic_upkeep(int player, int card, event_t event, int colorless, int black, int blue, int green,
          int red, int white)
{
    if( player != current_turn || current_phase != PHASE_UPKEEP ){
        return;
    }
    
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_SETUP_UPKEEP_COSTS ){
        instance->upkeep_green = green;
        instance->upkeep_colorless = colorless;
        instance->upkeep_red = red;
        instance->upkeep_white = white;
        instance->upkeep_black = black;
        instance->upkeep_blue = blue;
    }
    card_palladia_mors(player, card, event);
}

void cumulative_upkeep(int player, int card, event_t event, int colorless, int black, int blue, int green,
          int red, int white){
    
    if(comes_into_play(player, card, event) == 1 ){
        set_counters(player, card, 0);
    }
    
    if( player == current_turn && trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
        if(event == EVENT_TRIGGER){
            event_result |= RESOLVE_TRIGGER_MANDATORY;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            add_counter(player, card);
        }
    }    
    
    int num = count_counters(player, card);
    
    return basic_upkeep( player, card, event, num * colorless, num * black, num * blue, num * green,
          num * red, num * white );
}
